![DifferentiationInterface Logo](https://raw.githubusercontent.com/JuliaDiff/DifferentiationInterface.jl/main/DifferentiationInterface/docs/src/assets/logo.svg)

# DifferentiationInterface

| Category | Badges |
|---|---|
| Build status | [![Tests](https://github.com/JuliaDiff/DifferentiationInterface.jl/actions/workflows/Test.yml/badge.svg?branch=main)](https://github.com/JuliaDiff/DifferentiationInterface.jl/actions/workflows/Test.yml?query=branch%3Amain) [![Coverage](https://codecov.io/gh/JuliaDiff/DifferentiationInterface.jl/branch/main/graph/badge.svg?flag=DI)](https://app.codecov.io/gh/JuliaDiff/DifferentiationInterface.jl) |
| Documentation | [![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://juliadiff.org/DifferentiationInterface.jl/DifferentiationInterface/stable/)     [![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://juliadiff.org/DifferentiationInterface.jl/DifferentiationInterface/dev/) [![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor%27s%20Guide-blueviolet)](https://github.com/SciML/ColPrac) |
| Code quality | [![code style: runic](https://img.shields.io/badge/code_style-%E1%9A%B1%E1%9A%A2%E1%9A%BE%E1%9B%81%E1%9A%B2-black)](https://github.com/fredrikekre/Runic.jl) [![Aqua QA](https://juliatesting.github.io/Aqua.jl/dev/assets/badge.svg)](https://github.com/JuliaTesting/Aqua.jl) |
| Downloads | [![Downloads](https://img.shields.io/badge/dynamic/json?url=http%3A%2F%2Fjuliapkgstats.com%2Fapi%2Fv2%2Fmonthly_downloads%2FDifferentiationInterface&query=total_requests&suffix=%2Fmonth&label=Downloads)](http://juliapkgstats.com/pkg/DifferentiationInterface) [![Dependents](https://juliahub.com/docs/General/DifferentiationInterface/stable/deps.svg)](https://juliahub.com/ui/Packages/General/DifferentiationInterface?#dependents) |
| Community | [![All Contributors](https://img.shields.io/github/all-contributors/JuliaDiff/DifferentiationInterface.jl?color=ee8449)](#contributors) |
| References | [![JMLR](https://img.shields.io/badge/JMLR-2026-magenta.svg)](https://www.jmlr.org/papers/v27/25-1024.html) [![DOI](https://img.shields.io/badge/DOI-10.5281/zenodo.11092033-blue.svg)](https://zenodo.org/doi/10.5281/zenodo.11092033) |

An interface to various automatic differentiation (AD) backends in Julia.

## Goal

This package provides a unified syntax to differentiate functions, including:

- First- and second-order operators (gradients, Jacobians, Hessians and more)
- In-place and out-of-place differentiation
- Preparation mechanism (e.g. to pre-allocate a cache or record a tape)
- Built-in sparsity handling
- Thorough validation on standard inputs and outputs (numbers, vectors, matrices)
- Testing and benchmarking utilities accessible to users with [DifferentiationInterfaceTest](https://github.com/JuliaDiff/DifferentiationInterface.jl/tree/main/DifferentiationInterfaceTest)

## Compatibility

We support the following backends defined by [ADTypes.jl](https://github.com/SciML/ADTypes.jl):

- [ChainRulesCore.jl](https://github.com/JuliaDiff/ChainRulesCore.jl)
- [Diffractor.jl](https://github.com/JuliaDiff/Diffractor.jl) (currently broken)
- [Enzyme.jl](https://github.com/EnzymeAD/Enzyme.jl) (see below)
- [FastDifferentiation.jl](https://github.com/brianguenter/FastDifferentiation.jl)
- [FiniteDiff.jl](https://github.com/JuliaDiff/FiniteDiff.jl)
- [FiniteDifferences.jl](https://github.com/JuliaDiff/FiniteDifferences.jl)
- [ForwardDiff.jl](https://github.com/JuliaDiff/ForwardDiff.jl)
- [HyperHessians.jl](https://github.com/KristofferC/HyperHessians.jl)
- [GTPSA.jl](https://github.com/bmad-sim/GTPSA.jl)
- [Mooncake.jl](https://github.com/chalk-lab/Mooncake.jl)
- [PolyesterForwardDiff.jl](https://github.com/JuliaDiff/PolyesterForwardDiff.jl)
- [ReverseDiff.jl](https://github.com/JuliaDiff/ReverseDiff.jl)
- [Symbolics.jl](https://github.com/JuliaSymbolics/Symbolics.jl)
- [Tracker.jl](https://github.com/FluxML/Tracker.jl)
- [Zygote.jl](https://github.com/FluxML/Zygote.jl)

> [!CAUTION]
> Note that in some cases, going through DifferentiationInterface.jl might be slower or cause more errors than a direct call to the backend's API. This is especially true for Enzyme.jl, whose handling of activities and multiple arguments is not fully supported here. We are working on this challenge, and welcome any suggestions or contributions. Meanwhile, if differentiation fails or takes too long, consider using Enzyme.jl through its [native API](https://enzymead.github.io/Enzyme.jl/stable/) instead.

## Installation

To install the stable version of the package, run the following code in a Julia REPL:

```julia
using Pkg

Pkg.add("DifferentiationInterface")
```

To install the development version, run this instead:

```julia
using Pkg

Pkg.add(;
    url="https://github.com/JuliaDiff/DifferentiationInterface.jl",
    subdir="DifferentiationInterface",
)
```

## Example

```julia
using DifferentiationInterface
using ForwardDiff: ForwardDiff
using Enzyme: Enzyme
using Zygote: Zygote  # AD backends you want to use

f(x) = sum(abs2, x)

x = [1.0, 2.0]

value_and_gradient(f, AutoForwardDiff(), x) # returns (5.0, [2.0, 4.0]) with ForwardDiff.jl
value_and_gradient(f, AutoEnzyme(), x) # returns (5.0, [2.0, 4.0]) with Enzyme.jl
value_and_gradient(f, AutoZygote(), x) # returns (5.0, [2.0, 4.0]) with Zygote.jl
```

To improve your performance by up to several orders of magnitude compared to this example, take a look at the tutorial and its section on operator preparation.

## Citation

Whenever you refer to this package or the ideas it contains, please cite:

 1. our JMLR paper [*A Common Interface for Automatic Differentiation*](https://jmlr.org/papers/v27/25-1024.html);
 2. our inspiration [AbstractDifferentiation.jl](https://github.com/JuliaDiff/AbstractDifferentiation.jl).
 3. if you use sparse differentiation capabilities, our companion packages [SparseConnectivityTracer.jl](https://github.com/adrhill/SparseConnectivityTracer.jl) and [SparseMatrixColorings.jl](https://github.com/JuliaDiff/SparseMatrixColorings.jl) which provide these capabilities (see their respective repositories for guidelines).

For the first two items, you can use the provided [`CITATION.cff`](https://github.com/JuliaDiff/DifferentiationInterface.jl/blob/main/CITATION.cff) file or the following BibTeX entries:

```bibtex
@article{dalle2026commoninterfaceautomaticdifferentiation,
  author  = {Guillaume Dalle and Adrian Hill},
  title   = {A Common Interface for Automatic Differentiation},
  journal = {Journal of Machine Learning Research},
  year    = {2026},
  volume  = {27},
  number  = {25},
  pages   = {1--13},
  url     = {http://jmlr.org/papers/v27/25-1024.html}
}

@misc{schäfer2022abstractdifferentiationjlbackendagnostic,
  title         = {AbstractDifferentiation.jl: Backend-Agnostic Differentiable Programming in Julia},
  author        = {Frank Schäfer and Mohamed Tarek and Lyndon White and Chris Rackauckas},
  year          = {2022},
  eprint        = {2109.12449},
  archiveprefix = {arXiv},
  primaryclass  = {cs.MS},
  url           = {https://arxiv.org/abs/2109.12449}
}
```

If you run the actual software as part of your experiments, please cite the precise [Zenodo DOI](https://zenodo.org/records/11092033) of the package version you used, or the BibTeX entry below:

```bibtex
@software{dalle2024DifferentiationInterface202,
  author    = {Dalle, Guillaume and Hill, Adrian},
  title     = {Differentiation{I}nterface.jl},
  year      = {2024},
  publisher = {Zenodo},
  doi       = {10.5281/zenodo.11092033},
  url       = {https://doi.org/10.5281/zenodo.11092033}
}
```

## Contributors

<!-- ALL-CONTRIBUTORS-LIST:START - Do not remove or modify this section -->
<!-- prettier-ignore-start -->
<!-- markdownlint-disable -->
<table>
  <tbody>
    <tr>
      <td align="center" valign="top" width="14.28%"><a href="https://gdalle.github.io/"><img src="https://avatars.githubusercontent.com/u/22795598?v=4?s=100" width="100px;" alt="Guillaume Dalle"/><br /><sub><b>Guillaume Dalle</b></sub></a><br /><a href="#code-gdalle" title="Code">💻</a> <a href="#doc-gdalle" title="Documentation">📖</a> <a href="#ideas-gdalle" title="Ideas, Planning, & Feedback">🤔</a> <a href="#maintenance-gdalle" title="Maintenance">🚧</a> <a href="#research-gdalle" title="Research">🔬</a> <a href="#review-gdalle" title="Reviewed Pull Requests">👀</a> <a href="#test-gdalle" title="Tests">⚠️</a> <a href="#talk-gdalle" title="Talks">📢</a></td>
      <td align="center" valign="top" width="14.28%"><a href="http://adrianhill.de"><img src="https://avatars.githubusercontent.com/u/20258504?v=4?s=100" width="100px;" alt="Adrian Hill"/><br /><sub><b>Adrian Hill</b></sub></a><br /><a href="#code-adrhill" title="Code">💻</a> <a href="#doc-adrhill" title="Documentation">📖</a> <a href="#ideas-adrhill" title="Ideas, Planning, & Feedback">🤔</a> <a href="#maintenance-adrhill" title="Maintenance">🚧</a> <a href="#research-adrhill" title="Research">🔬</a> <a href="#review-adrhill" title="Reviewed Pull Requests">👀</a> <a href="#test-adrhill" title="Tests">⚠️</a> <a href="#talk-adrhill" title="Talks">📢</a></td>
    </tr>
  </tbody>
</table>

<!-- markdownlint-restore -->
<!-- prettier-ignore-end -->

<!-- ALL-CONTRIBUTORS-LIST:END -->

module DifferentiationInterfaceDiffractorExt

using ADTypes: ADTypes, AutoDiffractor
import DifferentiationInterface as DI
using Diffractor: DiffractorRuleConfig, TaylorTangentIndex, ZeroBundle, bundle, ∂☆

DI.check_available(::AutoDiffractor) = true
DI.inplace_support(::AutoDiffractor) = DI.InPlaceNotSupported()
DI.pullback_performance(::AutoDiffractor) = DI.PullbackSlow()

## Pushforward

function DI.prepare_pushforward_nokwarg(
        strict::Val, f, backend::AutoDiffractor, x, tx::NTuple
    )
    _sig = DI.signature(f, backend, x, tx; strict)
    return DI.NoPushforwardPrep(_sig)
end

function DI.pushforward(
        f, prep::DI.NoPushforwardPrep, backend::AutoDiffractor, x, tx::NTuple
    )
    DI.check_prep(f, prep, backend, x, tx)
    ty = map(tx) do dx
        # code copied from Diffractor.jl
        z = ∂☆{1}()(ZeroBundle{1}(f), bundle(x, dx))
        dy = z[TaylorTangentIndex(1)]
        dy
    end
    return ty
end

function DI.value_and_pushforward(
        f, prep::DI.NoPushforwardPrep, backend::AutoDiffractor, x, tx::NTuple
    )
    DI.check_prep(f, prep, backend, x, tx)
    return f(x), DI.pushforward(f, prep, backend, x, tx)
end

end

"""
    Context

Abstract supertype for additional context arguments, which can be passed to differentiation operators after the active input `x` but are not differentiated.

# Subtypes

  - [`Constant`](@ref)
  - [`Cache`](@ref)
  - [`ConstantOrCache`](@ref)
"""
abstract type Context end

abstract type GeneralizedConstant <: Context end

unwrap(c::Context) = c.data
Base.:(==)(c1::Context, c2::Context) = unwrap(c1) == unwrap(c2)

## Public contexts

"""
    Constant

Concrete type of [`Context`](@ref) argument which is kept constant during differentiation.

Note that an operator can be prepared with an arbitrary value of the constant.
However, same-point preparation must occur with the exact value that will be reused later.

!!! warning

    Some backends require any `Constant` context to be a `Number` or an `AbstractArray`.

# Example

```jldoctest
julia> using DifferentiationInterface

julia> using ForwardDiff: ForwardDiff

julia> f(x, c) = c * sum(abs2, x);

julia> gradient(f, AutoForwardDiff(), [1.0, 2.0], Constant(10))
2-element Vector{Float64}:
 20.0
 40.0

julia> gradient(f, AutoForwardDiff(), [1.0, 2.0], Constant(100))
2-element Vector{Float64}:
 200.0
 400.0
```
"""
struct Constant{T} <: GeneralizedConstant
    data::T
end

constant_maker(c) = Constant(c)
maker(::Constant) = constant_maker
adapt_eltype(c::Constant, ::Type) = c

"""
    Cache

Concrete type of [`Context`](@ref) argument which can be mutated with active values during differentiation.

The initial values present inside the cache do not matter.

For some backends, preparation allocates the required memory for `Cache` contexts with the right element type, similar to [PreallocationTools.jl](https://github.com/SciML/PreallocationTools.jl).

!!! warning

    Some backends require any `Cache` context to be an `AbstractArray`, others accept nested (named) tuples of `AbstractArray`s.

# Example

```jldoctest
julia> using DifferentiationInterface

julia> using ForwardDiff: ForwardDiff

julia> f(x, c) = sum(copyto!(c, x));

julia> prep = prepare_gradient(f, AutoForwardDiff(), [1.0, 2.0], Cache(zeros(2)));

julia> gradient(f, prep, AutoForwardDiff(), [3.0, 4.0], Cache(zeros(2)))
2-element Vector{Float64}:
 1.0
 1.0
```
"""
struct Cache{T} <: Context
    data::T
end

cache_maker(c) = Cache(c)
maker(::Cache) = cache_maker
adapt_eltype(c::Cache, ::Type{T}) where {T} = Cache(recursive_similar(unwrap(c), T))

"""
    ConstantOrCache

Concrete type of [`Context`](@ref) argument which can contain a mixture of constants and caches, passed along to the backend without modification.

Unlike for [`Cache`](@ref), it is up to the user to ensure that the internal storage can adapt to the required element types, for instance by using [PreallocationTools.jl](https://github.com/SciML/PreallocationTools.jl) directly.
"""
struct ConstantOrCache{T} <: Context
    data::T
end

constantorcache_maker(c) = ConstantOrCache(c)
maker(::ConstantOrCache) = constantorcache_maker
adapt_eltype(c::ConstantOrCache, ::Type) = c

## Internal contexts for passing stuff around

"""
    FunctionContext

Private type of [`Context`](@ref) argument used for passing functions inside second-order differentiation.

Behaves differently for Enzyme only, where the function can be annotated.
"""
struct FunctionContext{T} <: GeneralizedConstant
    data::T
end

## Context manipulation

"""
    Rewrap

Utility for recording context types of additional arguments (e.g. `Constant` or `Cache`) and re-wrapping them into their types after they have been unwrapped.

Useful for second-order differentiation.
"""
struct Rewrap{C, T}
    context_makers::T
    function Rewrap(contexts::Vararg{Context, C}) where {C}
        context_makers = map(maker, contexts)
        return new{C, typeof(context_makers)}(context_makers)
    end
end

(::Rewrap{0})() = ()

function (r::Rewrap{C, T})(unannotated_contexts::Vararg{Any, C}) where {C, T}
    return map(r.context_makers, unannotated_contexts) do maker, c
        maker(c)
    end
end

## Closures

"""
    FixTail

Closure around a function `f` and a set of tail argument `tail_args` such that

```
(ft::FixTail)(args...) = ft.f(args..., ft.tail_args...)
```
"""
struct FixTail{F, A <: Tuple}
    f::F
    tail_args::A
    function FixTail(f::F, tail_args::Vararg{Any, N}) where {F, N}
        return new{F, typeof(tail_args)}(f, tail_args)
    end
end

function (ft::FixTail)(args::Vararg{Any, N}) where {N}
    return ft.f(args..., ft.tail_args...)
end

"""
    fix_tail(f, tail_args...)

Convenience for constructing a [`FixTail`](@ref), with a shortcut when there are no tail arguments.
"""
@inline fix_tail(f::F) where {F} = f
fix_tail(f::F, args::Vararg{Any, N}) where {F, N} = FixTail(f, args...)

## Pushforward

struct PolyesterForwardDiffOneArgPushforwardPrep{SIG, P} <: DI.PushforwardPrep{SIG}
    _sig::Val{SIG}
    single_threaded_prep::P
end

function DI.prepare_pushforward_nokwarg(
        strict::Val,
        f,
        backend::AutoPolyesterForwardDiff,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, tx, contexts...; strict)
    single_threaded_prep = DI.prepare_pushforward_nokwarg(
        strict, f, single_threaded(backend), x, tx, contexts...
    )
    return PolyesterForwardDiffOneArgPushforwardPrep(_sig, single_threaded_prep)
end

function DI.value_and_pushforward(
        f,
        prep::PolyesterForwardDiffOneArgPushforwardPrep,
        backend::AutoPolyesterForwardDiff,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    return DI.value_and_pushforward(
        f, prep.single_threaded_prep, single_threaded(backend), x, tx, contexts...
    )
end

function DI.value_and_pushforward!(
        f,
        ty::NTuple,
        prep::PolyesterForwardDiffOneArgPushforwardPrep,
        backend::AutoPolyesterForwardDiff,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    return DI.value_and_pushforward!(
        f, ty, prep.single_threaded_prep, single_threaded(backend), x, tx, contexts...
    )
end

function DI.pushforward(
        f,
        prep::PolyesterForwardDiffOneArgPushforwardPrep,
        backend::AutoPolyesterForwardDiff,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    return DI.pushforward(
        f, prep.single_threaded_prep, single_threaded(backend), x, tx, contexts...
    )
end

function DI.pushforward!(
        f,
        ty::NTuple,
        prep::PolyesterForwardDiffOneArgPushforwardPrep,
        backend::AutoPolyesterForwardDiff,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    return DI.pushforward!(
        f, ty, prep.single_threaded_prep, single_threaded(backend), x, tx, contexts...
    )
end

## Derivative

struct PolyesterForwardDiffOneArgDerivativePrep{SIG, P} <: DI.DerivativePrep{SIG}
    _sig::Val{SIG}
    single_threaded_prep::P
end

function DI.prepare_derivative_nokwarg(
        strict::Val, f, backend::AutoPolyesterForwardDiff, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    single_threaded_prep = DI.prepare_derivative_nokwarg(
        strict, f, single_threaded(backend), x, contexts...
    )
    return PolyesterForwardDiffOneArgDerivativePrep(_sig, single_threaded_prep)
end

function DI.value_and_derivative(
        f,
        prep::PolyesterForwardDiffOneArgDerivativePrep,
        backend::AutoPolyesterForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return DI.value_and_derivative(
        f, prep.single_threaded_prep, single_threaded(backend), x, contexts...
    )
end

function DI.value_and_derivative!(
        f,
        der,
        prep::PolyesterForwardDiffOneArgDerivativePrep,
        backend::AutoPolyesterForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return DI.value_and_derivative!(
        f, der, prep.single_threaded_prep, single_threaded(backend), x, contexts...
    )
end

function DI.derivative(
        f,
        prep::PolyesterForwardDiffOneArgDerivativePrep,
        backend::AutoPolyesterForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return DI.derivative(
        f, prep.single_threaded_prep, single_threaded(backend), x, contexts...
    )
end

function DI.derivative!(
        f,
        der,
        prep::PolyesterForwardDiffOneArgDerivativePrep,
        backend::AutoPolyesterForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return DI.derivative!(
        f, der, prep.single_threaded_prep, single_threaded(backend), x, contexts...
    )
end

## Gradient

struct PolyesterForwardDiffGradientPrep{SIG, chunksize, P} <: DI.GradientPrep{SIG}
    _sig::Val{SIG}
    chunk::Chunk{chunksize}
    single_threaded_prep::P
end

function DI.prepare_gradient_nokwarg(
        strict::Val,
        f,
        backend::AutoPolyesterForwardDiff{chunksize},
        x,
        contexts::Vararg{DI.Context, C}
    ) where {chunksize, C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    if isnothing(chunksize)
        chunk = Chunk(x)
    else
        chunk = Chunk{chunksize}()
    end
    single_threaded_prep = DI.prepare_gradient_nokwarg(
        strict, f, single_threaded(backend), x, contexts...
    )
    return PolyesterForwardDiffGradientPrep(_sig, chunk, single_threaded_prep)
end

function DI.value_and_gradient!(
        f,
        grad,
        prep::PolyesterForwardDiffGradientPrep,
        backend::AutoPolyesterForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    if contexts isa NTuple{C, DI.GeneralizedConstant}
        fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
        threaded_gradient!(fc, grad, x, prep.chunk)
        return fc(x), grad
    else
        # TODO: optimize
        return DI.value_and_gradient!(
            f, grad, prep.single_threaded_prep, single_threaded(backend), x, contexts...
        )
    end
end

function DI.gradient!(
        f,
        grad,
        prep::PolyesterForwardDiffGradientPrep,
        backend::AutoPolyesterForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    if contexts isa NTuple{C, DI.GeneralizedConstant}
        fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
        threaded_gradient!(fc, grad, x, prep.chunk)
        return grad
    else
        # TODO: optimize
        return DI.gradient!(
            f, grad, prep.single_threaded_prep, single_threaded(backend), x, contexts...
        )
    end
end

function DI.value_and_gradient(
        f,
        prep::PolyesterForwardDiffGradientPrep,
        backend::AutoPolyesterForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return DI.value_and_gradient!(f, similar(x), prep, backend, x, contexts...)
end

function DI.gradient(
        f,
        prep::PolyesterForwardDiffGradientPrep,
        backend::AutoPolyesterForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return DI.gradient!(f, similar(x), prep, backend, x, contexts...)
end

## Jacobian

struct PolyesterForwardDiffOneArgJacobianPrep{SIG, chunksize, P} <: DI.JacobianPrep{SIG}
    _sig::Val{SIG}
    chunk::Chunk{chunksize}
    single_threaded_prep::P
end

function DI.prepare_jacobian_nokwarg(
        strict::Val,
        f,
        backend::AutoPolyesterForwardDiff{chunksize},
        x,
        contexts::Vararg{DI.Context, C}
    ) where {chunksize, C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    if isnothing(chunksize)
        chunk = Chunk(x)
    else
        chunk = Chunk{chunksize}()
    end
    single_threaded_prep = DI.prepare_jacobian_nokwarg(
        strict, f, single_threaded(backend), x, contexts...
    )
    return PolyesterForwardDiffOneArgJacobianPrep(_sig, chunk, single_threaded_prep)
end

function DI.value_and_jacobian!(
        f,
        jac,
        prep::PolyesterForwardDiffOneArgJacobianPrep,
        backend::AutoPolyesterForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    if contexts isa NTuple{C, DI.GeneralizedConstant}
        fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
        return fc(x), threaded_jacobian!(fc, jac, x, prep.chunk)
    else
        return DI.value_and_jacobian!(
            f, jac, prep.single_threaded_prep, single_threaded(backend), x, contexts...
        )
    end
end

function DI.jacobian!(
        f,
        jac,
        prep::PolyesterForwardDiffOneArgJacobianPrep,
        backend::AutoPolyesterForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    if contexts isa NTuple{C, DI.GeneralizedConstant}
        fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
        return threaded_jacobian!(fc, jac, x, prep.chunk)
    else
        return DI.jacobian!(
            f, jac, prep.single_threaded_prep, single_threaded(backend), x, contexts...
        )
    end
end

function DI.value_and_jacobian(
        f,
        prep::PolyesterForwardDiffOneArgJacobianPrep,
        backend::AutoPolyesterForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    y = f(x, map(DI.unwrap, contexts)...)
    jac = similar(y, length(y), length(x))
    return DI.value_and_jacobian!(f, jac, prep, backend, x, contexts...)
end

function DI.jacobian(
        f,
        prep::PolyesterForwardDiffOneArgJacobianPrep,
        backend::AutoPolyesterForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    y = f(x, map(DI.unwrap, contexts)...)
    jac = similar(y, length(y), length(x))
    return DI.jacobian!(f, jac, prep, backend, x, contexts...)
end

## Hessian

struct PolyesterForwardDiffHessianPrep{SIG, P} <: DI.HessianPrep{SIG}
    _sig::Val{SIG}
    single_threaded_prep::P
end

function DI.prepare_hessian_nokwarg(
        strict::Val, f, backend::AutoPolyesterForwardDiff, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    single_threaded_prep = DI.prepare_hessian_nokwarg(
        strict, f, single_threaded(backend), x, contexts...
    )
    return PolyesterForwardDiffHessianPrep(_sig, single_threaded_prep)
end

function DI.hessian(
        f,
        prep::PolyesterForwardDiffHessianPrep,
        backend::AutoPolyesterForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return DI.hessian(
        f, prep.single_threaded_prep, single_threaded(backend), x, contexts...
    )
end

function DI.hessian!(
        f,
        hess,
        prep::PolyesterForwardDiffHessianPrep,
        backend::AutoPolyesterForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return DI.hessian!(
        f, hess, prep.single_threaded_prep, single_threaded(backend), x, contexts...
    )
end

function DI.value_gradient_and_hessian(
        f,
        prep::PolyesterForwardDiffHessianPrep,
        backend::AutoPolyesterForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return DI.value_gradient_and_hessian(
        f, prep.single_threaded_prep, single_threaded(backend), x, contexts...
    )
end

function DI.value_gradient_and_hessian!(
        f,
        grad,
        hess,
        prep::PolyesterForwardDiffHessianPrep,
        backend::AutoPolyesterForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return DI.value_gradient_and_hessian!(
        f, grad, hess, prep.single_threaded_prep, single_threaded(backend), x, contexts...
    )
end

## Second derivative

struct PolyesterForwardDiffOneArgSecondDerivativePrep{SIG, P} <: DI.SecondDerivativePrep{SIG}
    _sig::Val{SIG}
    single_threaded_prep::P
end

function DI.prepare_second_derivative_nokwarg(
        strict::Val, f, backend::AutoPolyesterForwardDiff, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    single_threaded_prep = DI.prepare_second_derivative_nokwarg(
        strict, f, single_threaded(backend), x, contexts...
    )
    return PolyesterForwardDiffOneArgSecondDerivativePrep(_sig, single_threaded_prep)
end

function DI.value_derivative_and_second_derivative(
        f,
        prep::PolyesterForwardDiffOneArgSecondDerivativePrep,
        backend::AutoPolyesterForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return DI.value_derivative_and_second_derivative(
        f, prep.single_threaded_prep, single_threaded(backend), x, contexts...
    )
end

function DI.value_derivative_and_second_derivative!(
        f,
        der,
        der2,
        prep::PolyesterForwardDiffOneArgSecondDerivativePrep,
        backend::AutoPolyesterForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return DI.value_derivative_and_second_derivative!(
        f, der, der2, prep.single_threaded_prep, single_threaded(backend), x, contexts...
    )
end

function DI.second_derivative(
        f,
        prep::PolyesterForwardDiffOneArgSecondDerivativePrep,
        backend::AutoPolyesterForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return DI.second_derivative(
        f, prep.single_threaded_prep, single_threaded(backend), x, contexts...
    )
end

function DI.second_derivative!(
        f,
        der2,
        prep::PolyesterForwardDiffOneArgSecondDerivativePrep,
        backend::AutoPolyesterForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return DI.second_derivative!(
        f, der2, prep.single_threaded_prep, single_threaded(backend), x, contexts...
    )
end

"""
    AutoSimpleFiniteDiff <: ADTypes.AbstractADType

Forward mode backend based on the finite difference `(f(x + ε) - f(x)) / ε`, with artificial chunk size to mimick ForwardDiff.

# Constructor

    AutoSimpleFiniteDiff(ε=1e-5; chunksize=nothing)
"""
struct AutoSimpleFiniteDiff{chunksize, T <: Real} <: AbstractADType
    ε::T
end

function AutoSimpleFiniteDiff(ε = 1.0e-5; chunksize = nothing)
    return AutoSimpleFiniteDiff{chunksize, typeof(ε)}(ε)
end

ADTypes.mode(::AutoSimpleFiniteDiff) = ForwardMode()
check_available(::AutoSimpleFiniteDiff) = true
inplace_support(::AutoSimpleFiniteDiff) = InPlaceSupported()
inner_preparation_behavior(::AutoSimpleFiniteDiff) = PrepareInnerSimple()

function pick_batchsize(::AutoSimpleFiniteDiff{nothing}, N::Integer)
    B = reasonable_batchsize(N, 12)
    return BatchSizeSettings{B}(N)
end

function pick_batchsize(::AutoSimpleFiniteDiff{chunksize}, N::Integer) where {chunksize}
    return BatchSizeSettings{chunksize}(N)
end

function threshold_batchsize(
        backend::AutoSimpleFiniteDiff{chunksize1}, chunksize2::Integer
    ) where {chunksize1}
    chunksize = isnothing(chunksize1) ? nothing : min(chunksize1, chunksize2)
    return AutoSimpleFiniteDiff(backend.ε; chunksize)
end

function prepare_pushforward_nokwarg(
        strict::Val,
        f::F,
        backend::AutoSimpleFiniteDiff,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C}
    ) where {F, C}
    _sig = signature(f, backend, x, tx, contexts...; strict)
    return NoPushforwardPrep(_sig)
end

function prepare_pushforward_nokwarg(
        strict::Val,
        f!::F,
        y,
        backend::AutoSimpleFiniteDiff,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C}
    ) where {F, C}
    _sig = signature(f!, y, backend, x, tx, contexts...; strict)
    return NoPushforwardPrep(_sig)
end

function value_and_pushforward(
        f::F,
        prep::NoPushforwardPrep,
        backend::AutoSimpleFiniteDiff,
        x,
        tx::NTuple{B},
        contexts::Vararg{Context, C},
    ) where {F, B, C}
    check_prep(f, prep, backend, x, tx, contexts...)
    ε = eltype(x)(backend.ε)
    y = f(x, map(unwrap, contexts)...)
    ty = map(tx) do dx
        y1 = f(x + ε * dx, map(unwrap, contexts)...)
        y0 = f(x - ε * dx, map(unwrap, contexts)...)
        (y1 - y0) / 2ε
    end
    return y, ty
end

function value_and_pushforward(
        f!::F,
        y,
        prep::NoPushforwardPrep,
        backend::AutoSimpleFiniteDiff,
        x,
        tx::NTuple{B},
        contexts::Vararg{Context, C},
    ) where {F, B, C}
    check_prep(f!, y, prep, backend, x, tx, contexts...)
    ε = eltype(x)(backend.ε)
    ty = map(tx) do dx
        f!(y, x + ε * dx, map(unwrap, contexts)...)
        y1 = copy(y)
        f!(y, x - ε * dx, map(unwrap, contexts)...)
        y0 = copy(y)
        (y1 - y0) / 2ε
    end
    f!(y, x, map(unwrap, contexts)...)
    return y, ty
end

## Pushforward

struct FiniteDiffOneArgPushforwardPrep{SIG, C, R, A, D} <: DI.PushforwardPrep{SIG}
    _sig::Val{SIG}
    cache::C
    relstep::R
    absstep::A
    dir::D
end

function DI.prepare_pushforward_nokwarg(
        strict::Val, f, backend::AutoFiniteDiff, x, tx::NTuple, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, tx, contexts...; strict)
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    y = fc(x)
    cache = if x isa Number || y isa Number
        nothing
    else
        JVPCache(similar(x), y, fdtype(backend))
    end
    relstep = if isnothing(backend.relstep)
        default_relstep(fdtype(backend), eltype(x))
    else
        backend.relstep
    end
    absstep = if isnothing(backend.absstep)
        relstep
    else
        backend.absstep
    end
    dir = backend.dir
    return FiniteDiffOneArgPushforwardPrep(_sig, cache, relstep, absstep, dir)
end

function DI.pushforward(
        f,
        prep::FiniteDiffOneArgPushforwardPrep{SIG, Nothing},
        backend::AutoFiniteDiff,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {SIG, C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    (; relstep, absstep, dir) = prep
    step(t::Number, dx) = f(x .+ t .* dx, map(DI.unwrap, contexts)...)
    ty = map(tx) do dx
        finite_difference_derivative(
            Base.Fix2(step, dx), zero(eltype(x)), fdtype(backend); relstep, absstep, dir
        )
    end
    return ty
end

function DI.value_and_pushforward(
        f,
        prep::FiniteDiffOneArgPushforwardPrep{SIG, Nothing},
        backend::AutoFiniteDiff,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {SIG, C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    (; relstep, absstep, dir) = prep
    step(t::Number, dx) = f(x .+ t .* dx, map(DI.unwrap, contexts)...)
    y = f(x, map(DI.unwrap, contexts)...)
    ty = map(tx) do dx
        finite_difference_derivative(
            Base.Fix2(step, dx),
            zero(eltype(x)),
            fdtype(backend),
            eltype(y),
            y;
            relstep,
            absstep,
            dir,
        )
    end
    return y, ty
end

function DI.pushforward(
        f,
        prep::FiniteDiffOneArgPushforwardPrep{SIG, <:JVPCache},
        backend::AutoFiniteDiff,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {SIG, C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    (; relstep, absstep, dir) = prep
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    ty = map(tx) do dx
        finite_difference_jvp(fc, x, dx, prep.cache; relstep, absstep, dir)
    end
    return ty
end

function DI.value_and_pushforward(
        f,
        prep::FiniteDiffOneArgPushforwardPrep{SIG, <:JVPCache},
        backend::AutoFiniteDiff,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {SIG, C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    (; relstep, absstep, dir) = prep
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    y = fc(x)
    ty = map(tx) do dx
        finite_difference_jvp(fc, x, dx, prep.cache, y; relstep, absstep, dir)
    end
    return y, ty
end

## Derivative

struct FiniteDiffOneArgDerivativePrep{SIG, C, R, A, D} <: DI.DerivativePrep{SIG}
    _sig::Val{SIG}
    cache::C
    relstep::R
    absstep::A
    dir::D
end

function DI.prepare_derivative_nokwarg(
        strict::Val, f, backend::AutoFiniteDiff, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    y = fc(x)
    cache = if y isa Number
        nothing
    elseif y isa AbstractArray
        df = similar(y)
        cache = GradientCache(df, x, fdtype(backend), eltype(y), FUNCTION_NOT_INPLACE)
    end
    relstep = if isnothing(backend.relstep)
        default_relstep(fdtype(backend), eltype(x))
    else
        backend.relstep
    end
    absstep = if isnothing(backend.absstep)
        relstep
    else
        backend.absstep
    end
    dir = backend.dir
    return FiniteDiffOneArgDerivativePrep(_sig, cache, relstep, absstep, dir)
end

### Scalar to scalar

function DI.derivative(
        f,
        prep::FiniteDiffOneArgDerivativePrep{SIG, Nothing},
        backend::AutoFiniteDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {SIG, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    (; relstep, absstep, dir) = prep
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    return finite_difference_derivative(fc, x, fdtype(backend); relstep, absstep, dir)
end

function DI.value_and_derivative(
        f,
        prep::FiniteDiffOneArgDerivativePrep{SIG, Nothing},
        backend::AutoFiniteDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {SIG, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    (; relstep, absstep, dir) = prep
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    y = fc(x)
    return (
        y,
        finite_difference_derivative(
            fc, x, fdtype(backend), eltype(y), y; relstep, absstep, dir
        ),
    )
end

### Scalar to array

function DI.derivative(
        f,
        prep::FiniteDiffOneArgDerivativePrep{SIG, <:GradientCache},
        backend::AutoFiniteDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {SIG, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    (; relstep, absstep, dir) = prep
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    return finite_difference_gradient(fc, x, prep.cache; relstep, absstep, dir)
end

function DI.derivative!(
        f,
        der,
        prep::FiniteDiffOneArgDerivativePrep{SIG, <:GradientCache},
        backend::AutoFiniteDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {SIG, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    (; relstep, absstep, dir) = prep
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    return finite_difference_gradient!(der, fc, x, prep.cache; relstep, absstep, dir)
end

function DI.value_and_derivative(
        f,
        prep::FiniteDiffOneArgDerivativePrep{SIG, <:GradientCache},
        backend::AutoFiniteDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {SIG, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    (; relstep, absstep, dir) = prep
    y = fc(x)
    return (y, finite_difference_gradient(fc, x, prep.cache; relstep, absstep, dir))
end

function DI.value_and_derivative!(
        f,
        der,
        prep::FiniteDiffOneArgDerivativePrep{SIG, <:GradientCache},
        backend::AutoFiniteDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {SIG, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    (; relstep, absstep, dir) = prep
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    return (
        fc(x), finite_difference_gradient!(der, fc, x, prep.cache; relstep, absstep, dir),
    )
end

## Gradient

struct FiniteDiffGradientPrep{SIG, C, R, A, D} <: DI.GradientPrep{SIG}
    _sig::Val{SIG}
    cache::C
    relstep::R
    absstep::A
    dir::D
end

function DI.prepare_gradient_nokwarg(
        strict::Val, f, backend::AutoFiniteDiff, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    y = fc(x)
    df = zero(y) .* x
    cache = GradientCache(df, x, fdtype(backend))
    relstep = if isnothing(backend.relstep)
        default_relstep(fdtype(backend), eltype(x))
    else
        backend.relstep
    end
    absstep = if isnothing(backend.absstep)
        relstep
    else
        backend.absstep
    end
    dir = backend.dir
    return FiniteDiffGradientPrep(_sig, cache, relstep, absstep, dir)
end

function DI.gradient(
        f,
        prep::FiniteDiffGradientPrep,
        backend::AutoFiniteDiff,
        x::AbstractArray,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    (; relstep, absstep, dir) = prep
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    return finite_difference_gradient(fc, x, prep.cache; relstep, absstep, dir)
end

function DI.value_and_gradient(
        f,
        prep::FiniteDiffGradientPrep,
        backend::AutoFiniteDiff,
        x::AbstractArray,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    (; relstep, absstep, dir) = prep
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    return fc(x), finite_difference_gradient(fc, x, prep.cache; relstep, absstep, dir)
end

function DI.gradient!(
        f,
        grad,
        prep::FiniteDiffGradientPrep,
        backend::AutoFiniteDiff,
        x::AbstractArray,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    (; relstep, absstep, dir) = prep
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    return finite_difference_gradient!(grad, fc, x, prep.cache; relstep, absstep, dir)
end

function DI.value_and_gradient!(
        f,
        grad,
        prep::FiniteDiffGradientPrep,
        backend::AutoFiniteDiff,
        x::AbstractArray,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    (; relstep, absstep, dir) = prep
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    return (
        fc(x), finite_difference_gradient!(grad, fc, x, prep.cache; relstep, absstep, dir),
    )
end

## Jacobian

struct FiniteDiffOneArgJacobianPrep{SIG, C, R, A, D} <: DI.JacobianPrep{SIG}
    _sig::Val{SIG}
    cache::C
    relstep::R
    absstep::A
    dir::D
end

function DI.prepare_jacobian_nokwarg(
        strict::Val, f, backend::AutoFiniteDiff, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    y = fc(x)
    x1 = similar(x)
    fx = similar(y)
    fx1 = similar(y)
    cache = JacobianCache(x1, fx, fx1, fdjtype(backend))
    relstep = if isnothing(backend.relstep)
        default_relstep(fdjtype(backend), eltype(x))
    else
        backend.relstep
    end
    absstep = if isnothing(backend.absstep)
        relstep
    else
        backend.absstep
    end
    dir = backend.dir
    return FiniteDiffOneArgJacobianPrep(_sig, cache, relstep, absstep, dir)
end

function DI.jacobian(
        f,
        prep::FiniteDiffOneArgJacobianPrep,
        backend::AutoFiniteDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    (; relstep, absstep, dir) = prep
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    return finite_difference_jacobian(fc, x, prep.cache; relstep, absstep, dir)
end

function DI.value_and_jacobian(
        f,
        prep::FiniteDiffOneArgJacobianPrep,
        backend::AutoFiniteDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    (; relstep, absstep, dir) = prep
    y = fc(x)
    return (y, finite_difference_jacobian(fc, x, prep.cache, y; relstep, absstep, dir))
end

function DI.jacobian!(
        f,
        jac,
        prep::FiniteDiffOneArgJacobianPrep,
        backend::AutoFiniteDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    (; relstep, absstep, dir) = prep
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    return copyto!(
        jac,
        finite_difference_jacobian(
            fc, x, prep.cache; jac_prototype = jac, relstep, absstep, dir
        ),
    )
end

function DI.value_and_jacobian!(
        f,
        jac,
        prep::FiniteDiffOneArgJacobianPrep,
        backend::AutoFiniteDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    (; relstep, absstep, dir) = prep
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    y = fc(x)
    return (
        y,
        copyto!(
            jac,
            finite_difference_jacobian(
                fc, x, prep.cache, y; jac_prototype = jac, relstep, absstep, dir
            ),
        ),
    )
end

## Hessian

struct FiniteDiffHessianPrep{SIG, C1, C2, RG, AG, RH, AH} <: DI.HessianPrep{SIG}
    _sig::Val{SIG}
    gradient_cache::C1
    hessian_cache::C2
    relstep_g::RG
    absstep_g::AG
    relstep_h::RH
    absstep_h::AH
end

function DI.prepare_hessian_nokwarg(
        strict::Val, f, backend::AutoFiniteDiff, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    y = fc(x)
    df = zero(y) .* x
    gradient_cache = GradientCache(df, x, fdtype(backend))
    hessian_cache = HessianCache(x, fdhtype(backend))
    relstep_g = if isnothing(backend.relstep)
        default_relstep(fdtype(backend), eltype(x))
    else
        backend.relstep
    end
    relstep_h = if isnothing(backend.relstep)
        default_relstep(fdhtype(backend), eltype(x))
    else
        backend.relstep
    end
    absstep_g = if isnothing(backend.absstep)
        relstep_g
    else
        backend.absstep
    end
    absstep_h = if isnothing(backend.absstep)
        relstep_h
    else
        backend.absstep
    end
    return FiniteDiffHessianPrep(
        _sig, gradient_cache, hessian_cache, relstep_g, absstep_g, relstep_h, absstep_h
    )
end

function DI.hessian(
        f,
        prep::FiniteDiffHessianPrep,
        backend::AutoFiniteDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    (; relstep_h, absstep_h) = prep
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    return finite_difference_hessian(
        fc, x, prep.hessian_cache; relstep = relstep_h, absstep = absstep_h
    )
end

function DI.hessian!(
        f,
        hess,
        prep::FiniteDiffHessianPrep,
        backend::AutoFiniteDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    (; relstep_h, absstep_h) = prep
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    return finite_difference_hessian!(
        hess, fc, x, prep.hessian_cache; relstep = relstep_h, absstep = absstep_h
    )
end

function DI.value_gradient_and_hessian(
        f,
        prep::FiniteDiffHessianPrep,
        backend::AutoFiniteDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    (; relstep_g, absstep_g, relstep_h, absstep_h) = prep
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    grad = finite_difference_gradient(
        fc, x, prep.gradient_cache; relstep = relstep_g, absstep = absstep_g
    )
    hess = finite_difference_hessian(
        fc, x, prep.hessian_cache; relstep = relstep_h, absstep = absstep_h
    )
    return fc(x), grad, hess
end

function DI.value_gradient_and_hessian!(
        f,
        grad,
        hess,
        prep::FiniteDiffHessianPrep,
        backend::AutoFiniteDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    (; relstep_g, absstep_g, relstep_h, absstep_h) = prep
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    finite_difference_gradient!(
        grad, fc, x, prep.gradient_cache; relstep = relstep_g, absstep = absstep_g
    )
    finite_difference_hessian!(
        hess, fc, x, prep.hessian_cache; relstep = relstep_h, absstep = absstep_h
    )
    return fc(x), grad, hess
end

include("../../testutils.jl")

using ADTypes: jacobian_sparsity, hessian_sparsity
using DifferentiationInterface
using ForwardDiff: ForwardDiff
using ReverseDiff: ReverseDiff
using LinearAlgebra
using SparseArrays
using StableRNGs
using Test

rng = StableRNG(63)

const Jc = sprand(rng, Bool, 10, 20, 0.3)
const Hc = sparse(Symmetric(sprand(rng, Bool, 20, 20, 0.3)))

f(x::AbstractVector) = Jc * x
f(x::AbstractMatrix) = reshape(f(vec(x)), (5, 2))

function f!(y, x)
    y .= f(x)
    return nothing
end

g(x::AbstractVector) = dot(x, Hc, x)
g(x::AbstractMatrix) = g(vec(x))

@testset verbose = true "$(typeof(backend))" for backend in
    [AutoForwardDiff(), AutoReverseDiff()]
    @test_throws ArgumentError DenseSparsityDetector(backend; atol = 1.0e-5, method = :random)
    @testset "$method" for method in (:iterative, :direct)
        detector = DenseSparsityDetector(backend; atol = 1.0e-5, method)
        string(detector)
        for (x, y) in ((rand(20), zeros(10)), (rand(2, 10), zeros(5, 2)))
            @test Jc == jacobian_sparsity(f, x, detector)
            @test Jc == jacobian_sparsity(f!, copy(y), x, detector)
        end
        for x in (rand(20), rand(2, 10))
            @test Hc == hessian_sparsity(g, x, detector)
        end
    end
end

using DifferentiationInterface
using DifferentiationInterface: AutoZeroForward, AutoZeroReverse
using DifferentiationInterfaceTest
using LinearAlgebra
using ComponentArrays: ComponentArrays
using JLArrays: JLArrays
using SparseMatrixColorings
using StaticArrays: StaticArrays
using Test
using JET

zero_backends = [AutoZeroForward(), AutoZeroReverse()]

for backend in zero_backends
    @test check_available(backend)
    @test check_inplace(backend)
end

@testset "Type stability" begin
    test_differentiation(
        [
            AutoZeroForward(),
            AutoZeroReverse(),
            SecondOrder(AutoZeroForward(), AutoZeroReverse()),
            SecondOrder(AutoZeroReverse(), AutoZeroForward()),
        ],
        default_scenarios(; include_batchified = false, include_constantified = true);
        correctness = false,
        type_stability = safetypestab(:full),
        logging = LOGGING,
    )

    test_differentiation(
        AutoSparse.(zero_backends, coloring_algorithm = GreedyColoringAlgorithm()),
        default_scenarios(; include_constantified = true);
        correctness = false,
        type_stability = safetypestab(:full),
        excluded = [
            :pushforward, :pullback, :gradient, :derivative, :hvp, :second_derivative,
        ],
        logging = LOGGING,
    )
end

@testset "Weird arrays" begin
    test_differentiation(
        [AutoZeroForward(), AutoZeroReverse()],
        zero.(vcat(component_scenarios(), static_scenarios(), gpu_scenarios()));
        correctness = true,
        logging = LOGGING,
    )
end

@testset "Empty arrays" begin
    test_differentiation(
        [AutoZeroForward(), AutoZeroReverse()], empty_scenarios(); excluded = [:jacobian]
    )
end;

include("../../testutils.jl")

using ADTypes: ADTypes
using ComponentArrays: ComponentArrays
using DifferentiationInterface, DifferentiationInterfaceTest
import DifferentiationInterface as DI
import DifferentiationInterfaceTest as DIT
using ForwardDiff: ForwardDiff
using StaticArrays: StaticArrays, @SVector
using JLArrays: JLArrays
using Test
import JET, Chairmarks

using ExplicitImports
check_no_implicit_imports(DifferentiationInterface)

struct MyTag end

backends = [
    AutoForwardDiff(),
    AutoForwardDiff(; chunksize = 5),
    AutoForwardDiff(; tag = ForwardDiff.Tag(MyTag(), Float64)),
]

for backend in backends
    @test check_available(backend)
    @test check_inplace(backend)
    test_counterparts(backend)
end

@testset "Dense" begin
    test_differentiation(
        backends, default_scenarios(; include_constantified = true); logging = LOGGING
    )

    test_differentiation(
        AutoForwardDiff(),
        default_scenarios(;
            include_normal = false,
            include_batchified = false,
            include_cachified = true,
            include_constantorcachified = true,
            use_tuples = true,
            include_smaller = true,
        );
        logging = LOGGING,
    )

    test_differentiation(
        AutoForwardDiff();
        correctness = false,
        type_stability = safetypestab(:prepared),
        logging = LOGGING,
    )

    test_differentiation(
        AutoForwardDiff(; chunksize = 5);
        correctness = false,
        type_stability = safetypestab(:full),
        excluded = [:hessian],
        logging = LOGGING,
    )
end

@testset "Sparse" begin
    test_differentiation(
        MyAutoSparse(AutoForwardDiff()), default_scenarios(); logging = LOGGING
    )

    test_differentiation(
        MyAutoSparse(AutoForwardDiff()),
        sparse_scenarios(; include_constantified = true);
        sparsity = true,
        logging = LOGGING,
    )
end

@testset "Weird" begin
    test_differentiation(AutoForwardDiff(), component_scenarios(); logging = LOGGING)
    test_differentiation(AutoForwardDiff(), static_scenarios(); logging = LOGGING)
    test_differentiation(
        DI.AutoForwardFromPrimitive(AutoForwardDiff()), gpu_scenarios(); logging = LOGGING
    )

    @testset "Batch size" begin
        @test DI.pick_batchsize(AutoForwardDiff(), rand(7)) isa DI.BatchSizeSettings{7}
        @test DI.pick_batchsize(AutoForwardDiff(; chunksize = 5), rand(7)) isa
            DI.BatchSizeSettings{5}
        @test (@inferred DI.pick_batchsize(AutoForwardDiff(), @SVector(rand(7)))) isa
            DI.BatchSizeSettings{7}
        @test (
            @inferred DI.pick_batchsize(
                AutoForwardDiff(; chunksize = 5), @SVector(rand(7))
            )
        ) isa DI.BatchSizeSettings{5}
    end
end

@testset verbose = true "Overloaded inputs" begin
    backend = AutoForwardDiff()
    sparse_backend = MyAutoSparse(AutoForwardDiff())

    # Derivative
    x = 1.0
    y = [1.0, 1.0]
    @test DI.overloaded_input_type(prepare_derivative(copy, backend, x)) ==
        ForwardDiff.Dual{ForwardDiff.Tag{typeof(copy), Float64}, Float64, 1}
    @test DI.overloaded_input_type(prepare_derivative(copyto!, y, backend, x)) ==
        ForwardDiff.Dual{ForwardDiff.Tag{typeof(copyto!), Float64}, Float64, 1}

    # Gradient
    x = [1.0, 1.0]
    @test DI.overloaded_input_type(prepare_gradient(sum, backend, x)) ==
        Vector{ForwardDiff.Dual{ForwardDiff.Tag{typeof(sum), Float64}, Float64, 2}}

    # Jacobian
    x = [1.0, 0.0, 0.0]
    @test DI.overloaded_input_type(prepare_jacobian(copy, backend, x)) ==
        Vector{ForwardDiff.Dual{ForwardDiff.Tag{typeof(copy), Float64}, Float64, 3}}
    @test DI.overloaded_input_type(prepare_jacobian(copyto!, similar(x), backend, x)) ==
        Vector{ForwardDiff.Dual{ForwardDiff.Tag{typeof(copyto!), Float64}, Float64, 3}}
    @test DI.overloaded_input_type(
        prepare_jacobian(copyto!, similar(x), sparse_backend, x)
    ) == Vector{ForwardDiff.Dual{ForwardDiff.Tag{typeof(copyto!), Float64}, Float64, 1}}
    # Jacobian with one-element input
    @test DI.overloaded_input_type(prepare_jacobian(copy, backend, [1.0])) ==
        Vector{ForwardDiff.Dual{ForwardDiff.Tag{typeof(copy), Float64}, Float64, 1}}
end;

include("benchmark.jl")

macro public(ex)
    return if VERSION >= v"1.11.0-DEV.469"
        args = if ex isa Symbol
            (ex,)
        elseif Base.isexpr(ex, :tuple)
            ex.args
        else
            error("Expected a symbol or a tuple of symbols, got $(repr(ex))")
        end
        esc(Expr(:public, args...))
    else
        nothing
    end
end

## Pullback

struct MooncakeOneArgPullbackPrep{SIG, Tcache, N} <: DI.PullbackPrep{SIG}
    _sig::Val{SIG}
    cache::Tcache
    args_to_zero::NTuple{N, Bool}
end

function DI.prepare_pullback_nokwarg(
        strict::Val, f::F, backend::AutoMooncake, x, ty::NTuple, contexts::Vararg{DI.Context, C}
    ) where {F, C}
    _sig = DI.signature(f, backend, x, ty, contexts...; strict)
    config = get_config(backend)
    cache = prepare_pullback_cache(f, x, map(DI.unwrap, contexts)...; config)
    contexts_tup_true_except_cache = map(c -> !(c isa DI.Cache), contexts)
    args_to_zero = (
        true,  # f
        true,  # x
        contexts_tup_true_except_cache...,
    )
    prep = MooncakeOneArgPullbackPrep(_sig, cache, args_to_zero)
    return prep
end

function DI.value_and_pullback(
        f::F,
        prep::MooncakeOneArgPullbackPrep{Y},
        backend::AutoMooncake,
        x,
        ty::NTuple{1},
        contexts::Vararg{DI.Context, C},
    ) where {F, Y, C}
    DI.check_prep(f, prep, backend, x, ty, contexts...)
    dy = only(ty)
    new_y, (_, new_dx) = value_and_pullback!!(
        prep.cache, dy, f, x, map(DI.unwrap, contexts)...; prep.args_to_zero
    )
    return new_y, (_copy_output(new_dx),)
end

function DI.value_and_pullback(
        f::F,
        prep::MooncakeOneArgPullbackPrep{Y},
        backend::AutoMooncake,
        x,
        ty::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {F, Y, C}
    DI.check_prep(f, prep, backend, x, ty, contexts...)
    ys_and_tx = map(ty) do dy
        y, (_, new_dx) = value_and_pullback!!(
            prep.cache, dy, f, x, map(DI.unwrap, contexts)...; prep.args_to_zero
        )
        y, _copy_output(new_dx)
    end
    y = first(ys_and_tx[1])
    tx = map(last, ys_and_tx)
    return y, tx
end

function DI.value_and_pullback!(
        f::F,
        tx::NTuple,
        prep::MooncakeOneArgPullbackPrep,
        backend::AutoMooncake,
        x,
        ty::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, ty, contexts...)
    y, new_tx = DI.value_and_pullback(f, prep, backend, x, ty, contexts...)
    foreach(copyto!, tx, new_tx)
    return y, tx
end

function DI.pullback(
        f::F,
        prep::MooncakeOneArgPullbackPrep,
        backend::AutoMooncake,
        x,
        ty::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, ty, contexts...)
    return DI.value_and_pullback(f, prep, backend, x, ty, contexts...)[2]
end

function DI.pullback!(
        f::F,
        tx::NTuple,
        prep::MooncakeOneArgPullbackPrep,
        backend::AutoMooncake,
        x,
        ty::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, ty, contexts...)
    return DI.value_and_pullback!(f, tx, prep, backend, x, ty, contexts...)[2]
end

## Gradient

struct MooncakeGradientPrep{SIG, Tcache, N} <: DI.GradientPrep{SIG}
    _sig::Val{SIG}
    cache::Tcache
    args_to_zero::NTuple{N, Bool}
end

function DI.prepare_gradient_nokwarg(
        strict::Val, f::F, backend::AutoMooncake, x, contexts::Vararg{DI.Context, C}
    ) where {F, C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    config = get_config(backend)
    cache = prepare_gradient_cache(f, x, map(DI.unwrap, contexts)...; config)
    contexts_tup_true_except_cache = map(c -> !(c isa DI.Cache), contexts)
    args_to_zero = (
        true,  # f
        true,  # x
        contexts_tup_true_except_cache...,
    )
    prep = MooncakeGradientPrep(_sig, cache, args_to_zero)
    return prep
end

function DI.value_and_gradient(
        f::F,
        prep::MooncakeGradientPrep,
        backend::AutoMooncake,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    y, (_, new_grad) = value_and_gradient!!(
        prep.cache, f, x, map(DI.unwrap, contexts)...;
        prep.args_to_zero
    )
    return y, _copy_output(new_grad)
end

function DI.value_and_gradient!(
        f::F,
        grad,
        prep::MooncakeGradientPrep,
        backend::AutoMooncake,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    y, (_, new_grad) = value_and_gradient!!(
        prep.cache, f, x, map(DI.unwrap, contexts)...;
        prep.args_to_zero
    )
    copyto!(grad, new_grad)
    return y, grad
end

function DI.gradient(
        f::F,
        prep::MooncakeGradientPrep,
        backend::AutoMooncake,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    _, grad = DI.value_and_gradient(f, prep, backend, x, contexts...)
    return grad
end

function DI.gradient!(
        f::F,
        grad,
        prep::MooncakeGradientPrep,
        backend::AutoMooncake,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    DI.value_and_gradient!(f, grad, prep, backend, x, contexts...)
    return grad
end

"""
    Prep

Abstract supertype for all preparation results (outputs of `prepare_operator` functions).

!!! warning
    The public API does not make any guarantees about the type parameters or field layout of `Prep`, the only guarantee is that this type exists.
"""
abstract type Prep{SIG} end

"""
$(docstring_preptype("PushforwardPrep", "pushforward"))
"""
abstract type PushforwardPrep{SIG} <: Prep{SIG} end

struct NoPushforwardPrep{SIG} <: PushforwardPrep{SIG}
    _sig::Val{SIG}
end

"""
$(docstring_preptype("PullbackPrep", "pullback"))
"""
abstract type PullbackPrep{SIG} <: Prep{SIG} end

struct NoPullbackPrep{SIG} <: PullbackPrep{SIG}
    _sig::Val{SIG}
end

"""
$(docstring_preptype("DerivativePrep", "derivative"))
"""
abstract type DerivativePrep{SIG} <: Prep{SIG} end

struct NoDerivativePrep{SIG} <: DerivativePrep{SIG}
    _sig::Val{SIG}
end

"""
$(docstring_preptype("GradientPrep", "gradient"))
"""
abstract type GradientPrep{SIG} <: Prep{SIG} end

struct NoGradientPrep{SIG} <: GradientPrep{SIG}
    _sig::Val{SIG}
end

"""
$(docstring_preptype("JacobianPrep", "jacobian"))
"""
abstract type JacobianPrep{SIG} <: Prep{SIG} end

struct NoJacobianPrep{SIG} <: JacobianPrep{SIG}
    _sig::Val{SIG}
end

# assume the existence of a `sparsity` field
abstract type SparseJacobianPrep{SIG} <: JacobianPrep{SIG} end

"""
$(docstring_preptype("HVPPrep", "hvp"))
"""
abstract type HVPPrep{SIG} <: Prep{SIG} end

struct NoHVPPrep{SIG} <: HVPPrep{SIG}
    _sig::Val{SIG}
end

"""
$(docstring_preptype("HessianPrep", "hessian"))
"""
abstract type HessianPrep{SIG} <: Prep{SIG} end

struct NoHessianPrep{SIG} <: HessianPrep{SIG}
    _sig::Val{SIG}
end

# assume the existence of a `sparsity` field
abstract type SparseHessianPrep{SIG} <: HessianPrep{SIG} end

"""
$(docstring_preptype("SecondDerivativePrep", "second_derivative"))
"""
abstract type SecondDerivativePrep{SIG} <: Prep{SIG} end

struct NoSecondDerivativePrep{SIG} <: SecondDerivativePrep{SIG}
    _sig::Val{SIG}
end

## Checks

is_strict(::Prep{Nothing}) = Val(false)
is_strict(::Prep) = Val(true)

struct PreparationMismatchError{SIG, EXEC_SIG} <: Exception
    format::Vector{Symbol}
end

function PreparationMismatchError(
        ::Type{SIG}, ::Type{EXEC_SIG}; format
    ) where {SIG, EXEC_SIG}
    return PreparationMismatchError{SIG, EXEC_SIG}(format)
end

function Base.showerror(
        io::IO, e::PreparationMismatchError{SIG, EXEC_SIG}
    ) where {SIG <: Tuple, EXEC_SIG <: Tuple}
    println(
        io,
        "PreparationMismatchError (inconsistent types between preparation and execution):",
    )
    for (s, pt, et) in zip(e.format, SIG.types, EXEC_SIG.types)
        if pt == et
            println(io, "  - $s: ✅")
        else
            println(io, "  - $s: ❌\n    - prep: $pt\n    - exec: $et")
        end
    end
    println(
        io,
        "If you are confident that this check is superfluous, you can disable it by running preparation with the keyword argument `strict=Val(false)` inside DifferentiationInterface.",
    )
    return nothing
end

function signature(
        f, backend::AbstractADType, x, contexts::Vararg{Context, C}; strict::Val{S}
    ) where {C, S}
    if S
        return Val(typeof((f, backend, x, contexts)))
    else
        return Val(Nothing)
    end
end

function signature(
        f!, y, backend::AbstractADType, x, contexts::Vararg{Context, C}; strict::Val{S}
    ) where {C, S}
    if S
        return Val(typeof((f!, y, backend, x, contexts)))
    else
        return Val(Nothing)
    end
end

function signature(
        f, backend::AbstractADType, x, t::NTuple, contexts::Vararg{Context, C}; strict::Val{S}
    ) where {C, S}
    if S
        return Val(typeof((f, backend, x, t, contexts)))
    else
        return Val(Nothing)
    end
end

function signature(
        f!,
        y,
        backend::AbstractADType,
        x,
        t::NTuple,
        contexts::Vararg{Context, C};
        strict::Val{S},
    ) where {C, S}
    if S
        return Val(typeof((f!, y, backend, x, t, contexts)))
    else
        return Val(Nothing)
    end
end

function check_prep(
        f, ::Prep{SIG}, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {SIG, C}
    return if SIG !== Nothing
        EXEC_SIG = typeof((f, backend, x, contexts))
        if SIG != EXEC_SIG
            throw(
                PreparationMismatchError(
                    SIG, EXEC_SIG; format = [:f, :backend, :x, :contexts]
                ),
            )
        end
    end
end

function check_prep(
        f!, y, ::Prep{SIG}, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {SIG, C}
    return if SIG !== Nothing
        EXEC_SIG = typeof((f!, y, backend, x, contexts))
        if SIG != EXEC_SIG
            throw(
                PreparationMismatchError(
                    SIG, EXEC_SIG; format = [:f!, :y, :backend, :x, :contexts]
                ),
            )
        end
    end
end

function check_prep(
        f, ::Prep{SIG}, backend::AbstractADType, x, t::NTuple, contexts::Vararg{Context, C}
    ) where {SIG, C}
    return if SIG !== Nothing
        EXEC_SIG = typeof((f, backend, x, t, contexts))
        if SIG != EXEC_SIG
            throw(
                PreparationMismatchError(
                    SIG, EXEC_SIG; format = [:f, :backend, :x, :t, :contexts]
                ),
            )
        end
    end
end

function check_prep(
        f!, y, ::Prep{SIG}, backend::AbstractADType, x, t::NTuple, contexts::Vararg{Context, C}
    ) where {SIG, C}
    return if SIG !== Nothing
        EXEC_SIG = typeof((f!, y, backend, x, t, contexts))
        if SIG != EXEC_SIG
            throw(
                PreparationMismatchError(
                    SIG, EXEC_SIG; format = [:f!, :y, :backend, :x, :t, :contexts]
                ),
            )
        end
    end
end

include("../../testutils.jl")

using DifferentiationInterface, DifferentiationInterfaceTest
using SparseMatrixColorings
using LinearAlgebra
using FastDifferentiation: FastDifferentiation
using Test

using ExplicitImports
check_no_implicit_imports(DifferentiationInterface)

for backend in [AutoFastDifferentiation(), AutoSparse(AutoFastDifferentiation())]
    @test check_available(backend)
    @test check_inplace(backend)
    test_counterparts(backend)
end

test_differentiation(
    AutoFastDifferentiation(),
    default_scenarios(;
        include_constantified = true, include_cachified = true, use_tuples = false
    );
    logging = LOGGING,
);

test_differentiation(
    AutoSparse(AutoFastDifferentiation()),
    sparse_scenarios(; band_sizes = 0:-1);
    sparsity = true,
    logging = LOGGING,
);

@testset "SparseMatrixColorings access" begin
    x = rand(10)
    backend = AutoSparse(AutoFastDifferentiation())
    jac_prep = prepare_jacobian(copy, backend, x)
    jac!_prep = prepare_jacobian(copyto!, similar(x), backend, x)
    hess_prep = prepare_hessian(x -> sum(abs2, x), backend, x)
    @test sparsity_pattern(jac_prep) == Diagonal(trues(10))
    @test sparsity_pattern(jac!_prep) == Diagonal(trues(10))
    @test sparsity_pattern(hess_prep) == Diagonal(trues(10))
end

include("../../testutils.jl")

using DifferentiationInterface, DifferentiationInterfaceTest
using FiniteDifferences: FiniteDifferences
using Test

using ExplicitImports
check_no_implicit_imports(DifferentiationInterface)

for backend in [AutoFiniteDifferences(; fdm = FiniteDifferences.central_fdm(3, 1))]
    @test check_available(backend)
    @test !check_inplace(backend)
    test_counterparts(backend)
    @test DifferentiationInterface.inner_preparation_behavior(backend) isa
        DifferentiationInterface.PrepareInnerSimple
end

test_differentiation(
    AutoFiniteDifferences(; fdm = FiniteDifferences.central_fdm(3, 1)),
    default_scenarios(;
        include_constantified = true, include_cachified = true, use_tuples = true
    );
    excluded = SECOND_ORDER,
    logging = LOGGING,
);

## Pushforward

struct FiniteDiffTwoArgPushforwardPrep{SIG, C, R, A, D} <: DI.PushforwardPrep{SIG}
    _sig::Val{SIG}
    cache::C
    relstep::R
    absstep::A
    dir::D
end

function DI.prepare_pushforward_nokwarg(
        strict::Val,
        f!,
        y,
        backend::AutoFiniteDiff,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f!, y, backend, x, tx, contexts...; strict)
    cache = if x isa Number
        nothing
    else
        JVPCache(similar(x), similar(y), fdtype(backend))
    end
    relstep = if isnothing(backend.relstep)
        default_relstep(fdtype(backend), eltype(x))
    else
        backend.relstep
    end
    absstep = if isnothing(backend.absstep)
        relstep
    else
        backend.absstep
    end
    dir = backend.dir
    return FiniteDiffTwoArgPushforwardPrep(_sig, cache, relstep, absstep, dir)
end

function DI.value_and_pushforward(
        f!,
        y,
        prep::FiniteDiffTwoArgPushforwardPrep{SIG, Nothing},
        backend::AutoFiniteDiff,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {SIG, C}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    (; relstep, absstep, dir) = prep
    function step(t::Number, dx)
        new_y = similar(y)
        f!(new_y, x .+ t .* dx, map(DI.unwrap, contexts)...)
        return new_y
    end
    ty = map(tx) do dx
        finite_difference_derivative(
            Base.Fix2(step, dx),
            zero(eltype(x)),
            fdtype(backend),
            eltype(y),
            y;
            relstep,
            absstep,
            dir,
        )
    end
    f!(y, x, map(DI.unwrap, contexts)...)
    return y, ty
end

function DI.pushforward(
        f!,
        y,
        prep::FiniteDiffTwoArgPushforwardPrep{SIG, <:JVPCache},
        backend::AutoFiniteDiff,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {SIG, C}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    (; relstep, absstep, dir) = prep
    fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
    ty = map(tx) do dx
        dy = similar(y)
        finite_difference_jvp!(dy, fc!, x, dx, prep.cache; relstep, absstep, dir)
        dy
    end
    return ty
end

function DI.value_and_pushforward(
        f!,
        y,
        prep::FiniteDiffTwoArgPushforwardPrep{SIG, <:JVPCache},
        backend::AutoFiniteDiff,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {SIG, C}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    (; relstep, absstep, dir) = prep
    fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
    ty = map(tx) do dx
        dy = similar(y)
        finite_difference_jvp!(dy, fc!, x, dx, prep.cache; relstep, absstep, dir)
        dy
    end
    fc!(y, x)
    return y, ty
end

function DI.pushforward!(
        f!,
        y,
        ty::NTuple,
        prep::FiniteDiffTwoArgPushforwardPrep{SIG, <:JVPCache},
        backend::AutoFiniteDiff,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {SIG, C}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    (; relstep, absstep, dir) = prep
    fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
    for b in eachindex(tx, ty)
        dx, dy = tx[b], ty[b]
        finite_difference_jvp!(dy, fc!, x, dx, prep.cache; relstep, absstep, dir)
    end
    return ty
end

function DI.value_and_pushforward!(
        f!,
        y,
        ty::NTuple,
        prep::FiniteDiffTwoArgPushforwardPrep{SIG, <:JVPCache},
        backend::AutoFiniteDiff,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {SIG, C}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    (; relstep, absstep, dir) = prep
    fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
    for b in eachindex(tx, ty)
        dx, dy = tx[b], ty[b]
        finite_difference_jvp!(dy, fc!, x, dx, prep.cache; relstep, absstep, dir)
    end
    fc!(y, x)
    return y, ty
end

## Derivative

struct FiniteDiffTwoArgDerivativePrep{SIG, C, R, A, D} <: DI.DerivativePrep{SIG}
    _sig::Val{SIG}
    cache::C
    relstep::R
    absstep::A
    dir::D
end

function DI.prepare_derivative_nokwarg(
        strict::Val, f!, y, backend::AutoFiniteDiff, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f!, y, backend, x, contexts...; strict)
    df = similar(y)
    cache = GradientCache(df, x, fdtype(backend), eltype(y), FUNCTION_INPLACE)
    relstep = if isnothing(backend.relstep)
        default_relstep(fdtype(backend), eltype(x))
    else
        backend.relstep
    end
    absstep = if isnothing(backend.absstep)
        relstep
    else
        backend.absstep
    end
    dir = backend.dir
    return FiniteDiffTwoArgDerivativePrep(_sig, cache, relstep, absstep, dir)
end

function DI.prepare!_derivative(
        f!,
        y,
        old_prep::FiniteDiffTwoArgDerivativePrep,
        backend::AutoFiniteDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, old_prep, backend, x, contexts...)
    if y isa Vector
        (; cache) = old_prep
        cache.fx isa Union{Number, Nothing} || resize!(cache.fx, length(y))
        cache.c1 isa Union{Number, Nothing} || resize!(cache.c1, length(y))
        cache.c2 isa Union{Number, Nothing} || resize!(cache.c2, length(y))
        cache.c3 isa Union{Number, Nothing} || resize!(cache.c3, length(y))
        return old_prep
    else
        return DI.prepare_derivative_nokwarg(
            DI.is_strict(old_prep), f!, y, backend, x, contexts...
        )
    end
end

function DI.value_and_derivative(
        f!,
        y,
        prep::FiniteDiffTwoArgDerivativePrep,
        backend::AutoFiniteDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    (; relstep, absstep, dir) = prep
    fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
    fc!(y, x)
    der = finite_difference_gradient(fc!, x, prep.cache; relstep, absstep, dir)
    return y, der
end

function DI.value_and_derivative!(
        f!,
        y,
        der,
        prep::FiniteDiffTwoArgDerivativePrep,
        backend::AutoFiniteDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    (; relstep, absstep, dir) = prep
    fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
    fc!(y, x)
    finite_difference_gradient!(der, fc!, x, prep.cache; relstep, absstep, dir)
    return y, der
end

function DI.derivative(
        f!,
        y,
        prep::FiniteDiffTwoArgDerivativePrep,
        backend::AutoFiniteDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    (; relstep, absstep, dir) = prep
    fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
    fc!(y, x)
    der = finite_difference_gradient(fc!, x, prep.cache; relstep, absstep, dir)
    return der
end

function DI.derivative!(
        f!,
        y,
        der,
        prep::FiniteDiffTwoArgDerivativePrep,
        backend::AutoFiniteDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    (; relstep, absstep, dir) = prep
    fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
    finite_difference_gradient!(der, fc!, x, prep.cache; relstep, absstep, dir)
    return der
end

## Jacobian

struct FiniteDiffTwoArgJacobianPrep{SIG, C, R, A, D} <: DI.JacobianPrep{SIG}
    _sig::Val{SIG}
    cache::C
    relstep::R
    absstep::A
    dir::D
end

function DI.prepare_jacobian_nokwarg(
        strict::Val, f!, y, backend::AutoFiniteDiff, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f!, y, backend, x, contexts...; strict)
    x1 = similar(x)
    fx = similar(y)
    fx1 = similar(y)
    cache = JacobianCache(x1, fx, fx1, fdjtype(backend))
    relstep = if isnothing(backend.relstep)
        default_relstep(fdjtype(backend), eltype(x))
    else
        backend.relstep
    end
    absstep = if isnothing(backend.absstep)
        relstep
    else
        backend.absstep
    end
    dir = backend.dir
    return FiniteDiffTwoArgJacobianPrep(_sig, cache, relstep, absstep, dir)
end

function DI.prepare!_jacobian(
        f!,
        y,
        old_prep::FiniteDiffTwoArgJacobianPrep,
        backend::AutoFiniteDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, old_prep, backend, x, contexts...)
    if x isa Vector && y isa Vector
        (; cache) = old_prep
        cache.x1 isa Union{Number, Nothing} || resize!(cache.x1, length(x))
        cache.x2 isa Union{Number, Nothing} || resize!(cache.x2, length(x))
        cache.fx isa Union{Number, Nothing} || resize!(cache.fx, length(y))
        cache.fx1 isa Union{Number, Nothing} || resize!(cache.fx1, length(y))
        cache.colorvec = 1:length(x)
        cache.sparsity = nothing
        return old_prep
    else
        return DI.prepare_jacobian_nokwarg(
            DI.is_strict(old_prep), f!, y, backend, x, contexts...
        )
    end
end

function DI.value_and_jacobian(
        f!,
        y,
        prep::FiniteDiffTwoArgJacobianPrep,
        backend::AutoFiniteDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    (; relstep, absstep, dir) = prep
    fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
    jac = similar(y, length(y), length(x))
    finite_difference_jacobian!(jac, fc!, x, prep.cache; relstep, absstep, dir)
    fc!(y, x)
    return y, jac
end

function DI.value_and_jacobian!(
        f!,
        y,
        jac,
        prep::FiniteDiffTwoArgJacobianPrep,
        backend::AutoFiniteDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    (; relstep, absstep, dir) = prep
    fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
    finite_difference_jacobian!(jac, fc!, x, prep.cache; relstep, absstep, dir)
    fc!(y, x)
    return y, jac
end

function DI.jacobian(
        f!,
        y,
        prep::FiniteDiffTwoArgJacobianPrep,
        backend::AutoFiniteDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    (; relstep, absstep, dir) = prep
    fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
    jac = similar(y, length(y), length(x))
    finite_difference_jacobian!(jac, fc!, x, prep.cache; relstep, absstep, dir)
    return jac
end

function DI.jacobian!(
        f!,
        y,
        jac,
        prep::FiniteDiffTwoArgJacobianPrep,
        backend::AutoFiniteDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    (; relstep, absstep, dir) = prep
    fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
    finite_difference_jacobian!(jac, fc!, x, prep.cache; relstep, absstep, dir)
    return jac
end

using DifferentiationInterface: recursive_similar, get_pattern, arroftup_to_tupofarr
using SparseArrays
using Test
using JLArrays, ComponentArrays

@testset "Recursive similar" begin
    @test recursive_similar(ones(Int, 2), Float32) isa Vector{Float32}
    @test recursive_similar((ones(Int, 2), ones(Bool, 3, 4)), Float32) isa
        Tuple{Vector{Float32}, Matrix{Float32}}
    @test recursive_similar((a = ones(Int, 2), b = (ones(Bool, 3, 4),)), Float32) isa
        @NamedTuple{a::Vector{Float32}, b::Tuple{Matrix{Float32}}}
    @test_throws MethodError recursive_similar(1, Float32)
end

@testset "Sparsity pattern" begin
    D = Diagonal(rand(10))
    @test_broken get_pattern(D) == Diagonal(trues(10))
    @test get_pattern(sparse(D)) == Diagonal(trues(10))
end

@testset "Wrong-mode array conversion" begin
    x = [1.0, 3.0, 5.0]
    xt = [(1.0, 2.0), (3.0, 4.0), (5.0, 6.0)]
    y = ComponentVector(a = [1.0, 3.0], b = [5.0])
    yt = ComponentVector(a = [(1.0, 2.0), (3.0, 4.0)], b = [(5.0, 6.0)])
    z = jl([1.0, 3.0, 5.0])
    zt = jl([(1.0, 2.0), (3.0, 4.0), (5.0, 6.0)])
    @test arroftup_to_tupofarr((1.0, 2.0), 1.0) == (1.0, 2.0)
    @test arroftup_to_tupofarr(xt, x) == ([1.0, 3.0, 5.0], [2.0, 4.0, 6.0])
    @test arroftup_to_tupofarr(yt, y) == (ComponentVector(a = [1.0, 3.0], b = [5.0]), ComponentVector(a = [2.0, 4.0], b = [6.0]))
    @test arroftup_to_tupofarr(zt, z) == (jl([1.0, 3.0, 5.0]), jl([2.0, 4.0, 6.0]))
    @test arroftup_to_tupofarr(xt, x)[1] isa Vector
    @test arroftup_to_tupofarr(yt, y)[1] isa ComponentVector
    @test arroftup_to_tupofarr(zt, z)[1] isa JLVector
end

function __init__()
    return Base.Experimental.register_error_hint(MethodError) do io, exc, argtypes, kwargs
        if exc.f in (_prepare_pushforward_aux, _prepare_pullback_aux)
            B = first(T for T in argtypes if T <: AbstractADType)
            packages = required_packages(B)
            loaded = map(string, values(Base.loaded_modules))
            missing_package = any(!(p in loaded) for p in packages)
            if missing_package
                import_statement = "import $(packages[1])"
                for p in packages[2:end]
                    import_statement *= ", $p"
                end
                printstyled(
                    io,
                    "\n\nThe autodiff backend you chose requires a package which may not be loaded. Please run the following command and try again:";
                    bold = true,
                )
                printstyled(io, "\n\n\t$import_statement"; color = :cyan, bold = true)
            else
                printstyled(
                    io,
                    "\n\nThe autodiff backend you chose may not be compatible with the operation you want to perform. Please refer to the documentation of DifferentiationInterface.jl and open an issue if necessary.";
                    bold = true,
                )
            end
        end
    end
end

# tested first so that the suite fails quickly

using Aqua: Aqua
using Base: get_extension
using DifferentiationInterface
using ExplicitImports
using JET: JET
using Test
using SparseMatrixColorings
using SparseArrays

const DI = DifferentiationInterface

@testset "Aqua" begin
    Aqua.test_all(DifferentiationInterface; ambiguities = false, undocumented_names = true)
end

@testset "JET" begin
    JET.test_package(
        DI;
        target_modules = (
            DI,
            filter(
                !isnothing, (
                    get_extension(DI, :DifferentiationInterfaceChainRulesCoreExt),
                    # get_extension(DI, :DifferentiationInterfaceDiffractorExt),
                    get_extension(DI, :DifferentiationInterfaceEnzymeExt),
                    get_extension(DI, :DifferentiationInterfaceFastDifferentiationExt),
                    get_extension(DI, :DifferentiationInterfaceFiniteDiffExt),
                    get_extension(DI, :DifferentiationInterfaceFiniteDifferencesExt),
                    get_extension(DI, :DifferentiationInterfaceForwardDiffExt),
                    get_extension(DI, :DifferentiationInterfaceGPUArraysCoreExt),
                    get_extension(DI, :DifferentiationInterfaceHyperHessiansExt),
                    get_extension(DI, :DifferentiationInterfaceGTPSAExt),
                    get_extension(DI, :DifferentiationInterfaceMooncakeExt),
                    get_extension(DI, :DifferentiationInterfacePolyesterForwardDiffExt),
                    get_extension(DI, :DifferentiationInterfaceReverseDiffExt),
                    get_extension(DI, :DifferentiationInterfaceSparseArraysExt),
                    get_extension(DI, :DifferentiationInterfaceSparseConnectivityTracerExt),
                    get_extension(DI, :DifferentiationInterfaceSparseMatrixColoringsExt),
                    get_extension(DI, :DifferentiationInterfaceStaticArraysExt),
                    get_extension(DI, :DifferentiationInterfaceSymbolicsExt),
                    get_extension(DI, :DifferentiationInterfaceTrackerExt),
                    get_extension(DI, :DifferentiationInterfaceZygoteExt),
                )
            )...,
        )
    )
end

@testset "Documentation" begin
    if VERSION >= v"1.11"
        @test isempty(Docs.undocumented_names(DifferentiationInterface))
    end
end

@testset "ExplicitImports" begin
    @test check_no_implicit_imports(DifferentiationInterface) === nothing
    @test check_no_stale_explicit_imports(DifferentiationInterface) === nothing
    @test check_all_explicit_imports_via_owners(DifferentiationInterface) === nothing
    @test check_all_qualified_accesses_via_owners(DifferentiationInterface) === nothing
    @test check_no_self_qualified_accesses(DifferentiationInterface) === nothing
    if VERSION >= v"1.11"
        @test check_all_explicit_imports_are_public(DifferentiationInterface) === nothing
        @test_skip check_all_qualified_accesses_are_public(DifferentiationInterface) ===
            nothing
    end
end

include("../../testutils.jl")

using ComponentArrays: ComponentArrays
using DifferentiationInterface, DifferentiationInterfaceTest
using ForwardDiff: ForwardDiff
using JLArrays: JLArrays
using StaticArrays: StaticArrays
using Test
using Zygote: Zygote

using ExplicitImports
check_no_implicit_imports(DifferentiationInterface)

backends = [AutoZygote()]
second_order_backends = [SecondOrder(AutoForwardDiff(), AutoZygote())]

for backend in vcat(backends, second_order_backends)
    @test check_available(backend)
    @test !check_inplace(backend)
    test_counterparts(backend)
end

## Dense

@testset "Dense" begin
    test_differentiation(
        backends,
        default_scenarios(;
            include_constantified = true, include_cachified = true, use_tuples = true
        );
        excluded = [:second_derivative],
        logging = LOGGING,
    )

    test_differentiation(second_order_backends; logging = LOGGING)

    test_differentiation(
        backends[1],
        vcat(component_scenarios(), gpu_scenarios());
        excluded = SECOND_ORDER,
        logging = LOGGING,
    )
end

test_differentiation(
    AutoZygote(), complex_scenarios(); excluded = [:gradient, :jacobian], logging = LOGGING
);

## Sparse

@testset "Sparse" begin
    test_differentiation(
        MyAutoSparse.(vcat(backends, second_order_backends)),
        sparse_scenarios(; band_sizes = 0:-1);
        sparsity = true,
        logging = LOGGING,
    )
end

include("../../testutils.jl")

using ChainRulesTestUtils: ChainRulesTestUtils
using DifferentiationInterface, DifferentiationInterfaceTest
import DifferentiationInterfaceTest as DIT
using FiniteDiff: FiniteDiff
using ForwardDiff: ForwardDiff
using Zygote: Zygote
using Mooncake: Mooncake
using StableRNGs
using Test

struct ADBreaker{F}
    f::F
end

function (adb::ADBreaker)(x::Number)
    copyto!(Float64[0], x)  # break ForwardDiff and Zygote
    return adb.f(x)
end

function (adb::ADBreaker)(x::AbstractArray)
    copyto!(similar(x, Float64), x)  # break ForwardDiff and Zygote
    return adb.f(x)
end

function differentiatewith_scenarios()
    outofplace_scens = filter(DIT.default_scenarios()) do scen
        DIT.function_place(scen) == :out
    end
    # with bad_scens, everything would break
    bad_scens = map(outofplace_scens) do scen
        DIT.change_function(scen, ADBreaker(scen.f))
    end
    # with good_scens, everything is fixed
    good_scens = map(bad_scens) do scen
        DIT.change_function(scen, DifferentiateWith(scen.f, AutoFiniteDiff()))
    end
    return good_scens
end

test_differentiation(
    [AutoForwardDiff(), AutoZygote(), AutoMooncake(; config = nothing)],
    differentiatewith_scenarios();
    excluded = SECOND_ORDER,
    logging = LOGGING,
    testset_name = "DI tests",
)

@testset "ChainRules tests" begin
    @testset for scen in filter(differentiatewith_scenarios()) do scen
            DIT.operator(scen) == :pullback
        end
        ChainRulesTestUtils.test_rrule(scen.f, scen.x; rtol = 1.0e-4)
    end
end;

@testset "Mooncake tests" begin
    @testset for scen in filter(differentiatewith_scenarios()) do scen
            DIT.operator(scen) == :pullback
        end
        Mooncake.TestUtils.test_rule(
            StableRNG(0), scen.f, scen.x; is_primitive = true, mode = Mooncake.ReverseMode
        )
    end
end;

@testset "Mooncake errors" begin
    MooncakeDifferentiateWithError =
        Base.get_extension(DifferentiationInterface, :DifferentiationInterfaceMooncakeExt).MooncakeDifferentiateWithError

    e = MooncakeDifferentiateWithError(identity, 1.0, 2.0)
    @test sprint(showerror, e) ==
        "MooncakeDifferentiateWithError: For the function type typeof(identity) and input type Float64, the output type Float64 is currently not supported."

    f_num2tup(x::Number) = (x,)
    f_vec2tup(x::Vector) = (first(x),)
    f_tup2num(x::Tuple{<:Number}) = only(x)
    f_tup2vec(x::Tuple{<:Number}) = [only(x)]

    @test_throws MooncakeDifferentiateWithError pullback(
        DifferentiateWith(f_num2tup, AutoFiniteDiff()),
        AutoMooncake(; config = nothing),
        1.0,
        ((2.0,),),
    )
    @test_throws MooncakeDifferentiateWithError pullback(
        DifferentiateWith(f_vec2tup, AutoFiniteDiff()),
        AutoMooncake(; config = nothing),
        [1.0],
        ((2.0,),),
    )
    @test_throws MethodError pullback(
        DifferentiateWith(f_tup2num, AutoFiniteDiff()),
        AutoMooncake(; config = nothing),
        (1.0,),
        (2.0,),
    )
    @test_throws MethodError pullback(
        DifferentiateWith(f_tup2vec, AutoFiniteDiff()),
        AutoMooncake(; config = nothing),
        (1.0,),
        ([2.0],),
    )
end

using DifferentiationInterface
using DifferentiationInterface: AutoZeroReverse, AutoZeroForward
using Test

backend = AutoZeroForward()
other_backend = AutoZeroReverse()
f(x, c) = x + c
f!(y, x) = y .= x
x = 1.0
y = zeros(2)
c = 2.0

@testset "Out of place, no tangents" begin
    prep = prepare_derivative(f, backend, x, Constant(c))
    prep_chill = prepare_derivative(f, backend, x, Constant(c); strict = Val(false))

    @test_throws MethodError derivative(nothing, prep_chill, backend, x, Constant(c))

    @test_throws """
    PreparationMismatchError (inconsistent types between preparation and execution):
      - f: ❌
        - prep: typeof(f)
        - exec: Nothing
      - backend: ✅
      - x: ✅
      - contexts: ✅
    """ derivative(nothing, prep, backend, x, Constant(c))

    @test_throws """
    PreparationMismatchError (inconsistent types between preparation and execution):
      - f: ✅
      - backend: ❌
        - prep: AutoZeroForward
        - exec: AutoZeroReverse
      - x: ✅
      - contexts: ✅
    """ derivative(f, prep, other_backend, x, Constant(c))

    @test_throws """
    PreparationMismatchError (inconsistent types between preparation and execution):
      - f: ✅
      - backend: ✅
      - x: ❌
        - prep: Float64
        - exec: Int64
      - contexts: ✅
    """ derivative(f, prep, backend, 1, Constant(c))

    @test_throws """
    PreparationMismatchError (inconsistent types between preparation and execution):
      - f: ✅
      - backend: ✅
      - x: ✅
      - contexts: ❌
        - prep: Tuple{Constant{Float64}}
        - exec: Tuple{Constant{Int64}}
    """ derivative(f, prep, backend, x, Constant(2))

    @test_throws """
    PreparationMismatchError (inconsistent types between preparation and execution):
      - f: ✅
      - backend: ✅
      - x: ✅
      - contexts: ❌
        - prep: Tuple{Constant{Float64}}
        - exec: Tuple{Constant{Int64}, Constant{Int64}}
    """ derivative(f, prep, backend, x, Constant(2), Constant(3))
end

@testset "In place, no tangents" begin
    prep = prepare_derivative(f!, y, backend, x)
    prep_chill = prepare_derivative(f!, y, backend, x; strict = Val(false))

    @test_throws MethodError derivative(nothing, y, prep_chill, backend, x, Constant(c))

    @test_throws """
    PreparationMismatchError (inconsistent types between preparation and execution):
      - f!: ❌
        - prep: typeof(f!)
        - exec: Nothing
      - y: ✅
      - backend: ✅
      - x: ✅
      - contexts: ✅
    """ derivative(nothing, y, prep, backend, x)
end

@testset "Out of place, with tangents" begin
    prep = prepare_pushforward(f, backend, x, (x,), Constant(c))
    prep_chill = prepare_pushforward(f, backend, x, (x,), Constant(c); strict = Val(false))

    @test_throws MethodError pushforward(nothing, prep_chill, backend, x, (x,))

    @test_throws """
    PreparationMismatchError (inconsistent types between preparation and execution):
      - f: ❌
        - prep: typeof(f)
        - exec: Nothing
      - backend: ✅
      - x: ✅
      - t: ✅
      - contexts: ✅
    """ pushforward(nothing, prep, backend, x, (x,), Constant(c))
end

@testset "In place, with tangents" begin
    prep = prepare_pushforward(f!, y, backend, x, (x,))
    prep_chill = prepare_pushforward(
        f!, y, backend, x, (x,), Constant(c); strict = Val(false)
    )

    @test_throws MethodError pushforward(nothing, y, prep_chill, backend, x, (x,))

    @test_throws """
    PreparationMismatchError (inconsistent types between preparation and execution):
      - f!: ❌
        - prep: typeof(f!)
        - exec: Nothing
      - y: ✅
      - backend: ✅
      - x: ✅
      - t: ✅
      - contexts: ✅
    """ pushforward(nothing, y, prep, backend, x, (x,))
end

using DifferentiationInterface
using DifferentiationInterface: Rewrap, fix_tail
using Test

f1(x) = x
g1 = @inferred fix_tail(f1)
@test @inferred g1(4) == 4

f2(x, a, b) = a * x + b
g2 = @inferred fix_tail(f2, 2, 3)
@test @inferred g2(4) == 2 * 4 + 3

contexts = ()
r = @inferred Rewrap()
@test r() == ()

contexts = (Constant(1.0), Cache([2.0]))
r = @inferred Rewrap(contexts...)
@test (@inferred r(3.0, [4.0])) == (Constant(3.0), Cache([4.0]))
@test (@inferred r(3, [4.0f0])) isa Tuple{Constant{Int}, Cache{Vector{Float32}}}

required_packages(b::AbstractADType) = required_packages(typeof(b))

function required_packages(::Type{B}) where {B <: AbstractADType}
    s = string(B)
    s = chopprefix(s, "ADTypes.")
    s = chopprefix(s, "Auto")
    k = findfirst('{', s)
    if isnothing(k)
        return [s]
    else
        return [s[begin:(k - 1)]]
    end
end

function required_packages(::Type{SecondOrder{O, I}}) where {O, I}
    p1 = required_packages(O)
    p2 = required_packages(I)
    return unique(vcat(p1, p2))
end

function required_packages(::Type{MixedMode{F, R}}) where {F, R}
    p1 = required_packages(F)
    p2 = required_packages(R)
    return unique(vcat(p1, p2))
end

function required_packages(::Type{<:AutoSparse{D}}) where {D}
    return unique(vcat(required_packages(D), "SparseMatrixColorings"))
end

using DifferentiationInterface: Prep
using InteractiveUtils: subtypes
using Test

@test subtypes(Prep) == [
    DifferentiationInterface.DerivativePrep,
    DifferentiationInterface.GradientPrep,
    DifferentiationInterface.HVPPrep,
    DifferentiationInterface.HessianPrep,
    DifferentiationInterface.JacobianPrep,
    DifferentiationInterface.PullbackPrep,
    DifferentiationInterface.PushforwardPrep,
    DifferentiationInterface.SecondDerivativePrep,
]

## Pushforward

# Contains either a single pre-allocated initial TPS
# or a vector of pre-allocated TPSs.
struct GTPSAOneArgPushforwardPrep{SIG, X} <: DI.PushforwardPrep{SIG}
    _sig::Val{SIG}
    xt::X
end

function DI.prepare_pushforward_nokwarg(
        strict::Val,
        f::F,
        backend::AutoGTPSA{D},
        x,
        tx::NTuple,
        contexts::Vararg{DI.Constant, C}
    ) where {F, D, C}
    _sig = DI.signature(f, backend, x, tx, contexts...; strict)
    # For pushforward/JVP, we only actually need 1 single variable (in the GTPSA sense)
    # because we even if we did multiple we will add up the derivatives of each at the end.
    if D != Nothing
        d = backend.descriptor
    else
        d = Descriptor(1, 1) # 1 variable to first order
    end
    if x isa Number
        xt = TPS{promote_type(typeof(first(tx)), typeof(x), Float64)}(; use = d)
        return GTPSAOneArgPushforwardPrep(_sig, xt)
    else
        xt = similar(x, TPS{promote_type(eltype(first(tx)), eltype(x), Float64)})
        for i in eachindex(xt)
            xt[i] = TPS{promote_type(eltype(first(tx)), eltype(x), Float64)}(; use = d)
        end
        return GTPSAOneArgPushforwardPrep(_sig, xt)
    end
end

function DI.pushforward(
        f,
        prep::GTPSAOneArgPushforwardPrep,
        backend::AutoGTPSA,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Constant, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    ty = map(tx) do dx
        foreach((t, xi, dxi) -> (t[0] = xi; t[1] = dxi), prep.xt, x, dx)
        yt = fc(prep.xt)
        if yt isa Number
            return yt[1]
        else
            dy = map(t -> t[1], yt)
            return dy
        end
    end
    return ty
end

function DI.pushforward!(
        f,
        ty::NTuple,
        prep::GTPSAOneArgPushforwardPrep,
        backend::AutoGTPSA,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Constant, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    for b in eachindex(tx, ty)
        dx, dy = tx[b], ty[b]
        foreach((t, xi, dxi) -> (t[0] = xi; t[1] = dxi), prep.xt, x, dx)
        yt = fc(prep.xt)
        map!(t -> t[1], dy, yt)
    end
    return ty
end

function DI.value_and_pushforward(
        f,
        prep::GTPSAOneArgPushforwardPrep,
        backend::AutoGTPSA,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Constant, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    ty = DI.pushforward(f, prep, backend, x, tx, contexts...)
    y = f(x, map(DI.unwrap, contexts)...)  # TODO: optimize
    return y, ty
end

function DI.value_and_pushforward!(
        f,
        ty::NTuple,
        prep::GTPSAOneArgPushforwardPrep,
        backend::AutoGTPSA,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Constant, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    DI.pushforward!(f, ty, prep, backend, x, tx, contexts...)
    y = f(x, map(DI.unwrap, contexts)...)  # TODO: optimize
    return y, ty
end

## Gradient
# Contains a vector of pre-allocated TPSs.
struct GTPSAOneArgGradientPrep{SIG, X} <: DI.GradientPrep{SIG}
    _sig::Val{SIG}
    xt::X
end

# Unlike JVP, this requires us to use all variables
function DI.prepare_gradient_nokwarg(
        strict::Val, f, backend::AutoGTPSA{D}, x, contexts::Vararg{DI.Constant, C}
    ) where {D, C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    if D != Nothing
        d = backend.descriptor
    else
        d = Descriptor(length(x), 1) # n variables to first order
    end
    xt = similar(x, TPS{promote_type(eltype(x), Float64)})
    j = 1
    for i in eachindex(xt)
        xt[i] = TPS{promote_type(eltype(x), Float64)}(; use = d)
        xt[i][j] = 1
        j += 1
    end
    return GTPSAOneArgGradientPrep(_sig, xt)
end

function DI.gradient(
        f, prep::GTPSAOneArgGradientPrep, backend::AutoGTPSA, x, contexts::Vararg{DI.Constant, C}
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    foreach((t, xi) -> t[0] = xi, prep.xt, x) # Set the scalar part (slopes set in prepare)
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    yt = fc(prep.xt)
    grad = similar(x, GTPSA.numtype(yt))
    GTPSA.gradient!(grad, yt; include_params = true, unsafe_inbounds = true)
    return grad
end

function DI.gradient!(
        f,
        grad,
        prep::GTPSAOneArgGradientPrep,
        backend::AutoGTPSA,
        x,
        contexts::Vararg{DI.Constant, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    foreach((t, xi) -> t[0] = xi, prep.xt, x) # Set the scalar part
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    yt = fc(prep.xt)
    GTPSA.gradient!(grad, yt; include_params = true, unsafe_inbounds = true)
    return grad
end

function DI.value_and_gradient(
        f, prep::GTPSAOneArgGradientPrep, backend::AutoGTPSA, x, contexts::Vararg{DI.Constant, C}
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    foreach((t, xi) -> t[0] = xi, prep.xt, x) # Set the scalar part (slopes set in prepare)
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    yt = fc(prep.xt)
    grad = similar(x, GTPSA.numtype(yt))
    GTPSA.gradient!(grad, yt; include_params = true, unsafe_inbounds = true)
    return yt[0], grad
end

function DI.value_and_gradient!(
        f,
        grad,
        prep::GTPSAOneArgGradientPrep,
        backend::AutoGTPSA,
        x,
        contexts::Vararg{DI.Constant, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    foreach((t, xi) -> t[0] = xi, prep.xt, x) # Set the scalar part (slopes set in prepare)
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    yt = fc(prep.xt)
    GTPSA.gradient!(grad, yt; include_params = true, unsafe_inbounds = true)
    return yt[0], grad
end

## Jacobian
# Contains a vector of pre-allocated TPSs
struct GTPSAOneArgJacobianPrep{SIG, X} <: DI.JacobianPrep{SIG}
    _sig::Val{SIG}
    xt::X
end

# To materialize the entire Jacobian we use all variables
function DI.prepare_jacobian_nokwarg(
        strict::Val, f, backend::AutoGTPSA{D}, x, contexts::Vararg{DI.Constant, C}
    ) where {D, C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    if D != Nothing
        d = backend.descriptor
    else
        d = Descriptor(length(x), 1) # n variables to first order
    end

    # We set the slopes of each variable to 1 here, this will always be the case for Jacobian
    xt = similar(x, TPS{promote_type(eltype(x), Float64)})
    j = 1
    for i in eachindex(xt)
        xt[i] = TPS{promote_type(eltype(x), Float64)}(; use = d)
        xt[i][j] = 1
        j += 1
    end
    return GTPSAOneArgJacobianPrep(_sig, xt)
end

function DI.jacobian(
        f, prep::GTPSAOneArgJacobianPrep, backend::AutoGTPSA, x, contexts::Vararg{DI.Constant, C}
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    foreach((t, xi) -> t[0] = xi, prep.xt, x) # Set the scalar part
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    yt = fc(prep.xt)
    jac = similar(x, GTPSA.numtype(eltype(yt)), (length(yt), length(x)))
    GTPSA.jacobian!(jac, yt; include_params = true, unsafe_inbounds = true)
    return jac
end

function DI.jacobian!(
        f,
        jac,
        prep::GTPSAOneArgJacobianPrep,
        backend::AutoGTPSA,
        x,
        contexts::Vararg{DI.Constant, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    foreach((t, xi) -> t[0] = xi, prep.xt, x) # Set the scalar part
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    yt = fc(prep.xt)
    GTPSA.jacobian!(jac, yt; include_params = true, unsafe_inbounds = true)
    return jac
end

function DI.value_and_jacobian(
        f, prep::GTPSAOneArgJacobianPrep, backend::AutoGTPSA, x, contexts::Vararg{DI.Constant, C}
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    foreach((t, xi) -> t[0] = xi, prep.xt, x) # Set the scalar part
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    yt = fc(prep.xt)
    jac = similar(x, GTPSA.numtype(eltype(yt)), (length(yt), length(x)))
    GTPSA.jacobian!(jac, yt; include_params = true, unsafe_inbounds = true)
    y = map(t -> t[0], yt)
    return y, jac
end

function DI.value_and_jacobian!(
        f,
        jac,
        prep::GTPSAOneArgJacobianPrep,
        backend::AutoGTPSA,
        x,
        contexts::Vararg{DI.Constant, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    foreach((t, xi) -> t[0] = xi, prep.xt, x) # Set the scalar part
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    yt = fc(prep.xt)
    GTPSA.jacobian!(jac, yt; include_params = true, unsafe_inbounds = true)
    y = map(t -> t[0], yt)
    return y, jac
end

## Second derivative
# Contains single pre-allocated TPS
struct GTPSAOneArgSecondDerivativePrep{SIG, X} <: DI.SecondDerivativePrep{SIG}
    _sig::Val{SIG}
    xt::X
end

function DI.prepare_second_derivative_nokwarg(
        strict::Val, f, backend::AutoGTPSA{D}, x, contexts::Vararg{DI.Constant, C}
    ) where {D, C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    if D != Nothing
        d = backend.descriptor
    else
        d = Descriptor(1, 2)
    end
    xt = TPS{promote_type(typeof(x), Float64)}(; use = d)
    xt[1] = 1 # Set slope
    return GTPSAOneArgSecondDerivativePrep(_sig, xt)
end

function DI.second_derivative(
        f,
        prep::GTPSAOneArgSecondDerivativePrep,
        backend::AutoGTPSA{D},
        x,
        contexts::Vararg{DI.Constant, C},
    ) where {D, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    prep.xt[0] = x
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    yt = fc(prep.xt)
    if D == Nothing
        idx2 = 2
    else
        idx2 = GTPSA.numnn(backend.descriptor) + 1 # index of first second derivative
    end

    if yt isa Number
        return yt[idx2] * 2
    else
        der2 = similar(yt, GTPSA.numtype(eltype(yt)))
        for i in eachindex(yt)
            der2[i] = yt[i][idx2] * 2 # *2 because monomial coefficient is 1/2
        end
        return der2
    end
end

function DI.second_derivative!(
        f,
        der2,
        prep::GTPSAOneArgSecondDerivativePrep,
        backend::AutoGTPSA{D},
        x,
        contexts::Vararg{DI.Constant, C},
    ) where {D, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    prep.xt[0] = x
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    yt = fc(prep.xt)
    if D == Nothing
        idx2 = 2
    else
        idx2 = GTPSA.numnn(backend.descriptor) + 1 # index of first second derivative
    end
    for i in eachindex(yt)
        der2[i] = yt[i][idx2] * 2
    end
    return der2
end

function DI.value_derivative_and_second_derivative(
        f,
        prep::GTPSAOneArgSecondDerivativePrep,
        backend::AutoGTPSA{D},
        x,
        contexts::Vararg{DI.Constant, C},
    ) where {D, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    prep.xt[0] = x
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    yt = fc(prep.xt)
    if D == Nothing
        idx2 = 2
    else
        idx2 = GTPSA.numnn(backend.descriptor) + 1 # index of first second derivative
    end
    if yt isa Number
        return yt[0], yt[1], yt[idx2] * 2
    else
        y = map(t -> t[0], yt)
        der = similar(yt, GTPSA.numtype(eltype(yt)))
        der2 = similar(yt, GTPSA.numtype(eltype(yt)))
        for i in eachindex(yt)
            der[i] = yt[i][1]
            der2[i] = yt[i][idx2] * 2
        end
        return y, der, der2
    end
end

function DI.value_derivative_and_second_derivative!(
        f,
        der,
        der2,
        prep::GTPSAOneArgSecondDerivativePrep,
        backend::AutoGTPSA{D},
        x,
        contexts::Vararg{DI.Constant, C},
    ) where {D, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    prep.xt[0] = x
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    yt = fc(prep.xt)
    y = map(t -> t[0], yt)
    if D == Nothing
        idx2 = 2
    else
        idx2 = GTPSA.numnn(backend.descriptor) + 1 # index of first second derivative
    end
    for i in eachindex(yt)
        der[i] = yt[i][1]
        der2[i] = yt[i][idx2] * 2
    end
    return y, der, der2
end

## Hessian
# Stores allocated array of TPS and an array for the monomial coefficient
# indexing in GTPSA.cycle! (which is used if a Descriptor is specified)
struct GTPSAOneArgHessianPrep{SIG, X, M} <: DI.HessianPrep{SIG}
    _sig::Val{SIG}
    xt::X
    m::M
end

function DI.prepare_hessian_nokwarg(
        strict::Val, f, backend::AutoGTPSA{D}, x, contexts::Vararg{DI.Constant, C}
    ) where {D, C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    if D != Nothing
        d = backend.descriptor
        m = Vector{UInt8}(undef, length(x))
    else
        nn = length(x)
        d = Descriptor(nn, 2)
        # If all variables/variable+parameters have truncation order > 2, then
        # the indexing is known beforehand and we can do it (very slightly) faster
        m = nothing
    end
    xt = similar(x, TPS{promote_type(eltype(x), Float64)})

    # xt and x have same indexing because of similar
    # Setting the first derivatives must be 1-based
    # linear with the variables.
    j = 1
    for i in eachindex(xt)
        xt[i] = TPS{promote_type(eltype(x), Float64)}(; use = d)
        xt[i][j] = 1
        j += 1
    end

    return GTPSAOneArgHessianPrep(_sig, xt, m)
end

function DI.hessian(
        f,
        prep::GTPSAOneArgHessianPrep,
        backend::AutoGTPSA{D},
        x,
        contexts::Vararg{DI.Constant, C},
    ) where {D, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    foreach((t, xi) -> t[0] = xi, prep.xt, x) # Set the scalar part
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    yt = fc(prep.xt)
    hess = similar(x, GTPSA.numtype(yt), (length(x), length(x)))
    unsafe_fast = D == Nothing ? true : false
    GTPSA.hessian!(
        hess,
        yt;
        include_params = true,
        unsafe_inbounds = true,
        unsafe_fast = unsafe_fast,
        tmp_mono = prep.m,
    )
    return hess
end

function DI.hessian!(
        f,
        hess,
        prep::GTPSAOneArgHessianPrep,
        backend::AutoGTPSA{D},
        x,
        contexts::Vararg{DI.Constant, C},
    ) where {D, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    foreach((t, xi) -> t[0] = xi, prep.xt, x) # Set the scalar part
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    yt = fc(prep.xt)
    unsafe_fast = D == Nothing ? true : false
    GTPSA.hessian!(
        hess,
        yt;
        include_params = true,
        unsafe_inbounds = true,
        unsafe_fast = unsafe_fast,
        tmp_mono = prep.m,
    )
    return hess
end

function DI.value_gradient_and_hessian(
        f,
        prep::GTPSAOneArgHessianPrep,
        backend::AutoGTPSA{D},
        x,
        contexts::Vararg{DI.Constant, C},
    ) where {D, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    foreach((t, xi) -> t[0] = xi, prep.xt, x) # Set the scalar part
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    yt = fc(prep.xt)
    grad = similar(x, GTPSA.numtype(yt))
    GTPSA.gradient!(grad, yt; include_params = true, unsafe_inbounds = true)
    hess = similar(x, GTPSA.numtype(yt), (length(x), length(x)))
    unsafe_fast = D == Nothing ? true : false
    GTPSA.hessian!(
        hess,
        yt;
        include_params = true,
        unsafe_inbounds = true,
        unsafe_fast = unsafe_fast,
        tmp_mono = prep.m,
    )
    return yt[0], grad, hess
end

function DI.value_gradient_and_hessian!(
        f,
        grad,
        hess,
        prep::GTPSAOneArgHessianPrep,
        backend::AutoGTPSA{D},
        x,
        contexts::Vararg{DI.Constant, C},
    ) where {D, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    foreach((t, xi) -> t[0] = xi, prep.xt, x) # Set the scalar part
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    yt = fc(prep.xt)
    GTPSA.gradient!(grad, yt; include_params = true, unsafe_inbounds = true)
    unsafe_fast = D == Nothing ? true : false
    GTPSA.hessian!(
        hess,
        yt;
        include_params = true,
        unsafe_inbounds = true,
        unsafe_fast = unsafe_fast,
        tmp_mono = prep.m,
    )
    return yt[0], grad, hess
end

struct GTPSAOneArgHVPPrep{SIG, E, H} <: DI.HVPPrep{SIG}
    _sig::Val{SIG}
    hessprep::E
    hess::H
end

function DI.prepare_hvp_nokwarg(
        strict::Val, f, backend::AutoGTPSA, x, tx::NTuple, contexts::Vararg{DI.Constant, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, tx, contexts...; strict)
    hessprep = DI.prepare_hessian_nokwarg(strict, f, backend, x, contexts...)
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    hess = similar(x, typeof(fc(x)), (length(x), length(x)))
    return GTPSAOneArgHVPPrep(_sig, hessprep, hess)
end

function DI.hvp(
        f,
        prep::GTPSAOneArgHVPPrep,
        backend::AutoGTPSA,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Constant, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    DI.hessian!(f, prep.hess, prep.hessprep, backend, x, contexts...)
    tg = map(tx) do dx
        dg = similar(x, eltype(prep.hess))
        dg .= 0
        j = 1
        for dxi in dx
            for i in 1:size(prep.hess, 1)
                dg[i] += prep.hess[i, j] * dxi
            end
            j += 1
        end
        return dg
    end
    return tg
end

function DI.hvp!(
        f,
        tg::NTuple,
        prep::GTPSAOneArgHVPPrep,
        backend::AutoGTPSA,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Constant, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    DI.hessian!(f, prep.hess, prep.hessprep, backend, x, contexts...)
    for b in eachindex(tg)
        dx, dg = tx[b], tg[b]
        dg .= 0
        j = 1
        for dxi in dx
            for i in 1:size(prep.hess, 1)
                dg[i] += prep.hess[i, j] * dxi
            end
            j += 1
        end
    end
    return tg
end

function DI.gradient_and_hvp(
        f,
        prep::GTPSAOneArgHVPPrep,
        backend::AutoGTPSA{D},
        x,
        tx::NTuple,
        contexts::Vararg{DI.Constant, C},
    ) where {D, C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    grad = similar(x, eltype(prep.hess))
    DI.value_gradient_and_hessian!(
        f, grad, prep.hess, prep.hessprep, backend, x, contexts...
    )
    tg = map(tx) do dx
        dg = similar(x, eltype(prep.hess))
        dg .= 0
        j = 1
        for dxi in dx
            for i in 1:size(prep.hess, 1)
                dg[i] += prep.hess[i, j] * dxi
            end
            j += 1
        end
        return dg
    end
    return grad, tg
end

function DI.gradient_and_hvp!(
        f,
        grad,
        tg,
        prep::GTPSAOneArgHVPPrep,
        backend::AutoGTPSA{D},
        x,
        tx::NTuple,
        contexts::Vararg{DI.Constant, C},
    ) where {D, C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    DI.value_gradient_and_hessian!(
        f, grad, prep.hess, prep.hessprep, backend, x, contexts...
    )
    for b in eachindex(tg, tx)
        dg, dx = tg[b], tx[b]
        dg .= 0
        j = 1
        for dxi in dx
            for i in 1:size(prep.hess, 1)
                dg[i] += prep.hess[i, j] * dxi
            end
            j += 1
        end
    end
    return grad, tg
end

using Pkg

using ADTypes: ADTypes
using DataFrames: DataFrame
using DifferentiationInterface, DifferentiationInterfaceTest
import DifferentiationInterface as DI
import DifferentiationInterfaceTest as DIT
using FiniteDiff: FiniteDiff
using Test
import Chairmarks

@testset "Benchmarking sparse" begin
    filtered_sparse_scenarios = filter(sparse_scenarios(; band_sizes = [])) do scen
        DIT.function_place(scen) == :in &&
            DIT.operator_place(scen) == :in &&
            scen.x isa AbstractVector &&
            scen.y isa AbstractVector
    end

    data = benchmark_differentiation(
        MyAutoSparse(AutoFiniteDiff()),
        filtered_sparse_scenarios;
        benchmark = :prepared,
        excluded = SECOND_ORDER,
        logging = LOGGING,
    ) |> DataFrame
    @testset "Analyzing benchmark results" begin
        @testset "$(row[:scenario])" for row in eachrow(data)
            @test row[:allocs] == 0
        end
    end
end

## Pushforward
DI.overloaded_input_type(prep::ForwardDiffOneArgPushforwardPrep) = typeof(prep.xdual_tmp)
DI.overloaded_input_type(prep::ForwardDiffTwoArgPushforwardPrep) = typeof(prep.xdual_tmp)

function DI.overloaded_input(
        ::typeof(DI.pushforward), f::F, backend::AutoForwardDiff, x, tx::NTuple{B}
    ) where {F, B}
    T = tag_type(f, backend, x)
    xdual = make_dual(T, x, tx)
    return xdual
end

function DI.overloaded_input(
        ::typeof(DI.pushforward), f!::F, y, backend::AutoForwardDiff, x, tx::NTuple{B}
    ) where {F, B}
    T = tag_type(f!, backend, x)
    xdual = make_dual(T, x, tx)
    return xdual
end

## Derivative
function DI.overloaded_input_type(prep::ForwardDiffOneArgDerivativePrep)
    return DI.overloaded_input_type(prep.pushforward_prep)
end
function DI.overloaded_input_type(
        prep::ForwardDiffTwoArgDerivativePrep{SIG, X, <:DerivativeConfig{T}}
    ) where {SIG, X, T}
    return typeof(Dual{T}(one(X), one(X)))
end

## Gradient
DI.overloaded_input_type(prep::ForwardDiffGradientPrep) = typeof(prep.config.duals)

## Jacobian
DI.overloaded_input_type(prep::ForwardDiffOneArgJacobianPrep) = typeof(prep.config.duals)
DI.overloaded_input_type(prep::ForwardDiffTwoArgJacobianPrep) = typeof(prep.config.duals[2])

get_config(::AnyAutoMooncake{Nothing}) = Config()
get_config(backend::AnyAutoMooncake{<:Config}) = backend.config

@inline zero_tangent_unwrap(c::DI.Context) = zero_tangent(DI.unwrap(c))
@inline first_unwrap(c, dc) = (DI.unwrap(c), dc)

function call_and_return(f!::F, y, x, contexts...) where {F}
    f!(y, x, contexts...)
    return y
end

function adaptive_tangent_to_primal!!(primal, tangent)
    @static if new_friendly_tangents()
        # TODO: optimize performance by allocating cache during prep
        return Mooncake.tangent_to_friendly!!(primal, tangent)
    else
        return Mooncake.tangent_to_primal!!(primal, tangent)
    end
end

function zero_tangent_or_primal(x, backend::AnyAutoMooncake)
    if get_config(backend).friendly_tangents
        # zero(x) but safer
        return adaptive_tangent_to_primal!!(_copy_output(x), zero_tangent(x))
    else
        return zero_tangent(x)
    end
end

struct ReturnZero{T}
    template::T
end

(rz::ReturnZero)(i) = zero(rz.template)

_zero!(x::AbstractArray{T}) where {T} = fill!(x, zero(T))

## Forward

"""
    AutoZeroForward <: ADTypes.AbstractADType

Trivial backend that sets all derivatives to zero.
Used in testing and benchmarking.
"""
struct AutoZeroForward <: AbstractADType end

ADTypes.mode(::AutoZeroForward) = ForwardMode()
check_available(::AutoZeroForward) = true
inplace_support(::AutoZeroForward) = InPlaceSupported()

function prepare_pushforward_nokwarg(
        strict::Val, f::F, backend::AutoZeroForward, x, tx::NTuple, contexts::Vararg{Context, C}
    ) where {F, C}
    _sig = signature(f, backend, x, tx, contexts...; strict)
    return NoPushforwardPrep(_sig)
end

function prepare_pushforward_nokwarg(
        strict::Val,
        f!::F,
        y,
        backend::AutoZeroForward,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C}
    ) where {F, C}
    _sig = signature(f!, y, backend, x, tx, contexts...; strict)
    return NoPushforwardPrep(_sig)
end

function value_and_pushforward(
        f::F,
        prep::NoPushforwardPrep,
        backend::AutoZeroForward,
        x,
        tx::NTuple{B},
        contexts::Vararg{Context, C},
    ) where {F, B, C}
    check_prep(f, prep, backend, x, tx, contexts...)
    y = f(x, map(unwrap, contexts)...)
    ty = map(ReturnZero(y), tx)
    return y, ty
end

function value_and_pushforward(
        f!::F,
        y,
        prep::NoPushforwardPrep,
        backend::AutoZeroForward,
        x,
        tx::NTuple{B},
        contexts::Vararg{Context, C},
    ) where {F, B, C}
    check_prep(f!, y, prep, backend, x, tx, contexts...)
    f!(y, x, map(unwrap, contexts)...)
    ty = map(ReturnZero(y), tx)
    return y, ty
end

function value_and_pushforward!(
        f::F,
        ty::NTuple,
        prep::NoPushforwardPrep,
        backend::AutoZeroForward,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, tx, contexts...)
    y = f(x, map(unwrap, contexts)...)
    for b in eachindex(ty)
        _zero!(ty[b])
    end
    return y, ty
end

function value_and_pushforward!(
        f!::F,
        y,
        ty::NTuple,
        prep::NoPushforwardPrep,
        backend::AutoZeroForward,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f!, y, prep, backend, x, tx, contexts...)
    f!(y, x, map(unwrap, contexts)...)
    for b in eachindex(ty)
        _zero!(ty[b])
    end
    return y, ty
end

## Reverse

"""
    AutoZeroReverse <: ADTypes.AbstractADType

Trivial backend that sets all derivatives to zero.
Used in testing and benchmarking.
"""
struct AutoZeroReverse <: AbstractADType end

ADTypes.mode(::AutoZeroReverse) = ReverseMode()
check_available(::AutoZeroReverse) = true
inplace_support(::AutoZeroReverse) = InPlaceSupported()

function prepare_pullback_nokwarg(
        strict::Val, f::F, backend::AutoZeroReverse, x, ty::NTuple, contexts::Vararg{Context, C}
    ) where {F, C}
    _sig = signature(f, backend, x, ty, contexts...; strict)
    return NoPullbackPrep(_sig)
end

function prepare_pullback_nokwarg(
        strict::Val,
        f!::F,
        y,
        backend::AutoZeroReverse,
        x,
        ty::NTuple,
        contexts::Vararg{Context, C}
    ) where {F, C}
    _sig = signature(f!, y, backend, x, ty, contexts...; strict)
    return NoPullbackPrep(_sig)
end

function value_and_pullback(
        f::F,
        prep::NoPullbackPrep,
        backend::AutoZeroReverse,
        x,
        ty::NTuple{B},
        contexts::Vararg{Context, C},
    ) where {F, B, C}
    check_prep(f, prep, backend, x, ty, contexts...)
    y = f(x, map(unwrap, contexts)...)
    tx = ntuple(ReturnZero(x), Val(B))
    return y, tx
end

function value_and_pullback(
        f!::F,
        y,
        prep::NoPullbackPrep,
        backend::AutoZeroReverse,
        x,
        ty::NTuple{B},
        contexts::Vararg{Context, C},
    ) where {F, B, C}
    check_prep(f!, y, prep, backend, x, ty, contexts...)
    f!(y, x, map(unwrap, contexts)...)
    tx = ntuple(ReturnZero(x), Val(B))
    return y, tx
end

function value_and_pullback!(
        f::F,
        tx::NTuple,
        prep::NoPullbackPrep,
        backend::AutoZeroReverse,
        x,
        ty::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, ty, contexts...)
    y = f(x, map(unwrap, contexts)...)
    for b in eachindex(tx)
        _zero!(tx[b])
    end
    return y, tx
end

function value_and_pullback!(
        f!::F,
        y,
        tx::NTuple,
        prep::NoPullbackPrep,
        backend::AutoZeroReverse,
        x,
        ty::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f!, y, prep, backend, x, ty, contexts...)
    f!(y, x, map(unwrap, contexts)...)
    for b in eachindex(tx)
        _zero!(tx[b])
    end
    return y, tx
end

## Counterparts

# The zero backends are each other's counterpart, since they both return zero derivatives.

forward_counterpart(::AutoZeroReverse) = AutoZeroForward()
reverse_counterpart(::AutoZeroForward) = AutoZeroReverse()

abstract type FromPrimitive{inplace} <: AbstractADType end

check_available(backend::FromPrimitive) = check_available(backend.backend)
inplace_support(::FromPrimitive{true}) = InPlaceSupported()
inplace_support(::FromPrimitive{false}) = InPlaceNotSupported()

function pick_batchsize(backend::FromPrimitive, x_or_y::AbstractArray)
    return pick_batchsize(backend.backend, x_or_y)
end

function pick_batchsize(backend::FromPrimitive, N::Integer)
    return pick_batchsize(backend.backend, N)
end

function inner_preparation_behavior(backend::FromPrimitive)
    return inner_preparation_behavior(backend.backend)
end

function overloaded_input(::typeof(pushforward), f, backend::FromPrimitive, x, tx::NTuple)
    return overloaded_input(pushforward, f, backend.backend, x, tx)
end

function overloaded_input(
        ::typeof(pushforward), f!, y, backend::FromPrimitive, x, tx::NTuple
    )
    return overloaded_input(pushforward, f!, y, backend.backend, x, tx)
end

"""
    AutoForwardFromPrimitive(backend::AbstractADType)

Wrapper which forces a given backend to act as a forward-mode backend, using only its native `value_and_pushforward` primitive and re-implementing the rest from scratch.

!!! tip

    This can be useful to circumvent high-level operators when they have impractical limitations.
    For instance, ForwardDiff.jl's `jacobian` does not support GPU arrays but its `pushforward` does, so `AutoForwardFromPrimitive(AutoForwardDiff())` has a GPU-friendly `jacobian`.
"""
struct AutoForwardFromPrimitive{inplace, B <: AbstractADType} <: FromPrimitive{inplace}
    backend::B
end

function AutoForwardFromPrimitive(
        backend::AbstractADType; inplace::Bool = Bool(inplace_support(backend))
    )
    return AutoForwardFromPrimitive{inplace, typeof(backend)}(backend)
end

ADTypes.mode(::AutoForwardFromPrimitive) = ADTypes.ForwardMode()

function threshold_batchsize(
        backend::AutoForwardFromPrimitive{inplace}, dimension::Integer
    ) where {inplace}
    return AutoForwardFromPrimitive(
        threshold_batchsize(backend.backend, dimension); inplace
    )
end

struct FromPrimitivePushforwardPrep{SIG, E <: PushforwardPrep} <: PushforwardPrep{SIG}
    _sig::Val{SIG}
    pushforward_prep::E
end

function prepare_pushforward_nokwarg(
        strict::Val,
        f::F,
        backend::AutoForwardFromPrimitive,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C}
    ) where {F, C}
    _sig = signature(f, backend, x, tx, contexts...; strict)
    primitive_prep = prepare_pushforward_nokwarg(
        strict, f, backend.backend, x, tx, contexts...
    )
    return FromPrimitivePushforwardPrep(_sig, primitive_prep)
end

function prepare_pushforward_nokwarg(
        strict::Val,
        f!::F,
        y,
        backend::AutoForwardFromPrimitive,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C}
    ) where {F, C}
    _sig = signature(f!, y, backend, x, tx, contexts...; strict)
    primitive_prep = prepare_pushforward_nokwarg(
        strict, f!, y, backend.backend, x, tx, contexts...
    )
    return FromPrimitivePushforwardPrep(_sig, primitive_prep)
end

function value_and_pushforward(
        f::F,
        prep::FromPrimitivePushforwardPrep,
        backend::AutoForwardFromPrimitive,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, tx, contexts...)
    return value_and_pushforward(
        f, prep.pushforward_prep, backend.backend, x, tx, contexts...
    )
end

function value_and_pushforward(
        f!::F,
        y,
        prep::FromPrimitivePushforwardPrep,
        backend::AutoForwardFromPrimitive,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f!, y, prep, backend, x, tx, contexts...)
    return value_and_pushforward(
        f!, y, prep.pushforward_prep, backend.backend, x, tx, contexts...
    )
end

function value_and_pushforward!(
        f::F,
        ty::NTuple,
        prep::FromPrimitivePushforwardPrep,
        backend::AutoForwardFromPrimitive,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, tx, contexts...)
    return value_and_pushforward!(
        f, ty, prep.pushforward_prep, backend.backend, x, tx, contexts...
    )
end

function value_and_pushforward!(
        f!::F,
        y,
        ty::NTuple,
        prep::FromPrimitivePushforwardPrep,
        backend::AutoForwardFromPrimitive,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f!, y, prep, backend, x, tx, contexts...)
    return value_and_pushforward!(
        f!, y, ty, prep.pushforward_prep, backend.backend, x, tx, contexts...
    )
end

"""
    AutoReverseFromPrimitive(backend::AbstractADType)

Wrapper which forces a given backend to act as a reverse-mode backend, using only its native `value_and_pullback` implementation and rebuilding the rest from scratch.
"""
struct AutoReverseFromPrimitive{inplace, B <: AbstractADType} <: FromPrimitive{inplace}
    backend::B
end

function AutoReverseFromPrimitive(
        backend::AbstractADType; inplace::Bool = Bool(inplace_support(backend))
    )
    return AutoReverseFromPrimitive{inplace, typeof(backend)}(backend)
end

ADTypes.mode(::AutoReverseFromPrimitive) = ADTypes.ReverseMode()

function threshold_batchsize(
        backend::AutoReverseFromPrimitive{inplace}, dimension::Integer
    ) where {inplace}
    return AutoReverseFromPrimitive(
        threshold_batchsize(backend.backend, dimension); inplace
    )
end

struct FromPrimitivePullbackPrep{SIG, E <: PullbackPrep} <: PullbackPrep{SIG}
    _sig::Val{SIG}
    pullback_prep::E
end

function prepare_pullback_nokwarg(
        strict::Val,
        f::F,
        backend::AutoReverseFromPrimitive,
        x,
        ty::NTuple,
        contexts::Vararg{Context, C}
    ) where {F, C}
    _sig = signature(f, backend, x, ty, contexts...; strict)
    primitive_prep = prepare_pullback_nokwarg(
        strict, f, backend.backend, x, ty, contexts...
    )
    return FromPrimitivePullbackPrep(_sig, primitive_prep)
end

function prepare_pullback_nokwarg(
        strict::Val,
        f!::F,
        y,
        backend::AutoReverseFromPrimitive,
        x,
        ty::NTuple,
        contexts::Vararg{Context, C}
    ) where {F, C}
    _sig = signature(f!, y, backend, x, ty, contexts...; strict)
    primitive_prep = prepare_pullback_nokwarg(
        strict, f!, y, backend.backend, x, ty, contexts...
    )
    return FromPrimitivePullbackPrep(_sig, primitive_prep)
end

function value_and_pullback(
        f::F,
        prep::FromPrimitivePullbackPrep,
        backend::AutoReverseFromPrimitive,
        x,
        ty::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, ty, contexts...)
    return value_and_pullback(f, prep.pullback_prep, backend.backend, x, ty, contexts...)
end

function value_and_pullback(
        f!::F,
        y,
        prep::FromPrimitivePullbackPrep,
        backend::AutoReverseFromPrimitive,
        x,
        ty::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f!, y, prep, backend, x, ty, contexts...)
    return value_and_pullback(
        f!, y, prep.pullback_prep, backend.backend, x, ty, contexts...
    )
end

function value_and_pullback!(
        f::F,
        tx::NTuple,
        prep::FromPrimitivePullbackPrep,
        backend::AutoReverseFromPrimitive,
        x,
        ty::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, ty, contexts...)
    return value_and_pullback!(
        f, tx, prep.pullback_prep, backend.backend, x, ty, contexts...
    )
end

function value_and_pullback!(
        f!::F,
        y,
        tx::NTuple,
        prep::FromPrimitivePullbackPrep,
        backend::AutoReverseFromPrimitive,
        x,
        ty::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f!, y, prep, backend, x, ty, contexts...)
    return value_and_pullback!(
        f!, y, tx, prep.pullback_prep, backend.backend, x, ty, contexts...
    )
end

## Counterparts

# The counterpart of a `FromPrimitive` wrapper swaps the primitive (pushforward or
# pullback), applying the counterpart to the wrapped backend as well.

function forward_counterpart(backend::AutoReverseFromPrimitive)
    return AutoForwardFromPrimitive(forward_counterpart(backend.backend))
end

function reverse_counterpart(backend::AutoForwardFromPrimitive)
    return AutoReverseFromPrimitive(reverse_counterpart(backend.backend))
end

## Pushforward

struct FastDifferentiationOneArgPushforwardPrep{SIG, Y, E1, E1!} <: DI.PushforwardPrep{SIG}
    _sig::Val{SIG}
    y_prototype::Y
    jvp_exe::E1
    jvp_exe!::E1!
end

function DI.prepare_pushforward_nokwarg(
        strict::Val,
        f,
        backend::AutoFastDifferentiation,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, tx, contexts...; strict)
    y_prototype = f(x, map(DI.unwrap, contexts)...)
    x_var = variablize(x, :x)
    context_vars = variablize(contexts)
    y_var = f(x_var, context_vars...)
    x_vec_var = myvec(x_var)
    context_vec_vars = map(myvec, context_vars)
    y_vec_var = myvec(y_var)
    jv_vec_var, v_vec_var = jacobian_times_v(y_vec_var, x_vec_var)
    jvp_exe = make_function(
        jv_vec_var, x_vec_var, v_vec_var, context_vec_vars...; in_place = false
    )
    jvp_exe! = make_function(
        jv_vec_var, x_vec_var, v_vec_var, context_vec_vars...; in_place = true
    )
    return FastDifferentiationOneArgPushforwardPrep(_sig, y_prototype, jvp_exe, jvp_exe!)
end

function DI.pushforward(
        f,
        prep::FastDifferentiationOneArgPushforwardPrep,
        backend::AutoFastDifferentiation,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    ty = map(tx) do dx
        result = prep.jvp_exe(myvec(x), myvec(dx), map(myvec_unwrap, contexts)...)
        if prep.y_prototype isa Number
            return only(result)
        else
            return reshape(result, size(prep.y_prototype))
        end
    end
    return ty
end

function DI.pushforward!(
        f,
        ty::NTuple,
        prep::FastDifferentiationOneArgPushforwardPrep,
        backend::AutoFastDifferentiation,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    for b in eachindex(tx, ty)
        dx, dy = tx[b], ty[b]
        prep.jvp_exe!(myvec(dy), myvec(x), myvec(dx), map(myvec_unwrap, contexts)...)
    end
    return ty
end

function DI.value_and_pushforward(
        f,
        prep::FastDifferentiationOneArgPushforwardPrep,
        backend::AutoFastDifferentiation,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    return f(x, map(DI.unwrap, contexts)...),
        DI.pushforward(f, prep, backend, x, tx, contexts...)
end

function DI.value_and_pushforward!(
        f,
        ty::NTuple,
        prep::FastDifferentiationOneArgPushforwardPrep,
        backend::AutoFastDifferentiation,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    return f(x, map(DI.unwrap, contexts)...),
        DI.pushforward!(f, ty, prep, backend, x, tx, contexts...)
end

## Pullback

struct FastDifferentiationOneArgPullbackPrep{SIG, E1, E1!} <: DI.PullbackPrep{SIG}
    _sig::Val{SIG}
    vjp_exe::E1
    vjp_exe!::E1!
end

function DI.prepare_pullback_nokwarg(
        strict::Val,
        f,
        backend::AutoFastDifferentiation,
        x,
        ty::NTuple,
        contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, ty, contexts...; strict)
    x_var = variablize(x, :x)
    context_vars = variablize(contexts)
    y_var = f(x_var, context_vars...)

    x_vec_var = myvec(x_var)
    context_vec_vars = map(myvec, context_vars)
    y_vec_var = myvec(y_var)
    vj_vec_var, v_vec_var = jacobian_transpose_v(y_vec_var, x_vec_var)
    vjp_exe = make_function(
        vj_vec_var, x_vec_var, v_vec_var, context_vec_vars...; in_place = false
    )
    vjp_exe! = make_function(
        vj_vec_var, x_vec_var, v_vec_var, context_vec_vars...; in_place = true
    )
    return FastDifferentiationOneArgPullbackPrep(_sig, vjp_exe, vjp_exe!)
end

function DI.pullback(
        f,
        prep::FastDifferentiationOneArgPullbackPrep,
        backend::AutoFastDifferentiation,
        x,
        ty::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, ty, contexts...)
    tx = map(ty) do dy
        result = prep.vjp_exe(myvec(x), myvec(dy), map(myvec_unwrap, contexts)...)
        if x isa Number
            return only(result)
        else
            return reshape(result, size(x))
        end
    end
    return tx
end

function DI.pullback!(
        f,
        tx::NTuple,
        prep::FastDifferentiationOneArgPullbackPrep,
        backend::AutoFastDifferentiation,
        x,
        ty::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, ty, contexts...)
    for b in eachindex(tx, ty)
        dx, dy = tx[b], ty[b]
        prep.vjp_exe!(myvec(dx), myvec(x), myvec(dy), map(myvec_unwrap, contexts)...)
    end
    return tx
end

function DI.value_and_pullback(
        f,
        prep::FastDifferentiationOneArgPullbackPrep,
        backend::AutoFastDifferentiation,
        x,
        ty::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, ty, contexts...)
    return f(x, map(DI.unwrap, contexts)...),
        DI.pullback(f, prep, backend, x, ty, contexts...)
end

function DI.value_and_pullback!(
        f,
        tx::NTuple,
        prep::FastDifferentiationOneArgPullbackPrep,
        backend::AutoFastDifferentiation,
        x,
        ty::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, ty, contexts...)
    return f(x, map(DI.unwrap, contexts)...),
        DI.pullback!(f, tx, prep, backend, x, ty, contexts...)
end

## Derivative

struct FastDifferentiationOneArgDerivativePrep{SIG, Y, E1, E1!} <: DI.DerivativePrep{SIG}
    _sig::Val{SIG}
    y_prototype::Y
    der_exe::E1
    der_exe!::E1!
end

function DI.prepare_derivative_nokwarg(
        strict::Val, f, backend::AutoFastDifferentiation, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    y_prototype = f(x, map(DI.unwrap, contexts)...)
    x_var = variablize(x, :x)
    context_vars = variablize(contexts)
    y_var = f(x_var, context_vars...)

    x_vec_var = myvec(x_var)
    context_vec_vars = map(myvec, context_vars)
    y_vec_var = myvec(y_var)
    der_vec_var = derivative(y_vec_var, x_var)
    der_exe = make_function(der_vec_var, x_vec_var, context_vec_vars...; in_place = false)
    der_exe! = make_function(der_vec_var, x_vec_var, context_vec_vars...; in_place = true)
    return FastDifferentiationOneArgDerivativePrep(_sig, y_prototype, der_exe, der_exe!)
end

function DI.derivative(
        f,
        prep::FastDifferentiationOneArgDerivativePrep,
        backend::AutoFastDifferentiation,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    result = prep.der_exe(myvec(x), map(myvec_unwrap, contexts)...)
    if prep.y_prototype isa Number
        return only(result)
    else
        return reshape(result, size(prep.y_prototype))
    end
end

function DI.derivative!(
        f,
        der,
        prep::FastDifferentiationOneArgDerivativePrep,
        backend::AutoFastDifferentiation,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    prep.der_exe!(myvec(der), myvec(x), map(myvec_unwrap, contexts)...)
    return der
end

function DI.value_and_derivative(
        f,
        prep::FastDifferentiationOneArgDerivativePrep,
        backend::AutoFastDifferentiation,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return f(x, map(DI.unwrap, contexts)...),
        DI.derivative(f, prep, backend, x, contexts...)
end

function DI.value_and_derivative!(
        f,
        der,
        prep::FastDifferentiationOneArgDerivativePrep,
        backend::AutoFastDifferentiation,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return f(x, map(DI.unwrap, contexts)...),
        DI.derivative!(f, der, prep, backend, x, contexts...)
end

## Gradient

struct FastDifferentiationOneArgGradientPrep{SIG, E1, E1!} <: DI.GradientPrep{SIG}
    _sig::Val{SIG}
    jac_exe::E1
    jac_exe!::E1!
end

function DI.prepare_gradient_nokwarg(
        strict::Val, f, backend::AutoFastDifferentiation, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    x_var = variablize(x, :x)
    context_vars = variablize(contexts)
    y_var = f(x_var, context_vars...)

    x_vec_var = myvec(x_var)
    context_vec_vars = map(myvec, context_vars)
    y_vec_var = myvec(y_var)
    jac_var = jacobian(y_vec_var, x_vec_var)
    jac_exe = make_function(jac_var, x_vec_var, context_vec_vars...; in_place = false)
    jac_exe! = make_function(jac_var, x_vec_var, context_vec_vars...; in_place = true)
    return FastDifferentiationOneArgGradientPrep(_sig, jac_exe, jac_exe!)
end

function DI.gradient(
        f,
        prep::FastDifferentiationOneArgGradientPrep,
        backend::AutoFastDifferentiation,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    jac = prep.jac_exe(myvec(x), map(myvec_unwrap, contexts)...)
    grad_vec = @view jac[1, :]
    return reshape(grad_vec, size(x))
end

function DI.gradient!(
        f,
        grad,
        prep::FastDifferentiationOneArgGradientPrep,
        backend::AutoFastDifferentiation,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    prep.jac_exe!(reshape(grad, 1, length(grad)), myvec(x), map(myvec_unwrap, contexts)...)
    return grad
end

function DI.value_and_gradient(
        f,
        prep::FastDifferentiationOneArgGradientPrep,
        backend::AutoFastDifferentiation,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return f(x, map(DI.unwrap, contexts)...), DI.gradient(f, prep, backend, x, contexts...)
end

function DI.value_and_gradient!(
        f,
        grad,
        prep::FastDifferentiationOneArgGradientPrep,
        backend::AutoFastDifferentiation,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return f(x, map(DI.unwrap, contexts)...),
        DI.gradient!(f, grad, prep, backend, x, contexts...)
end

## Jacobian

struct FastDifferentiationOneArgJacobianPrep{SIG, Y, P, E1, E1!} <: DI.SparseJacobianPrep{SIG}
    _sig::Val{SIG}
    y_prototype::Y
    sparsity::P
    jac_exe::E1
    jac_exe!::E1!
end

function DI.prepare_jacobian_nokwarg(
        strict::Val,
        f,
        backend::Union{AutoFastDifferentiation, AutoSparse{<:AutoFastDifferentiation}},
        x,
        contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    y_prototype = f(x, map(DI.unwrap, contexts)...)
    x_var = variablize(x, :x)
    context_vars = variablize(contexts)
    y_var = f(x_var, context_vars...)

    x_vec_var = myvec(x_var)
    context_vec_vars = map(myvec, context_vars)
    y_vec_var = myvec(y_var)
    if backend isa AutoSparse
        jac_var = sparse_jacobian(y_vec_var, x_vec_var)
        sparsity = DI.get_pattern(jac_var)
    else
        jac_var = jacobian(y_vec_var, x_vec_var)
        sparsity = nothing
    end
    jac_exe = make_function(jac_var, x_vec_var, context_vec_vars...; in_place = false)
    jac_exe! = make_function(jac_var, x_vec_var, context_vec_vars...; in_place = true)
    return FastDifferentiationOneArgJacobianPrep(
        _sig, y_prototype, sparsity, jac_exe, jac_exe!
    )
end

function DI.jacobian(
        f,
        prep::FastDifferentiationOneArgJacobianPrep,
        backend::Union{AutoFastDifferentiation, AutoSparse{<:AutoFastDifferentiation}},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return prep.jac_exe(myvec(x), map(myvec_unwrap, contexts)...)
end

function DI.jacobian!(
        f,
        jac,
        prep::FastDifferentiationOneArgJacobianPrep,
        backend::Union{AutoFastDifferentiation, AutoSparse{<:AutoFastDifferentiation}},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    prep.jac_exe!(jac, myvec(x), map(myvec_unwrap, contexts)...)
    return jac
end

function DI.value_and_jacobian(
        f,
        prep::FastDifferentiationOneArgJacobianPrep,
        backend::Union{AutoFastDifferentiation, AutoSparse{<:AutoFastDifferentiation}},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return f(x, map(DI.unwrap, contexts)...), DI.jacobian(f, prep, backend, x, contexts...)
end

function DI.value_and_jacobian!(
        f,
        jac,
        prep::FastDifferentiationOneArgJacobianPrep,
        backend::Union{AutoFastDifferentiation, AutoSparse{<:AutoFastDifferentiation}},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return f(x, map(DI.unwrap, contexts)...),
        DI.jacobian!(f, jac, prep, backend, x, contexts...)
end

## Second derivative

struct FastDifferentiationAllocatingSecondDerivativePrep{SIG, Y, D, E2, E2!} <:
    DI.SecondDerivativePrep{SIG}
    _sig::Val{SIG}
    y_prototype::Y
    derivative_prep::D
    der2_exe::E2
    der2_exe!::E2!
end

function DI.prepare_second_derivative_nokwarg(
        strict::Val, f, backend::AutoFastDifferentiation, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    y_prototype = f(x, map(DI.unwrap, contexts)...)
    x_var = variablize(x, :x)
    context_vars = variablize(contexts)
    y_var = f(x_var, context_vars...)

    x_vec_var = myvec(x_var)
    context_vec_vars = map(myvec, context_vars)
    y_vec_var = myvec(y_var)

    der2_vec_var = derivative(y_vec_var, x_var, x_var)
    der2_exe = make_function(der2_vec_var, x_vec_var, context_vec_vars...; in_place = false)
    der2_exe! = make_function(der2_vec_var, x_vec_var, context_vec_vars...; in_place = true)

    derivative_prep = DI.prepare_derivative_nokwarg(strict, f, backend, x, contexts...)
    return FastDifferentiationAllocatingSecondDerivativePrep(
        _sig, y_prototype, derivative_prep, der2_exe, der2_exe!
    )
end

function DI.second_derivative(
        f,
        prep::FastDifferentiationAllocatingSecondDerivativePrep,
        backend::AutoFastDifferentiation,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    result = prep.der2_exe(myvec(x), map(myvec_unwrap, contexts)...)
    if prep.y_prototype isa Number
        return only(result)
    else
        return reshape(result, size(prep.y_prototype))
    end
end

function DI.second_derivative!(
        f,
        der2,
        prep::FastDifferentiationAllocatingSecondDerivativePrep,
        backend::AutoFastDifferentiation,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    prep.der2_exe!(myvec(der2), myvec(x), map(myvec_unwrap, contexts)...)
    return der2
end

function DI.value_derivative_and_second_derivative(
        f,
        prep::FastDifferentiationAllocatingSecondDerivativePrep,
        backend::AutoFastDifferentiation,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    y, der = DI.value_and_derivative(f, prep.derivative_prep, backend, x, contexts...)
    der2 = DI.second_derivative(f, prep, backend, x, contexts...)
    return y, der, der2
end

function DI.value_derivative_and_second_derivative!(
        f,
        der,
        der2,
        prep::FastDifferentiationAllocatingSecondDerivativePrep,
        backend::AutoFastDifferentiation,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    y, _ = DI.value_and_derivative!(f, der, prep.derivative_prep, backend, x, contexts...)
    DI.second_derivative!(f, der2, prep, backend, x, contexts...)
    return y, der, der2
end

## HVP

struct FastDifferentiationHVPPrep{SIG, E2, E2!, E1} <: DI.HVPPrep{SIG}
    sig::Val{SIG}
    hvp_exe::E2
    hvp_exe!::E2!
    gradient_prep::E1
end

function DI.prepare_hvp_nokwarg(
        strict::Val,
        f,
        backend::AutoFastDifferentiation,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, tx, contexts...; strict)
    x_var = variablize(x, :x)
    context_vars = variablize(contexts)
    y_var = f(x_var, context_vars...)

    x_vec_var = myvec(x_var)
    context_vec_vars = map(myvec, context_vars)
    hv_vec_var, v_vec_var = hessian_times_v(y_var, x_vec_var)
    hvp_exe = make_function(
        hv_vec_var, x_vec_var, v_vec_var, context_vec_vars...; in_place = false
    )
    hvp_exe! = make_function(
        hv_vec_var, x_vec_var, v_vec_var, context_vec_vars...; in_place = true
    )

    gradient_prep = DI.prepare_gradient_nokwarg(strict, f, backend, x, contexts...)
    return FastDifferentiationHVPPrep(_sig, hvp_exe, hvp_exe!, gradient_prep)
end

function DI.hvp(
        f,
        prep::FastDifferentiationHVPPrep,
        backend::AutoFastDifferentiation,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    tg = map(tx) do dx
        dg_vec = prep.hvp_exe(myvec(x), myvec(dx), map(myvec_unwrap, contexts)...)
        return reshape(dg_vec, size(x))
    end
    return tg
end

function DI.hvp!(
        f,
        tg::NTuple,
        prep::FastDifferentiationHVPPrep,
        backend::AutoFastDifferentiation,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    for b in eachindex(tx, tg)
        dx, dg = tx[b], tg[b]
        prep.hvp_exe!(myvec(dg), myvec(x), myvec(dx), map(myvec_unwrap, contexts)...)
    end
    return tg
end

function DI.gradient_and_hvp(
        f,
        prep::FastDifferentiationHVPPrep,
        backend::AutoFastDifferentiation,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    tg = DI.hvp(f, prep, backend, x, tx, contexts...)
    grad = DI.gradient(f, prep.gradient_prep, backend, x, contexts...)
    return grad, tg
end

function DI.gradient_and_hvp!(
        f,
        grad,
        tg::NTuple,
        prep::FastDifferentiationHVPPrep,
        backend::AutoFastDifferentiation,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    DI.hvp!(f, tg, prep, backend, x, tx, contexts...)
    DI.gradient!(f, grad, prep.gradient_prep, backend, x, contexts...)
    return grad, tg
end

## Hessian

struct FastDifferentiationHessianPrep{SIG, G, P, E2, E2!} <: DI.SparseHessianPrep{SIG}
    _sig::Val{SIG}
    gradient_prep::G
    sparsity::P
    hess_exe::E2
    hess_exe!::E2!
end

function DI.prepare_hessian_nokwarg(
        strict::Val,
        f,
        backend::Union{AutoFastDifferentiation, AutoSparse{<:AutoFastDifferentiation}},
        x,
        contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    x_var = variablize(x, :x)
    context_vars = variablize(contexts)
    y_var = f(x_var, context_vars...)

    x_vec_var = myvec(x_var)
    context_vec_vars = map(myvec, context_vars)

    if backend isa AutoSparse
        hess_var = sparse_hessian(y_var, x_vec_var)
        sparsity = DI.get_pattern(hess_var)
    else
        hess_var = hessian(y_var, x_vec_var)
        sparsity = nothing
    end
    hess_exe = make_function(hess_var, x_vec_var, context_vec_vars...; in_place = false)
    hess_exe! = make_function(hess_var, x_vec_var, context_vec_vars...; in_place = true)

    gradient_prep = DI.prepare_gradient_nokwarg(
        strict, f, dense_ad(backend), x, contexts...
    )
    return FastDifferentiationHessianPrep(
        _sig, gradient_prep, sparsity, hess_exe, hess_exe!
    )
end

function DI.hessian(
        f,
        prep::FastDifferentiationHessianPrep,
        backend::Union{AutoFastDifferentiation, AutoSparse{<:AutoFastDifferentiation}},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return prep.hess_exe(myvec(x), map(myvec_unwrap, contexts)...)
end

function DI.hessian!(
        f,
        hess,
        prep::FastDifferentiationHessianPrep,
        backend::Union{AutoFastDifferentiation, AutoSparse{<:AutoFastDifferentiation}},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    prep.hess_exe!(hess, myvec(x), map(myvec_unwrap, contexts)...)
    return hess
end

function DI.value_gradient_and_hessian(
        f,
        prep::FastDifferentiationHessianPrep,
        backend::Union{AutoFastDifferentiation, AutoSparse{<:AutoFastDifferentiation}},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    y, grad = DI.value_and_gradient(
        f, prep.gradient_prep, dense_ad(backend), x, contexts...
    )
    hess = DI.hessian(f, prep, backend, x, contexts...)
    return y, grad, hess
end

function DI.value_gradient_and_hessian!(
        f,
        grad,
        hess,
        prep::FastDifferentiationHessianPrep,
        backend::Union{AutoFastDifferentiation, AutoSparse{<:AutoFastDifferentiation}},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    y, _ = DI.value_and_gradient!(
        f, grad, prep.gradient_prep, dense_ad(backend), x, contexts...
    )
    DI.hessian!(f, hess, prep, backend, x, contexts...)
    return y, grad, hess
end

function seeded_autodiff_thunk(
        rmode::ReverseModeSplit{ReturnPrimal},
        dresult,
        f::FA,
        ::Type{RA},
        args::Vararg{Annotation, N},
    ) where {ReturnPrimal, FA <: Annotation, RA <: Annotation, N}
    forward, reverse = autodiff_thunk(rmode, FA, RA, typeof.(args)...)
    tape, result, shadow_result = forward(f, args...)
    if RA <: Active
        dinputs = only(reverse(f, args..., dresult, tape))
    else
        shadow_result .+= dresult  # TODO: generalize beyond arrays
        dinputs = only(reverse(f, args..., tape))
    end
    if ReturnPrimal
        return (dinputs, result)
    else
        return (dinputs,)
    end
end

function batch_seeded_autodiff_thunk(
        rmode::ReverseModeSplit{ReturnPrimal},
        dresults::NTuple{B},
        f::FA,
        ::Type{RA},
        args::Vararg{Annotation, N},
    ) where {ReturnPrimal, B, FA <: Annotation, RA <: Annotation, N}
    rmode_rightwidth = ReverseSplitWidth(rmode, Val(B))
    forward, reverse = autodiff_thunk(rmode_rightwidth, FA, RA, typeof.(args)...)
    tape, result, shadow_results = forward(f, args...)
    if RA <: Active
        dinputs = only(reverse(f, args..., dresults, tape))
    else
        foreach(shadow_results, dresults) do d0, d
            d0 .+= d  # use recursive_add here?
        end
        dinputs = only(reverse(f, args..., tape))
    end
    if ReturnPrimal
        return (dinputs, result)
    else
        return (dinputs,)
    end
end

## Pullback

struct EnzymeReverseOneArgPullbackPrep{SIG, DF, DC, Y} <: DI.PullbackPrep{SIG}
    _sig::Val{SIG}
    df::DF
    context_shadows::DC
    y_example::Y  # useful to create return activity
end

function DI.prepare_pullback_nokwarg(
        strict::Val,
        f::F,
        backend::AutoEnzyme{<:Union{ReverseMode, Nothing}},
        x,
        ty::NTuple{B},
        contexts::Vararg{DI.Context, C}
    ) where {F, B, C}
    _sig = DI.signature(f, backend, x, ty, contexts...; strict)
    mode = reverse_split_withprimal(backend)
    df = function_shadow(f, backend, mode, Val(B))
    context_shadows = make_context_shadows(backend, mode, Val(B), contexts...)
    y = f(x, map(DI.unwrap, contexts)...)
    return EnzymeReverseOneArgPullbackPrep(_sig, df, context_shadows, y)
end

### Out-of-place

function DI.value_and_pullback(
        f::F,
        prep::EnzymeReverseOneArgPullbackPrep,
        backend::AutoEnzyme{<:Union{ReverseMode, Nothing}},
        x,
        ty::NTuple{1},
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, ty, contexts...)
    (; df, context_shadows, y_example) = prep
    mode = reverse_split_withprimal(backend)
    f_and_df = force_annotation(get_f_and_df_prepared!(df, f, backend, Val(1)))
    IA = guess_activity(typeof(x), mode)
    RA = guess_activity(typeof(y_example), mode)
    dx = make_zero(x)
    annotated_contexts = translate_prepared!(context_shadows, contexts, Val(1))
    dinputs, result = seeded_autodiff_thunk(
        mode, only(ty), f_and_df, RA, annotate(IA, x, dx), annotated_contexts...
    )
    new_dx = first(dinputs)
    if isnothing(new_dx)
        return result, (dx,)
    else
        return result, (new_dx,)
    end
end

function DI.value_and_pullback(
        f::F,
        prep::EnzymeReverseOneArgPullbackPrep,
        backend::AutoEnzyme{<:Union{ReverseMode, Nothing}},
        x,
        ty::NTuple{B},
        contexts::Vararg{DI.Context, C},
    ) where {F, B, C}
    DI.check_prep(f, prep, backend, x, ty, contexts...)
    (; df, context_shadows, y_example) = prep
    mode = reverse_split_withprimal(backend)
    f_and_df = force_annotation(get_f_and_df_prepared!(df, f, backend, Val(B)))
    IA = batchify_activity(guess_activity(typeof(x), mode), Val(B))
    RA = batchify_activity(guess_activity(typeof(y_example), mode), Val(B))
    tx = ntuple(_ -> make_zero(x), Val(B))
    annotated_contexts = translate_prepared!(context_shadows, contexts, Val(B))
    dinputs, result = batch_seeded_autodiff_thunk(
        mode, ty, f_and_df, RA, annotate(IA, x, tx), annotated_contexts...
    )
    new_tx = values(first(dinputs))
    if isnothing(new_tx)
        return result, tx
    else
        return result, new_tx
    end
end

function DI.pullback(
        f::F,
        prep::EnzymeReverseOneArgPullbackPrep,
        backend::AutoEnzyme{<:Union{ReverseMode, Nothing}},
        x,
        ty::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, ty, contexts...)
    return last(DI.value_and_pullback(f, prep, backend, x, ty, contexts...))
end

### In-place

function DI.value_and_pullback!(
        f::F,
        tx::NTuple{1},
        prep::EnzymeReverseOneArgPullbackPrep,
        backend::AutoEnzyme{<:Union{ReverseMode, Nothing}},
        x,
        ty::NTuple{1},
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, ty, contexts...)
    (; df, context_shadows, y_example) = prep
    mode = reverse_split_withprimal(backend)
    f_and_df = force_annotation(get_f_and_df_prepared!(df, f, backend, Val(1)))
    RA = guess_activity(typeof(y_example), mode)
    dx = only(tx)
    make_zero!(dx)
    annotated_contexts = translate_prepared!(context_shadows, contexts, Val(1))
    _, result = seeded_autodiff_thunk(
        mode, only(ty), f_and_df, RA, Duplicated(x, dx), annotated_contexts...
    )
    return result, tx
end

function DI.value_and_pullback!(
        f::F,
        tx::NTuple{B},
        prep::EnzymeReverseOneArgPullbackPrep,
        backend::AutoEnzyme{<:Union{ReverseMode, Nothing}},
        x,
        ty::NTuple{B},
        contexts::Vararg{DI.Context, C},
    ) where {F, B, C}
    DI.check_prep(f, prep, backend, x, ty, contexts...)
    (; df, context_shadows, y_example) = prep
    mode = reverse_split_withprimal(backend)
    f_and_df = force_annotation(get_f_and_df_prepared!(df, f, backend, Val(B)))
    RA = batchify_activity(guess_activity(typeof(y_example), mode), Val(B))
    make_zero!(tx)
    annotated_contexts = translate_prepared!(context_shadows, contexts, Val(B))
    _, result = batch_seeded_autodiff_thunk(
        mode, ty, f_and_df, RA, BatchDuplicated(x, tx), annotated_contexts...
    )
    return result, tx
end

function DI.pullback!(
        f::F,
        tx::NTuple,
        prep::EnzymeReverseOneArgPullbackPrep,
        backend::AutoEnzyme{<:Union{ReverseMode, Nothing}},
        x,
        ty::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, ty, contexts...)
    return last(DI.value_and_pullback!(f, tx, prep, backend, x, ty, contexts...))
end

## Gradient

struct EnzymeGradientPrep{SIG, DF, DC} <: DI.GradientPrep{SIG}
    _sig::Val{SIG}
    df::DF
    context_shadows::DC
end

function DI.prepare_gradient_nokwarg(
        strict::Val,
        f::F,
        backend::AutoEnzyme{<:Union{ReverseMode, Nothing}},
        x,
        contexts::Vararg{DI.Context, C}
    ) where {F, C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    mode = reverse_withprimal(backend)
    df = function_shadow(f, backend, mode, Val(1))
    context_shadows = make_context_shadows(backend, mode, Val(1), contexts...)
    return EnzymeGradientPrep(_sig, df, context_shadows)
end

### Enzyme gradient API (only constants)

function DI.gradient(
        f::F,
        prep::EnzymeGradientPrep,
        backend::AutoEnzyme{<:Union{ReverseMode, Nothing}, <:Union{Nothing, Const}},
        x,
        contexts::Vararg{DI.Constant, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    (; df, context_shadows) = prep
    mode = reverse_noprimal(backend)
    f_and_df = get_f_and_df_prepared!(df, f, backend, Val(1))
    annotated_contexts = translate_prepared!(context_shadows, contexts, Val(1))
    grads = gradient(mode, f_and_df, x, annotated_contexts...)
    return first(grads)
end

function DI.value_and_gradient(
        f::F,
        prep::EnzymeGradientPrep,
        backend::AutoEnzyme{<:Union{ReverseMode, Nothing}, <:Union{Nothing, Const}},
        x,
        contexts::Vararg{DI.Constant, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    (; df, context_shadows) = prep
    mode = reverse_withprimal(backend)
    f_and_df = get_f_and_df_prepared!(df, f, backend, Val(1))
    annotated_contexts = translate_prepared!(context_shadows, contexts, Val(1))
    grads, result = gradient(mode, f_and_df, x, annotated_contexts...)
    return result, first(grads)
end

function DI.gradient!(
        f::F,
        grad,
        prep::EnzymeGradientPrep,
        backend::AutoEnzyme{<:Union{ReverseMode, Nothing}, <:Union{Nothing, Const}},
        x,
    ) where {F}
    DI.check_prep(f, prep, backend, x)
    (; df) = prep
    mode = reverse_noprimal(backend)
    f_and_df = get_f_and_df_prepared!(df, f, backend, Val(1))
    gradient!(mode, grad, f_and_df, x)
    return grad
end

function DI.value_and_gradient!(
        f::F,
        grad,
        prep::EnzymeGradientPrep,
        backend::AutoEnzyme{<:Union{ReverseMode, Nothing}, <:Union{Nothing, Const}},
        x,
    ) where {F}
    DI.check_prep(f, prep, backend, x)
    (; df) = prep
    mode = reverse_withprimal(backend)
    f_and_df = get_f_and_df_prepared!(df, f, backend, Val(1))
    _, result = gradient!(mode, grad, f_and_df, x)
    return result, grad
end

### Generic

function DI.gradient(
        f::F,
        prep::EnzymeGradientPrep,
        backend::AutoEnzyme{<:Union{ReverseMode, Nothing}},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    (; df, context_shadows) = prep
    mode = reverse_noprimal(backend)
    f_and_df = get_f_and_df_prepared!(df, f, backend, Val(1))
    IA = guess_activity(typeof(x), mode)
    grad = make_zero(x)
    annotated_contexts = translate_prepared!(context_shadows, contexts, Val(1))
    dinputs = only(
        autodiff(mode, f_and_df, Active, annotate(IA, x, grad), annotated_contexts...)
    )
    new_grad = first(dinputs)
    if isnothing(new_grad)
        return grad
    else
        return new_grad
    end
end

function DI.value_and_gradient(
        f::F,
        prep::EnzymeGradientPrep,
        backend::AutoEnzyme{<:Union{ReverseMode, Nothing}},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    (; df, context_shadows) = prep
    mode = reverse_withprimal(backend)
    f_and_df = get_f_and_df_prepared!(df, f, backend, Val(1))
    IA = guess_activity(typeof(x), mode)
    grad = make_zero(x)
    annotated_contexts = translate_prepared!(context_shadows, contexts, Val(1))
    dinputs, result = autodiff(
        mode, f_and_df, Active, annotate(IA, x, grad), annotated_contexts...
    )
    new_grad = first(dinputs)
    if isnothing(new_grad)
        return result, grad
    else
        return result, new_grad
    end
end

function DI.gradient!(
        f::F,
        grad,
        prep::EnzymeGradientPrep,
        backend::AutoEnzyme{<:Union{ReverseMode, Nothing}},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    (; df, context_shadows) = prep
    mode = reverse_noprimal(backend)
    f_and_df = get_f_and_df_prepared!(df, f, backend, Val(1))
    annotated_contexts = translate_prepared!(context_shadows, contexts, Val(1))
    make_zero!(grad)
    autodiff(mode, f_and_df, Active, Duplicated(x, grad), annotated_contexts...)
    return grad
end

function DI.value_and_gradient!(
        f::F,
        grad,
        prep::EnzymeGradientPrep,
        backend::AutoEnzyme{<:Union{ReverseMode, Nothing}},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    (; df, context_shadows) = prep
    mode = reverse_withprimal(backend)
    f_and_df = get_f_and_df_prepared!(df, f, backend, Val(1))
    annotated_contexts = translate_prepared!(context_shadows, contexts, Val(1))
    make_zero!(grad)
    _, y = autodiff(mode, f_and_df, Active, Duplicated(x, grad), annotated_contexts...)
    return y, grad
end

## Direct

function ADTypes.jacobian_sparsity(f, x, detector::DI.DenseSparsityDetector{:direct})
    (; backend, atol) = detector
    J = jacobian(f, backend, x)
    return sparse(abs.(J) .> atol)
end

function ADTypes.jacobian_sparsity(f!, y, x, detector::DI.DenseSparsityDetector{:direct})
    (; backend, atol) = detector
    J = jacobian(f!, y, backend, x)
    return sparse(abs.(J) .> atol)
end

function ADTypes.hessian_sparsity(f, x, detector::DI.DenseSparsityDetector{:direct})
    (; backend, atol) = detector
    H = hessian(f, backend, x)
    return sparse(abs.(H) .> atol)
end

## Iterative

function ADTypes.jacobian_sparsity(f, x, detector::DI.DenseSparsityDetector{:iterative})
    (; backend, atol) = detector
    y = f(x)
    n, m = length(x), length(y)
    I, J = Int[], Int[]
    if DI.pushforward_performance(backend) isa DI.PushforwardFast
        p = similar(y)
        prep = DI.prepare_pushforward_same_point(
            f, backend, x, (DI.basis(x, first(eachindex(x))),); strict = Val(true)
        )
        for (kj, j) in enumerate(eachindex(x))
            pushforward!(f, (p,), prep, backend, x, (DI.basis(x, j),))
            for ki in LinearIndices(p)
                if abs(p[ki]) > atol
                    push!(I, ki)
                    push!(J, kj)
                end
            end
        end
    else
        p = similar(x)
        prep = DI.prepare_pullback_same_point(
            f, backend, x, (DI.basis(y, first(eachindex(y))),); strict = Val(true)
        )
        for (ki, i) in enumerate(eachindex(y))
            pullback!(f, (p,), prep, backend, x, (DI.basis(y, i),))
            for kj in LinearIndices(p)
                if abs(p[kj]) > atol
                    push!(I, ki)
                    push!(J, kj)
                end
            end
        end
    end
    return sparse(I, J, ones(Bool, length(I)), m, n)
end

function ADTypes.jacobian_sparsity(f!, y, x, detector::DI.DenseSparsityDetector{:iterative})
    (; backend, atol) = detector
    n, m = length(x), length(y)
    I, J = Int[], Int[]
    if DI.pushforward_performance(backend) isa DI.PushforwardFast
        p = similar(y)
        prep = DI.prepare_pushforward_same_point(
            f!, y, backend, x, (DI.basis(x, first(eachindex(x))),); strict = Val(true)
        )
        for (kj, j) in enumerate(eachindex(x))
            pushforward!(f!, y, (p,), prep, backend, x, (DI.basis(x, j),))
            for ki in LinearIndices(p)
                if abs(p[ki]) > atol
                    push!(I, ki)
                    push!(J, kj)
                end
            end
        end
    else
        p = similar(x)
        prep = DI.prepare_pullback_same_point(
            f!, y, backend, x, (DI.basis(y, first(eachindex(y))),); strict = Val(true)
        )
        for (ki, i) in enumerate(eachindex(y))
            pullback!(f!, y, (p,), prep, backend, x, (DI.basis(y, i),))
            for kj in LinearIndices(p)
                if abs(p[kj]) > atol
                    push!(I, ki)
                    push!(J, kj)
                end
            end
        end
    end
    return sparse(I, J, ones(Bool, length(I)), m, n)
end

function ADTypes.hessian_sparsity(f, x, detector::DI.DenseSparsityDetector{:iterative})
    (; backend, atol) = detector
    n = length(x)
    I, J = Int[], Int[]
    p = similar(x)
    prep = DI.prepare_hvp_same_point(
        f, backend, x, (DI.basis(x, first(eachindex(x))),); strict = Val(true)
    )
    for (kj, j) in enumerate(eachindex(x))
        hvp!(f, (p,), prep, backend, x, (DI.basis(x, j),))
        for ki in LinearIndices(p)
            if abs(p[ki]) > atol
                push!(I, ki)
                push!(J, kj)
            end
        end
    end
    return sparse(I, J, ones(Bool, length(I)), n, n)
end

"""
    DenseSparsityDetector

Sparsity pattern detector satisfying the [detection API](https://sciml.github.io/ADTypes.jl/stable/#Sparse-AD) of [ADTypes.jl](https://github.com/SciML/ADTypes.jl).

The nonzeros in a Jacobian or Hessian are detected by computing the relevant matrix with _dense_ AD, and thresholding the entries with a given tolerance (which can be numerically inaccurate).
This process can be very slow, and should only be used if its output can be exploited multiple times to compute many sparse matrices.

!!! danger

    In general, the sparsity pattern you obtain can depend on the provided input `x`. If you want to reuse the pattern, make sure that it is input-agnostic.

!!! warning

    `DenseSparsityDetector` functionality is now located in a package extension, please load the SparseArrays.jl standard library before you use it.

# Fields

  - `backend::AbstractADType` is the dense AD backend used under the hood
  - `atol::Float64` is the minimum magnitude of a matrix entry to be considered nonzero

# Constructor

    DenseSparsityDetector(backend; atol, method=:iterative)

The keyword argument `method::Symbol` can be either:

  - `:iterative`: compute the matrix in a sequence of matrix-vector products (memory-efficient)
  - `:direct`: compute the matrix all at once (memory-hungry but sometimes faster).

Note that the constructor is type-unstable because `method` ends up being a type parameter of the `DenseSparsityDetector` object (this is not part of the API and might change).

# Examples

```jldoctest detector
using ADTypes, DifferentiationInterface, SparseArrays
using ForwardDiff: ForwardDiff

detector = DenseSparsityDetector(AutoForwardDiff(); atol=1e-5, method=:direct)

ADTypes.jacobian_sparsity(diff, rand(5), detector)

# output

4×5 SparseMatrixCSC{Bool, Int64} with 8 stored entries:
 1  1  ⋅  ⋅  ⋅
 ⋅  1  1  ⋅  ⋅
 ⋅  ⋅  1  1  ⋅
 ⋅  ⋅  ⋅  1  1
```

Sometimes the sparsity pattern is input-dependent:

```jldoctest detector
ADTypes.jacobian_sparsity(x -> [prod(x)], rand(2), detector)

# output

1×2 SparseMatrixCSC{Bool, Int64} with 2 stored entries:
 1  1
```

```jldoctest detector
ADTypes.jacobian_sparsity(x -> [prod(x)], [0, 1], detector)

# output

1×2 SparseMatrixCSC{Bool, Int64} with 1 stored entry:
 1  ⋅
```
"""
struct DenseSparsityDetector{method, B} <: ADTypes.AbstractSparsityDetector
    backend::B
    atol::Float64
end

function Base.show(io::IO, detector::DenseSparsityDetector{method}) where {method}
    (; backend, atol) = detector
    return print(
        io,
        DenseSparsityDetector,
        "(",
        repr(backend; context = io),
        "; atol=$atol, method=",
        repr(method; context = io),
        ")",
    )
end

function DenseSparsityDetector(
        backend::AbstractADType; atol::Float64, method::Symbol = :iterative
    )
    if !(method in (:iterative, :direct))
        throw(
            ArgumentError("The keyword `method` must be either `:iterative` or `:direct`.")
        )
    end
    return DenseSparsityDetector{method, typeof(backend)}(backend, atol)
end

"""
    SecondOrder

Combination of two backends for second-order differentiation.

!!! danger

    `SecondOrder` backends do not support first-order operators.

# Constructor

    SecondOrder(outer_backend, inner_backend)

# Fields

  - `outer::AbstractADType`: backend for the outer differentiation
  - `inner::AbstractADType`: backend for the inner differentiation
"""
struct SecondOrder{ADO <: AbstractADType, ADI <: AbstractADType} <: AbstractADType
    outer::ADO
    inner::ADI
end

function Base.show(io::IO, backend::SecondOrder)
    return print(
        io,
        SecondOrder,
        "(",
        repr(outer(backend); context = io),
        ", ",
        repr(inner(backend); context = io),
        ")",
    )
end

"""
    inner(backend::SecondOrder)
    inner(backend::AbstractADType)

Return the inner backend of a [`SecondOrder`](@ref) object, tasked with differentiation at the first order.

For any other backend type, this function acts like the identity.
"""
inner(backend::SecondOrder) = backend.inner
inner(backend::AbstractADType) = backend

"""
    outer(backend::SecondOrder)
    outer(backend::AbstractADType)

Return the outer backend of a [`SecondOrder`](@ref) object, tasked with differentiation at the second order.

For any other backend type, this function acts like the identity.
"""
outer(backend::SecondOrder) = backend.outer
outer(backend::AbstractADType) = backend

"""
    mode(backend::SecondOrder)

Return the _outer_ mode of the second-order backend.
"""
ADTypes.mode(backend::SecondOrder) = mode(outer(backend))

module DifferentiationInterfaceStaticArraysExt

using ADTypes: AutoForwardDiff, AutoEnzyme
import DifferentiationInterface as DI
using StaticArrays: SArray, StaticArray

function DI.stack_vec_col(t::NTuple{B, <:StaticArray}) where {B}
    return hcat(map(vec, t)...)
end

function DI.stack_vec_row(t::NTuple{B, <:StaticArray}) where {B}
    return vcat(transpose.(map(vec, t))...)
end

DI.ismutable_array(::Type{<:SArray}) = false

function DI.pick_batchsize(::DI.AutoSimpleFiniteDiff{nothing}, x::StaticArray)
    return DI.BatchSizeSettings{length(x), true, true}(length(x))
end

function DI.pick_batchsize(::AutoForwardDiff{nothing}, x::StaticArray)
    return DI.BatchSizeSettings{length(x), true, true}(length(x))
end

function DI.pick_batchsize(::AutoEnzyme, x::StaticArray)
    return DI.BatchSizeSettings{length(x), true, true}(length(x))
end

function DI.pick_batchsize(
        ::DI.AutoSimpleFiniteDiff{chunksize}, x::StaticArray
    ) where {chunksize}
    return DI.BatchSizeSettings{chunksize}(Val(length(x)))
end

function DI.pick_batchsize(::AutoForwardDiff{chunksize}, x::StaticArray) where {chunksize}
    return DI.BatchSizeSettings{chunksize}(Val(length(x)))
end

end

## Docstrings

"""
    prepare_derivative(f,     backend, x, [contexts...]; strict=Val(true)) -> prep
    prepare_derivative(f!, y, backend, x, [contexts...]; strict=Val(true)) -> prep

$(docstring_prepare("derivative"; inplace = true))
"""
function prepare_derivative(
        f::F, backend::AbstractADType, x, contexts::Vararg{Context, C}; strict::Val = Val(true)
    ) where {F, C}
    return prepare_derivative_nokwarg(strict, f, backend, x, contexts...)
end

function prepare_derivative(
        f!::F, y, backend::AbstractADType, x, contexts::Vararg{Context, C}; strict::Val = Val(true)
    ) where {F, C}
    return prepare_derivative_nokwarg(strict, f!, y, backend, x, contexts...)
end

"""
    prepare!_derivative(f,     prep, backend, x, [contexts...]) -> new_prep
    prepare!_derivative(f!, y, prep, backend, x, [contexts...]) -> new_prep

$(docstring_prepare!("derivative"))
"""
function prepare!_derivative(
        f::F, old_prep::DerivativePrep, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    check_prep(f, old_prep, backend, x, contexts...)
    return prepare_derivative_nokwarg(is_strict(old_prep), f, backend, x, contexts...)
end

function prepare!_derivative(
        f!::F,
        y,
        old_prep::DerivativePrep,
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f!, y, old_prep, backend, x, contexts...)
    return prepare_derivative_nokwarg(is_strict(old_prep), f!, y, backend, x, contexts...)
end

"""
    value_and_derivative(f,     [prep,] backend, x, [contexts...]) -> (y, der)
    value_and_derivative(f!, y, [prep,] backend, x, [contexts...]) -> (y, der)

Compute the value and the derivative of the function `f` at point `x`.

$(docstring_preparation_hint("derivative"))
"""
function value_and_derivative(
        f::F, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_derivative_nokwarg(Val(true), f, backend, x, contexts...)
    return value_and_derivative(f, prep, backend, x, contexts...)
end

function value_and_derivative(
        f!::F, y, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_derivative_nokwarg(Val(true), f!, y, backend, x, contexts...)
    return value_and_derivative(f!, y, prep, backend, x, contexts...)
end

"""
    value_and_derivative!(f,     der, [prep,] backend, x, [contexts...]) -> (y, der)
    value_and_derivative!(f!, y, der, [prep,] backend, x, [contexts...]) -> (y, der)

Compute the value and the derivative of the function `f` at point `x`, overwriting `der`.

$(docstring_preparation_hint("derivative"))
"""
function value_and_derivative!(
        f::F, der, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_derivative_nokwarg(Val(true), f, backend, x, contexts...)
    return value_and_derivative!(f, der, prep, backend, x, contexts...)
end

function value_and_derivative!(
        f!::F, y, der, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_derivative_nokwarg(Val(true), f!, y, backend, x, contexts...)
    return value_and_derivative!(f!, y, der, prep, backend, x, contexts...)
end

"""
    derivative(f,     [prep,] backend, x, [contexts...]) -> der
    derivative(f!, y, [prep,] backend, x, [contexts...]) -> der

Compute the derivative of the function `f` at point `x`.

$(docstring_preparation_hint("derivative"))
"""
function derivative(
        f::F, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_derivative_nokwarg(Val(true), f, backend, x, contexts...)
    return derivative(f, prep, backend, x, contexts...)
end

function derivative(
        f!::F, y, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_derivative_nokwarg(Val(true), f!, y, backend, x, contexts...)
    return derivative(f!, y, prep, backend, x, contexts...)
end

"""
    derivative!(f,     der, [prep,] backend, x, [contexts...]) -> der
    derivative!(f!, y, der, [prep,] backend, x, [contexts...]) -> der

Compute the derivative of the function `f` at point `x`, overwriting `der`.

$(docstring_preparation_hint("derivative"))
"""
function derivative!(
        f::F, der, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_derivative_nokwarg(Val(true), f, backend, x, contexts...)
    return derivative!(f, der, prep, backend, x, contexts...)
end

function derivative!(
        f!::F, y, der, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_derivative_nokwarg(Val(true), f!, y, backend, x, contexts...)
    return derivative!(f!, y, der, prep, backend, x, contexts...)
end

## Preparation

struct PushforwardDerivativePrep{SIG, E <: PushforwardPrep} <: DerivativePrep{SIG}
    _sig::Val{SIG}
    pushforward_prep::E
end

function prepare_derivative_nokwarg(
        strict::Val, f::F, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    _sig = signature(f, backend, x, contexts...; strict)
    pushforward_prep = prepare_pushforward_nokwarg(
        strict, f, backend, x, (oneunit(x),), contexts...
    )
    return PushforwardDerivativePrep(_sig, pushforward_prep)
end

function prepare_derivative_nokwarg(
        strict::Val, f!::F, y, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    _sig = signature(f!, y, backend, x, contexts...; strict)
    pushforward_prep = prepare_pushforward_nokwarg(
        strict, f!, y, backend, x, (oneunit(x),), contexts...
    )
    return PushforwardDerivativePrep(_sig, pushforward_prep)
end

## One argument

function value_and_derivative(
        f::F,
        prep::PushforwardDerivativePrep,
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, contexts...)
    y, ty = value_and_pushforward(
        f, prep.pushforward_prep, backend, x, (oneunit(x),), contexts...
    )
    return y, only(ty)
end

function value_and_derivative!(
        f::F,
        der,
        prep::PushforwardDerivativePrep,
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, contexts...)
    y, _ = value_and_pushforward!(
        f, (der,), prep.pushforward_prep, backend, x, (oneunit(x),), contexts...
    )
    return y, der
end

function derivative(
        f::F,
        prep::PushforwardDerivativePrep,
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, contexts...)
    ty = pushforward(f, prep.pushforward_prep, backend, x, (oneunit(x),), contexts...)
    return only(ty)
end

function derivative!(
        f::F,
        der,
        prep::PushforwardDerivativePrep,
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, contexts...)
    pushforward!(f, (der,), prep.pushforward_prep, backend, x, (oneunit(x),), contexts...)
    return der
end

## Two arguments

function value_and_derivative(
        f!::F,
        y,
        prep::PushforwardDerivativePrep,
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f!, y, prep, backend, x, contexts...)
    y, ty = value_and_pushforward(
        f!, y, prep.pushforward_prep, backend, x, (oneunit(x),), contexts...
    )
    return y, only(ty)
end

function value_and_derivative!(
        f!::F,
        y,
        der,
        prep::PushforwardDerivativePrep,
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f!, y, prep, backend, x, contexts...)
    y, _ = value_and_pushforward!(
        f!, y, (der,), prep.pushforward_prep, backend, x, (oneunit(x),), contexts...
    )
    return y, der
end

function derivative(
        f!::F,
        y,
        prep::PushforwardDerivativePrep,
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f!, y, prep, backend, x, contexts...)
    ty = pushforward(f!, y, prep.pushforward_prep, backend, x, (oneunit(x),), contexts...)
    return only(ty)
end

function derivative!(
        f!::F,
        y,
        der,
        prep::PushforwardDerivativePrep,
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f!, y, prep, backend, x, contexts...)
    pushforward!(
        f!, y, (der,), prep.pushforward_prep, backend, x, (oneunit(x),), contexts...
    )
    return der
end

## Shuffled

function shuffled_derivative(
        x, f::F, backend::AbstractADType, rewrap::Rewrap{C}, unannotated_contexts::Vararg{Any, C}
    ) where {F, C}
    return derivative(f, backend, x, rewrap(unannotated_contexts...)...)
end

include("../../testutils.jl")

using DifferentiationInterface, DifferentiationInterfaceTest
using DifferentiationInterface: DenseSparsityDetector
using FiniteDiff: FiniteDiff
using SparseMatrixColorings
using Test

using ExplicitImports
check_no_implicit_imports(DifferentiationInterface)

for backend in [AutoFiniteDiff()]
    @test check_available(backend)
    @test check_inplace(backend)
    test_counterparts(backend)
    @test DifferentiationInterface.inner_preparation_behavior(backend) isa
        DifferentiationInterface.PrepareInnerSimple
end

@testset "Dense" begin
    test_differentiation(
        AutoFiniteDiff(),
        default_scenarios(;
            include_constantified = true,
            include_cachified = true,
            include_constantorcachified = true,
            use_tuples = true,
            include_smaller = true,
        );
        excluded = [:second_derivative, :hvp],
        logging = LOGGING,
    )

    test_differentiation(
        SecondOrder(AutoFiniteDiff(; relstep = 1.0e-5, absstep = 1.0e-5), AutoFiniteDiff()),
        default_scenarios();
        logging = LOGGING,
        rtol = 1.0e-2,
    )

    test_differentiation(
        [
            AutoFiniteDiff(; relstep = cbrt(eps(Float64))),
            AutoFiniteDiff(; relstep = cbrt(eps(Float64)), absstep = cbrt(eps(Float64))),
            AutoFiniteDiff(; dir = 0.5),
        ];
        excluded = [:second_derivative, :hvp],
        logging = LOGGING,
    )
end

@testset "Sparse" begin
    test_differentiation(
        MyAutoSparse(AutoFiniteDiff()),
        sparse_scenarios();
        excluded = SECOND_ORDER,
        logging = LOGGING,
    )
end

@testset "Complex" begin
    test_differentiation(AutoFiniteDiff(), complex_scenarios(); logging = LOGGING)
    test_differentiation(
        AutoSparse(
            AutoFiniteDiff();
            sparsity_detector = DenseSparsityDetector(AutoFiniteDiff(); atol = 1.0e-5),
            coloring_algorithm = GreedyColoringAlgorithm(),
        ),
        complex_sparse_scenarios();
        logging = LOGGING,
    )
end;

@testset "Step size" begin  # fix 811
    backend = AutoFiniteDiff(; absstep = 1000, relstep = 0.1)
    preps = [
        prepare_pushforward(identity, backend, 1.0, (1.0,)),
        prepare_pushforward(copyto!, [0.0], backend, [1.0], ([1.0],)),
        prepare_derivative(identity, backend, 1.0),
        prepare_derivative((y, x) -> y .= x, [0.0], backend, 1.0),
        prepare_gradient(sum, backend, [1.0]),
        prepare_jacobian(identity, backend, [1.0]),
        prepare_jacobian(copyto!, [0.0], backend, [1.0]),
    ]
    for prep in preps
        @test prep.relstep == 0.1
        @test prep.absstep == 1000
    end
    prep = prepare_hessian(sum, backend, [1.0])
    @test prep.absstep_g == 1000
    @test prep.absstep_h == 1000
    @test prep.relstep_g == 0.1
    @test prep.relstep_h == 0.1

    backend = AutoFiniteDiff(; relstep = 0.1)
    preps = [
        prepare_pushforward(identity, backend, 1.0, (1.0,)),
        prepare_pushforward(copyto!, [0.0], backend, [1.0], ([1.0],)),
        prepare_derivative(identity, backend, 1.0),
        prepare_derivative((y, x) -> y .= x, [0.0], backend, 1.0),
        prepare_gradient(sum, backend, [1.0]),
        prepare_jacobian(identity, backend, [1.0]),
        prepare_jacobian(copyto!, [0.0], backend, [1.0]),
    ]
    for prep in preps
        @test prep.relstep == 0.1
        @test prep.absstep == 0.1
    end
    prep = prepare_hessian(sum, backend, [1.0])
    @test prep.absstep_g == 0.1
    @test prep.absstep_h == 0.1
    @test prep.relstep_g == 0.1
    @test prep.relstep_h == 0.1
end

include("benchmark.jl")

module DifferentiationInterfaceSymbolicsExt

using ADTypes: ADTypes, AutoSymbolics, AutoSparse
import DifferentiationInterface as DI
using LinearAlgebra: dot
using Symbolics:
    build_function,
    derivative,
    gradient,
    hessian,
    hessian_sparsity,
    jacobian,
    jacobian_sparsity,
    sparsehessian,
    sparsejacobian,
    substitute,
    variable,
    variables
using Symbolics.RuntimeGeneratedFunctions: RuntimeGeneratedFunction

DI.check_available(::AutoSymbolics) = true
DI.pullback_performance(::AutoSymbolics) = DI.PullbackSlow()

dense_ad(backend::AutoSymbolics) = backend
dense_ad(backend::AutoSparse{<:AutoSymbolics}) = ADTypes.dense_ad(backend)

variablize(::Number, name::Symbol) = variable(name)
variablize(x::AbstractArray, name::Symbol) = variables(name, axes(x)...)
variablize(::T, name::Symbol) where {T} = variable(name; T)

function variablize(contexts::NTuple{C, DI.Context}) where {C}
    return ntuple(Val(C)) do k
        c = contexts[k]
        variablize(DI.unwrap(c), Symbol("context$k"))
    end
end

function erase_cache_vars!(
        context_vars::NTuple{C}, contexts::NTuple{C, DI.Context}
    ) where {C}
    # erase the active data from caches before building function
    for (v, c) in zip(context_vars, contexts)
        if c isa DI.Cache
            fill!(v, zero(eltype(v)))
        end
    end
    return
end

include("onearg.jl")
include("twoarg.jl")

end

## Pushforward

struct PolyesterForwardDiffTwoArgPushforwardPrep{SIG, P} <: DI.PushforwardPrep{SIG}
    _sig::Val{SIG}
    single_threaded_prep::P
end

function DI.prepare_pushforward_nokwarg(
        strict::Val,
        f!,
        y,
        backend::AutoPolyesterForwardDiff,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f!, y, backend, x, tx, contexts...; strict)
    single_threaded_prep = DI.prepare_pushforward_nokwarg(
        strict, f!, y, single_threaded(backend), x, tx, contexts...
    )
    return PolyesterForwardDiffTwoArgPushforwardPrep(_sig, single_threaded_prep)
end

function DI.value_and_pushforward(
        f!,
        y,
        prep::PolyesterForwardDiffTwoArgPushforwardPrep,
        backend::AutoPolyesterForwardDiff,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    return DI.value_and_pushforward(
        f!, y, prep.single_threaded_prep, single_threaded(backend), x, tx, contexts...
    )
end

function DI.value_and_pushforward!(
        f!,
        y,
        ty::NTuple,
        prep::PolyesterForwardDiffTwoArgPushforwardPrep,
        backend::AutoPolyesterForwardDiff,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    return DI.value_and_pushforward!(
        f!, y, ty, prep.single_threaded_prep, single_threaded(backend), x, tx, contexts...
    )
end

function DI.pushforward(
        f!,
        y,
        prep::PolyesterForwardDiffTwoArgPushforwardPrep,
        backend::AutoPolyesterForwardDiff,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    return DI.pushforward(
        f!, y, prep.single_threaded_prep, single_threaded(backend), x, tx, contexts...
    )
end

function DI.pushforward!(
        f!,
        y,
        ty::NTuple,
        prep::PolyesterForwardDiffTwoArgPushforwardPrep,
        backend::AutoPolyesterForwardDiff,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    return DI.pushforward!(
        f!, y, ty, prep.single_threaded_prep, single_threaded(backend), x, tx, contexts...
    )
end

## Derivative

struct PolyesterForwardDiffTwoArgDerivativePrep{SIG, P} <: DI.DerivativePrep{SIG}
    _sig::Val{SIG}
    single_threaded_prep::P
end

function DI.prepare_derivative_nokwarg(
        strict::Val, f!, y, backend::AutoPolyesterForwardDiff, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f!, y, backend, x, contexts...; strict)
    single_threaded_prep = DI.prepare_derivative_nokwarg(
        strict, f!, y, single_threaded(backend), x, contexts...
    )
    return PolyesterForwardDiffTwoArgDerivativePrep(_sig, single_threaded_prep)
end

function DI.value_and_derivative(
        f!,
        y,
        prep::PolyesterForwardDiffTwoArgDerivativePrep,
        backend::AutoPolyesterForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    return DI.value_and_derivative(
        f!, y, prep.single_threaded_prep, single_threaded(backend), x, contexts...
    )
end

function DI.value_and_derivative!(
        f!,
        y,
        der,
        prep::PolyesterForwardDiffTwoArgDerivativePrep,
        backend::AutoPolyesterForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    return DI.value_and_derivative!(
        f!, y, der, prep.single_threaded_prep, single_threaded(backend), x, contexts...
    )
end

function DI.derivative(
        f!,
        y,
        prep::PolyesterForwardDiffTwoArgDerivativePrep,
        backend::AutoPolyesterForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    return DI.derivative(
        f!, y, prep.single_threaded_prep, single_threaded(backend), x, contexts...
    )
end

function DI.derivative!(
        f!,
        y,
        der,
        prep::PolyesterForwardDiffTwoArgDerivativePrep,
        backend::AutoPolyesterForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    return DI.derivative!(
        f!, y, der, prep.single_threaded_prep, single_threaded(backend), x, contexts...
    )
end

## Jacobian

struct PolyesterForwardDiffTwoArgJacobianPrep{SIG, chunksize, P} <: DI.JacobianPrep{SIG}
    _sig::Val{SIG}
    chunk::Chunk{chunksize}
    single_threaded_prep::P
end

function DI.prepare_jacobian_nokwarg(
        strict::Val,
        f!,
        y,
        backend::AutoPolyesterForwardDiff{chunksize},
        x,
        contexts::Vararg{DI.Context, C}
    ) where {chunksize, C}
    _sig = DI.signature(f!, y, backend, x, contexts...; strict)
    if isnothing(chunksize)
        chunk = Chunk(x)
    else
        chunk = Chunk{chunksize}()
    end
    single_threaded_prep = DI.prepare_jacobian_nokwarg(
        strict, f!, y, single_threaded(backend), x, contexts...
    )
    return PolyesterForwardDiffTwoArgJacobianPrep(_sig, chunk, single_threaded_prep)
end

function DI.value_and_jacobian(
        f!,
        y,
        prep::PolyesterForwardDiffTwoArgJacobianPrep,
        backend::AutoPolyesterForwardDiff{K},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {K, C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    if contexts isa NTuple{C, DI.GeneralizedConstant}
        fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
        jac = similar(y, length(y), length(x))
        threaded_jacobian!(fc!, y, jac, x, prep.chunk)
        fc!(y, x)
        return y, jac
    else
        return DI.value_and_jacobian(
            f!, y, prep.single_threaded_prep, single_threaded(backend), x, contexts...
        )
    end
end

function DI.value_and_jacobian!(
        f!,
        y,
        jac,
        prep::PolyesterForwardDiffTwoArgJacobianPrep,
        backend::AutoPolyesterForwardDiff{K},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {K, C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    if contexts isa NTuple{C, DI.GeneralizedConstant}
        fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
        threaded_jacobian!(fc!, y, jac, x, prep.chunk)
        fc!(y, x)
        return y, jac
    else
        return DI.value_and_jacobian!(
            f!, y, jac, prep.single_threaded_prep, single_threaded(backend), x, contexts...
        )
    end
end

function DI.jacobian(
        f!,
        y,
        prep::PolyesterForwardDiffTwoArgJacobianPrep,
        backend::AutoPolyesterForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    if contexts isa NTuple{C, DI.GeneralizedConstant}
        fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
        jac = similar(y, length(y), length(x))
        threaded_jacobian!(fc!, y, jac, x, prep.chunk)
        return jac
    else
        return DI.jacobian(
            f!, y, prep.single_threaded_prep, single_threaded(backend), x, contexts...
        )
    end
end

function DI.jacobian!(
        f!,
        y,
        jac,
        prep::PolyesterForwardDiffTwoArgJacobianPrep,
        backend::AutoPolyesterForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    if contexts isa NTuple{C, DI.GeneralizedConstant}
        fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
        threaded_jacobian!(fc!, y, jac, x, prep.chunk)
        return jac
    else
        return DI.jacobian!(
            f!, y, jac, prep.single_threaded_prep, single_threaded(backend), x, contexts...
        )
    end
end

## Docstrings

"""
    prepare_pushforward(f,     backend, x, tx, [contexts...]; strict=Val(true)) -> prep
    prepare_pushforward(f!, y, backend, x, tx, [contexts...]; strict=Val(true)) -> prep

$(docstring_prepare("pushforward"; inplace = true))
"""
function prepare_pushforward(
        f::F,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C};
        strict::Val = Val(true),
    ) where {F, C}
    return prepare_pushforward_nokwarg(strict, f, backend, x, tx, contexts...)
end

function prepare_pushforward(
        f!::F,
        y,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C};
        strict::Val = Val(true),
    ) where {F, C}
    return prepare_pushforward_nokwarg(strict, f!, y, backend, x, tx, contexts...)
end

"""
    prepare!_pushforward(f,     prep, backend, x, tx, [contexts...]) -> new_prep
    prepare!_pushforward(f!, y, prep, backend, x, tx, [contexts...]) -> new_prep

$(docstring_prepare!("pushforward"))
"""
function prepare!_pushforward(
        f::F,
        old_prep::PushforwardPrep,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, old_prep, backend, x, tx, contexts...)
    return prepare_pushforward_nokwarg(is_strict(old_prep), f, backend, x, tx, contexts...)
end

function prepare!_pushforward(
        f!::F,
        y,
        old_prep::PushforwardPrep,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f!, y, old_prep, backend, x, tx, contexts...)
    return prepare_pushforward_nokwarg(
        is_strict(old_prep), f!, y, backend, x, tx, contexts...
    )
end

"""
    prepare_pushforward_same_point(f,     backend, x, tx, [contexts...]; strict=Val(true)) -> prep_same
    prepare_pushforward_same_point(f!, y, backend, x, tx, [contexts...]; strict=Val(true)) -> prep_same

$(docstring_prepare("pushforward"; samepoint = true, inplace = true))
"""
function prepare_pushforward_same_point(
        f::F,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C};
        strict::Val = Val(true),
    ) where {F, C}
    return prepare_pushforward_same_point_nokwarg(strict, f, backend, x, tx, contexts...)
end

function prepare_pushforward_same_point(
        f!::F,
        y,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C};
        strict::Val = Val(true),
    ) where {F, C}
    return prepare_pushforward_same_point_nokwarg(
        strict, f!, y, backend, x, tx, contexts...
    )
end

function prepare_pushforward_same_point_nokwarg(
        strict::Val, f::F, backend::AbstractADType, x, tx::NTuple, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_pushforward_nokwarg(strict, f, backend, x, tx, contexts...)
    return prepare_pushforward_same_point(f, prep, backend, x, tx, contexts...)
end

function prepare_pushforward_same_point_nokwarg(
        strict::Val,
        f!::F,
        y,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_pushforward_nokwarg(strict, f!, y, backend, x, tx, contexts...)
    return prepare_pushforward_same_point(f!, y, prep, backend, x, tx, contexts...)
end

function prepare_pushforward_same_point(
        f::F,
        prep::PushforwardPrep,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, tx, contexts...)
    return prep
end

function prepare_pushforward_same_point(
        f!::F,
        y,
        prep::PushforwardPrep,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f!, y, prep, backend, x, tx, contexts...)
    return prep
end

"""
    value_and_pushforward(f,     [prep,] backend, x, tx, [contexts...]) -> (y, ty)
    value_and_pushforward(f!, y, [prep,] backend, x, tx, [contexts...]) -> (y, ty)

Compute the value and the pushforward of the function `f` at point `x` with a tuple of tangents `tx`.

$(docstring_preparation_hint("pushforward"; same_point = true))

!!! tip

    Pushforwards are also commonly called Jacobian-vector products or JVPs.
    This function could have been named `value_and_jvp`.

!!! info

    Required primitive for forward mode backends.
"""
function value_and_pushforward(
        f::F, backend::AbstractADType, x, tx, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_pushforward_nokwarg(Val(true), f, backend, x, tx, contexts...)
    return value_and_pushforward(f, prep, backend, x, tx, contexts...)
end

function value_and_pushforward(
        f!::F, y, backend::AbstractADType, x, tx, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_pushforward_nokwarg(Val(true), f!, y, backend, x, tx, contexts...)
    return value_and_pushforward(f!, y, prep, backend, x, tx, contexts...)
end

"""
    value_and_pushforward!(f,     dy, [prep,] backend, x, tx, [contexts...]) -> (y, ty)
    value_and_pushforward!(f!, y, dy, [prep,] backend, x, tx, [contexts...]) -> (y, ty)

Compute the value and the pushforward of the function `f` at point `x` with a tuple of tangents `tx`, overwriting `ty`.

$(docstring_preparation_hint("pushforward"; same_point = true))

!!! tip

    Pushforwards are also commonly called Jacobian-vector products or JVPs.
    This function could have been named `value_and_jvp!`.
"""
function value_and_pushforward!(
        f::F, ty, backend::AbstractADType, x, tx, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_pushforward_nokwarg(Val(true), f, backend, x, tx, contexts...)
    return value_and_pushforward!(f, ty, prep, backend, x, tx, contexts...)
end

function value_and_pushforward!(
        f!::F, y, ty, backend::AbstractADType, x, tx, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_pushforward_nokwarg(Val(true), f!, y, backend, x, tx, contexts...)
    return value_and_pushforward!(f!, y, ty, prep, backend, x, tx, contexts...)
end

"""
    pushforward(f,     [prep,] backend, x, tx, [contexts...]) -> ty
    pushforward(f!, y, [prep,] backend, x, tx, [contexts...]) -> ty

Compute the pushforward of the function `f` at point `x` with a tuple of tangents `tx`.

$(docstring_preparation_hint("pushforward"; same_point = true))

!!! tip

    Pushforwards are also commonly called Jacobian-vector products or JVPs.
    This function could have been named `jvp`.
"""
function pushforward(
        f::F, backend::AbstractADType, x, tx, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_pushforward_nokwarg(Val(true), f, backend, x, tx, contexts...)
    return pushforward(f, prep, backend, x, tx, contexts...)
end

function pushforward(
        f!::F, y, backend::AbstractADType, x, tx, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_pushforward_nokwarg(Val(true), f!, y, backend, x, tx, contexts...)
    return pushforward(f!, y, prep, backend, x, tx, contexts...)
end

"""
    pushforward!(f,     dy, [prep,] backend, x, tx, [contexts...]) -> ty
    pushforward!(f!, y, dy, [prep,] backend, x, tx, [contexts...]) -> ty

Compute the pushforward of the function `f` at point `x` with a tuple of tangents `tx`, overwriting `ty`.

$(docstring_preparation_hint("pushforward"; same_point = true))

!!! tip

    Pushforwards are also commonly called Jacobian-vector products or JVPs.
    This function could have been named `jvp!`.
"""
function pushforward!(
        f::F, ty, backend::AbstractADType, x, tx, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_pushforward_nokwarg(Val(true), f, backend, x, tx, contexts...)
    return pushforward!(f, ty, prep, backend, x, tx, contexts...)
end

function pushforward!(
        f!::F, y, ty, backend::AbstractADType, x, tx, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_pushforward_nokwarg(Val(true), f!, y, backend, x, tx, contexts...)
    return pushforward!(f!, y, ty, prep, backend, x, tx, contexts...)
end

## Preparation

struct PullbackPushforwardPrep{SIG, E, Y} <: PushforwardPrep{SIG}
    _sig::Val{SIG}
    pullback_prep::E
    y_example::Y
end

function prepare_pushforward_nokwarg(
        strict::Val, f::F, backend::AbstractADType, x, tx::NTuple, contexts::Vararg{Context, C}
    ) where {F, C}
    return _prepare_pushforward_aux(
        strict, pushforward_performance(backend), f, backend, x, tx, contexts...
    )
end

function prepare_pushforward_nokwarg(
        strict::Val,
        f!::F,
        y,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C}
    ) where {F, C}
    return _prepare_pushforward_aux(
        strict, pushforward_performance(backend), f!, y, backend, x, tx, contexts...
    )
end

function _prepare_pushforward_aux(
        strict::Val,
        ::PushforwardSlow,
        f::F,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C}
    ) where {F, C}
    _sig = signature(f, backend, x, tx, contexts...; strict)
    y = f(x, map(unwrap, contexts)...)
    dy = if y isa Number
        oneunit(y)
    else
        basis(y)
    end
    pullback_prep = prepare_pullback_nokwarg(strict, f, backend, x, (dy,), contexts...)
    return PullbackPushforwardPrep(_sig, pullback_prep, y)
end

function _prepare_pushforward_aux(
        strict::Val,
        ::PushforwardSlow,
        f!::F,
        y,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C}
    ) where {F, C}
    _sig = signature(f!, y, backend, x, tx, contexts...; strict)
    dy = basis(y)
    pullback_prep = prepare_pullback_nokwarg(strict, f!, y, backend, x, (dy,), contexts...)
    return PullbackPushforwardPrep(_sig, pullback_prep, y)
end

## One argument

function _value_and_pushforward_via_pullback(
        y_ex::Number,
        f::F,
        pullback_prep::PullbackPrep,
        backend::AbstractADType,
        x,
        tx::NTuple{B},
        contexts::Vararg{Context, C},
    ) where {F, B, C}
    y, a = onlysecond(value_and_pullback(f, pullback_prep, backend, x, (oneunit(y_ex),), contexts...))
    ty = map(tx) do dx
        dot(a, dx)
    end
    return y, arroftup_to_tupofarr(ty, y)
end

function _value_and_pushforward_via_pullback(
        y_ex::Complex,
        f::F,
        pullback_prep::PullbackPrep,
        backend::AbstractADType,
        x,
        tx::NTuple{B},
        contexts::Vararg{Context, C},
    ) where {F, B, C}
    y, a = onlysecond(value_and_pullback(f, pullback_prep, backend, x, (oneunit(y_ex),), contexts...))
    b = only(pullback(f, pullback_prep, backend, x, (im * oneunit(y_ex),), contexts...))
    ty = map(tx) do dx
        real(dot(a, dx)) + im * real(dot(b, dx))
    end
    return y, arroftup_to_tupofarr(ty, y)
end

function _value_and_pushforward_via_pullback(
        y_ex::AbstractArray{<:Real},
        f::F,
        pullback_prep::PullbackPrep,
        backend::AbstractADType,
        x,
        tx::NTuple{B},
        contexts::Vararg{Context, C},
    ) where {F, B, C}
    y = f(x, map(unwrap, contexts)...)
    ty = map(CartesianIndices(y_ex)) do i
        a = only(pullback(f, pullback_prep, backend, x, (basis(y_ex, i),), contexts...))
        map(tx) do dx
            dot(a, dx)
        end
    end
    return y, arroftup_to_tupofarr(ty, y)
end

function _value_and_pushforward_via_pullback(
        y_ex::AbstractArray{<:Complex},
        f::F,
        pullback_prep::PullbackPrep,
        backend::AbstractADType,
        x,
        tx::NTuple{B},
        contexts::Vararg{Context, C},
    ) where {F, B, C}
    y = f(x, map(unwrap, contexts)...)
    ty = map(CartesianIndices(y_ex)) do i
        a = only(pullback(f, pullback_prep, backend, x, (basis(y_ex, i),), contexts...))
        b = only(pullback(f, pullback_prep, backend, x, (im * basis(y_ex, i),), contexts...))
        map(tx) do dx
            real(dot(a, dx)) + im * real(dot(b, dx))
        end
    end
    return y, arroftup_to_tupofarr(ty, y)
end

function value_and_pushforward(
        f::F,
        prep::PullbackPushforwardPrep,
        backend::AbstractADType,
        x,
        tx::NTuple{B},
        contexts::Vararg{Context, C},
    ) where {F, B, C}
    check_prep(f, prep, backend, x, tx, contexts...)
    (; pullback_prep, y_example) = prep
    return _value_and_pushforward_via_pullback(y_example, f, pullback_prep, backend, x, tx, contexts...)
end

function value_and_pushforward!(
        f::F,
        ty::NTuple,
        prep::PushforwardPrep,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, tx, contexts...)
    y, new_ty = value_and_pushforward(f, prep, backend, x, tx, contexts...)
    foreach(copyto!, ty, new_ty)
    return y, ty
end

function pushforward(
        f::F,
        prep::PushforwardPrep,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, tx, contexts...)
    return value_and_pushforward(f, prep, backend, x, tx, contexts...)[2]
end

function pushforward!(
        f::F,
        ty::NTuple,
        prep::PushforwardPrep,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, tx, contexts...)
    return value_and_pushforward!(f, ty, prep, backend, x, tx, contexts...)[2]
end

## Two arguments

function _value_and_pushforward_via_pullback(
        f!::F,
        y::AbstractArray{<:Real},
        pullback_prep::PullbackPrep,
        backend::AbstractADType,
        x,
        tx::NTuple{B},
        contexts::Vararg{Context, C},
    ) where {F, B, C}
    ty = map(CartesianIndices(y)) do i  # preserve shape
        _, a = onlysecond(value_and_pullback(f!, y, pullback_prep, backend, x, (basis(y, i),), contexts...))
        map(tx) do dx
            dot(a, dx)
        end
    end
    return y, arroftup_to_tupofarr(ty, y)
end

function _value_and_pushforward_via_pullback(
        f!::F,
        y::AbstractArray{<:Complex},
        pullback_prep::PullbackPrep,
        backend::AbstractADType,
        x,
        tx::NTuple{B},
        contexts::Vararg{Context, C},
    ) where {F, B, C}
    ty = map(CartesianIndices(y)) do i  # preserve shape
        a = only(pullback(f!, y, pullback_prep, backend, x, (basis(y, i),), contexts...))
        _, b = onlysecond(
            value_and_pullback(f!, y, pullback_prep, backend, x, (im * basis(y, i),), contexts...)
        )
        map(tx) do dx
            real(dot(a, dx)) + im * real(dot(b, dx))
        end
    end
    return y, arroftup_to_tupofarr(ty, y)
end

function value_and_pushforward(
        f!::F,
        y,
        prep::PullbackPushforwardPrep,
        backend::AbstractADType,
        x,
        tx::NTuple{B},
        contexts::Vararg{Context, C},
    ) where {F, B, C}
    check_prep(f!, y, prep, backend, x, tx, contexts...)
    (; pullback_prep) = prep
    return _value_and_pushforward_via_pullback(f!, y, pullback_prep, backend, x, tx, contexts...)
end

function value_and_pushforward!(
        f!::F,
        y,
        ty::NTuple,
        prep::PushforwardPrep,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f!, y, prep, backend, x, tx, contexts...)
    y, new_ty = value_and_pushforward(f!, y, prep, backend, x, tx, contexts...)
    foreach(copyto!, ty, new_ty)
    return y, ty
end

function pushforward(
        f!::F,
        y,
        prep::PushforwardPrep,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f!, y, prep, backend, x, tx, contexts...)
    return value_and_pushforward(f!, y, prep, backend, x, tx, contexts...)[2]
end

function pushforward!(
        f!::F,
        y,
        ty::NTuple,
        prep::PushforwardPrep,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f!, y, prep, backend, x, tx, contexts...)
    return value_and_pushforward!(f!, y, ty, prep, backend, x, tx, contexts...)[2]
end

## Shuffled

function shuffled_single_pushforward(
        x,
        f::F,
        backend::AbstractADType,
        dx,
        rewrap::Rewrap{C},
        unannotated_contexts::Vararg{Any, C},
    ) where {F, C}
    ty = pushforward(f, backend, x, (dx,), rewrap(unannotated_contexts...)...)
    return only(ty)
end

## Docstrings

"""
    prepare_gradient(f, backend, x, [contexts...]; strict=Val(true)) -> prep

$(docstring_prepare("gradient"))
"""
function prepare_gradient(
        f::F, backend::AbstractADType, x, contexts::Vararg{Context, C}; strict::Val = Val(true)
    ) where {F, C}
    return prepare_gradient_nokwarg(strict, f, backend, x, contexts...)
end

"""
    prepare!_gradient(f, prep, backend, x, [contexts...]) -> new_prep

$(docstring_prepare!("gradient"))
"""
function prepare!_gradient(
        f::F, old_prep::GradientPrep, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    check_prep(f, old_prep, backend, x, contexts...)
    return prepare_gradient_nokwarg(is_strict(old_prep), f, backend, x, contexts...)
end

"""
    value_and_gradient(f, [prep,] backend, x, [contexts...]) -> (y, grad)

Compute the value and the gradient of the function `f` at point `x`.

$(docstring_preparation_hint("gradient"))
"""
function value_and_gradient(
        f::F, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_gradient_nokwarg(Val(true), f, backend, x, contexts...)
    return value_and_gradient(f, prep, backend, x, contexts...)
end

"""
    value_and_gradient!(f, grad, [prep,] backend, x, [contexts...]) -> (y, grad)

Compute the value and the gradient of the function `f` at point `x`, overwriting `grad`.

$(docstring_preparation_hint("gradient"))
"""
function value_and_gradient!(
        f::F, grad, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_gradient_nokwarg(Val(true), f, backend, x, contexts...)
    return value_and_gradient!(f, grad, prep, backend, x, contexts...)
end

"""
    gradient(f, [prep,] backend, x, [contexts...]) -> grad

Compute the gradient of the function `f` at point `x`.

$(docstring_preparation_hint("gradient"))
"""
function gradient(f::F, backend::AbstractADType, x, contexts::Vararg{Context, C}) where {F, C}
    prep = prepare_gradient_nokwarg(Val(true), f, backend, x, contexts...)
    return gradient(f, prep, backend, x, contexts...)
end

"""
    gradient!(f, grad, [prep,] backend, x, [contexts...]) -> grad

Compute the gradient of the function `f` at point `x`, overwriting `grad`.

$(docstring_preparation_hint("gradient"))
"""
function gradient!(
        f::F, grad, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_gradient_nokwarg(Val(true), f, backend, x, contexts...)
    return gradient!(f, grad, prep, backend, x, contexts...)
end

## Preparation

struct PullbackGradientPrep{SIG, Y, E <: PullbackPrep} <: GradientPrep{SIG}
    _sig::Val{SIG}
    y::Y
    pullback_prep::E
end

function prepare_gradient_nokwarg(
        strict::Val, f::F, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    _sig = signature(f, backend, x, contexts...; strict)
    y = f(x, map(unwrap, contexts)...)  # TODO: replace with output type inference?
    pullback_prep = prepare_pullback_nokwarg(
        strict, f, backend, x, (oneunit(typeof(y)),), contexts...
    )
    return PullbackGradientPrep(_sig, y, pullback_prep)
end

## One argument

function value_and_gradient(
        f::F,
        prep::PullbackGradientPrep{SIG, Y},
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {F, SIG, Y, C}
    check_prep(f, prep, backend, x, contexts...)
    y, tx = value_and_pullback(
        f, prep.pullback_prep, backend, x, (oneunit(Y),), contexts...
    )
    return y, only(tx)
end

function value_and_gradient!(
        f::F,
        grad,
        prep::PullbackGradientPrep{SIG, Y},
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {F, SIG, Y, C}
    check_prep(f, prep, backend, x, contexts...)
    y, _ = value_and_pullback!(
        f, (grad,), prep.pullback_prep, backend, x, (oneunit(Y),), contexts...
    )
    return y, grad
end

function gradient(
        f::F,
        prep::PullbackGradientPrep{SIG, Y},
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {F, SIG, Y, C}
    check_prep(f, prep, backend, x, contexts...)
    tx = pullback(f, prep.pullback_prep, backend, x, (oneunit(Y),), contexts...)
    return only(tx)
end

function gradient!(
        f::F,
        grad,
        prep::PullbackGradientPrep{SIG, Y},
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {F, SIG, Y, C}
    check_prep(f, prep, backend, x, contexts...)
    pullback!(f, (grad,), prep.pullback_prep, backend, x, (oneunit(Y),), contexts...)
    return grad
end

## Shuffled

function shuffled_gradient(
        x, f::F, backend::AbstractADType, rewrap::Rewrap{C}, unannotated_contexts::Vararg{Any, C}
    ) where {F, C}
    return gradient(f, backend, x, rewrap(unannotated_contexts...)...)
end

function shuffled_gradient(
        x,
        f::F,
        prep::GradientPrep,
        backend::AbstractADType,
        rewrap::Rewrap{C},
        unannotated_contexts::Vararg{Any, C},
    ) where {F, C}
    return gradient(f, prep, backend, x, rewrap(unannotated_contexts...)...)
end

function shuffled_gradient!(
        grad,
        x,
        f::F,
        backend::AbstractADType,
        rewrap::Rewrap{C},
        unannotated_contexts::Vararg{Any, C},
    ) where {F, C}
    gradient!(f, grad, backend, x, rewrap(unannotated_contexts...)...)
    return nothing
end

function shuffled_gradient!(
        grad,
        x,
        f::F,
        prep::GradientPrep,
        backend::AbstractADType,
        rewrap::Rewrap{C},
        unannotated_contexts::Vararg{Any, C},
    ) where {F, C}
    gradient!(f, grad, prep, backend, x, rewrap(unannotated_contexts...)...)
    return nothing
end

function ChainRulesCore.rrule(dw::DI.DifferentiateWith, x)
    (; f, backend) = dw
    y = f(x)
    prep_same = DI.prepare_pullback_same_point_nokwarg(Val(false), f, backend, x, (y,))
    function pullbackfunc(dy)
        tx = DI.pullback(f, prep_same, backend, x, (dy,))
        return (NoTangent(), only(tx))
    end
    return y, pullbackfunc
end

"""
    DifferentiationInterface

An interface to various automatic differentiation backends in Julia.
"""
module DifferentiationInterface

using ADTypes:
    ADTypes,
    AbstractADType,
    AbstractSparsityDetector,
    AutoSparse,
    ForwardMode,
    ForwardOrReverseMode,
    ReverseMode,
    SymbolicMode,
    dense_ad,
    mode,
    jacobian_sparsity,
    hessian_sparsity
using ADTypes:
    AutoChainRules,
    AutoDiffractor,
    AutoEnzyme,
    AutoFastDifferentiation,
    AutoFiniteDiff,
    AutoFiniteDifferences,
    AutoForwardDiff,
    AutoGTPSA,
    AutoMooncake,
    AutoMooncakeForward,
    AutoPolyesterForwardDiff,
    AutoReverseDiff,
    AutoSymbolics,
    AutoTracker,
    AutoZygote,
    AutoHyperHessians
using LinearAlgebra: dot

include("compat.jl")
include("docstrings.jl")

include("first_order/mixed_mode.jl")
include("second_order/second_order.jl")

include("utils/context.jl")
include("utils/prep.jl")
include("utils/traits.jl")
include("utils/basis.jl")
include("utils/batchsize.jl")
include("utils/check.jl")
include("utils/counterparts.jl")
include("utils/errors.jl")
include("utils/linalg.jl")
include("utils/sparse.jl")

include("first_order/pushforward.jl")
include("first_order/pullback.jl")
include("first_order/derivative.jl")
include("first_order/gradient.jl")
include("first_order/jacobian.jl")

include("second_order/second_derivative.jl")
include("second_order/hvp.jl")
include("second_order/hessian.jl")

include("misc/differentiate_with.jl")
include("misc/from_primitive.jl")
include("misc/sparsity_detector.jl")
include("misc/simple_finite_diff.jl")
include("misc/zero_backends.jl")
include("misc/overloading.jl")

## Exported

export Context, Constant, Cache, ConstantOrCache
export MixedMode, SecondOrder

export value_and_pushforward!, value_and_pushforward
export value_and_pullback!, value_and_pullback

export value_and_derivative!, value_and_derivative
export value_and_gradient!, value_and_gradient
export value_and_jacobian!, value_and_jacobian

export pushforward!, pushforward
export pullback!, pullback

export derivative!, derivative
export gradient!, gradient
export jacobian!, jacobian

export second_derivative!, second_derivative
export value_derivative_and_second_derivative, value_derivative_and_second_derivative!
export hvp!, hvp, gradient_and_hvp, gradient_and_hvp!
export hessian!, hessian
export value_gradient_and_hessian, value_gradient_and_hessian!

export prepare_pushforward, prepare_pushforward_same_point
export prepare_pullback, prepare_pullback_same_point
export prepare_hvp, prepare_hvp_same_point
export prepare_derivative, prepare_gradient, prepare_jacobian
export prepare_second_derivative, prepare_hessian

export DifferentiateWith
export DenseSparsityDetector

export check_available, check_inplace

## Re-exported from ADTypes

export AutoChainRules
export AutoDiffractor
export AutoEnzyme
export AutoFastDifferentiation
export AutoFiniteDiff
export AutoFiniteDifferences
export AutoForwardDiff
export AutoGTPSA
export AutoMooncake
export AutoMooncakeForward
export AutoPolyesterForwardDiff
export AutoReverseDiff
export AutoSymbolics
export AutoTracker
export AutoZygote
export AutoHyperHessians

export AutoSparse

## Public but not exported

@public inner, outer
@public AutoForwardFromPrimitive, AutoReverseFromPrimitive
@public Prep
@public forward_counterpart, reverse_counterpart

include("init.jl")

end # module

module DifferentiationInterfaceReverseDiffExt

using ADTypes: AutoReverseDiff
using Base: Fix2
import DifferentiationInterface as DI
import DiffResults as DR
using DiffResults: DiffResults, DiffResult, GradientResult, HessianResult, MutableDiffResult
using LinearAlgebra: dot, mul!
using ReverseDiff:
    ReverseDiff,
    CompiledGradient,
    CompiledHessian,
    CompiledJacobian,
    GradientConfig,
    GradientTape,
    HessianConfig,
    HessianTape,
    JacobianConfig,
    JacobianTape,
    gradient,
    gradient!,
    hessian,
    hessian!,
    jacobian,
    jacobian!

DI.check_available(::AutoReverseDiff) = true

include("onearg.jl")
include("twoarg.jl")
include("utils.jl")

end # module

stack_vec_col(t::NTuple) = stack(vec, t; dims = 2)
stack_vec_row(t::NTuple) = stack(vec, t; dims = 1)

"""
    ismutable_array(x)

Check whether `x` is a mutable array and return a `Bool`.

At the moment, this only returns `false` for `StaticArrays.SArray`.
"""
ismutable_array(::Type) = true
ismutable_array(x) = ismutable_array(typeof(x))

"""
    recursive_similar(x, T)

Apply `similar(_, T)` recursively to `x` or its components.

Works if `x` is an `AbstractArray` or a (nested) `NTuple` / `NamedTuple` of `AbstractArray`s.
"""
recursive_similar(x::AbstractArray, ::Type{T}) where {T} = similar(x, T)
function recursive_similar(x::Union{Tuple, NamedTuple}, ::Type{T}) where {T}
    return map(xi -> recursive_similar(xi, T), x)
end

"""
    get_pattern(M::AbstractMatrix)

Return the `Bool`-valued sparsity pattern for a given matrix.

Only specialized on `SparseMatrixCSC` because it is used with symbolic backends, and at the moment their sparse Jacobian/Hessian utilities return a `SparseMatrixCSC`.

The trivial dense fallback is designed to protect against a change of format in these packages.
"""
get_pattern(M::AbstractMatrix) = trues(size(M))

onlysecond((a, b)) = (a, only(b))

"""
    arroftup_to_tupofarr(tx, x)

Convert an array of tuples `tx` into a tuple of arrays, while respecting the array type of the primal `x`.
"""
arroftup_to_tupofarr(tx::NTuple{B, <:Number}, x::Number) where {B} = tx

function arroftup_to_tupofarr(tx::AbstractArray{<:NTuple{B, <:Number}}, x::AbstractArray{<:Number}) where {B}
    return ntuple(b -> similar(x, eltype(eltype(tx))) .= getindex.(tx, b), Val(B))
end

## Pullback

struct ChainRulesPullbackPrepSamePoint{SIG, Y, PB} <: DI.PullbackPrep{SIG}
    _sig::Val{SIG}
    y::Y
    pb::PB
end

function DI.prepare_pullback_nokwarg(
        strict::Val,
        f,
        backend::AutoReverseChainRules,
        x,
        ty::NTuple,
        contexts::Vararg{DI.GeneralizedConstant, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, ty, contexts...; strict)
    return DI.NoPullbackPrep(_sig)
end

function DI.prepare_pullback_same_point(
        f,
        prep::DI.NoPullbackPrep,
        backend::AutoReverseChainRules,
        x,
        ty::NTuple,
        contexts::Vararg{DI.GeneralizedConstant, C}
    ) where {C}
    DI.check_prep(f, prep, backend, x, ty, contexts...)
    _sig = DI.signature(f, backend, x, ty, contexts...; strict = DI.is_strict(prep))
    rc = ruleconfig(backend)
    y, pb = rrule_via_ad(rc, f, x, map(DI.unwrap, contexts)...)
    return ChainRulesPullbackPrepSamePoint(_sig, y, pb)
end

function DI.value_and_pullback(
        f,
        prep::DI.NoPullbackPrep,
        backend::AutoReverseChainRules,
        x,
        ty::NTuple,
        contexts::Vararg{DI.GeneralizedConstant, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, ty, contexts...)
    rc = ruleconfig(backend)
    y, pb = rrule_via_ad(rc, f, x, map(DI.unwrap, contexts)...)
    tx = map(ty) do dy
        unthunk(pb(dy)[2])
    end
    return y, tx
end

function DI.value_and_pullback(
        f,
        prep::ChainRulesPullbackPrepSamePoint,
        backend::AutoReverseChainRules,
        x,
        ty::NTuple,
        contexts::Vararg{DI.GeneralizedConstant, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, ty, contexts...)
    (; y, pb) = prep
    tx = map(ty) do dy
        unthunk(pb(dy)[2])
    end
    return copy(y), tx
end

function DI.pullback(
        f,
        prep::ChainRulesPullbackPrepSamePoint,
        backend::AutoReverseChainRules,
        x,
        ty::NTuple,
        contexts::Vararg{DI.GeneralizedConstant, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, ty, contexts...)
    (; pb) = prep
    tx = map(ty) do dy
        unthunk(pb(dy)[2])
    end
    return tx
end

module DifferentiationInterfaceSparseConnectivityTracerExt

using ADTypes: jacobian_sparsity, hessian_sparsity
import DifferentiationInterface as DI
using SparseConnectivityTracer:
    TracerSparsityDetector, TracerLocalSparsityDetector, jacobian_buffer, hessian_buffer

@inline function _translate(::Type, c::Union{DI.GeneralizedConstant, DI.ConstantOrCache})
    return DI.unwrap(c)
end
@inline function _translate(::Type{T}, c::DI.Cache) where {T}
    return DI.recursive_similar(DI.unwrap(c), T)
end

function jacobian_translate(detector, x, contexts::Vararg{DI.Context, C}) where {C}
    T = eltype(jacobian_buffer(x, detector))
    new_contexts = map(contexts) do c
        _translate(T, c)
    end
    return new_contexts
end

function hessian_translate(detector, x, contexts::Vararg{DI.Context, C}) where {C}
    T = eltype(hessian_buffer(x, detector))
    new_contexts = map(contexts) do c
        _translate(T, c)
    end
    return new_contexts
end

function DI.jacobian_sparsity_with_contexts(
        f::F,
        detector::Union{TracerSparsityDetector, TracerLocalSparsityDetector},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    contexts_tracer = jacobian_translate(detector, x, contexts...)
    fc = DI.fix_tail(f, contexts_tracer...)
    return jacobian_sparsity(fc, x, detector)
end

function DI.jacobian_sparsity_with_contexts(
        f!::F,
        y,
        detector::Union{TracerSparsityDetector, TracerLocalSparsityDetector},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    contexts_tracer = jacobian_translate(detector, x, contexts...)
    fc! = DI.fix_tail(f!, contexts_tracer...)
    return jacobian_sparsity(fc!, y, x, detector)
end

function DI.hessian_sparsity_with_contexts(
        f::F,
        detector::Union{TracerSparsityDetector, TracerLocalSparsityDetector},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    contexts_tracer = hessian_translate(detector, x, contexts...)
    fc = DI.fix_tail(f, contexts_tracer...)
    return hessian_sparsity(fc, x, detector)
end

end

## Pushforward

struct FastDifferentiationTwoArgPushforwardPrep{SIG, E1, E1!} <: DI.PushforwardPrep{SIG}
    _sig::Val{SIG}
    jvp_exe::E1
    jvp_exe!::E1!
end

function DI.prepare_pushforward_nokwarg(
        strict::Val,
        f!,
        y,
        backend::AutoFastDifferentiation,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f!, y, backend, x, tx, contexts...; strict)
    x_var = variablize(x, :x)
    context_vars = variablize(contexts)
    y_var = variablize(y, :y)
    f!(y_var, x_var, context_vars...)

    x_vec_var = myvec(x_var)
    context_vec_vars = map(myvec, context_vars)
    y_vec_var = myvec(y_var)
    jv_vec_var, v_vec_var = jacobian_times_v(y_vec_var, x_vec_var)
    jvp_exe = make_function(
        jv_vec_var, x_vec_var, v_vec_var, context_vec_vars...; in_place = false
    )
    jvp_exe! = make_function(
        jv_vec_var, x_vec_var, v_vec_var, context_vec_vars...; in_place = true
    )
    return FastDifferentiationTwoArgPushforwardPrep(_sig, jvp_exe, jvp_exe!)
end

function DI.pushforward(
        f!,
        y,
        prep::FastDifferentiationTwoArgPushforwardPrep,
        backend::AutoFastDifferentiation,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    ty = map(tx) do dx
        reshape(prep.jvp_exe(myvec(x), myvec(dx), map(myvec_unwrap, contexts)...), size(y))
    end
    return ty
end

function DI.pushforward!(
        f!,
        y,
        ty::NTuple,
        prep::FastDifferentiationTwoArgPushforwardPrep,
        backend::AutoFastDifferentiation,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    for b in eachindex(tx, ty)
        dx, dy = tx[b], ty[b]
        prep.jvp_exe!(myvec(dy), myvec(x), myvec(dx), map(myvec_unwrap, contexts)...)
    end
    return ty
end

function DI.value_and_pushforward(
        f!,
        y,
        prep::FastDifferentiationTwoArgPushforwardPrep,
        backend::AutoFastDifferentiation,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    ty = DI.pushforward(f!, y, prep, backend, x, tx, contexts...)
    f!(y, x, map(DI.unwrap, contexts)...)
    return y, ty
end

function DI.value_and_pushforward!(
        f!,
        y,
        ty::NTuple,
        prep::FastDifferentiationTwoArgPushforwardPrep,
        backend::AutoFastDifferentiation,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    DI.pushforward!(f!, y, ty, prep, backend, x, tx, contexts...)
    f!(y, x, map(DI.unwrap, contexts)...)
    return y, ty
end

## Pullback

struct FastDifferentiationTwoArgPullbackPrep{SIG, E1, E1!} <: DI.PullbackPrep{SIG}
    _sig::Val{SIG}
    vjp_exe::E1
    vjp_exe!::E1!
end

function DI.prepare_pullback_nokwarg(
        strict::Val,
        f!,
        y,
        backend::AutoFastDifferentiation,
        x,
        ty::NTuple,
        contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f!, y, backend, x, ty, contexts...; strict)
    x_var = variablize(x, :x)
    context_vars = variablize(contexts)
    y_var = variablize(y, :y)
    f!(y_var, x_var, context_vars...)

    x_vec_var = myvec(x_var)
    context_vec_vars = map(myvec, context_vars)
    y_vec_var = myvec(y_var)
    vj_vec_var, v_vec_var = jacobian_transpose_v(y_vec_var, x_vec_var)
    vjp_exe = make_function(
        vj_vec_var, x_vec_var, v_vec_var, context_vec_vars...; in_place = false
    )
    vjp_exe! = make_function(
        vj_vec_var, x_vec_var, v_vec_var, context_vec_vars...; in_place = true
    )
    return FastDifferentiationTwoArgPullbackPrep(_sig, vjp_exe, vjp_exe!)
end

function DI.pullback(
        f!,
        y,
        prep::FastDifferentiationTwoArgPullbackPrep,
        backend::AutoFastDifferentiation,
        x,
        ty::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, ty, contexts...)
    tx = map(ty) do dy
        result = prep.vjp_exe(myvec(x), myvec(dy), map(myvec_unwrap, contexts)...)
        if x isa Number
            return only(result)
        else
            return reshape(result, size(x))
        end
    end
    return tx
end

function DI.pullback!(
        f!,
        y,
        tx::NTuple,
        prep::FastDifferentiationTwoArgPullbackPrep,
        backend::AutoFastDifferentiation,
        x,
        ty::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, ty, contexts...)
    for b in eachindex(tx, ty)
        dx, dy = tx[b], ty[b]
        prep.vjp_exe!(myvec(dx), myvec(x), myvec(dy), map(myvec_unwrap, contexts)...)
    end
    return tx
end

function DI.value_and_pullback(
        f!,
        y,
        prep::FastDifferentiationTwoArgPullbackPrep,
        backend::AutoFastDifferentiation,
        x,
        ty::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, ty, contexts...)
    tx = DI.pullback(f!, y, prep, backend, x, ty, contexts...)
    f!(y, x, map(DI.unwrap, contexts)...)
    return y, tx
end

function DI.value_and_pullback!(
        f!,
        y,
        tx::NTuple,
        prep::FastDifferentiationTwoArgPullbackPrep,
        backend::AutoFastDifferentiation,
        x,
        ty::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, ty, contexts...)
    DI.pullback!(f!, y, tx, prep, backend, x, ty, contexts...)
    f!(y, x, map(DI.unwrap, contexts)...)
    return y, tx
end

## Derivative

struct FastDifferentiationTwoArgDerivativePrep{SIG, E1, E1!} <: DI.DerivativePrep{SIG}
    _sig::Val{SIG}
    der_exe::E1
    der_exe!::E1!
end

function DI.prepare_derivative_nokwarg(
        strict::Val, f!, y, backend::AutoFastDifferentiation, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f!, y, backend, x, contexts...; strict)
    x_var = variablize(x, :x)
    context_vars = variablize(contexts)
    y_var = variablize(y, :y)
    f!(y_var, x_var, context_vars...)

    x_vec_var = myvec(x_var)
    context_vec_vars = map(myvec, context_vars)
    y_vec_var = myvec(y_var)
    der_vec_var = derivative(y_vec_var, x_var)
    der_exe = make_function(der_vec_var, x_vec_var, context_vec_vars...; in_place = false)
    der_exe! = make_function(der_vec_var, x_vec_var, context_vec_vars...; in_place = true)
    return FastDifferentiationTwoArgDerivativePrep(_sig, der_exe, der_exe!)
end

function DI.value_and_derivative(
        f!,
        y,
        prep::FastDifferentiationTwoArgDerivativePrep,
        backend::AutoFastDifferentiation,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    f!(y, x, map(DI.unwrap, contexts)...)
    der = reshape(prep.der_exe(myvec(x), map(myvec_unwrap, contexts)...), size(y))
    return y, der
end

function DI.value_and_derivative!(
        f!,
        y,
        der,
        prep::FastDifferentiationTwoArgDerivativePrep,
        backend::AutoFastDifferentiation,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    f!(y, x, map(DI.unwrap, contexts)...)
    prep.der_exe!(myvec(der), myvec(x), map(myvec_unwrap, contexts)...)
    return y, der
end

function DI.derivative(
        f!,
        y,
        prep::FastDifferentiationTwoArgDerivativePrep,
        backend::AutoFastDifferentiation,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    der = reshape(prep.der_exe(myvec(x), map(myvec_unwrap, contexts)...), size(y))
    return der
end

function DI.derivative!(
        f!,
        y,
        der,
        prep::FastDifferentiationTwoArgDerivativePrep,
        backend::AutoFastDifferentiation,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    prep.der_exe!(myvec(der), myvec(x), map(myvec_unwrap, contexts)...)
    return der
end

## Jacobian

struct FastDifferentiationTwoArgJacobianPrep{SIG, P, E1, E1!} <: DI.SparseJacobianPrep{SIG}
    _sig::Val{SIG}
    sparsity::P
    jac_exe::E1
    jac_exe!::E1!
end

function DI.prepare_jacobian_nokwarg(
        strict::Val,
        f!,
        y,
        backend::Union{AutoFastDifferentiation, AutoSparse{<:AutoFastDifferentiation}},
        x,
        contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f!, y, backend, x, contexts...; strict)
    x_var = variablize(x, :x)
    context_vars = variablize(contexts)
    y_var = variablize(y, :y)
    f!(y_var, x_var, context_vars...)

    x_vec_var = myvec(x_var)
    context_vec_vars = map(myvec, context_vars)
    y_vec_var = myvec(y_var)
    if backend isa AutoSparse
        jac_var = sparse_jacobian(y_vec_var, x_vec_var)
        sparsity = DI.get_pattern(jac_var)
    else
        jac_var = jacobian(y_vec_var, x_vec_var)
        sparsity = nothing
    end
    jac_exe = make_function(jac_var, x_vec_var, context_vec_vars...; in_place = false)
    jac_exe! = make_function(jac_var, x_vec_var, context_vec_vars...; in_place = true)
    return FastDifferentiationTwoArgJacobianPrep(_sig, sparsity, jac_exe, jac_exe!)
end

function DI.value_and_jacobian(
        f!,
        y,
        prep::FastDifferentiationTwoArgJacobianPrep,
        backend::Union{AutoFastDifferentiation, AutoSparse{<:AutoFastDifferentiation}},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    f!(y, x, map(DI.unwrap, contexts)...)
    jac = prep.jac_exe(myvec(x), map(myvec_unwrap, contexts)...)
    return y, jac
end

function DI.value_and_jacobian!(
        f!,
        y,
        jac,
        prep::FastDifferentiationTwoArgJacobianPrep,
        backend::Union{AutoFastDifferentiation, AutoSparse{<:AutoFastDifferentiation}},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    f!(y, x, map(DI.unwrap, contexts)...)
    prep.jac_exe!(jac, myvec(x), map(myvec_unwrap, contexts)...)
    return y, jac
end

function DI.jacobian(
        f!,
        y,
        prep::FastDifferentiationTwoArgJacobianPrep,
        backend::Union{AutoFastDifferentiation, AutoSparse{<:AutoFastDifferentiation}},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    jac = prep.jac_exe(myvec(x), map(myvec_unwrap, contexts)...)
    return jac
end

function DI.jacobian!(
        f!,
        y,
        jac,
        prep::FastDifferentiationTwoArgJacobianPrep,
        backend::Union{AutoFastDifferentiation, AutoSparse{<:AutoFastDifferentiation}},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    prep.jac_exe!(jac, myvec(x), map(myvec_unwrap, contexts)...)
    return jac
end

module DifferentiationInterfaceTrackerExt

using ADTypes: AutoTracker
import DifferentiationInterface as DI
using Tracker: Tracker, back, data, forward, gradient, jacobian, param, withgradient

DI.check_available(::AutoTracker) = true
DI.inplace_support(::AutoTracker) = DI.InPlaceNotSupported()

## Pullback

struct TrackerPullbackPrepSamePoint{SIG, Y, PB} <: DI.PullbackPrep{SIG}
    _sig::Val{SIG}
    y::Y
    pb::PB
end

function DI.prepare_pullback_nokwarg(
        strict::Val,
        f,
        backend::AutoTracker,
        x,
        ty::NTuple,
        contexts::Vararg{DI.GeneralizedConstant, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, ty, contexts...; strict)
    return DI.NoPullbackPrep(_sig)
end

function DI.prepare_pullback_same_point(
        f,
        prep::DI.NoPullbackPrep,
        backend::AutoTracker,
        x,
        ty::NTuple,
        contexts::Vararg{DI.GeneralizedConstant, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, ty, contexts...)
    _sig = DI.signature(f, backend, x, ty, contexts...; strict = DI.is_strict(prep))
    y, pb = forward(f, x, map(DI.unwrap, contexts)...)
    return TrackerPullbackPrepSamePoint(_sig, y, pb)
end

function DI.value_and_pullback(
        f,
        prep::DI.NoPullbackPrep,
        backend::AutoTracker,
        x,
        ty::NTuple,
        contexts::Vararg{DI.GeneralizedConstant, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, ty, contexts...)
    y, pb = forward(f, x, map(DI.unwrap, contexts)...)
    tx = map(ty) do dy
        data(first(pb(dy)))
    end
    return y, tx
end

function DI.value_and_pullback(
        f,
        prep::TrackerPullbackPrepSamePoint,
        backend::AutoTracker,
        x,
        ty::NTuple,
        contexts::Vararg{DI.GeneralizedConstant, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, ty, contexts...)
    (; y, pb) = prep
    tx = map(ty) do dy
        data(first(pb(dy)))
    end
    return copy(y), tx
end

function DI.pullback(
        f,
        prep::TrackerPullbackPrepSamePoint,
        backend::AutoTracker,
        x,
        ty::NTuple,
        contexts::Vararg{DI.GeneralizedConstant, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, ty, contexts...)
    (; pb) = prep
    tx = map(ty) do dy
        data(first(pb(dy)))
    end
    return tx
end

## Gradient

function DI.prepare_gradient_nokwarg(
        strict::Val, f, backend::AutoTracker, x, contexts::Vararg{DI.GeneralizedConstant, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    return DI.NoGradientPrep(_sig)
end

function DI.value_and_gradient(
        f,
        prep::DI.NoGradientPrep,
        backend::AutoTracker,
        x,
        contexts::Vararg{DI.GeneralizedConstant, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    (; val, grad) = withgradient(f, x, map(DI.unwrap, contexts)...)
    return val, data(first(grad))
end

function DI.gradient(
        f,
        prep::DI.NoGradientPrep,
        backend::AutoTracker,
        x,
        contexts::Vararg{DI.GeneralizedConstant, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    (; grad) = withgradient(f, x, map(DI.unwrap, contexts)...)
    return data(first(grad))
end

function DI.value_and_gradient!(
        f,
        grad,
        prep::DI.NoGradientPrep,
        backend::AutoTracker,
        x,
        contexts::Vararg{DI.GeneralizedConstant, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    y, new_grad = DI.value_and_gradient(f, prep, backend, x, contexts...)
    return y, copyto!(grad, new_grad)
end

function DI.gradient!(
        f,
        grad,
        prep::DI.NoGradientPrep,
        backend::AutoTracker,
        x,
        contexts::Vararg{DI.GeneralizedConstant, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return copyto!(grad, DI.gradient(f, prep, backend, x, contexts...))
end

end

module DifferentiationInterfaceFiniteDiffExt

using ADTypes: AutoFiniteDiff
import DifferentiationInterface as DI
using FiniteDiff:
    DerivativeCache,
    GradientCache,
    HessianCache,
    JacobianCache,
    JVPCache,
    finite_difference_derivative,
    finite_difference_gradient,
    finite_difference_gradient!,
    finite_difference_hessian,
    finite_difference_hessian!,
    finite_difference_jacobian,
    finite_difference_jacobian!,
    finite_difference_jvp,
    finite_difference_jvp!,
    default_relstep
using LinearAlgebra: dot, mul!

DI.check_available(::AutoFiniteDiff) = true
DI.inner_preparation_behavior(::AutoFiniteDiff) = DI.PrepareInnerSimple()

# see https://github.com/SciML/ADTypes.jl/issues/33

fdtype(::AutoFiniteDiff{fdt}) where {fdt} = fdt
fdjtype(::AutoFiniteDiff{fdt, fdjt}) where {fdt, fdjt} = fdjt
fdhtype(::AutoFiniteDiff{fdt, fdjt, fdht}) where {fdt, fdjt, fdht} = fdht

# see https://docs.sciml.ai/FiniteDiff/stable/#f-Definitions
const FUNCTION_INPLACE = Val{true}
const FUNCTION_NOT_INPLACE = Val{false}

include("onearg.jl")
include("twoarg.jl")

end # module

function DI.pick_batchsize(::AutoForwardDiff{nothing}, N::Integer)
    chunksize = pickchunksize(N)
    return DI.BatchSizeSettings{chunksize}(N)
end

function DI.pick_batchsize(::AutoForwardDiff{chunksize}, N::Integer) where {chunksize}
    return DI.BatchSizeSettings{chunksize}(N)
end

function DI.threshold_batchsize(
        backend::AutoForwardDiff{chunksize1}, chunksize2::Integer
    ) where {chunksize1}
    chunksize = isnothing(chunksize1) ? nothing : min(chunksize1, chunksize2)
    return AutoForwardDiff(; chunksize, tag = backend.tag)
end

choose_chunk(::AutoForwardDiff{nothing}, x) = Chunk(x)
choose_chunk(::AutoForwardDiff{chunksize}, x) where {chunksize} = Chunk{chunksize}()

get_tag(f, backend::AutoForwardDiff, x) = backend.tag

function get_tag(f::F, backend::AutoForwardDiff{chunksize, Nothing}, x) where {F, chunksize}
    return Tag(f, eltype(x))
end

tag_type(::AutoForwardDiff{chunksize, T}) where {chunksize, T} = T
tag_type(f::F, backend::AutoForwardDiff, x) where {F} = typeof(get_tag(f, backend, x))

dual_type(config::DerivativeConfig) = eltype(config.duals)
dual_type(config::GradientConfig) = eltype(config.duals)
dual_type(config::JacobianConfig{T, V, N}) where {T, V, N} = Dual{T, V, N}
dual_type(config::HessianConfig) = dual_type(config.gradient_config)

function make_dual_similar(::Type{T}, x::Number, tx::NTuple{B}) where {T, B}
    return Dual{T}(x, tx...)
end

function make_dual_similar(::Type{T}, x, tx::NTuple{B}) where {T, B}
    return similar(x, Dual{T, eltype(x), B})
end

function make_dual(::Type{T}, x::Number, dx::Number) where {T}
    return Dual{T}(x, dx)
end

function make_dual(::Type{T}, x::Number, tx::NTuple{B}) where {T, B}
    return Dual{T}(x, tx...)
end

function make_dual(::Type{T}, x, tx::NTuple{B}) where {T, B}
    return Dual{T}.(x, tx...)
end

function make_dual!(::Type{T}, xdual, x, tx::NTuple{B}) where {T, B}
    return xdual .= Dual{T}.(x, tx...)
end

myvalue(::Type{T}, ydual::Number) where {T} = value(T, ydual)
myvalue(::Type{T}, ydual) where {T} = myvalue.(T, ydual)
myvalue!(::Type{T}, y, ydual) where {T} = y .= myvalue.(T, ydual)

myderivative(::Type{T}, ydual::Number) where {T} = extract_derivative(T, ydual)
myderivative(::Type{T}, ydual) where {T} = myderivative.(T, ydual)
myderivative!(::Type{T}, dy, ydual) where {T} = dy .= myderivative.(T, ydual)

function mypartials(::Type{T}, ::Val{B}, ydual::Number) where {T, B}
    return ntuple(Val(B)) do b
        partials(T, ydual, b)
    end
end

function mypartials(::Type{T}, ::Val{B}, ydual) where {T, B}
    return ntuple(Val(B)) do b
        partials.(T, ydual, b)
    end
end

function mypartials!(::Type{T}, ty::NTuple{B}, ydual) where {T, B}
    for b in eachindex(ty)
        ty[b] .= partials.(T, ydual, b)
    end
    return ty
end

function _translate(
        ::Type{D}, c::Union{DI.GeneralizedConstant, DI.ConstantOrCache}
    ) where {D <: Dual}
    return DI.unwrap(c)
end
function _translate(::Type{D}, c::DI.Cache) where {D <: Dual}
    c0 = DI.unwrap(c)
    return DI.recursive_similar(c0, D)
end

function translate(::Type{D}, contexts::NTuple{C, DI.Context}) where {D <: Dual, C}
    new_contexts = map(contexts) do c
        _translate(D, c)
    end
    return new_contexts
end

function _translate_toprep(
        ::Type{D}, c::Union{DI.GeneralizedConstant, DI.ConstantOrCache}
    ) where {D <: Dual}
    return nothing
end
function _translate_toprep(::Type{D}, c::DI.Cache) where {D <: Dual}
    c0 = DI.unwrap(c)
    return DI.recursive_similar(c0, D)
end

function translate_toprep(::Type{D}, contexts::NTuple{C, DI.Context}) where {D <: Dual, C}
    new_contexts = map(contexts) do c
        _translate_toprep(D, c)
    end
    return new_contexts
end

function _translate_prepared(c::Union{DI.GeneralizedConstant, DI.ConstantOrCache}, _pc)
    return DI.unwrap(c)
end
_translate_prepared(_c::DI.Cache, pc) = pc

function translate_prepared(
        contexts::NTuple{C, DI.Context}, prep_contexts::NTuple{C, Any}
    ) where {C}
    new_contexts = map(contexts, prep_contexts) do c, pc
        _translate_prepared(c, pc)
    end
    return new_contexts
end

module DifferentiationInterfaceChainRulesCoreExt

using ADTypes: ADTypes, AutoChainRules
using ChainRulesCore:
    ChainRulesCore,
    HasForwardsMode,
    HasReverseMode,
    NoTangent,
    RuleConfig,
    frule_via_ad,
    rrule_via_ad,
    unthunk
import DifferentiationInterface as DI

ruleconfig(backend::AutoChainRules) = backend.ruleconfig

const AutoForwardChainRules = AutoChainRules{<:RuleConfig{>:HasForwardsMode}}
const AutoReverseChainRules = AutoChainRules{<:RuleConfig{>:HasReverseMode}}

DI.check_available(::AutoChainRules) = true
DI.inplace_support(::AutoChainRules) = DI.InPlaceNotSupported()

include("reverse_onearg.jl")
include("differentiate_with.jl")

end

module DifferentiationInterfacePolyesterForwardDiffExt

using ADTypes: AutoForwardDiff, AutoPolyesterForwardDiff
import DifferentiationInterface as DI
using LinearAlgebra: mul!
using PolyesterForwardDiff: threaded_gradient!, threaded_jacobian!
using ForwardDiff: Chunk
using DiffResults: DiffResults

const FDExt = Base.get_extension(DI, :DifferentiationInterfaceForwardDiffExt)
@assert !isnothing(FDExt)

function single_threaded(backend::AutoPolyesterForwardDiff{chunksize, T}) where {chunksize, T}
    return AutoForwardDiff(; chunksize, tag = backend.tag)
end

DI.check_available(::AutoPolyesterForwardDiff) = true
DI.inner_preparation_behavior(::AutoPolyesterForwardDiff) = DI.PrepareInnerOverload()

include("utils.jl")
include("onearg.jl")
include("twoarg.jl")
include("misc.jl")

end # module

using Pkg

@static if VERSION < v"1.11"
    DIT_PATH = joinpath(@__DIR__, "..", "..", "DifferentiationInterfaceTest")
    if isdir(DIT_PATH)
        Pkg.develop(; path = DIT_PATH)
    else
        Pkg.add("DifferentiationInterfaceTest")
    end
end

using ADTypes
using DifferentiationInterfaceTest
using SparseConnectivityTracer
using SparseMatrixColorings
using Test

using DifferentiationInterfaceTest:
    default_scenarios,
    sparse_scenarios,
    complex_scenarios,
    complex_sparse_scenarios,
    static_scenarios,
    component_scenarios,
    gpu_scenarios,
    empty_scenarios,
    test_counterparts

function MyAutoSparse(backend::AbstractADType)
    return AutoSparse(
        backend;
        sparsity_detector = TracerSparsityDetector(),
        coloring_algorithm = GreedyColoringAlgorithm(; postprocessing = true),
    )
end

safetypestab(symb) = VERSION < v"1.12-" ? symb : :none  # TODO: remove

LOGGING = get(ENV, "CI", "false") == "false"

## Pushforward

struct EnzymeOneArgPushforwardPrep{SIG, DF, DC} <: DI.PushforwardPrep{SIG}
    _sig::Val{SIG}
    df::DF
    context_shadows::DC
end

function DI.prepare_pushforward_nokwarg(
        strict::Val,
        f::F,
        backend::AutoEnzyme{<:Union{ForwardMode, Nothing}},
        x,
        tx::NTuple{B},
        contexts::Vararg{DI.Context, C}
    ) where {F, C, B}
    _sig = DI.signature(f, backend, x, tx, contexts...; strict)
    mode = forward_withprimal(backend)
    df = function_shadow(f, backend, mode, Val(B))
    context_shadows = make_context_shadows(backend, mode, Val(B), contexts...)
    return EnzymeOneArgPushforwardPrep(_sig, df, context_shadows)
end

function DI.value_and_pushforward(
        f::F,
        prep::EnzymeOneArgPushforwardPrep,
        backend::AutoEnzyme{<:Union{ForwardMode, Nothing}},
        x,
        tx::NTuple{1},
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    (; df, context_shadows) = prep
    mode = forward_withprimal(backend)
    f_and_df = get_f_and_df_prepared!(df, f, backend, Val(1))
    dx = only(tx)
    x_and_dx = Duplicated(x, dx)
    annotated_contexts = translate_prepared!(context_shadows, contexts, Val(1))
    dy, y = autodiff(mode, f_and_df, x_and_dx, annotated_contexts...)
    return y, (dy,)
end

function DI.value_and_pushforward(
        f::F,
        prep::EnzymeOneArgPushforwardPrep,
        backend::AutoEnzyme{<:Union{ForwardMode, Nothing}},
        x,
        tx::NTuple{B},
        contexts::Vararg{DI.Context, C},
    ) where {F, B, C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    (; df, context_shadows) = prep
    mode = forward_withprimal(backend)
    f_and_df = get_f_and_df_prepared!(df, f, backend, Val(B))
    x_and_tx = BatchDuplicated(x, tx)
    annotated_contexts = translate_prepared!(context_shadows, contexts, Val(B))
    ty, y = autodiff(mode, f_and_df, x_and_tx, annotated_contexts...)
    return y, values(ty)
end

function DI.pushforward(
        f::F,
        prep::EnzymeOneArgPushforwardPrep,
        backend::AutoEnzyme{<:Union{ForwardMode, Nothing}},
        x,
        tx::NTuple{1},
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    (; df, context_shadows) = prep
    mode = forward_noprimal(backend)
    f_and_df = get_f_and_df_prepared!(df, f, backend, Val(1))
    dx = only(tx)
    x_and_dx = Duplicated(x, dx)
    annotated_contexts = translate_prepared!(context_shadows, contexts, Val(1))
    dy = only(autodiff(mode, f_and_df, x_and_dx, annotated_contexts...))
    return (dy,)
end

function DI.pushforward(
        f::F,
        prep::EnzymeOneArgPushforwardPrep,
        backend::AutoEnzyme{<:Union{ForwardMode, Nothing}},
        x,
        tx::NTuple{B},
        contexts::Vararg{DI.Context, C},
    ) where {F, B, C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    (; df, context_shadows) = prep
    mode = forward_noprimal(backend)
    f_and_df = get_f_and_df_prepared!(df, f, backend, Val(B))
    x_and_tx = BatchDuplicated(x, tx)
    annotated_contexts = translate_prepared!(context_shadows, contexts, Val(B))
    ty = only(autodiff(mode, f_and_df, x_and_tx, annotated_contexts...))
    return values(ty)
end

function DI.value_and_pushforward!(
        f::F,
        ty::NTuple,
        prep::EnzymeOneArgPushforwardPrep,
        backend::AutoEnzyme{<:Union{ForwardMode, Nothing}},
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    # dy cannot be passed anyway
    y, new_ty = DI.value_and_pushforward(f, prep, backend, x, tx, contexts...)
    foreach(copyto!, ty, new_ty)
    return y, ty
end

function DI.pushforward!(
        f::F,
        ty::NTuple,
        prep::EnzymeOneArgPushforwardPrep,
        backend::AutoEnzyme{<:Union{ForwardMode, Nothing}},
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    # dy cannot be passed anyway
    new_ty = DI.pushforward(f, prep, backend, x, tx, contexts...)
    foreach(copyto!, ty, new_ty)
    return ty
end

## Gradient

struct EnzymeForwardGradientPrep{SIG, B, DF, DC, O} <: DI.GradientPrep{SIG}
    _sig::Val{SIG}
    _valB::Val{B}
    df::DF
    context_shadows::DC
    basis_shadows::O
end

function DI.prepare_gradient_nokwarg(
        strict::Val,
        f::F,
        backend::AutoEnzyme{<:ForwardMode, <:Union{Nothing, Const}},
        x,
        contexts::Vararg{DI.Constant, C}
    ) where {F, C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    valB = to_val(DI.pick_batchsize(backend, x))
    mode = forward_withprimal(backend)
    df = function_shadow(f, backend, mode, valB)
    context_shadows = make_context_shadows(backend, mode, valB, contexts...)
    basis_shadows = create_shadows(valB, x)
    return EnzymeForwardGradientPrep(_sig, valB, df, context_shadows, basis_shadows)
end

function DI.gradient(
        f::F,
        prep::EnzymeForwardGradientPrep{SIG, B},
        backend::AutoEnzyme{<:ForwardMode, <:Union{Nothing, Const}},
        x,
        contexts::Vararg{DI.Constant, C},
    ) where {F, SIG, B, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    (; df, context_shadows, basis_shadows) = prep
    mode = forward_noprimal(backend)
    f_and_df = get_f_and_df_prepared!(df, f, backend, Val(B))
    annotated_contexts = translate_prepared!(context_shadows, contexts, Val(B))
    derivs = gradient(
        mode, f_and_df, x, annotated_contexts...; chunk = Val(B), shadows = basis_shadows
    )
    return first(derivs)
end

function DI.value_and_gradient(
        f::F,
        prep::EnzymeForwardGradientPrep{SIG, B},
        backend::AutoEnzyme{<:ForwardMode, <:Union{Nothing, Const}},
        x,
        contexts::Vararg{DI.Constant, C},
    ) where {F, SIG, B, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    (; df, context_shadows, basis_shadows) = prep
    mode = forward_withprimal(backend)
    f_and_df = get_f_and_df_prepared!(df, f, backend, Val(B))
    annotated_contexts = translate_prepared!(context_shadows, contexts, Val(B))
    (; derivs, val) = gradient(
        mode, f_and_df, x, annotated_contexts...; chunk = Val(B), shadows = basis_shadows
    )
    return val, first(derivs)
end

function DI.gradient!(
        f::F,
        grad,
        prep::EnzymeForwardGradientPrep{SIG, B},
        backend::AutoEnzyme{<:ForwardMode, <:Union{Nothing, Const}},
        x,
        contexts::Vararg{DI.Constant, C},
    ) where {F, SIG, B, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return copyto!(grad, DI.gradient(f, prep, backend, x, contexts...))
end

function DI.value_and_gradient!(
        f::F,
        grad,
        prep::EnzymeForwardGradientPrep{SIG, B},
        backend::AutoEnzyme{<:ForwardMode, <:Union{Nothing, Const}},
        x,
        contexts::Vararg{DI.Constant, C},
    ) where {F, SIG, B, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    y, new_grad = DI.value_and_gradient(f, prep, backend, x, contexts...)
    return y, copyto!(grad, new_grad)
end

## Jacobian

struct EnzymeForwardOneArgJacobianPrep{SIG, B, DF, DC, O} <: DI.JacobianPrep{SIG}
    _sig::Val{SIG}
    _valB::Val{B}
    df::DF
    context_shadows::DC
    basis_shadows::O
    output_length::Int
end

function DI.prepare_jacobian_nokwarg(
        strict::Val,
        f::F,
        backend::AutoEnzyme{<:Union{ForwardMode, Nothing}, <:Union{Nothing, Const}},
        x,
        contexts::Vararg{DI.Constant, C}
    ) where {F, C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    y = f(x, map(DI.unwrap, contexts)...)
    valB = to_val(DI.pick_batchsize(backend, x))
    mode = forward_withprimal(backend)
    df = function_shadow(f, backend, mode, valB)
    context_shadows = make_context_shadows(backend, mode, valB, contexts...)
    basis_shadows = create_shadows(valB, x)
    return EnzymeForwardOneArgJacobianPrep(
        _sig, valB, df, context_shadows, basis_shadows, length(y)
    )
end

function DI.jacobian(
        f::F,
        prep::EnzymeForwardOneArgJacobianPrep{SIG, B},
        backend::AutoEnzyme{<:Union{ForwardMode, Nothing}, <:Union{Nothing, Const}},
        x,
        contexts::Vararg{DI.Constant, C},
    ) where {F, SIG, B, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    (; df, context_shadows, basis_shadows, output_length) = prep
    mode = forward_noprimal(backend)
    f_and_df = get_f_and_df_prepared!(df, f, backend, Val(B))
    annotated_contexts = translate_prepared!(context_shadows, contexts, Val(B))
    derivs = jacobian(
        mode, f_and_df, x, annotated_contexts...; chunk = Val(B), shadows = basis_shadows
    )
    jac_tensor = first(derivs)
    return maybe_reshape(jac_tensor, output_length, length(x))
end

function DI.value_and_jacobian(
        f::F,
        prep::EnzymeForwardOneArgJacobianPrep{SIG, B},
        backend::AutoEnzyme{<:Union{ForwardMode, Nothing}, <:Union{Nothing, Const}},
        x,
        contexts::Vararg{DI.Constant, C},
    ) where {F, SIG, B, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    (; df, context_shadows, basis_shadows, output_length) = prep
    mode = forward_withprimal(backend)
    f_and_df = get_f_and_df_prepared!(df, f, backend, Val(B))
    annotated_contexts = translate_prepared!(context_shadows, contexts, Val(B))
    (; derivs, val) = jacobian(
        mode, f_and_df, x, annotated_contexts...; chunk = Val(B), shadows = basis_shadows
    )
    jac_tensor = first(derivs)
    return val, maybe_reshape(jac_tensor, output_length, length(x))
end

function DI.jacobian!(
        f::F,
        jac,
        prep::EnzymeForwardOneArgJacobianPrep,
        backend::AutoEnzyme{<:Union{ForwardMode, Nothing}, <:Union{Nothing, Const}},
        x,
        contexts::Vararg{DI.Constant, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return copyto!(jac, DI.jacobian(f, prep, backend, x, contexts...))
end

function DI.value_and_jacobian!(
        f::F,
        jac,
        prep::EnzymeForwardOneArgJacobianPrep,
        backend::AutoEnzyme{<:Union{ForwardMode, Nothing}, <:Union{Nothing, Const}},
        x,
        contexts::Vararg{DI.Constant, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    y, new_jac = DI.value_and_jacobian(f, prep, backend, x, contexts...)
    return y, copyto!(jac, new_jac)
end

module DifferentiationInterfaceForwardDiffExt

using ADTypes: AutoForwardDiff
import DifferentiationInterface as DI
import DiffResults as DR
using DiffResults: DiffResults, DiffResult, GradientResult, HessianResult, MutableDiffResult
using ForwardDiff:
    Chunk,
    Dual,
    DerivativeConfig,
    ForwardDiff,
    GradientConfig,
    HessianConfig,
    JacobianConfig,
    Tag,
    checktag,
    derivative,
    derivative!,
    extract_derivative,
    gradient,
    gradient!,
    hessian,
    hessian!,
    jacobian,
    jacobian!,
    partials,
    pickchunksize,
    value

DI.check_available(::AutoForwardDiff) = true
DI.inner_preparation_behavior(::AutoForwardDiff) = DI.PrepareInnerOverload()

include("utils.jl")
include("onearg.jl")
include("twoarg.jl")
include("differentiate_with.jl")
include("misc.jl")

end # module

## Pushforward

### Unprepared (avoid working on `similar(x)`)

function DI.value_and_pushforward(
        f::F, backend::AutoForwardDiff, x, tx::NTuple{B}, contexts::Vararg{DI.Context, C}
    ) where {F, B, C}
    T = tag_type(f, backend, x)
    xdual = make_dual(T, x, tx)
    contexts_dual = translate(eltype(xdual), contexts)
    ydual = f(xdual, contexts_dual...)
    y = myvalue(T, ydual)
    ty = mypartials(T, Val(B), ydual)
    return y, ty
end

function DI.value_and_pushforward!(
        f::F,
        ty::NTuple{B},
        backend::AutoForwardDiff,
        x,
        tx::NTuple{B},
        contexts::Vararg{DI.Context, C},
    ) where {F, B, C}
    T = tag_type(f, backend, x)
    xdual = make_dual(T, x, tx)
    contexts_dual = translate(eltype(xdual), contexts)
    ydual = f(xdual, contexts_dual...)
    y = myvalue(T, ydual)
    mypartials!(T, ty, ydual)
    return y, ty
end

function DI.pushforward(
        f::F, backend::AutoForwardDiff, x, tx::NTuple{B}, contexts::Vararg{DI.Context, C}
    ) where {F, B, C}
    T = tag_type(f, backend, x)
    xdual = make_dual(T, x, tx)
    contexts_dual = translate(eltype(xdual), contexts)
    ydual = f(xdual, contexts_dual...)
    ty = mypartials(T, Val(B), ydual)
    return ty
end

function DI.pushforward!(
        f::F,
        ty::NTuple{B},
        backend::AutoForwardDiff,
        x,
        tx::NTuple{B},
        contexts::Vararg{DI.Context, C},
    ) where {F, B, C}
    T = tag_type(f, backend, x)
    xdual = make_dual(T, x, tx)
    contexts_dual = translate(eltype(xdual), contexts)
    ydual = f(xdual, contexts_dual...)
    mypartials!(T, ty, ydual)
    return ty
end

### Prepared

struct ForwardDiffOneArgPushforwardPrep{SIG, T, X, CD} <: DI.PushforwardPrep{SIG}
    _sig::Val{SIG}
    _t::Type{T}
    xdual_tmp::X
    contexts_dual::CD
end

function DI.prepare_pushforward_nokwarg(
        strict::Val,
        f::F,
        backend::AutoForwardDiff,
        x,
        tx::NTuple{B},
        contexts::Vararg{DI.Context, C}
    ) where {F, B, C}
    _sig = DI.signature(f, backend, x, tx, contexts...; strict)
    T = tag_type(f, backend, x)
    if DI.ismutable_array(x)
        xdual_tmp = make_dual_similar(T, x, tx)
    else
        xdual_tmp = nothing
    end
    contexts_dual = translate_toprep(Dual{T, eltype(x), B}, contexts)
    return ForwardDiffOneArgPushforwardPrep(_sig, T, xdual_tmp, contexts_dual)
end

function compute_ydual_onearg(
        f::F,
        prep::ForwardDiffOneArgPushforwardPrep{SIG, T},
        x::Number,
        tx::NTuple{B},
        contexts::Vararg{DI.Context, C},
    ) where {F, SIG, T, B, C}
    xdual = make_dual(T, x, tx)
    contexts_dual = translate_prepared(contexts, prep.contexts_dual)
    ydual = f(xdual, contexts_dual...)
    return ydual
end

function compute_ydual_onearg(
        f::F,
        prep::ForwardDiffOneArgPushforwardPrep{SIG, T},
        x,
        tx::NTuple{B},
        contexts::Vararg{DI.Context, C},
    ) where {F, SIG, T, B, C}
    if DI.ismutable_array(x)
        make_dual!(T, prep.xdual_tmp, x, tx)
        xdual_tmp = prep.xdual_tmp
    else
        xdual_tmp = make_dual(T, x, tx)
    end
    contexts_dual = translate_prepared(contexts, prep.contexts_dual)
    ydual = f(xdual_tmp, contexts_dual...)
    return ydual
end

function DI.value_and_pushforward(
        f::F,
        prep::ForwardDiffOneArgPushforwardPrep{SIG, T},
        backend::AutoForwardDiff,
        x,
        tx::NTuple{B},
        contexts::Vararg{DI.Context, C},
    ) where {F, SIG, T, B, C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    ydual = compute_ydual_onearg(f, prep, x, tx, contexts...)
    y = myvalue(T, ydual)
    ty = mypartials(T, Val(B), ydual)
    return y, ty
end

function DI.value_and_pushforward!(
        f::F,
        ty::NTuple,
        prep::ForwardDiffOneArgPushforwardPrep{SIG, T},
        backend::AutoForwardDiff,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {F, SIG, T, C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    ydual = compute_ydual_onearg(f, prep, x, tx, contexts...)
    y = myvalue(T, ydual)
    mypartials!(T, ty, ydual)
    return y, ty
end

function DI.pushforward(
        f::F,
        prep::ForwardDiffOneArgPushforwardPrep{SIG, T},
        backend::AutoForwardDiff,
        x,
        tx::NTuple{B},
        contexts::Vararg{DI.Context, C},
    ) where {F, SIG, T, B, C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    ydual = compute_ydual_onearg(f, prep, x, tx, contexts...)
    ty = mypartials(T, Val(B), ydual)
    return ty
end

function DI.pushforward!(
        f::F,
        ty::NTuple,
        prep::ForwardDiffOneArgPushforwardPrep{SIG, T},
        backend::AutoForwardDiff,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {F, SIG, T, C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    ydual = compute_ydual_onearg(f, prep, x, tx, contexts...)
    mypartials!(T, ty, ydual)
    return ty
end

## Derivative

struct ForwardDiffOneArgDerivativePrep{SIG, E} <: DI.DerivativePrep{SIG}
    _sig::Val{SIG}
    pushforward_prep::E
end

### Unprepared

function DI.value_and_derivative(
        f::F, backend::AutoForwardDiff, x, contexts::Vararg{DI.Context, C}
    ) where {F, C}
    y, ty = DI.value_and_pushforward(f, backend, x, (oneunit(x),), contexts...)
    return y, only(ty)
end

function DI.value_and_derivative!(
        f::F, der, backend::AutoForwardDiff, x, contexts::Vararg{DI.Context, C}
    ) where {F, C}
    y, _ = DI.value_and_pushforward!(f, (der,), backend, x, (oneunit(x),), contexts...)
    return y, der
end

function DI.derivative(
        f::F, backend::AutoForwardDiff, x, contexts::Vararg{DI.Context, C}
    ) where {F, C}
    return only(DI.pushforward(f, backend, x, (oneunit(x),), contexts...))
end

function DI.derivative!(
        f::F, der, backend::AutoForwardDiff, x, contexts::Vararg{DI.Context, C}
    ) where {F, C}
    DI.pushforward!(f, (der,), backend, x, (oneunit(x),), contexts...)
    return der
end

### Prepared

function DI.prepare_derivative_nokwarg(
        strict::Val, f::F, backend::AutoForwardDiff, x, contexts::Vararg{DI.Context, C}
    ) where {F, C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    pushforward_prep = DI.prepare_pushforward_nokwarg(
        strict, f, backend, x, (oneunit(x),), contexts...
    )
    return ForwardDiffOneArgDerivativePrep(_sig, pushforward_prep)
end

function DI.value_and_derivative(
        f::F,
        prep::ForwardDiffOneArgDerivativePrep,
        backend::AutoForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    y, ty = DI.value_and_pushforward(
        f, prep.pushforward_prep, backend, x, (oneunit(x),), contexts...
    )
    return y, only(ty)
end

function DI.value_and_derivative!(
        f::F,
        der,
        prep::ForwardDiffOneArgDerivativePrep,
        backend::AutoForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    y, _ = DI.value_and_pushforward!(
        f, (der,), prep.pushforward_prep, backend, x, (oneunit(x),), contexts...
    )
    return y, der
end

function DI.derivative(
        f::F,
        prep::ForwardDiffOneArgDerivativePrep,
        backend::AutoForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return only(
        DI.pushforward(f, prep.pushforward_prep, backend, x, (oneunit(x),), contexts...)
    )
end

function DI.derivative!(
        f::F,
        der,
        prep::ForwardDiffOneArgDerivativePrep,
        backend::AutoForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    DI.pushforward!(
        f, (der,), prep.pushforward_prep, backend, x, (oneunit(x),), contexts...
    )
    return der
end

## Gradient

### Unprepared, only when chunk size and tag are not specified

function DI.value_and_gradient!(
        f::F, grad, backend::AutoForwardDiff{chunksize, T}, x, contexts::Vararg{DI.Context, C}
    ) where {F, C, chunksize, T}
    if (
            isnothing(chunksize) &&
                T === Nothing &&
                contexts isa NTuple{C, DI.GeneralizedConstant}
        )
        fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
        result = DiffResult(zero(eltype(x)), (grad,))
        result = gradient!(result, fc, x)
        y = DR.value(result)
        grad === DR.gradient(result) || copyto!(grad, DR.gradient(result))
        return y, grad
    else
        prep = DI.prepare_gradient_nokwarg(Val(true), f, backend, x, contexts...)
        return DI.value_and_gradient!(f, grad, prep, backend, x, contexts...)
    end
end

function DI.value_and_gradient(
        f::F, backend::AutoForwardDiff{chunksize, T}, x, contexts::Vararg{DI.Context, C}
    ) where {F, C, chunksize, T}
    if (
            isnothing(chunksize) &&
                T === Nothing &&
                contexts isa NTuple{C, DI.GeneralizedConstant}
        )
        fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
        result = GradientResult(x)
        result = gradient!(result, fc, x)
        return DR.value(result), DR.gradient(result)
    else
        prep = DI.prepare_gradient_nokwarg(Val(true), f, backend, x, contexts...)
        return DI.value_and_gradient(f, prep, backend, x, contexts...)
    end
end

function DI.gradient!(
        f::F, grad, backend::AutoForwardDiff{chunksize, T}, x, contexts::Vararg{DI.Context, C}
    ) where {F, C, chunksize, T}
    if (
            isnothing(chunksize) &&
                T === Nothing &&
                contexts isa NTuple{C, DI.GeneralizedConstant}
        )
        fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
        return gradient!(grad, fc, x)
    else
        prep = DI.prepare_gradient_nokwarg(Val(true), f, backend, x, contexts...)
        return DI.gradient!(f, grad, prep, backend, x, contexts...)
    end
end

function DI.gradient(
        f::F, backend::AutoForwardDiff{chunksize, T}, x, contexts::Vararg{DI.Context, C}
    ) where {F, C, chunksize, T}
    if (
            isnothing(chunksize) &&
                T === Nothing &&
                contexts isa NTuple{C, DI.GeneralizedConstant}
        )
        fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
        return gradient(fc, x)
    else
        prep = DI.prepare_gradient_nokwarg(Val(true), f, backend, x, contexts...)
        return DI.gradient(f, prep, backend, x, contexts...)
    end
end

### Prepared

struct ForwardDiffGradientPrep{SIG, C, CD} <: DI.GradientPrep{SIG}
    _sig::Val{SIG}
    config::C
    contexts_dual::CD
end

function DI.prepare_gradient_nokwarg(
        strict::Val,
        f::F,
        backend::AutoForwardDiff,
        x::AbstractArray,
        contexts::Vararg{DI.Context, C}
    ) where {F, C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    chunk = choose_chunk(backend, x)
    tag = get_tag(f, backend, x)
    config = GradientConfig(nothing, x, chunk, tag)
    contexts_dual = translate_toprep(dual_type(config), contexts)
    return ForwardDiffGradientPrep(_sig, config, contexts_dual)
end

function DI.value_and_gradient!(
        f::F,
        grad,
        prep::ForwardDiffGradientPrep,
        backend::AutoForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    contexts_dual = translate_prepared(contexts, prep.contexts_dual)
    fc = DI.fix_tail(f, contexts_dual...)
    result = DiffResult(zero(eltype(x)), (grad,))
    CHK = tag_type(backend) === Nothing
    if CHK
        checktag(prep.config, f, x)
    end
    result = gradient!(result, fc, x, prep.config, Val(false))
    y = DR.value(result)
    grad === DR.gradient(result) || copyto!(grad, DR.gradient(result))
    return y, grad
end

function DI.value_and_gradient(
        f::F,
        prep::ForwardDiffGradientPrep,
        backend::AutoForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    contexts_dual = translate_prepared(contexts, prep.contexts_dual)
    fc = DI.fix_tail(f, contexts_dual...)
    result = GradientResult(x)
    CHK = tag_type(backend) === Nothing
    if CHK
        checktag(prep.config, f, x)
    end
    result = gradient!(result, fc, x, prep.config, Val(false))
    return DR.value(result), DR.gradient(result)
end

function DI.gradient!(
        f::F,
        grad,
        prep::ForwardDiffGradientPrep,
        backend::AutoForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    contexts_dual = translate_prepared(contexts, prep.contexts_dual)
    fc = DI.fix_tail(f, contexts_dual...)
    CHK = tag_type(backend) === Nothing
    if CHK
        checktag(prep.config, f, x)
    end
    return gradient!(grad, fc, x, prep.config, Val(false))
end

function DI.gradient(
        f::F,
        prep::ForwardDiffGradientPrep,
        backend::AutoForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    contexts_dual = translate_prepared(contexts, prep.contexts_dual)
    fc = DI.fix_tail(f, contexts_dual...)
    CHK = tag_type(backend) === Nothing
    if CHK
        checktag(prep.config, f, x)
    end
    return gradient(fc, x, prep.config, Val(false))
end

## Jacobian

### Unprepared, only when chunk size and tag are not specified

function DI.value_and_jacobian!(
        f::F, jac, backend::AutoForwardDiff{chunksize, T}, x, contexts::Vararg{DI.Context, C}
    ) where {F, C, chunksize, T}
    if (
            isnothing(chunksize) &&
                T === Nothing &&
                contexts isa NTuple{C, DI.GeneralizedConstant}
        )
        fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
        y = fc(x)
        result = DiffResult(y, (jac,))
        result = jacobian!(result, fc, x)
        y = DR.value(result)
        jac === DR.jacobian(result) || copyto!(jac, DR.jacobian(result))
        return y, jac
    else
        prep = DI.prepare_jacobian_nokwarg(Val(true), f, backend, x, contexts...)
        return DI.value_and_jacobian!(f, jac, prep, backend, x, contexts...)
    end
end

function DI.value_and_jacobian(
        f::F, backend::AutoForwardDiff{chunksize, T}, x, contexts::Vararg{DI.Context, C}
    ) where {F, C, chunksize, T}
    if (
            isnothing(chunksize) &&
                T === Nothing &&
                contexts isa NTuple{C, DI.GeneralizedConstant}
        )
        fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
        return fc(x), jacobian(fc, x)
    else
        prep = DI.prepare_jacobian_nokwarg(Val(true), f, backend, x, contexts...)
        return DI.value_and_jacobian(f, prep, backend, x, contexts...)
    end
end

function DI.jacobian!(
        f::F, jac, backend::AutoForwardDiff{chunksize, T}, x, contexts::Vararg{DI.Context, C}
    ) where {F, C, chunksize, T}
    if (
            isnothing(chunksize) &&
                T === Nothing &&
                contexts isa NTuple{C, DI.GeneralizedConstant}
        )
        fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
        return jacobian!(jac, fc, x)
    else
        prep = DI.prepare_jacobian_nokwarg(Val(true), f, backend, x, contexts...)
        return DI.jacobian!(f, jac, prep, backend, x, contexts...)
    end
end

function DI.jacobian(
        f::F, backend::AutoForwardDiff{chunksize, T}, x, contexts::Vararg{DI.Context, C}
    ) where {F, C, chunksize, T}
    if (
            isnothing(chunksize) &&
                T === Nothing &&
                contexts isa NTuple{C, DI.GeneralizedConstant}
        )
        fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
        return jacobian(fc, x)
    else
        prep = DI.prepare_jacobian_nokwarg(Val(true), f, backend, x, contexts...)
        return DI.jacobian(f, prep, backend, x, contexts...)
    end
end

### Prepared

struct ForwardDiffOneArgJacobianPrep{SIG, C, CD} <: DI.JacobianPrep{SIG}
    _sig::Val{SIG}
    config::C
    contexts_dual::CD
end

function DI.prepare_jacobian_nokwarg(
        strict::Val, f::F, backend::AutoForwardDiff, x, contexts::Vararg{DI.Context, C}
    ) where {F, C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    chunk = choose_chunk(backend, x)
    tag = get_tag(f, backend, x)
    config = JacobianConfig(nothing, x, chunk, tag)
    contexts_dual = translate_toprep(dual_type(config), contexts)
    return ForwardDiffOneArgJacobianPrep(_sig, config, contexts_dual)
end

function DI.value_and_jacobian!(
        f::F,
        jac,
        prep::ForwardDiffOneArgJacobianPrep,
        backend::AutoForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    contexts_dual = translate_prepared(contexts, prep.contexts_dual)
    fc = DI.fix_tail(f, contexts_dual...)
    y = fc(x)
    result = DiffResult(y, (jac,))
    CHK = tag_type(backend) === Nothing
    if CHK
        checktag(prep.config, f, x)
    end
    result = jacobian!(result, fc, x, prep.config, Val(false))
    y = DR.value(result)
    jac === DR.jacobian(result) || copyto!(jac, DR.jacobian(result))
    return y, jac
end

function DI.value_and_jacobian(
        f::F,
        prep::ForwardDiffOneArgJacobianPrep,
        backend::AutoForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    contexts_dual = translate_prepared(contexts, prep.contexts_dual)
    fc = DI.fix_tail(f, contexts_dual...)
    CHK = tag_type(backend) === Nothing
    if CHK
        checktag(prep.config, f, x)
    end
    return fc(x), jacobian(fc, x, prep.config, Val(false))
end

function DI.jacobian!(
        f::F,
        jac,
        prep::ForwardDiffOneArgJacobianPrep,
        backend::AutoForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    contexts_dual = translate_prepared(contexts, prep.contexts_dual)
    fc = DI.fix_tail(f, contexts_dual...)
    CHK = tag_type(backend) === Nothing
    if CHK
        checktag(prep.config, f, x)
    end
    return jacobian!(jac, fc, x, prep.config, Val(false))
end

function DI.jacobian(
        f::F,
        prep::ForwardDiffOneArgJacobianPrep,
        backend::AutoForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    contexts_dual = translate_prepared(contexts, prep.contexts_dual)
    fc = DI.fix_tail(f, contexts_dual...)
    CHK = tag_type(backend) === Nothing
    if CHK
        checktag(prep.config, f, x)
    end
    return jacobian(fc, x, prep.config, Val(false))
end

## Second derivative

function DI.prepare_second_derivative_nokwarg(
        strict::Val, f::F, backend::AutoForwardDiff, x, contexts::Vararg{DI.Context, C}
    ) where {F, C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    return DI.NoSecondDerivativePrep(_sig)
end

function DI.second_derivative(
        f::F,
        prep::DI.NoSecondDerivativePrep,
        backend::AutoForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    T = tag_type(f, backend, x)
    xdual = make_dual(T, x, oneunit(x))
    T2 = tag_type(f, backend, xdual)
    xdual2 = make_dual(T2, xdual, oneunit(xdual))
    contexts_dual = translate(typeof(xdual2), contexts)
    ydual = f(xdual2, contexts_dual...)
    return myderivative(T, myderivative(T2, ydual))
end

function DI.second_derivative!(
        f::F,
        der2,
        prep::DI.NoSecondDerivativePrep,
        backend::AutoForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    T = tag_type(f, backend, x)
    xdual = make_dual(T, x, oneunit(x))
    T2 = tag_type(f, backend, xdual)
    xdual2 = make_dual(T2, xdual, oneunit(xdual))
    contexts_dual = translate(typeof(xdual2), contexts)
    ydual = f(xdual2, contexts_dual...)
    return myderivative!(T, der2, myderivative(T2, ydual))
end

function DI.value_derivative_and_second_derivative(
        f::F,
        prep::DI.NoSecondDerivativePrep,
        backend::AutoForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    T = tag_type(f, backend, x)
    xdual = make_dual(T, x, oneunit(x))
    T2 = tag_type(f, backend, xdual)
    xdual2 = make_dual(T2, xdual, oneunit(xdual))
    contexts_dual = translate(typeof(xdual2), contexts)
    ydual = f(xdual2, contexts_dual...)
    y = myvalue(T, myvalue(T2, ydual))
    der = myderivative(T, myvalue(T2, ydual))
    der2 = myderivative(T, myderivative(T2, ydual))
    return y, der, der2
end

function DI.value_derivative_and_second_derivative!(
        f::F,
        der,
        der2,
        prep::DI.NoSecondDerivativePrep,
        backend::AutoForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    T = tag_type(f, backend, x)
    xdual = make_dual(T, x, oneunit(x))
    T2 = tag_type(f, backend, xdual)
    xdual2 = make_dual(T2, xdual, oneunit(xdual))
    contexts_dual = translate(typeof(xdual2), contexts)
    ydual = f(xdual2, contexts_dual...)
    y = myvalue(T, myvalue(T2, ydual))
    myderivative!(T, der, myvalue(T2, ydual))
    myderivative!(T, der2, myderivative(T2, ydual))
    return y, der, der2
end

## Hessian

### Unprepared, only when chunk size and tag are not specified

function DI.hessian!(
        f::F, hess, backend::AutoForwardDiff{chunksize, T}, x, contexts::Vararg{DI.Context, C}
    ) where {F, C, chunksize, T}
    if (
            isnothing(chunksize) &&
                T === Nothing &&
                contexts isa NTuple{C, DI.GeneralizedConstant}
        )
        fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
        return hessian!(hess, fc, x)
    else
        prep = DI.prepare_hessian_nokwarg(Val(true), f, backend, x, contexts...)
        return DI.hessian!(f, hess, prep, backend, x, contexts...)
    end
end

function DI.hessian(
        f::F, backend::AutoForwardDiff{chunksize, T}, x, contexts::Vararg{DI.Context, C}
    ) where {F, C, chunksize, T}
    if (
            isnothing(chunksize) &&
                T === Nothing &&
                contexts isa NTuple{C, DI.GeneralizedConstant}
        )
        fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
        return hessian(fc, x)
    else
        prep = DI.prepare_hessian_nokwarg(Val(true), f, backend, x, contexts...)
        return DI.hessian(f, prep, backend, x, contexts...)
    end
end

function DI.value_gradient_and_hessian!(
        f::F,
        grad,
        hess,
        backend::AutoForwardDiff{chunksize, T},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C, chunksize, T}
    if (
            isnothing(chunksize) &&
                T === Nothing &&
                contexts isa NTuple{C, DI.GeneralizedConstant}
        )
        fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
        result = DiffResult(oneunit(eltype(x)), (grad, hess))
        result = hessian!(result, fc, x)
        y = DR.value(result)
        grad === DR.gradient(result) || copyto!(grad, DR.gradient(result))
        hess === DR.hessian(result) || copyto!(hess, DR.hessian(result))
        return (y, grad, hess)
    else
        prep = DI.prepare_hessian_nokwarg(Val(true), f, backend, x, contexts...)
        return DI.value_gradient_and_hessian!(f, grad, hess, prep, backend, x, contexts...)
    end
end

function DI.value_gradient_and_hessian(
        f::F, backend::AutoForwardDiff{chunksize, T}, x, contexts::Vararg{DI.Context, C}
    ) where {F, C, chunksize, T}
    if (
            isnothing(chunksize) &&
                T === Nothing &&
                contexts isa NTuple{C, DI.GeneralizedConstant}
        )
        fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
        result = HessianResult(x)
        result = hessian!(result, fc, x)
        return (DR.value(result), DR.gradient(result), DR.hessian(result))
    else
        prep = DI.prepare_hessian_nokwarg(Val(true), f, backend, x, contexts...)
        return DI.value_gradient_and_hessian(f, prep, backend, x, contexts...)
    end
end

### Prepared

struct ForwardDiffHessianPrep{SIG, C1, C2, CD} <: DI.HessianPrep{SIG}
    _sig::Val{SIG}
    array_config::C1
    result_config::C2
    contexts_dual::CD
end

function DI.prepare_hessian_nokwarg(
        strict::Val, f::F, backend::AutoForwardDiff, x, contexts::Vararg{DI.Context, C}
    ) where {F, C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    chunk = choose_chunk(backend, x)
    tag = get_tag(f, backend, x)
    result = HessianResult(x)
    array_config = HessianConfig(nothing, x, chunk, tag)
    result_config = HessianConfig(nothing, result, x, chunk, tag)
    contexts_dual = translate_toprep(dual_type(array_config), contexts)
    return ForwardDiffHessianPrep(_sig, array_config, result_config, contexts_dual)
end

function DI.hessian!(
        f::F,
        hess,
        prep::ForwardDiffHessianPrep,
        backend::AutoForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    contexts_dual = translate_prepared(contexts, prep.contexts_dual)
    fc = DI.fix_tail(f, contexts_dual...)
    CHK = tag_type(backend) === Nothing
    if CHK
        checktag(prep.array_config, f, x)
    end
    return hessian!(hess, fc, x, prep.array_config, Val(false))
end

function DI.hessian(
        f::F,
        prep::ForwardDiffHessianPrep,
        backend::AutoForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    contexts_dual = translate_prepared(contexts, prep.contexts_dual)
    fc = DI.fix_tail(f, contexts_dual...)
    CHK = tag_type(backend) === Nothing
    if CHK
        checktag(prep.array_config, f, x)
    end
    return hessian(fc, x, prep.array_config, Val(false))
end

function DI.value_gradient_and_hessian!(
        f::F,
        grad,
        hess,
        prep::ForwardDiffHessianPrep,
        backend::AutoForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    contexts_dual = translate_prepared(contexts, prep.contexts_dual)
    fc = DI.fix_tail(f, contexts_dual...)
    result = DiffResult(oneunit(eltype(x)), (grad, hess))
    CHK = tag_type(backend) === Nothing
    if CHK
        checktag(prep.result_config, f, x)
    end
    result = hessian!(result, fc, x, prep.result_config, Val(false))
    y = DR.value(result)
    grad === DR.gradient(result) || copyto!(grad, DR.gradient(result))
    hess === DR.hessian(result) || copyto!(hess, DR.hessian(result))
    return (y, grad, hess)
end

function DI.value_gradient_and_hessian(
        f::F,
        prep::ForwardDiffHessianPrep,
        backend::AutoForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    contexts_dual = translate_prepared(contexts, prep.contexts_dual)
    fc = DI.fix_tail(f, contexts_dual...)
    result = HessianResult(x)
    CHK = tag_type(backend) === Nothing
    if CHK
        checktag(prep.result_config, f, x)
    end
    result = hessian!(result, fc, x, prep.result_config, Val(false))
    return (DR.value(result), DR.gradient(result), DR.hessian(result))
end

using Pkg

using ADTypes: ADTypes
using DifferentiationInterface, DifferentiationInterfaceTest
import DifferentiationInterface as DI
import DifferentiationInterfaceTest as DIT
using ForwardDiff: ForwardDiff
using StaticArrays: StaticArrays, @SVector
using Test

@testset verbose = true "Benchmarking static" begin
    filtered_static_scenarios = filter(static_scenarios(; include_batchified = false)) do scen
        DIT.function_place(scen) == :out && DIT.operator_place(scen) == :out
    end
    data = benchmark_differentiation(
        AutoForwardDiff(),
        filtered_static_scenarios;
        benchmark = :prepared,
        excluded = [:hessian, :pullback],  # TODO: figure this out
        logging = LOGGING,
    )
    @testset "Analyzing benchmark results" begin
        @testset "$(row[:scenario])" for row in eachrow(data)
            @test row[:allocs] == 0
        end
    end
end

@testset "Benchmarking sparse" begin
    filtered_sparse_scenarios = filter(sparse_scenarios(; band_sizes = [])) do scen
        DIT.function_place(scen) == :in &&
            DIT.operator_place(scen) == :in &&
            scen.x isa AbstractVector &&
            scen.y isa AbstractVector
    end

    data = benchmark_differentiation(
        MyAutoSparse(AutoForwardDiff()),
        filtered_sparse_scenarios;
        benchmark = :prepared,
        excluded = SECOND_ORDER,
        logging = LOGGING,
    )
    @testset "Analyzing benchmark results" begin
        @testset "$(row[:scenario])" for row in eachrow(data)
            @test row[:allocs] == 0
        end
    end
end

struct MooncakeHVPPrep{SIG, Tcache} <: DI.HVPPrep{SIG}
    _sig::Val{SIG}
    cache::Tcache
end

function DI.prepare_hvp_nokwarg(
        strict::Val, f::F, backend::AutoMooncakeForwardOverReverse, x, tx::NTuple, contexts::Vararg{DI.Context, C}
    ) where {F, C}
    _sig = DI.signature(f, backend, x, tx, contexts...; strict)
    config = get_config(backend)
    cache = prepare_hvp_cache(f, x, map(DI.unwrap, contexts)...; config)
    prep = MooncakeHVPPrep(_sig, cache)
    return prep
end

function DI.gradient_and_hvp(
        f::F,
        prep::MooncakeHVPPrep{Y},
        backend::AutoMooncakeForwardOverReverse,
        x,
        tx::NTuple{1},
        contexts::Vararg{DI.Context, C},
    ) where {F, Y, C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    dx = only(tx)
    if isempty(contexts)
        _, new_g, new_dg = value_and_hvp!!(
            prep.cache, f, (dx,), x
        )
    else
        dall = (dx, map(zero_tangent_unwrap, contexts)...)
        _, (new_g,), (new_dg,) = value_and_hvp!!(
            prep.cache, f, dall, x, map(DI.unwrap, contexts)...
        )
    end
    return _copy_output(new_g), (_copy_output(new_dg),)
end

function DI.gradient_and_hvp(
        f::F,
        prep::MooncakeHVPPrep{Y},
        backend::AutoMooncakeForwardOverReverse,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {F, Y, C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    gs_and_tg = map(tx) do dx
        if isempty(contexts)
            _, new_g, new_dg = value_and_hvp!!(
                prep.cache, f, dx, x
            )
        else
            dall = (dx, map(zero_tangent_unwrap, contexts)...)
            _, (new_g,), (new_dg,) = value_and_hvp!!(
                prep.cache, f, dall, x, map(DI.unwrap, contexts)...
            )
        end
        _copy_output(new_g), _copy_output(new_dg)
    end
    g = first(gs_and_tg[1])
    tg = map(last, gs_and_tg)
    return g, tg
end

function DI.gradient_and_hvp!(
        f::F,
        g,
        tg::NTuple,
        prep::MooncakeHVPPrep,
        backend::AutoMooncakeForwardOverReverse,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    new_g, new_tg = DI.gradient_and_hvp(f, prep, backend, x, tx, contexts...)
    copyto!(g, new_g)
    foreach(copyto!, tg, new_tg)
    return g, tg
end

function DI.hvp(
        f::F,
        prep::MooncakeHVPPrep,
        backend::AutoMooncakeForwardOverReverse,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    return DI.gradient_and_hvp(f, prep, backend, x, tx, contexts...)[2]
end

function DI.hvp!(
        f::F,
        tg::NTuple,
        prep::MooncakeHVPPrep,
        backend::AutoMooncakeForwardOverReverse,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    _, new_tg = DI.gradient_and_hvp(f, prep, backend, x, tx, contexts...)
    foreach(copyto!, tg, new_tg)
    return tg
end

"""
    check_available(backend)

Check whether `backend` is available (i.e. whether the extension is loaded) and return a `Bool`.
"""
check_available(backend::AbstractADType) = false

function check_available(backend::SecondOrder)
    return check_available(inner(backend)) && check_available(outer(backend))
end

check_available(backend::AutoSparse) = check_available(dense_ad(backend))

function check_available(backend::MixedMode)
    return check_available(forward_backend(backend)) &&
        check_available(reverse_backend(backend))
end

check_available(::ADTypes.NoAutoDiff) = throw(ADTypes.NoAutoDiffSelectedError())

"""
    check_inplace(backend)

Check whether `backend` supports differentiation of in-place functions and return a `Bool`.
"""
check_inplace(backend::AbstractADType) = Bool(inplace_support(backend))

## Mutation

abstract type InPlaceBehavior end

"""
    InPlaceSupported

Trait identifying backends that support in-place functions `f!(y, x)`.
"""
struct InPlaceSupported <: InPlaceBehavior end

"""
    InPlaceNotSupported

Trait identifying backends that do not support in-place functions `f!(y, x)`.
"""
struct InPlaceNotSupported <: InPlaceBehavior end

"""
    inplace_support(backend)

Return [`InPlaceSupported`](@ref) or [`InPlaceNotSupported`](@ref) in a statically predictable way.
"""
inplace_support(::AbstractADType) = InPlaceSupported()

inplace_support(::ADTypes.NoAutoDiff) = throw(ADTypes.NoAutoDiffSelectedError())

function inplace_support(backend::SecondOrder)
    if inplace_support(inner(backend)) isa InPlaceSupported &&
            inplace_support(outer(backend)) isa InPlaceSupported
        return InPlaceSupported()
    else
        return InPlaceNotSupported()
    end
end

inplace_support(backend::AutoSparse) = inplace_support(dense_ad(backend))

function inplace_support(backend::MixedMode)
    if Bool(inplace_support(forward_backend(backend))) &&
            Bool(inplace_support(reverse_backend(backend)))
        return InPlaceSupported()
    else
        return InPlaceNotSupported()
    end
end

## Pushforward

abstract type PushforwardPerformance end

"""
    PushforwardFast

Trait identifying backends that support efficient pushforwards.
"""
struct PushforwardFast <: PushforwardPerformance end

"""
    PushforwardSlow

Trait identifying backends that do not support efficient pushforwards.
"""
struct PushforwardSlow <: PushforwardPerformance end

"""
    pushforward_performance(backend)

Return [`PushforwardFast`](@ref) or [`PushforwardSlow`](@ref) in a statically predictable way.
"""
pushforward_performance(backend::AbstractADType) = pushforward_performance(mode(backend))
pushforward_performance(::ForwardMode) = PushforwardFast()
pushforward_performance(::ForwardOrReverseMode) = PushforwardFast()
pushforward_performance(::ReverseMode) = PushforwardSlow()
pushforward_performance(::SymbolicMode) = PushforwardFast()

function pushforward_performance(backend::Union{AutoSparse, SecondOrder})
    throw(ArgumentError("Pushforward performance not defined for `$backend`."))
end

## Pullback

abstract type PullbackPerformance end

"""
    PullbackFast

Trait identifying backends that support efficient pullbacks.
"""
struct PullbackFast <: PullbackPerformance end

"""
    PullbackSlow

Trait identifying backends that do not support efficient pullbacks.
"""
struct PullbackSlow <: PullbackPerformance end

"""
    pullback_performance(backend)

Return [`PullbackFast`](@ref) or [`PullbackSlow`](@ref) in a statically predictable way.
"""
pullback_performance(backend::AbstractADType) = pullback_performance(mode(backend))
pullback_performance(::ForwardMode) = PullbackSlow()
pullback_performance(::ForwardOrReverseMode) = PullbackFast()
pullback_performance(::ReverseMode) = PullbackFast()
pullback_performance(::SymbolicMode) = PullbackFast()

function pullback_performance(backend::Union{AutoSparse, SecondOrder})
    throw(ArgumentError("Pullback performance not defined for `$backend`."))
end

## HVP

abstract type HVPMode end

"""
    ForwardOverReverse

Traits identifying second-order backends that compute HVPs in forward over reverse mode.
"""
struct ForwardOverReverse <: HVPMode end

"""
    ReverseOverForward

Traits identifying second-order backends that compute HVPs in reverse over forward mode.
"""
struct ReverseOverForward <: HVPMode end

"""
    ReverseOverReverse

Traits identifying second-order backends that compute HVPs in reverse over reverse mode.
"""
struct ReverseOverReverse <: HVPMode end

"""
    ForwardOverForward

Traits identifying second-order backends that compute HVPs in forward over forward mode (inefficient).
"""
struct ForwardOverForward <: HVPMode end

const ForwardOverAnything = Union{ForwardOverForward, ForwardOverReverse}

"""
    hvp_mode(backend)

Return the best combination of modes for [`hvp`](@ref) and its variants, among the following options:

  - [`ForwardOverForward`](@ref)
  - [`ForwardOverReverse`](@ref)
  - [`ReverseOverForward`](@ref)
  - [`ReverseOverReverse`](@ref)
"""
hvp_mode(backend::AbstractADType) = hvp_mode(SecondOrder(backend, backend))

function hvp_mode(ba::SecondOrder)
    if Bool(pushforward_performance(outer(ba))) && Bool(pullback_performance(inner(ba)))
        return ForwardOverReverse()
    elseif Bool(pullback_performance(outer(ba))) && Bool(pushforward_performance(inner(ba)))
        return ReverseOverForward()
    elseif Bool(pullback_performance(outer(ba))) && Bool(pullback_performance(inner(ba)))
        return ReverseOverReverse()
    else
        return ForwardOverForward()
    end
end

function hvp_mode(backend::AutoSparse)
    throw(ArgumentError("HVP mode not defined for `$backend`."))
end

## Inner prep

abstract type InnerPreparationBehavior end

"""
    PrepareInnerSimple

Trait identifying outer backends for which the inner backend in second-order autodiff should be prepared with the same input type.
"""
struct PrepareInnerSimple <: InnerPreparationBehavior end

"""
    PrepareInnerOverload

Trait identifying outer backends for which the inner backend in second-order autodiff should be prepared with an overloaded input type.
"""
struct PrepareInnerOverload <: InnerPreparationBehavior end

"""
    DontPrepareInner

Trait identifying outer backends for which the inner backend in second-order autodiff should not be prepared at all.
"""
struct DontPrepareInner <: InnerPreparationBehavior end

"""
    inner_preparation_behavior(backend::AbstractADType)

Return [`PrepareInnerSimple`](@ref), [`PrepareInnerOverload`](@ref) or [`DontPrepareInner`](@ref) in a statically predictable way.
"""
inner_preparation_behavior(::AbstractADType) = DontPrepareInner()

## Conversions

Base.Bool(::InPlaceSupported) = true
Base.Bool(::InPlaceNotSupported) = false

Base.Bool(::PushforwardFast) = true
Base.Bool(::PushforwardSlow) = false

Base.Bool(::PullbackFast) = true
Base.Bool(::PullbackSlow) = false

function DI.overloaded_input(
        ::typeof(DI.pushforward), f::F, backend::AutoPolyesterForwardDiff, x, tx::NTuple{B}
    ) where {F, B}
    return DI.overloaded_input(DI.pushforward, f, single_threaded(backend), x, tx)
end

function DI.overloaded_input(
        ::typeof(DI.pushforward), f!::F, y, backend::AutoPolyesterForwardDiff, x, tx::NTuple{B}
    ) where {F, B}
    return DI.overloaded_input(DI.pushforward, f!, y, single_threaded(backend), x, tx)
end

## Docstrings

"""
    prepare_pullback(f,     backend, x, ty, [contexts...]; strict=Val(true)) -> prep
    prepare_pullback(f!, y, backend, x, ty, [contexts...]; strict=Val(true)) -> prep

$(docstring_prepare("pullback"; inplace = true))
"""
function prepare_pullback(
        f::F,
        backend::AbstractADType,
        x,
        ty::NTuple,
        contexts::Vararg{Context, C};
        strict::Val = Val(true),
    ) where {F, C}
    return prepare_pullback_nokwarg(strict, f, backend, x, ty, contexts...)
end

function prepare_pullback(
        f!::F,
        y,
        backend::AbstractADType,
        x,
        ty::NTuple,
        contexts::Vararg{Context, C};
        strict::Val = Val(true),
    ) where {F, C}
    return prepare_pullback_nokwarg(strict, f!, y, backend, x, ty, contexts...)
end

"""
    prepare!_pullback(f,     prep, backend, x, ty, [contexts...]) -> new_prep
    prepare!_pullback(f!, y, prep, backend, x, ty, [contexts...]) -> new_prep

$(docstring_prepare!("pullback"))
"""
function prepare!_pullback(
        f::F,
        old_prep::PullbackPrep,
        backend::AbstractADType,
        x,
        ty::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, old_prep, backend, x, ty, contexts...)
    return prepare_pullback_nokwarg(is_strict(old_prep), f, backend, x, ty, contexts...)
end

function prepare!_pullback(
        f!::F,
        y,
        old_prep::PullbackPrep,
        backend::AbstractADType,
        x,
        ty::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f!, y, old_prep, backend, x, ty, contexts...)
    return prepare_pullback_nokwarg(is_strict(old_prep), f!, y, backend, x, ty, contexts...)
end

"""
    prepare_pullback_same_point(f,     backend, x, ty, [contexts...]; strict=Val(true)) -> prep_same
    prepare_pullback_same_point(f!, y, backend, x, ty, [contexts...]; strict=Val(true)) -> prep_same

$(docstring_prepare("pullback"; samepoint = true, inplace = true))
"""
function prepare_pullback_same_point(
        f::F,
        backend::AbstractADType,
        x,
        ty::NTuple,
        contexts::Vararg{Context, C};
        strict::Val = Val(true),
    ) where {F, C}
    return prepare_pullback_same_point_nokwarg(strict, f, backend, x, ty, contexts...)
end

function prepare_pullback_same_point(
        f!::F,
        y,
        backend::AbstractADType,
        x,
        ty::NTuple,
        contexts::Vararg{Context, C};
        strict::Val = Val(true),
    ) where {F, C}
    return prepare_pullback_same_point_nokwarg(strict, f!, y, backend, x, ty, contexts...)
end

function prepare_pullback_same_point_nokwarg(
        strict::Val, f::F, backend::AbstractADType, x, ty::NTuple, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_pullback_nokwarg(strict, f, backend, x, ty, contexts...)
    return prepare_pullback_same_point(f, prep, backend, x, ty, contexts...)
end

function prepare_pullback_same_point_nokwarg(
        strict::Val,
        f!::F,
        y,
        backend::AbstractADType,
        x,
        ty::NTuple,
        contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_pullback_nokwarg(strict, f!, y, backend, x, ty, contexts...)
    return prepare_pullback_same_point(f!, y, prep, backend, x, ty, contexts...)
end

function prepare_pullback_same_point(
        f::F,
        prep::PullbackPrep,
        backend::AbstractADType,
        x,
        ty::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, ty, contexts...)
    return prep
end

function prepare_pullback_same_point(
        f!::F,
        y,
        prep::PullbackPrep,
        backend::AbstractADType,
        x,
        ty::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f!, y, prep, backend, x, ty, contexts...)
    return prep
end

"""
    value_and_pullback(f,     [prep,] backend, x, ty, [contexts...]) -> (y, tx)
    value_and_pullback(f!, y, [prep,] backend, x, ty, [contexts...]) -> (y, tx)

Compute the value and the pullback of the function `f` at point `x` with a tuple of tangents `ty`.

$(docstring_preparation_hint("pullback"; same_point = true))

!!! tip

    Pullbacks are also commonly called vector-Jacobian products or VJPs.
    This function could have been named `value_and_vjp`.

!!! info

    Required primitive for reverse mode backends.
"""
function value_and_pullback(
        f::F, backend::AbstractADType, x, ty, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_pullback_nokwarg(Val(true), f, backend, x, ty, contexts...)
    return value_and_pullback(f, prep, backend, x, ty, contexts...)
end

function value_and_pullback(
        f!::F, y, backend::AbstractADType, x, ty, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_pullback_nokwarg(Val(true), f!, y, backend, x, ty, contexts...)
    return value_and_pullback(f!, y, prep, backend, x, ty, contexts...)
end

"""
    value_and_pullback!(f,     dx, [prep,] backend, x, ty, [contexts...]) -> (y, tx)
    value_and_pullback!(f!, y, dx, [prep,] backend, x, ty, [contexts...]) -> (y, tx)

Compute the value and the pullback of the function `f` at point `x` with a tuple of tangents `ty`, overwriting `dx`.

$(docstring_preparation_hint("pullback"; same_point = true))

!!! tip

    Pullbacks are also commonly called vector-Jacobian products or VJPs.
    This function could have been named `value_and_vjp!`.
"""
function value_and_pullback!(
        f::F, tx, backend::AbstractADType, x, ty, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_pullback_nokwarg(Val(true), f, backend, x, ty, contexts...)
    return value_and_pullback!(f, tx, prep, backend, x, ty, contexts...)
end

function value_and_pullback!(
        f!::F, y, tx, backend::AbstractADType, x, ty, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_pullback_nokwarg(Val(true), f!, y, backend, x, ty, contexts...)
    return value_and_pullback!(f!, y, tx, prep, backend, x, ty, contexts...)
end

"""
    pullback(f,     [prep,] backend, x, ty, [contexts...]) -> tx
    pullback(f!, y, [prep,] backend, x, ty, [contexts...]) -> tx

Compute the pullback of the function `f` at point `x` with a tuple of tangents `ty`.

$(docstring_preparation_hint("pullback"; same_point = true))

!!! tip

    Pullbacks are also commonly called vector-Jacobian products or VJPs.
    This function could have been named `vjp`.
"""
function pullback(
        f::F, backend::AbstractADType, x, ty, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_pullback_nokwarg(Val(true), f, backend, x, ty, contexts...)
    return pullback(f, prep, backend, x, ty, contexts...)
end

function pullback(
        f!::F, y, backend::AbstractADType, x, ty, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_pullback_nokwarg(Val(true), f!, y, backend, x, ty, contexts...)
    return pullback(f!, y, prep, backend, x, ty, contexts...)
end

"""
    pullback!(f,     dx, [prep,] backend, x, ty, [contexts...]) -> tx
    pullback!(f!, y, dx, [prep,] backend, x, ty, [contexts...]) -> tx

Compute the pullback of the function `f` at point `x` with a tuple of tangents `ty`, overwriting `dx`.

$(docstring_preparation_hint("pullback"; same_point = true))

!!! tip

    Pullbacks are also commonly called vector-Jacobian products or VJPs.
    This function could have been named `vjp!`.
"""
function pullback!(
        f::F, tx, backend::AbstractADType, x, ty, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_pullback_nokwarg(Val(true), f, backend, x, ty, contexts...)
    return pullback!(f, tx, prep, backend, x, ty, contexts...)
end

function pullback!(
        f!::F, y, tx, backend::AbstractADType, x, ty, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_pullback_nokwarg(Val(true), f!, y, backend, x, ty, contexts...)
    return pullback!(f!, y, tx, prep, backend, x, ty, contexts...)
end

## Preparation

struct PushforwardPullbackPrep{SIG, E} <: PullbackPrep{SIG}
    _sig::Val{SIG}
    pushforward_prep::E
end

function prepare_pullback_nokwarg(
        strict::Val, f::F, backend::AbstractADType, x, ty::NTuple, contexts::Vararg{Context, C}
    ) where {F, C}
    return _prepare_pullback_aux(
        strict, pullback_performance(backend), f, backend, x, ty, contexts...
    )
end

function prepare_pullback_nokwarg(
        strict::Val,
        f!::F,
        y,
        backend::AbstractADType,
        x,
        ty::NTuple,
        contexts::Vararg{Context, C}
    ) where {F, C}
    return _prepare_pullback_aux(
        strict, pullback_performance(backend), f!, y, backend, x, ty, contexts...
    )
end

function _prepare_pullback_aux(
        strict::Val,
        ::PullbackSlow,
        f::F,
        backend::AbstractADType,
        x,
        ty::NTuple,
        contexts::Vararg{Context, C}
    ) where {F, C}
    _sig = signature(f, backend, x, ty, contexts...; strict)
    dx = if x isa Number
        oneunit(x)
    else
        basis(x)
    end
    pushforward_prep = prepare_pushforward_nokwarg(
        strict, f, backend, x, (dx,), contexts...
    )
    return PushforwardPullbackPrep(_sig, pushforward_prep)
end

function _prepare_pullback_aux(
        strict::Val,
        ::PullbackSlow,
        f!::F,
        y,
        backend::AbstractADType,
        x,
        ty::NTuple,
        contexts::Vararg{Context, C}
    ) where {F, C}
    _sig = signature(f!, y, backend, x, ty, contexts...; strict)
    dx = if x isa Number
        oneunit(x)
    else
        basis(x)
    end
    pushforward_prep = prepare_pushforward_nokwarg(
        strict, f!, y, backend, x, (dx,), contexts...
    )
    return PushforwardPullbackPrep(_sig, pushforward_prep)
end

## One argument

function _value_and_pullback_via_pushforward(
        f::F,
        pushforward_prep::PushforwardPrep,
        backend::AbstractADType,
        x::Real,
        ty::NTuple{B},
        contexts::Vararg{Context, C},
    ) where {F, B, C}
    y, a = onlysecond(value_and_pushforward(f, pushforward_prep, backend, x, (oneunit(x),), contexts...))
    tx = map(ty) do dy
        dot(a, dy)
    end
    return y, arroftup_to_tupofarr(tx, x)
end

function _value_and_pullback_via_pushforward(
        f::F,
        pushforward_prep::PushforwardPrep,
        backend::AbstractADType,
        x::Complex,
        ty::NTuple{B},
        contexts::Vararg{Context, C},
    ) where {F, B, C}
    y, a = onlysecond(value_and_pushforward(f, pushforward_prep, backend, x, (oneunit(x),), contexts...))
    b = only(pushforward(f, pushforward_prep, backend, x, (im * oneunit(x),), contexts...))
    tx = map(ty) do dy
        real(dot(a, dy)) + im * real(dot(b, dy))
    end
    return y, arroftup_to_tupofarr(tx, x)
end

function _value_and_pullback_via_pushforward(
        f::F,
        pushforward_prep::PushforwardPrep,
        backend::AbstractADType,
        x::AbstractArray{<:Real},
        ty::NTuple{B},
        contexts::Vararg{Context, C},
    ) where {F, B, C}
    y = f(x, map(unwrap, contexts)...)
    tx = map(CartesianIndices(x)) do j
        a = only(pushforward(f, pushforward_prep, backend, x, (basis(x, j),), contexts...))
        map(ty) do dy
            dot(a, dy)
        end
    end
    return y, arroftup_to_tupofarr(tx, x)
end

function _value_and_pullback_via_pushforward(
        f::F,
        pushforward_prep::PushforwardPrep,
        backend::AbstractADType,
        x::AbstractArray{<:Complex},
        ty::NTuple{B},
        contexts::Vararg{Context, C},
    ) where {F, B, C}
    y = f(x, map(unwrap, contexts)...)
    tx = map(CartesianIndices(x)) do j
        a = only(pushforward(f, pushforward_prep, backend, x, (basis(x, j),), contexts...))
        b = only(
            pushforward(f, pushforward_prep, backend, x, (im * basis(x, j),), contexts...),
        )
        map(ty) do dy
            real(dot(a, dy)) + im * real(dot(b, dy))
        end
    end
    return y, arroftup_to_tupofarr(tx, x)
end

function value_and_pullback(
        f::F,
        prep::PushforwardPullbackPrep,
        backend::AbstractADType,
        x,
        ty::NTuple{B},
        contexts::Vararg{Context, C},
    ) where {F, B, C}
    check_prep(f, prep, backend, x, ty, contexts...)
    (; pushforward_prep) = prep
    return _value_and_pullback_via_pushforward(f, pushforward_prep, backend, x, ty, contexts...)
end

function value_and_pullback!(
        f::F,
        tx::NTuple,
        prep::PullbackPrep,
        backend::AbstractADType,
        x,
        ty::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, ty, contexts...)
    y, new_tx = value_and_pullback(f, prep, backend, x, ty, contexts...)
    foreach(copyto!, tx, new_tx)
    return y, tx
end

function pullback(
        f::F,
        prep::PullbackPrep,
        backend::AbstractADType,
        x,
        ty::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, ty, contexts...)
    return value_and_pullback(f, prep, backend, x, ty, contexts...)[2]
end

function pullback!(
        f::F,
        tx::NTuple,
        prep::PullbackPrep,
        backend::AbstractADType,
        x,
        ty::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, ty, contexts...)
    return value_and_pullback!(f, tx, prep, backend, x, ty, contexts...)[2]
end

## Two arguments

function _value_and_pullback_via_pushforward(
        f!::F,
        y,
        pushforward_prep::PushforwardPrep,
        backend::AbstractADType,
        x::Real,
        ty::NTuple{B},
        contexts::Vararg{Context, C},
    ) where {F, B, C}
    _, a = onlysecond(value_and_pushforward(f!, y, pushforward_prep, backend, x, (oneunit(x),), contexts...))
    tx = map(ty) do dy
        dot(a, dy)
    end
    return y, arroftup_to_tupofarr(tx, x)
end

function _value_and_pullback_via_pushforward(
        f!::F,
        y,
        pushforward_prep::PushforwardPrep,
        backend::AbstractADType,
        x::Complex,
        ty::NTuple{B},
        contexts::Vararg{Context, C},
    ) where {F, B, C}
    a = only(pushforward(f!, y, pushforward_prep, backend, x, (oneunit(x),), contexts...))
    _, b = onlysecond(
        value_and_pushforward(f!, y, pushforward_prep, backend, x, (im * oneunit(x),), contexts...)
    )
    tx = map(ty) do dy
        real(dot(a, dy)) + im * real(dot(b, dy))
    end
    return y, arroftup_to_tupofarr(tx, x)
end

function _value_and_pullback_via_pushforward(
        f!::F,
        y,
        pushforward_prep::PushforwardPrep,
        backend::AbstractADType,
        x::AbstractArray{<:Real},
        ty::NTuple{B},
        contexts::Vararg{Context, C},
    ) where {F, B, C}
    tx = map(CartesianIndices(x)) do j  # preserve shape
        _, a = onlysecond(value_and_pushforward(f!, y, pushforward_prep, backend, x, (basis(x, j),), contexts...))
        map(ty) do dy
            dot(a, dy)
        end
    end
    return y, arroftup_to_tupofarr(tx, x)
end

function _value_and_pullback_via_pushforward(
        f!::F,
        y,
        pushforward_prep::PushforwardPrep,
        backend::AbstractADType,
        x::AbstractArray{<:Complex},
        ty::NTuple{B},
        contexts::Vararg{Context, C},
    ) where {F, B, C}
    tx = map(CartesianIndices(x)) do j  # preserve shape
        a = only(pushforward(f!, y, pushforward_prep, backend, x, (basis(x, j),), contexts...))
        _, b = onlysecond(
            value_and_pushforward(
                f!, y, pushforward_prep, backend, x, (im * basis(x, j),), contexts...
            ),
        )
        map(ty) do dy
            real(dot(a, dy)) + im * real(dot(b, dy))
        end
    end
    return y, arroftup_to_tupofarr(tx, x)
end

function value_and_pullback(
        f!::F,
        y,
        prep::PushforwardPullbackPrep,
        backend::AbstractADType,
        x,
        ty::NTuple{B},
        contexts::Vararg{Context, C},
    ) where {F, B, C}
    check_prep(f!, y, prep, backend, x, ty, contexts...)
    (; pushforward_prep) = prep
    return _value_and_pullback_via_pushforward(
        f!, y, pushforward_prep, backend, x, ty, contexts...
    )
end

function value_and_pullback!(
        f!::F,
        y,
        tx::NTuple,
        prep::PullbackPrep,
        backend::AbstractADType,
        x,
        ty::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f!, y, prep, backend, x, ty, contexts...)
    y, new_tx = value_and_pullback(f!, y, prep, backend, x, ty, contexts...)
    foreach(copyto!, tx, new_tx)
    return y, tx
end

function pullback(
        f!::F,
        y,
        prep::PullbackPrep,
        backend::AbstractADType,
        x,
        ty::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f!, y, prep, backend, x, ty, contexts...)
    return value_and_pullback(f!, y, prep, backend, x, ty, contexts...)[2]
end

function pullback!(
        f!::F,
        y,
        tx::NTuple,
        prep::PullbackPrep,
        backend::AbstractADType,
        x,
        ty::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f!, y, prep, backend, x, ty, contexts...)
    return value_and_pullback!(f!, y, tx, prep, backend, x, ty, contexts...)[2]
end

## Pushforward

struct SymbolicsTwoArgPushforwardPrep{SIG, E1, E1!} <: DI.PushforwardPrep{SIG}
    _sig::Val{SIG}
    pushforward_exe::E1
    pushforward_exe!::E1!
end

function DI.prepare_pushforward_nokwarg(
        strict::Val,
        f!,
        y,
        backend::AutoSymbolics,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f!, y, backend, x, tx, contexts...; strict)
    dx = first(tx)
    x_var = variablize(x, :x)
    dx_var = variablize(dx, :dx)
    context_vars = variablize(contexts)
    y_var = variablize(y, :y)
    t_var = variable(:t)
    f!(y_var, x_var + t_var * dx_var, context_vars...)
    step_der_var = derivative(y_var, t_var)
    pf_var = substitute(step_der_var, Dict(t_var => zero(eltype(x))))

    erase_cache_vars!(context_vars, contexts)
    res = build_function(
        pf_var, x_var, dx_var, context_vars...; expression = Val(false), cse = true
    )
    (pushforward_exe, pushforward_exe!) = res
    return SymbolicsTwoArgPushforwardPrep(_sig, pushforward_exe, pushforward_exe!)
end

function DI.pushforward(
        f!,
        y,
        prep::SymbolicsTwoArgPushforwardPrep,
        backend::AutoSymbolics,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    ty = map(tx) do dx
        dy = prep.pushforward_exe(x, dx, map(DI.unwrap, contexts)...)
    end
    return ty
end

function DI.pushforward!(
        f!,
        y,
        ty::NTuple,
        prep::SymbolicsTwoArgPushforwardPrep,
        backend::AutoSymbolics,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    for b in eachindex(tx, ty)
        dx, dy = tx[b], ty[b]
        prep.pushforward_exe!(dy, x, dx, map(DI.unwrap, contexts)...)
    end
    return ty
end

function DI.value_and_pushforward(
        f!,
        y,
        prep::SymbolicsTwoArgPushforwardPrep,
        backend::AutoSymbolics,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    ty = DI.pushforward(f!, y, prep, backend, x, tx, contexts...)
    f!(y, x, map(DI.unwrap, contexts)...)
    return y, ty
end

function DI.value_and_pushforward!(
        f!,
        y,
        ty::NTuple,
        prep::SymbolicsTwoArgPushforwardPrep,
        backend::AutoSymbolics,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    DI.pushforward!(f!, y, ty, prep, backend, x, tx, contexts...)
    f!(y, x, map(DI.unwrap, contexts)...)
    return y, ty
end

## Derivative

struct SymbolicsTwoArgDerivativePrep{SIG, E1, E1!} <: DI.DerivativePrep{SIG}
    _sig::Val{SIG}
    der_exe::E1
    der_exe!::E1!
end

function DI.prepare_derivative_nokwarg(
        strict::Val, f!, y, backend::AutoSymbolics, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f!, y, backend, x, contexts...; strict)
    x_var = variablize(x, :x)
    y_var = variablize(y, :y)
    context_vars = variablize(contexts)
    f!(y_var, x_var, context_vars...)
    der_var = derivative(y_var, x_var)

    erase_cache_vars!(context_vars, contexts)
    res = build_function(der_var, x_var, context_vars...; expression = Val(false), cse = true)
    (der_exe, der_exe!) = res
    return SymbolicsTwoArgDerivativePrep(_sig, der_exe, der_exe!)
end

function DI.derivative(
        f!,
        y,
        prep::SymbolicsTwoArgDerivativePrep,
        backend::AutoSymbolics,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    return prep.der_exe(x, map(DI.unwrap, contexts)...)
end

function DI.derivative!(
        f!,
        y,
        der,
        prep::SymbolicsTwoArgDerivativePrep,
        backend::AutoSymbolics,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    prep.der_exe!(der, x, map(DI.unwrap, contexts)...)
    return der
end

function DI.value_and_derivative(
        f!,
        y,
        prep::SymbolicsTwoArgDerivativePrep,
        backend::AutoSymbolics,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    der = DI.derivative(f!, y, prep, backend, x, contexts...)
    f!(y, x, map(DI.unwrap, contexts)...)
    return y, der
end

function DI.value_and_derivative!(
        f!,
        y,
        der,
        prep::SymbolicsTwoArgDerivativePrep,
        backend::AutoSymbolics,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    DI.derivative!(f!, y, der, prep, backend, x, contexts...)
    f!(y, x, map(DI.unwrap, contexts)...)
    return y, der
end

## Jacobian

struct SymbolicsTwoArgJacobianPrep{SIG, P, E1, E1!} <: DI.SparseJacobianPrep{SIG}
    _sig::Val{SIG}
    sparsity::P
    jac_exe::E1
    jac_exe!::E1!
end

function DI.prepare_jacobian_nokwarg(
        strict::Val,
        f!,
        y,
        backend::Union{AutoSymbolics, AutoSparse{<:AutoSymbolics}},
        x,
        contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f!, y, backend, x, contexts...; strict)
    x_var = variablize(x, :x)
    y_var = variablize(y, :y)
    context_vars = variablize(contexts)
    f!(y_var, x_var, context_vars...)
    if backend isa AutoSparse
        jac_var = sparsejacobian(vec(y_var), vec(x_var))
        sparsity = DI.get_pattern(jac_var)
    else
        jac_var = jacobian(y_var, x_var)
        sparsity = nothing
    end

    erase_cache_vars!(context_vars, contexts)
    res = build_function(jac_var, x_var, context_vars...; expression = Val(false), cse = true)
    (jac_exe, jac_exe!) = res
    return SymbolicsTwoArgJacobianPrep(_sig, sparsity, jac_exe, jac_exe!)
end

function DI.jacobian(
        f!,
        y,
        prep::SymbolicsTwoArgJacobianPrep,
        backend::Union{AutoSymbolics, AutoSparse{<:AutoSymbolics}},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    return prep.jac_exe(x, map(DI.unwrap, contexts)...)
end

function DI.jacobian!(
        f!,
        y,
        jac,
        prep::SymbolicsTwoArgJacobianPrep,
        backend::Union{AutoSymbolics, AutoSparse{<:AutoSymbolics}},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    prep.jac_exe!(jac, x, map(DI.unwrap, contexts)...)
    return jac
end

function DI.value_and_jacobian(
        f!,
        y,
        prep::SymbolicsTwoArgJacobianPrep,
        backend::Union{AutoSymbolics, AutoSparse{<:AutoSymbolics}},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    jac = DI.jacobian(f!, y, prep, backend, x, contexts...)
    f!(y, x, map(DI.unwrap, contexts)...)
    return y, jac
end

function DI.value_and_jacobian!(
        f!,
        y,
        jac,
        prep::SymbolicsTwoArgJacobianPrep,
        backend::Union{AutoSymbolics, AutoSparse{<:AutoSymbolics}},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    DI.jacobian!(f!, y, jac, prep, backend, x, contexts...)
    f!(y, x, map(DI.unwrap, contexts)...)
    return y, jac
end

"""
    forward_counterpart(backend)

Return a forward-mode counterpart of `backend`.

If `backend` has a dedicated forward-mode counterpart (e.g. `AutoMooncake` has
`AutoMooncakeForward`), it is returned.

!!! warning
    If `backend` has no known forward-mode counterpart, it is returned unchanged, even
    when it is reverse-mode only (DI allows reverse-mode backends to execute
    pushforwards).
"""
forward_counterpart(backend::AbstractADType) = backend

"""
    reverse_counterpart(backend)

Return a reverse-mode counterpart of `backend`.

If `backend` has a dedicated reverse-mode counterpart (e.g. `AutoMooncakeForward` has
`AutoMooncake`), it is returned.

!!! warning
    If `backend` has no known reverse-mode counterpart, it is returned unchanged, even
    when it is forward-mode only (DI allows forward-mode backends to execute pullbacks).
"""
reverse_counterpart(backend::AbstractADType) = backend

forward_counterpart(::ADTypes.NoAutoDiff) = throw(ADTypes.NoAutoDiffSelectedError())
reverse_counterpart(::ADTypes.NoAutoDiff) = throw(ADTypes.NoAutoDiffSelectedError())

## Wrapper backends

# The counterpart of `AutoSparse` acts on the dense backend and preserves the sparsity
# detection and coloring machinery.

function forward_counterpart(backend::AutoSparse)
    return AutoSparse(
        forward_counterpart(dense_ad(backend));
        sparsity_detector = backend.sparsity_detector,
        coloring_algorithm = backend.coloring_algorithm,
    )
end

function reverse_counterpart(backend::AutoSparse)
    return AutoSparse(
        reverse_counterpart(dense_ad(backend));
        sparsity_detector = backend.sparsity_detector,
        coloring_algorithm = backend.coloring_algorithm,
    )
end

# A `MixedMode` backend already combines a forward- and a reverse-mode backend, each used
# where it works best, so it is its own counterpart in both directions.

forward_counterpart(backend::MixedMode) = backend
reverse_counterpart(backend::MixedMode) = backend

# For `SecondOrder` there is no meaningful counterpart: flipping the modes of the inner
# and outer backends changes the nature of the second-order combination.

function forward_counterpart(::SecondOrder)
    throw(
        ArgumentError(
            "`forward_counterpart` is ambiguous for `SecondOrder` backends, apply it to `inner(backend)` and `outer(backend)` separately.",
        )
    )
end

function reverse_counterpart(::SecondOrder)
    throw(
        ArgumentError(
            "`reverse_counterpart` is ambiguous for `SecondOrder` backends, apply it to `inner(backend)` and `outer(backend)` separately.",
        )
    )
end

# Counterparts for `FromPrimitive` wrappers are defined in `misc/from_primitive.jl`, and
# backend-specific counterparts (e.g., for AutoMooncake and AutoEnzyme) are defined in the
# corresponding package extensions.

include("../../testutils.jl")

using DifferentiationInterface, DifferentiationInterfaceTest
using Tracker: Tracker
using Test

using ExplicitImports
check_no_implicit_imports(DifferentiationInterface)

for backend in [AutoTracker()]
    @test check_available(backend)
    @test !check_inplace(backend)
    test_counterparts(backend)
end

test_differentiation(
    AutoTracker(),
    default_scenarios(; include_constantified = true);
    excluded = SECOND_ORDER,
    logging = LOGGING,
);

include("../../testutils.jl")

using Pkg

using ADTypes: ADTypes
using DataFrames: DataFrame
using DifferentiationInterface, DifferentiationInterfaceTest
import DifferentiationInterface as DI
import DifferentiationInterfaceTest as DIT
using FiniteDiff: FiniteDiff
using Test
import Chairmarks
using StaticArrays: @SVector

@testset "Benchmarking sparse" begin
    filtered_sparse_scenarios = filter(sparse_scenarios(; band_sizes = [])) do scen
        DIT.function_place(scen) == :in &&
            DIT.operator_place(scen) == :in &&
            scen.x isa AbstractVector &&
            scen.y isa AbstractVector
    end

    data = benchmark_differentiation(
        MyAutoSparse(AutoFiniteDiff()),
        filtered_sparse_scenarios;
        benchmark = :prepared,
        excluded = SECOND_ORDER,
        logging = LOGGING,
    ) |> DataFrame
    @testset "Analyzing benchmark results" begin
        @testset "$(row[:scenario])" for row in eachrow(data)
            @test row[:allocs] == 0
        end
    end
end


@testset "allocations checks" begin
    function pushforward_allocs()
        backend = AutoFiniteDiff()
        x = @SVector [1.0, 2.0]
        tx = (2.0 .* x,)
        f(x) = @. 3.0 * x
        prep = DifferentiationInterface.prepare_pushforward(f, backend, x, tx)
        return prep
    end
    pushforward_allocs()
    allocs = @allocated prep = pushforward_allocs()
    # This needs FiniteDiff v2.31.1.
    @test allocs == 0

    function derivative_allocs()
        backend = AutoFiniteDiff()
        x = 3.0
        f(x) = x .* (@SVector [1.0, 2.0])
        prep = DifferentiationInterface.prepare_derivative(f, backend, x)
        return prep
    end
    derivative_allocs()
    allocs = @allocated prep = derivative_allocs()
    @test allocs == 0

    function jacobian_allocs()
        backend = AutoFiniteDiff()
        x = @SVector [1.0, 2.0]
        f(x) = 3.0 .* x
        prep = DifferentiationInterface.prepare_jacobian(f, backend, x)
        return prep
    end
    jacobian_allocs()
    allocs = @allocated prep = jacobian_allocs()
    # Using FiniteDiff.jl with StaticArrays to calculate a Jacobian does result in some allocations, apparently because the `FiniteDiff.JacobianCache` is a `mutable struct`.
    @test_broken allocs == 0
end

## Backend counterparts

DI.forward_counterpart(backend::AutoMooncake) = AutoMooncakeForward(; config = backend.config)
DI.reverse_counterpart(backend::AutoMooncakeForward) = AutoMooncake(; config = backend.config)

function DI.pick_batchsize(backend::AutoPolyesterForwardDiff, x::AbstractArray)
    return DI.pick_batchsize(single_threaded(backend), x)
end

function DI.pick_batchsize(backend::AutoPolyesterForwardDiff, N::Integer)
    return DI.pick_batchsize(single_threaded(backend), N)
end

function DI.threshold_batchsize(
        backend::AutoPolyesterForwardDiff{chunksize1}, chunksize2::Integer
    ) where {chunksize1}
    chunksize = isnothing(chunksize1) ? nothing : min(chunksize1, chunksize2)
    return AutoPolyesterForwardDiff(; chunksize, tag = backend.tag)
end

include("../../testutils.jl")

using DifferentiationInterface, DifferentiationInterfaceTest
using SparseMatrixColorings
using LinearAlgebra
using Symbolics: Symbolics
using Test

using ExplicitImports
check_no_implicit_imports(DifferentiationInterface)

for backend in [AutoSymbolics(), AutoSparse(AutoSymbolics())]
    @test check_available(backend)
    @test check_inplace(backend)
    test_counterparts(backend)
end

test_differentiation(
    AutoSymbolics(), default_scenarios(; include_constantified = true); logging = LOGGING
);

test_differentiation(
    AutoSymbolics(),
    default_scenarios(; include_normal = false, include_cachified = true, use_tuples = false);
    logging = LOGGING,
);

test_differentiation(
    AutoSparse(AutoSymbolics()),
    sparse_scenarios(; band_sizes = 0:-1);
    sparsity = true,
    logging = LOGGING,
);

@testset "SparseMatrixColorings access" begin
    x = rand(10)
    backend = AutoSparse(AutoSymbolics())
    jac_prep = prepare_jacobian(copy, backend, x)
    jac!_prep = prepare_jacobian(copyto!, similar(x), backend, x)
    hess_prep = prepare_hessian(x -> sum(abs2, x), backend, x)
    @test sparsity_pattern(jac_prep) == Diagonal(trues(10))
    @test sparsity_pattern(jac!_prep) == Diagonal(trues(10))
    @test sparsity_pattern(hess_prep) == Diagonal(trues(10))
end

@testset "Non-numeric arguments" begin
    function differentiate_me!(out, x, c)
        @assert c isa Any # Just to use it somewhere
        return copyto!(out, x)
    end
    function differentiate_me(x, c)
        tmp = similar(x)
        differentiate_me!(tmp, x, c)
        return tmp
    end
    x = rand(10)
    xbuffer = copy(x)
    c = "I am a string"
    backend = AutoSymbolics()
    jac_prep = prepare_jacobian(differentiate_me, backend, x, Constant(c))
    jac!_prep = prepare_jacobian(differentiate_me!, xbuffer, backend, x, Constant(c))
    @test jacobian(differentiate_me, jac_prep, backend, x, Constant(c)) ≈ I
    @test jacobian(differentiate_me!, xbuffer, jac!_prep, backend, x, Constant(c)) ≈ I
end

"""
    MixedMode

Combination of a forward and a reverse mode backend for mixed-mode sparse Jacobian computation.

!!! danger

    `MixedMode` backends only support [`jacobian`](@ref) and its variants, and it should be used inside an [`AutoSparse`](@extref ADTypes.AutoSparse) wrapper.

# Constructor

    MixedMode(forward_backend, reverse_backend)
"""
struct MixedMode{F <: AbstractADType, R <: AbstractADType} <: AbstractADType
    forward::F
    reverse::R
    function MixedMode(forward::AbstractADType, reverse::AbstractADType)
        @assert pushforward_performance(forward) isa PushforwardFast
        @assert pullback_performance(reverse) isa PullbackFast
        return new{typeof(forward), typeof(reverse)}(forward, reverse)
    end
end

"""
    forward_backend(m::MixedMode)

Return the forward-mode part of a `MixedMode` backend.
"""
forward_backend(m::MixedMode) = m.forward

"""
    reverse_backend(m::MixedMode)

Return the reverse-mode part of a `MixedMode` backend.
"""
reverse_backend(m::MixedMode) = m.reverse

"""
    ForwardAndReverseMode <: ADTypes.AbstractMode

Appropriate mode type for `MixedMode` backends.
"""
struct ForwardAndReverseMode <: ADTypes.AbstractMode end
ADTypes.mode(::MixedMode) = ForwardAndReverseMode()

function threshold_batchsize(backend::MixedMode, B::Integer)
    return MixedMode(
        threshold_batchsize(forward_backend(backend), B),
        threshold_batchsize(reverse_backend(backend), B),
    )
end

using DifferentiationInterface, DifferentiationInterfaceTest
using DifferentiationInterface:
    AutoSimpleFiniteDiff,
    AutoForwardFromPrimitive,
    AutoReverseFromPrimitive,
    DenseSparsityDetector
using SparseMatrixColorings
using JLArrays, StaticArrays
using Test

backends = [ #
    AutoSimpleFiniteDiff(; chunksize = 5),
    AutoForwardFromPrimitive(AutoSimpleFiniteDiff(; chunksize = 4)),
    AutoReverseFromPrimitive(AutoSimpleFiniteDiff(; chunksize = 4)),
]

second_order_backends = [ #
    SecondOrder(
        AutoForwardFromPrimitive(AutoSimpleFiniteDiff(; chunksize = 5)),
        AutoReverseFromPrimitive(AutoSimpleFiniteDiff(; chunksize = 4)),
    ),
    SecondOrder(
        AutoReverseFromPrimitive(AutoSimpleFiniteDiff(; chunksize = 5)),
        AutoForwardFromPrimitive(AutoSimpleFiniteDiff(; chunksize = 4)),
    ),
]

second_order_hvp_backends = [ #
    SecondOrder(
        AutoReverseFromPrimitive(AutoSimpleFiniteDiff(); inplace = false),
        AutoForwardFromPrimitive(AutoSimpleFiniteDiff()),
    ),
    SecondOrder(
        AutoForwardFromPrimitive(AutoSimpleFiniteDiff(); inplace = false),
        AutoReverseFromPrimitive(AutoSimpleFiniteDiff()),
    ),
    SecondOrder(
        AutoForwardFromPrimitive(AutoSimpleFiniteDiff(); inplace = false),
        AutoForwardFromPrimitive(AutoSimpleFiniteDiff()),
    ),
    SecondOrder(
        AutoReverseFromPrimitive(AutoSimpleFiniteDiff(); inplace = false),
        AutoReverseFromPrimitive(AutoSimpleFiniteDiff()),
    ),
]

adaptive_backends = [ #
    AutoSimpleFiniteDiff(),
    AutoReverseFromPrimitive(AutoSimpleFiniteDiff()),
    SecondOrder(AutoSimpleFiniteDiff(), AutoReverseFromPrimitive(AutoSimpleFiniteDiff())),
    SecondOrder(AutoReverseFromPrimitive(AutoSimpleFiniteDiff()), AutoSimpleFiniteDiff()),
]

for backend in vcat(backends, second_order_backends)
    @test check_available(backend)
    @test check_inplace(backend)
end

## Dense scenarios

@testset "Dense" begin
    test_differentiation(
        vcat(backends, second_order_backends),
        default_scenarios(; include_constantified = true, include_smaller = true);
        logging = LOGGING,
    )

    test_differentiation(
        second_order_hvp_backends,
        default_scenarios(; include_constantorcachified = true);
        excluded = vcat(FIRST_ORDER, :hessian, :second_derivative),
        logging = LOGGING,
    )

    test_differentiation(
        vcat(
            backends[2:3],
            AutoReverseFromPrimitive(AutoSimpleFiniteDiff(; chunksize = 1))
        ),
        complex_scenarios();
        logging = LOGGING
    )
end

@testset "Sparse" begin
    test_differentiation(
        MyAutoSparse.(adaptive_backends),
        default_scenarios(; include_constantified = true);
        logging = LOGGING,
    )

    test_differentiation(
        MyAutoSparse.(
            vcat(adaptive_backends, MixedMode(adaptive_backends[1], adaptive_backends[2]))
        ),
        sparse_scenarios(;
            include_constantified = true,
            include_cachified = true,
            include_constantorcachified = true,
            use_tuples = true,
        );
        sparsity = true,
        logging = LOGGING,
    )

    @testset "Complex numbers" begin
        test_differentiation(
            AutoSparse.(
                vcat(
                    adaptive_backends, MixedMode(adaptive_backends[1], adaptive_backends[2])
                );
                sparsity_detector = DenseSparsityDetector(AutoSimpleFiniteDiff(); atol = 1.0e-5),
                coloring_algorithm = GreedyColoringAlgorithm(),
            ),
            complex_sparse_scenarios();
            logging = LOGGING,
        )
    end

    @testset "SparseMatrixColorings access" begin
        jac_for_prep = prepare_jacobian(copy, MyAutoSparse(adaptive_backends[1]), rand(10))
        jac_rev_prep = prepare_jacobian(copy, MyAutoSparse(adaptive_backends[2]), rand(10))
        hess_prep = prepare_hessian(
            x -> sum(abs2, x), MyAutoSparse(adaptive_backends[1]), rand(10)
        )

        @test all(==(1), column_colors(jac_for_prep))
        @test all(==(1), row_colors(jac_rev_prep))
        @test all(==(1), column_colors(hess_prep))
        @test ncolors(jac_for_prep) == 1
        @test ncolors(hess_prep) == 1
        @test only(column_groups(jac_for_prep)) == 1:10
        @test only(row_groups(jac_rev_prep)) == 1:10
        @test only(column_groups(hess_prep)) == 1:10
    end

    @testset "Empty color groups in sparse AD" begin # issue 857
        # forward
        backend = MyAutoSparse(adaptive_backends[1])
        @test jacobian(zero, backend, ones(10)) isa AbstractMatrix
        @test hessian(sum ∘ zero, backend, ones(10)) isa AbstractMatrix
        # reverse
        backend = MyAutoSparse(adaptive_backends[2])
        @test jacobian(zero, backend, ones(10)) isa AbstractMatrix
        @test hessian(sum ∘ zero, backend, ones(10)) isa AbstractMatrix
        # mixed
        backend = MyAutoSparse(MixedMode(adaptive_backends[1], adaptive_backends[2]))
        @test jacobian(copyto!, zeros(10), backend, ones(10)) isa AbstractMatrix
    end
end

@testset "Misc" begin
    @test_throws ArgumentError DifferentiationInterface.overloaded_input(
        pushforward, sum, AutoSimpleFiniteDiff(), 1, (1, 2)
    )
    @test_throws ArgumentError DifferentiationInterface.overloaded_input(
        pushforward, copyto!, [1.0], AutoSimpleFiniteDiff(), [1.0], ([1.0], [1.0])
    )
end

@testset "Weird arrays" begin
    test_differentiation(
        [
            AutoSimpleFiniteDiff(),
            AutoForwardFromPrimitive(AutoSimpleFiniteDiff()),
            AutoReverseFromPrimitive(AutoSimpleFiniteDiff()),
        ],
        vcat(static_scenarios(), gpu_scenarios());
        logging = LOGGING,
    )
end;

@testset "Array format preservation in wrong mode" begin
    @test gradient(sum, AutoSimpleFiniteDiff(), jl(ones(2))) isa JLVector
    @test derivative(t -> jl(fill(t, 2)), AutoReverseFromPrimitive(AutoSimpleFiniteDiff()), 1.0) isa JLVector
end

const HINT_END = "\n\nThis hint appears because DifferentiationInterface and Enzyme are both loaded. It does not necessarily imply that Enzyme is being called through DifferentiationInterface.\n\n"

function HINT_START(option)
    return "\nIf you are using Enzyme by selecting the `AutoEnzyme` object from ADTypes, you may want to try setting the `$option` option as follows:"
end

function __init__()
    if !isdefined(Base.Experimental, :register_error_hint)
        return nothing
    end
    # robust against internal changes
    condition = (
        isdefined(Enzyme, :Compiler) &&
            Enzyme.Compiler isa Module &&
            isdefined(Enzyme.Compiler, :EnzymeError) &&
            Enzyme.Compiler.EnzymeError isa DataType
    )
    condition || return nothing
    # see https://github.com/JuliaLang/julia/issues/58367 for why this isn't easier
    for n in names(Enzyme.Compiler; all = true)
        T = getfield(Enzyme.Compiler, n)
        if T isa DataType && T <: Enzyme.Compiler.EnzymeError
            # robust against internal changes
            Base.Experimental.register_error_hint(T) do io, exc
                if occursin("EnzymeMutabilityException", string(nameof(T)))
                    printstyled(io, HINT_START("function_annotation"); bold = true)
                    printstyled(
                        io,
                        "\n\n\tAutoEnzyme(; function_annotation=Enzyme.Duplicated)";
                        color = :cyan,
                        bold = true,
                    )
                    printstyled(io, HINT_END; italic = true)
                end
                # EnzymeRuntimeActivityError is no longer a concrete type since https://github.com/EnzymeAD/Enzyme.jl/pull/2555 (now a UnionAll) so we cannot define a hint
            end
        end
    end
    return
end

module DifferentiationInterfaceSparseMatrixColoringsExt

using ADTypes: ADTypes, AutoSparse, coloring_algorithm, dense_ad, sparsity_detector
import DifferentiationInterface as DI
using SparseMatrixColorings:
    AbstractColoringResult,
    ColoringProblem,
    coloring,
    column_colors,
    row_colors,
    ncolors,
    column_groups,
    row_groups,
    sparsity_pattern,
    decompress!
import SparseMatrixColorings as SMC

## SMC overloads

abstract type SMCSparseJacobianPrep{SIG} <: DI.SparseJacobianPrep{SIG} end

"""
    SMC.sparsity_pattern(prep::DI.SparseJacobianPrep)

Return the sparsity pattern of a sparse `prep` object created by [`prepare_jacobian`](@ref).
"""
SMC.sparsity_pattern(prep::DI.SparseJacobianPrep) = prep.sparsity

"""
    SMC.column_colors(prep::DI.SparseJacobianPrep)

Return the column colors of a sparse `prep` object created by [`prepare_jacobian`](@ref).
"""
SMC.column_colors(prep::DI.SparseJacobianPrep) = column_colors(prep.coloring_result)

"""
    SMC.column_groups(prep::DI.SparseJacobianPrep)

Return the column groups of a sparse `prep` object created by [`prepare_jacobian`](@ref).
"""
SMC.column_groups(prep::DI.SparseJacobianPrep) = column_groups(prep.coloring_result)

"""
    SMC.row_colors(prep::DI.SparseJacobianPrep)

Return the row colors of a sparse `prep` object created by [`prepare_jacobian`](@ref).
"""
SMC.row_colors(prep::DI.SparseJacobianPrep) = row_colors(prep.coloring_result)

"""
    SMC.row_groups(prep::DI.SparseJacobianPrep)

Return the row groups of a sparse `prep` object created by [`prepare_jacobian`](@ref).
"""
SMC.row_groups(prep::DI.SparseJacobianPrep) = row_groups(prep.coloring_result)

"""
    SMC.ncolors(prep::DI.SparseJacobianPrep)

Return the number of colors of a sparse `prep` object created by [`prepare_jacobian`](@ref).
"""
SMC.ncolors(prep::DI.SparseJacobianPrep) = ncolors(prep.coloring_result)


"""
    SMC.sparsity_pattern(prep::DI.SparseHessianPrep)

Return the sparsity pattern of a sparse `prep` object created by [`prepare_hessian`](@ref).
"""
SMC.sparsity_pattern(prep::DI.SparseHessianPrep) = prep.sparsity

"""
    SMC.column_colors(prep::DI.SparseHessianPrep)

Return the column colors of a sparse `prep` object created by [`prepare_hessian`](@ref).
"""
SMC.column_colors(prep::DI.SparseHessianPrep) = column_colors(prep.coloring_result)

"""
    SMC.column_groups(prep::DI.SparseHessianPrep)

Return the column groups of a sparse `prep` object created by [`prepare_hessian`](@ref).
"""
SMC.column_groups(prep::DI.SparseHessianPrep) = column_groups(prep.coloring_result)

"""
    SMC.ncolors(prep::DI.SparseHessianPrep)

Return the number of colors of a sparse `prep` object created by [`prepare_hessian`](@ref).
"""
SMC.ncolors(prep::DI.SparseHessianPrep) = ncolors(prep.coloring_result)


include("jacobian.jl")
include("jacobian_mixed.jl")
include("hessian.jl")


end

## Docstrings

"""
    prepare_jacobian(f,     backend, x, [contexts...]; strict=Val(true)) -> prep
    prepare_jacobian(f!, y, backend, x, [contexts...]; strict=Val(true)) -> prep

$(docstring_prepare("jacobian"; inplace = true))
"""
function prepare_jacobian(
        f::F, backend::AbstractADType, x, contexts::Vararg{Context, C}; strict::Val = Val(true)
    ) where {F, C}
    return prepare_jacobian_nokwarg(strict, f, backend, x, contexts...)
end

function prepare_jacobian(
        f!::F, y, backend::AbstractADType, x, contexts::Vararg{Context, C}; strict::Val = Val(true)
    ) where {F, C}
    return prepare_jacobian_nokwarg(strict, f!, y, backend, x, contexts...)
end

"""
    prepare!_jacobian(f,     prep, backend, x, [contexts...]) -> new_prep
    prepare!_jacobian(f!, y, prep, backend, x, [contexts...]) -> new_prep

$(docstring_prepare!("jacobian"))
"""
function prepare!_jacobian(
        f::F, old_prep::JacobianPrep, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    check_prep(f, old_prep, backend, x, contexts...)
    return prepare_jacobian_nokwarg(is_strict(old_prep), f, backend, x, contexts...)
end

function prepare!_jacobian(
        f!::F,
        y,
        old_prep::JacobianPrep,
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C}
    ) where {F, C}
    check_prep(f!, y, old_prep, backend, x, contexts...)
    return prepare_jacobian_nokwarg(is_strict(old_prep), f!, y, backend, x, contexts...)
end

"""
    value_and_jacobian(f,     [prep,] backend, x, [contexts...]) -> (y, jac)
    value_and_jacobian(f!, y, [prep,] backend, x, [contexts...]) -> (y, jac)

Compute the value and the Jacobian matrix of the function `f` at point `x`.

$(docstring_preparation_hint("jacobian"))
"""
function value_and_jacobian(
        f::F, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_jacobian_nokwarg(Val(true), f, backend, x, contexts...)
    return value_and_jacobian(f, prep, backend, x, contexts...)
end

function value_and_jacobian(
        f!::F, y, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_jacobian_nokwarg(Val(true), f!, y, backend, x, contexts...)
    return value_and_jacobian(f!, y, prep, backend, x, contexts...)
end

"""
    value_and_jacobian!(f,     jac, [prep,] backend, x, [contexts...]) -> (y, jac)
    value_and_jacobian!(f!, y, jac, [prep,] backend, x, [contexts...]) -> (y, jac)

Compute the value and the Jacobian matrix of the function `f` at point `x`, overwriting `jac`.

$(docstring_preparation_hint("jacobian"))
"""
function value_and_jacobian!(
        f::F, jac, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_jacobian_nokwarg(Val(true), f, backend, x, contexts...)
    return value_and_jacobian!(f, jac, prep, backend, x, contexts...)
end

function value_and_jacobian!(
        f!::F, y, jac, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_jacobian_nokwarg(Val(true), f!, y, backend, x, contexts...)
    return value_and_jacobian!(f!, y, jac, prep, backend, x, contexts...)
end

"""
    jacobian(f,     [prep,] backend, x, [contexts...]) -> jac
    jacobian(f!, y, [prep,] backend, x, [contexts...]) -> jac

Compute the Jacobian matrix of the function `f` at point `x`.

$(docstring_preparation_hint("jacobian"))
"""
function jacobian(f::F, backend::AbstractADType, x, contexts::Vararg{Context, C}) where {F, C}
    prep = prepare_jacobian_nokwarg(Val(true), f, backend, x, contexts...)
    return jacobian(f, prep, backend, x, contexts...)
end

function jacobian(
        f!::F, y, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_jacobian_nokwarg(Val(true), f!, y, backend, x, contexts...)
    return jacobian(f!, y, prep, backend, x, contexts...)
end

"""
    jacobian!(f,     jac, [prep,] backend, x, [contexts...]) -> jac
    jacobian!(f!, y, jac, [prep,] backend, x, [contexts...]) -> jac

Compute the Jacobian matrix of the function `f` at point `x`, overwriting `jac`.

$(docstring_preparation_hint("jacobian"))
"""
function jacobian!(
        f::F, jac, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_jacobian_nokwarg(Val(true), f, backend, x, contexts...)
    return jacobian!(f, jac, prep, backend, x, contexts...)
end

function jacobian!(
        f!::F, y, jac, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_jacobian_nokwarg(Val(true), f!, y, backend, x, contexts...)
    return jacobian!(f!, y, jac, prep, backend, x, contexts...)
end

## Preparation

abstract type StandardJacobianPrep{SIG} <: JacobianPrep{SIG} end

struct PushforwardJacobianPrep{
        SIG,
        BS <: BatchSizeSettings,
        S <: AbstractVector{<:NTuple},
        R <: AbstractVector{<:NTuple},
        SE <: NTuple,
        E <: PushforwardPrep,
    } <: StandardJacobianPrep{SIG}
    _sig::Val{SIG}
    batch_size_settings::BS
    batched_seeds::S
    batched_results::R
    seed_example::SE
    pushforward_prep::E
end

struct PullbackJacobianPrep{
        SIG,
        BS <: BatchSizeSettings,
        S <: AbstractVector{<:NTuple},
        R <: AbstractVector{<:NTuple},
        SE <: NTuple,
        E <: PullbackPrep,
    } <: StandardJacobianPrep{SIG}
    _sig::Val{SIG}
    batch_size_settings::BS
    batched_seeds::S
    batched_results::R
    seed_example::SE
    pullback_prep::E
end

function prepare_jacobian_nokwarg(
        strict::Val, f::F, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    y = f(x, map(unwrap, contexts)...)
    perf = pushforward_performance(backend)
    # type-unstable
    if perf isa PushforwardFast
        batch_size_settings = pick_batchsize(backend, x)
    else
        batch_size_settings = pick_batchsize(backend, y)
    end
    # function barrier
    return _prepare_jacobian_aux(
        strict, perf, batch_size_settings, y, (f,), backend, x, contexts...
    )
end

function prepare_jacobian_nokwarg(
        strict::Val, f!::F, y, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    perf = pushforward_performance(backend)
    # type-unstable
    if perf isa PushforwardFast
        batch_size_settings = pick_batchsize(backend, x)
    else
        batch_size_settings = pick_batchsize(backend, y)
    end
    # function barrier
    return _prepare_jacobian_aux(
        strict, perf, batch_size_settings, y, (f!, y), backend, x, contexts...
    )
end

function _prepare_jacobian_aux(
        strict::Val,
        ::PushforwardFast,
        batch_size_settings::BatchSizeSettings{B},
        y,
        f_or_f!y::FY,
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C}
    ) where {B, FY, C}
    _sig = signature(f_or_f!y..., backend, x, contexts...; strict)
    (; N, A) = batch_size_settings
    seeds = [basis(x, ind) for ind in eachindex(x)]
    batched_seeds = [
        ntuple(b -> seeds[1 + ((a - 1) * B + (b - 1)) % N], Val(B)) for a in 1:A
    ]
    batched_results = [ntuple(b -> similar(y), Val(B)) for _ in batched_seeds]
    seed_example = ntuple(b -> basis(x), Val(B))
    pushforward_prep = prepare_pushforward_nokwarg(
        strict, f_or_f!y..., backend, x, seed_example, contexts...
    )
    return PushforwardJacobianPrep(
        _sig,
        batch_size_settings,
        batched_seeds,
        batched_results,
        seed_example,
        pushforward_prep,
    )
end

function _prepare_jacobian_aux(
        strict::Val,
        ::PushforwardSlow,
        batch_size_settings::BatchSizeSettings{B},
        y,
        f_or_f!y::FY,
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C}
    ) where {B, FY, C}
    _sig = signature(f_or_f!y..., backend, x, contexts...; strict)
    (; N, A) = batch_size_settings
    seeds = [basis(y, ind) for ind in eachindex(y)]
    batched_seeds = [
        ntuple(b -> seeds[1 + ((a - 1) * B + (b - 1)) % N], Val(B)) for a in 1:A
    ]
    batched_results = [ntuple(b -> similar(x), Val(B)) for _ in batched_seeds]
    seed_example = ntuple(b -> basis(y), Val(B))
    pullback_prep = prepare_pullback_nokwarg(
        strict, f_or_f!y..., backend, x, seed_example, contexts...
    )
    return PullbackJacobianPrep(
        _sig,
        batch_size_settings,
        batched_seeds,
        batched_results,
        seed_example,
        pullback_prep,
    )
end

## One argument

function jacobian(
        f::F,
        prep::StandardJacobianPrep,
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, contexts...)
    return _jacobian_aux((f,), prep, backend, x, contexts...)
end

function jacobian!(
        f::F,
        jac,
        prep::StandardJacobianPrep,
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, contexts...)
    return _jacobian_aux!((f,), jac, prep, backend, x, contexts...)
end

function value_and_jacobian(
        f::F, prep::JacobianPrep, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    check_prep(f, prep, backend, x, contexts...)
    return f(x, map(unwrap, contexts)...), jacobian(f, prep, backend, x, contexts...)
end

function value_and_jacobian!(
        f::F, jac, prep::JacobianPrep, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    check_prep(f, prep, backend, x, contexts...)
    return f(x, map(unwrap, contexts)...), jacobian!(f, jac, prep, backend, x, contexts...)
end

## Two arguments

function jacobian(
        f!::F,
        y,
        prep::StandardJacobianPrep,
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f!, y, prep, backend, x, contexts...)
    return _jacobian_aux((f!, y), prep, backend, x, contexts...)
end

function jacobian!(
        f!::F,
        y,
        jac,
        prep::StandardJacobianPrep,
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f!, y, prep, backend, x, contexts...)
    return _jacobian_aux!((f!, y), jac, prep, backend, x, contexts...)
end

function value_and_jacobian(
        f!::F, y, prep::JacobianPrep, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    check_prep(f!, y, prep, backend, x, contexts...)
    jac = jacobian(f!, y, prep, backend, x, contexts...)
    f!(y, x, map(unwrap, contexts)...)
    return y, jac
end

function value_and_jacobian!(
        f!::F,
        y,
        jac,
        prep::JacobianPrep,
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f!, y, prep, backend, x, contexts...)
    jacobian!(f!, y, jac, prep, backend, x, contexts...)
    f!(y, x, map(unwrap, contexts)...)
    return y, jac
end

## Common auxiliaries

function _jacobian_aux(
        f_or_f!y::FY,
        prep::PushforwardJacobianPrep{SIG, <:BatchSizeSettings{B, true, aligned}},
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {FY, SIG, B, aligned, C}
    (; batch_size_settings, batched_seeds, pushforward_prep) = prep
    (; B_last) = batch_size_settings
    dy_batch = pushforward(
        f_or_f!y..., pushforward_prep, backend, x, only(batched_seeds), contexts...
    )
    block = stack_vec_col(dy_batch)
    if aligned
        return block
    else
        return block[:, 1:B_last]
    end
end

function _jacobian_aux(
        f_or_f!y::FY,
        prep::PushforwardJacobianPrep{SIG, <:BatchSizeSettings{1, false, true}},
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {FY, SIG, C}
    (; batched_seeds, seed_example, pushforward_prep) = prep

    pushforward_prep_same = prepare_pushforward_same_point(
        f_or_f!y..., pushforward_prep, backend, x, seed_example, contexts...
    )

    jac = stack(eachindex(batched_seeds); dims = 2) do a
        dy = only(
            pushforward(
                f_or_f!y...,
                pushforward_prep_same,
                backend,
                x,
                batched_seeds[a],
                contexts...,
            )
        )
        return vec(dy)
    end
    return jac
end

function _jacobian_aux(
        f_or_f!y::FY,
        prep::PushforwardJacobianPrep{SIG, <:BatchSizeSettings{B, false, aligned}},
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {FY, SIG, B, aligned, C}
    (; batch_size_settings, batched_seeds, seed_example, pushforward_prep) = prep
    (; A, B_last) = batch_size_settings

    pushforward_prep_same = prepare_pushforward_same_point(
        f_or_f!y..., pushforward_prep, backend, x, seed_example, contexts...
    )

    jac = mapreduce(hcat, eachindex(batched_seeds)) do a
        dy_batch = pushforward(
            f_or_f!y...,
            pushforward_prep_same,
            backend,
            x,
            batched_seeds[a],
            contexts...,
        )
        block = stack_vec_col(dy_batch)
        if !aligned && a == A
            return block[:, 1:B_last]
        else
            return block
        end
    end
    return jac
end

function _jacobian_aux(
        f_or_f!y::FY,
        prep::PullbackJacobianPrep{SIG, <:BatchSizeSettings{B, true, aligned}},
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {FY, SIG, B, aligned, C}
    (; batch_size_settings, batched_seeds, pullback_prep) = prep
    (; B_last) = batch_size_settings
    dx_batch = pullback(
        f_or_f!y..., pullback_prep, backend, x, only(batched_seeds), contexts...
    )
    if eltype(x) <: Complex
        dx_batch = map(conj, dx_batch)
    end
    block = stack_vec_row(dx_batch)
    if aligned
        return block
    else
        return block[1:B_last, :]
    end
end

function _jacobian_aux(
        f_or_f!y::FY,
        prep::PullbackJacobianPrep{SIG, <:BatchSizeSettings{1, false, true}},
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {FY, SIG, C}
    (; batched_seeds, seed_example, pullback_prep) = prep

    pullback_prep_same = prepare_pullback_same_point(
        f_or_f!y..., pullback_prep, backend, x, seed_example, contexts...
    )

    jac = stack(eachindex(batched_seeds); dims = 1) do a
        dx = only(
            pullback(
                f_or_f!y..., pullback_prep_same, backend, x, batched_seeds[a], contexts...
            )
        )
        if eltype(x) <: Complex
            return map(conj, vec(dx))
        else
            return vec(dx)
        end
    end
    return jac
end

function _jacobian_aux(
        f_or_f!y::FY,
        prep::PullbackJacobianPrep{SIG, <:BatchSizeSettings{B, false, aligned}},
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {FY, SIG, B, aligned, C}
    (; batch_size_settings, batched_seeds, seed_example, pullback_prep) = prep
    (; A, B_last) = batch_size_settings

    pullback_prep_same = prepare_pullback_same_point(
        f_or_f!y..., pullback_prep, backend, x, seed_example, contexts...
    )

    jac = mapreduce(vcat, eachindex(batched_seeds)) do a
        dx_batch = pullback(
            f_or_f!y..., pullback_prep_same, backend, x, batched_seeds[a], contexts...
        )
        if eltype(x) <: Complex
            dx_batch = map(conj, dx_batch)
        end
        block = stack_vec_row(dx_batch)
        if !aligned && a == A
            return block[1:B_last, :]
        else
            return block
        end
    end
    return jac
end

function _jacobian_aux!(
        f_or_f!y::FY,
        jac,
        prep::PushforwardJacobianPrep{SIG, <:BatchSizeSettings{B}},
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {FY, SIG, B, C}
    (;
        batch_size_settings, batched_seeds, batched_results, seed_example, pushforward_prep,
    ) = prep
    (; N) = batch_size_settings

    pushforward_prep_same = prepare_pushforward_same_point(
        f_or_f!y..., pushforward_prep, backend, x, seed_example, contexts...
    )

    for a in eachindex(batched_seeds, batched_results)
        pushforward!(
            f_or_f!y...,
            batched_results[a],
            pushforward_prep_same,
            backend,
            x,
            batched_seeds[a],
            contexts...,
        )

        for b in eachindex(batched_results[a])
            copyto!(
                view(jac, :, 1 + ((a - 1) * B + (b - 1)) % N), vec(batched_results[a][b])
            )
        end
    end

    return jac
end

function _jacobian_aux!(
        f_or_f!y::FY,
        jac,
        prep::PullbackJacobianPrep{SIG, <:BatchSizeSettings{B}},
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {FY, SIG, B, C}
    (; batch_size_settings, batched_seeds, batched_results, seed_example, pullback_prep) =
        prep
    (; N) = batch_size_settings

    pullback_prep_same = prepare_pullback_same_point(
        f_or_f!y..., pullback_prep, backend, x, seed_example, contexts...
    )

    for a in eachindex(batched_seeds, batched_results)
        pullback!(
            f_or_f!y...,
            batched_results[a],
            pullback_prep_same,
            backend,
            x,
            batched_seeds[a],
            contexts...,
        )

        for b in eachindex(batched_results[a])
            if eltype(x) <: Complex
                batched_results[a][b] .= conj.(batched_results[a][b])
            end
            copyto!(
                view(jac, 1 + ((a - 1) * B + (b - 1)) % N, :), vec(batched_results[a][b])
            )
        end
    end

    return jac
end

using DifferentiationInterface
using Test

include("testutils.jl")

## Main tests

if haskey(ENV, "JULIA_DI_TEST_GROUP")
    folders = [ENV["JULIA_DI_TEST_GROUP"]]
else
    folders = ["Internals", "SimpleFiniteDiff", "ZeroBackends"]
end

@time @testset verbose = true "DifferentiationInterface.jl (Core)" begin
    @testset verbose = true "$folder" for folder in folders
        @testset verbose = true "$file" for file in readdir(
                joinpath(@__DIR__, "Core", folder)
            )
            endswith(file, ".jl") || continue
            @info "Testing $folder/$file"
            include(joinpath(@__DIR__, "Core", folder, file))
            yield()
        end
    end
end;

include("../../testutils.jl")

using DifferentiationInterface, DifferentiationInterfaceTest
import DifferentiationInterface as DI
using ForwardDiff: ForwardDiff
using ReverseDiff: ReverseDiff
using StaticArrays: StaticArrays
using Test

using ExplicitImports
check_no_implicit_imports(DifferentiationInterface)

backends = [AutoReverseDiff(; compile = false), AutoReverseDiff(; compile = true)]
second_order_backends = [SecondOrder(AutoForwardDiff(), AutoReverseDiff())]

for backend in vcat(backends, second_order_backends)
    @test check_available(backend)
    @test check_inplace(backend)
    test_counterparts(backend)
end

## Dense

test_differentiation(
    vcat(backends, second_order_backends),
    default_scenarios(; include_constantified = true);
    logging = LOGGING,
);

test_differentiation(
    backends, static_scenarios(; include_constantified = true); logging = LOGGING
);

## Sparse

test_differentiation(
    MyAutoSparse.(vcat(backends, second_order_backends)),
    sparse_scenarios();
    sparsity = true,
    logging = LOGGING,
);

@testset verbose = true "Overloaded inputs" begin
    backend = AutoReverseDiff()

    # Derivative
    x = 1.0
    @test_skip DI.overloaded_input_type(prepare_derivative(copy, backend, x)) ==
        ReverseDiff.TrackedArray{Float64, Float64, 1, Vector{Float64}, Vector{Float64}}

    # Gradient
    x = [1.0; 0.0; 0.0]
    @test DI.overloaded_input_type(prepare_gradient(sum, backend, x)) ==
        ReverseDiff.TrackedArray{Float64, Float64, 1, Vector{Float64}, Vector{Float64}}

    # Jacobian
    @test DI.overloaded_input_type(prepare_jacobian(copy, backend, x)) ==
        ReverseDiff.TrackedArray{Float64, Float64, 1, Vector{Float64}, Vector{Float64}}
    @test DI.overloaded_input_type(prepare_jacobian(copyto!, similar(x), backend, x)) ==
        ReverseDiff.TrackedArray{Float64, Float64, 1, Vector{Float64}, Vector{Float64}}
end;

module DifferentiationInterfaceZygoteExt

using ADTypes: AutoForwardDiff, AutoZygote
import DifferentiationInterface as DI
using ForwardDiff: ForwardDiff
using Zygote:
    Buffer,
    ZygoteRuleConfig,
    gradient,
    hessian,
    jacobian,
    pullback,
    withgradient,
    withjacobian

DI.check_available(::AutoZygote) = true
DI.inplace_support(::AutoZygote) = DI.InPlaceNotSupported()

translate(c::DI.Context) = DI.unwrap(c)
translate(c::DI.Cache{<:AbstractArray}) = Buffer(DI.unwrap(c))
function translate(c::DI.Cache{<:Union{Tuple, NamedTuple}})
    return map(translate, map(DI.Cache, DI.unwrap(c)))
end

## Pullback

struct ZygotePullbackPrepSamePoint{SIG, Y, PB} <: DI.PullbackPrep{SIG}
    _sig::Val{SIG}
    y::Y
    pb::PB
end

function DI.prepare_pullback_nokwarg(
        strict::Val, f, backend::AutoZygote, x, ty::NTuple, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, ty, contexts...; strict)
    return DI.NoPullbackPrep(_sig)
end

function DI.prepare_pullback_same_point(
        f,
        prep::DI.NoPullbackPrep,
        backend::AutoZygote,
        x,
        ty::NTuple,
        contexts::Vararg{DI.Context, C}
    ) where {C}
    DI.check_prep(f, prep, backend, x, ty, contexts...)
    _sig = DI.signature(f, backend, x, ty, contexts...; strict = DI.is_strict(prep))
    y, pb = pullback(f, x, map(translate, contexts)...)
    return ZygotePullbackPrepSamePoint(_sig, y, pb)
end

function DI.value_and_pullback(
        f,
        prep::DI.NoPullbackPrep,
        backend::AutoZygote,
        x,
        ty::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, ty, contexts...)
    y, pb = pullback(f, x, map(translate, contexts)...)
    tx = map(ty) do dy
        first(pb(dy))
    end
    return y, tx
end

function DI.value_and_pullback(
        f,
        prep::ZygotePullbackPrepSamePoint,
        backend::AutoZygote,
        x,
        ty::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, ty, contexts...)
    (; y, pb) = prep
    tx = map(ty) do dy
        first(pb(dy))
    end
    return copy(y), tx
end

function DI.pullback(
        f,
        prep::ZygotePullbackPrepSamePoint,
        backend::AutoZygote,
        x,
        ty::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, ty, contexts...)
    (; pb) = prep
    tx = map(ty) do dy
        first(pb(dy))
    end
    return tx
end

## Gradient

function DI.prepare_gradient_nokwarg(
        strict::Val, f, backend::AutoZygote, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    return DI.NoGradientPrep(_sig)
end

function DI.value_and_gradient(
        f, prep::DI.NoGradientPrep, backend::AutoZygote, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    (; val, grad) = withgradient(f, x, map(translate, contexts)...)
    return val, first(grad)
end

function DI.gradient(
        f, prep::DI.NoGradientPrep, backend::AutoZygote, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    grad = gradient(f, x, map(translate, contexts)...)
    return first(grad)
end

function DI.value_and_gradient!(
        f, grad, prep::DI.NoGradientPrep, backend::AutoZygote, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    y, new_grad = DI.value_and_gradient(f, prep, backend, x, contexts...)
    return y, copyto!(grad, new_grad)
end

function DI.gradient!(
        f, grad, prep::DI.NoGradientPrep, backend::AutoZygote, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return copyto!(grad, DI.gradient(f, prep, backend, x, contexts...))
end

## Jacobian

function DI.prepare_jacobian_nokwarg(
        strict::Val, f, backend::AutoZygote, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    return DI.NoJacobianPrep(_sig)
end

function DI.value_and_jacobian(
        f, prep::DI.NoJacobianPrep, backend::AutoZygote, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    y = f(x, map(translate, contexts)...)
    # https://github.com/FluxML/Zygote.jl/issues/1506
    jac = jacobian(f, x, map(translate, contexts)...)
    return y, first(jac)
end

function DI.jacobian(
        f, prep::DI.NoJacobianPrep, backend::AutoZygote, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    jac = jacobian(f, x, map(translate, contexts)...)
    return first(jac)
end

function DI.value_and_jacobian!(
        f, jac, prep::DI.NoJacobianPrep, backend::AutoZygote, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    y, new_jac = DI.value_and_jacobian(f, prep, backend, x, contexts...)
    return y, copyto!(jac, new_jac)
end

function DI.jacobian!(
        f, jac, prep::DI.NoJacobianPrep, backend::AutoZygote, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return copyto!(jac, DI.jacobian(f, prep, backend, x, contexts...))
end

## HVP

# Beware, this uses ForwardDiff for the inner differentiation

struct ZygoteHVPPrep{SIG, P} <: DI.HVPPrep{SIG}
    _sig::Val{SIG}
    fd_prep::P
end

function DI.prepare_hvp_nokwarg(
        strict::Val, f, backend::AutoZygote, x, tx::NTuple, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, tx, contexts...; strict)
    fd_prep = DI.prepare_hvp_nokwarg(
        strict, f, DI.SecondOrder(AutoForwardDiff(), backend), x, tx, contexts...
    )
    return ZygoteHVPPrep(_sig, fd_prep)
end

function DI.hvp(
        f,
        prep::ZygoteHVPPrep,
        backend::AutoZygote,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    return DI.hvp(
        f, prep.fd_prep, DI.SecondOrder(AutoForwardDiff(), backend), x, tx, contexts...
    )
end

function DI.hvp!(
        f,
        tg::NTuple,
        prep::ZygoteHVPPrep,
        backend::AutoZygote,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    return DI.hvp!(
        f, tg, prep.fd_prep, DI.SecondOrder(AutoForwardDiff(), backend), x, tx, contexts...
    )
end

function DI.gradient_and_hvp(
        f,
        prep::ZygoteHVPPrep,
        backend::AutoZygote,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    return DI.gradient_and_hvp(
        f, prep.fd_prep, DI.SecondOrder(AutoForwardDiff(), backend), x, tx, contexts...
    )
end

function DI.gradient_and_hvp!(
        f,
        grad,
        tg::NTuple,
        prep::ZygoteHVPPrep,
        backend::AutoZygote,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    return DI.gradient_and_hvp!(
        f,
        grad,
        tg,
        prep.fd_prep,
        DI.SecondOrder(AutoForwardDiff(), backend),
        x,
        tx,
        contexts...,
    )
end

## Hessian

function DI.prepare_hessian_nokwarg(
        strict::Val, f, backend::AutoZygote, x, contexts::Vararg{DI.GeneralizedConstant, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    return DI.NoHessianPrep(_sig)
end

function DI.hessian(
        f,
        prep::DI.NoHessianPrep,
        backend::AutoZygote,
        x,
        contexts::Vararg{DI.GeneralizedConstant, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    hess = hessian(fc, x)
    return hess
end

function DI.hessian!(
        f,
        hess,
        prep::DI.NoHessianPrep,
        backend::AutoZygote,
        x,
        contexts::Vararg{DI.GeneralizedConstant, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return copyto!(hess, DI.hessian(f, prep, backend, x, contexts...))
end

function DI.value_gradient_and_hessian(
        f,
        prep::DI.NoHessianPrep,
        backend::AutoZygote,
        x,
        contexts::Vararg{DI.GeneralizedConstant, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    y, grad = DI.value_and_gradient(f, backend, x, contexts...)
    hess = DI.hessian(f, prep, backend, x, contexts...)
    return y, grad, hess
end

function DI.value_gradient_and_hessian!(
        f,
        grad,
        hess,
        prep::DI.NoHessianPrep,
        backend::AutoZygote,
        x,
        contexts::Vararg{DI.GeneralizedConstant, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    y, _ = DI.value_and_gradient!(f, grad, backend, x, contexts...)
    DI.hessian!(f, hess, prep, backend, x, contexts...)
    return y, grad, hess
end

end

include("../../testutils.jl")

using DifferentiationInterface, DifferentiationInterfaceTest
using Mooncake: Mooncake
using LinearAlgebra
using Test

using ExplicitImports
check_no_implicit_imports(DifferentiationInterface)

nomatrix(scens) = filter(s -> !(s.x isa AbstractMatrix) && !(s.y isa AbstractMatrix), scens)

backends = [
    AutoMooncake(),
    AutoMooncakeForward(),
    AutoMooncake(; config = Mooncake.Config(; friendly_tangents = true)),
    AutoMooncakeForward(; config = Mooncake.Config(; friendly_tangents = true)),
]

for backend in backends
    @test check_available(backend)
    @test check_inplace(backend)
    test_counterparts(backend)
end

@testset "Counterpart config" begin
    config = Mooncake.Config(; friendly_tangents = true)
    @test DifferentiationInterface.forward_counterpart(AutoMooncake()) === AutoMooncakeForward()
    @test DifferentiationInterface.reverse_counterpart(AutoMooncakeForward()) === AutoMooncake()
    # the Mooncake config must carry over to the counterpart
    @test DifferentiationInterface.forward_counterpart(AutoMooncake(; config)) ===
        AutoMooncakeForward(; config)
    @test DifferentiationInterface.reverse_counterpart(AutoMooncakeForward(; config)) ===
        AutoMooncake(; config)
end

test_differentiation(
    backends[3:4],
    default_scenarios();
    excluded = SECOND_ORDER,
    logging = LOGGING,
    testset_name = "Basics"
);

test_differentiation(
    backends[3:4],
    nomatrix(
        default_scenarios(;
            include_normal = false,
            include_constantified = true,
            include_cachified = true,
            use_tuples = true
        )
    );
    excluded = SECOND_ORDER,
    logging = LOGGING,
    testset_name = "Constantified and cachified"
);

test_differentiation(
    backends[1:2],
    nomatrix(default_scenarios());
    excluded = SECOND_ORDER,
    logging = LOGGING,
    testset_name = "No friendly tangents"
);

EXCLUDED = @static if VERSION ≥ v"1.11-" && VERSION ≤ v"1.12-"
    # testing only :hessian on 1.11 due to an opaque closure bug.
    # this is potentially the same issue as discussed in
    # https://github.com/chalk-lab/MistyClosures.jl/pull/12#issue-3278662295
    [FIRST_ORDER..., :hvp, :second_derivative]
else
    [FIRST_ORDER...]
end

# Test second-order differentiation (forward-over-reverse)
test_differentiation(
    [SecondOrder(AutoMooncakeForward(), AutoMooncake())],
    nomatrix(default_scenarios());
    excluded = EXCLUDED,
    logging = LOGGING,
    testset_name = "Second order"
)

@testset "NamedTuples" begin
    ps = (; A = rand(5), B = rand(5))
    myfun(ps) = sum(ps.A .* ps.B)
    grad = gradient(myfun, backends[1], ps)
    @test grad.A == ps.B
    @test grad.B == ps.A
end

# see https://github.com/JuliaDiff/DifferentiationInterface.jl/issues/986
if pkgversion(Mooncake) < v"0.5.25"
    test_differentiation(
        backends[3:4],
        nomatrix(static_scenarios());
        logging = LOGGING,
        excluded = SECOND_ORDER,
        testset_name = "Static scenarios"
    )
end

@testset "Zeroing of constant contexts" begin
    # https://github.com/chalk-lab/Mooncake.jl/issues/1238
    @testset "Closure" begin
        function make_f()
            data = [1.0, 2.0, 3.0]
            return p -> sum(
                abs2,
                LowerTriangular([p[1] 0 0; p[2] p[1] 0; p[3] p[2] p[1]] + I) \ data
            )
        end
        f = make_f()
        xA = [0.3, 0.5, 0.2]
        xB = [1.5, 2.0, -1.0]
        backend = AutoMooncake()
        g = gradient(f, backend, xB)
        prep = prepare_gradient(f, backend, xA)
        @test gradient(f, prep, backend, xB) ≈ g
        @test gradient(f, prep, backend, xB) ≈ g
    end
    @testset "Constant context" begin
        f(p, data) = sum(
            abs2,
            LowerTriangular([p[1] 0 0; p[2] p[1] 0; p[3] p[2] p[1]] + I) \ data
        )
        data = [1.0, 2.0, 3.0]
        xA = [0.3, 0.5, 0.2]
        xB = [1.5, 2.0, -1.0]
        backend = AutoMooncake()
        g = gradient(f, backend, xB, Constant(data))
        prep = prepare_gradient(f, backend, xA, Constant(data))
        @test gradient(f, prep, backend, xB, Constant(data)) ≈ g
        @test gradient(f, prep, backend, xB, Constant(data)) ≈ g
    end
end

struct SMCSparseHessianPrep{
        SIG,
        BS <: DI.BatchSizeSettings,
        P <: AbstractMatrix,
        C <: AbstractColoringResult{:symmetric, :column},
        M <: AbstractMatrix{<:Number},
        Sp <: NTuple,
        S <: AbstractVector{<:NTuple},
        R <: AbstractVector{<:NTuple},
        E2 <: DI.HVPPrep,
        E1 <: DI.GradientPrep,
    } <: DI.SparseHessianPrep{SIG}
    _sig::Val{SIG}
    batch_size_settings::BS
    sparsity::P
    coloring_result::C
    compressed_matrix::M
    batched_seed_prep::Sp
    batched_seeds::S
    batched_results::R
    hvp_prep::E2
    gradient_prep::E1
end

## Hessian, one argument

function DI.prepare_hessian_nokwarg(
        strict::Val, f::F, backend::AutoSparse, x, contexts::Vararg{DI.Context, C}
    ) where {F, C}
    dense_backend = dense_ad(backend)
    sparsity = DI.hessian_sparsity_with_contexts(
        f, sparsity_detector(backend), x, contexts...
    )
    problem = ColoringProblem{:symmetric, :column}()
    coloring_result = coloring(
        sparsity, problem, coloring_algorithm(backend); decompression_eltype = eltype(x)
    )
    N = length(column_groups(coloring_result))
    batch_size_settings = DI.pick_batchsize(DI.outer(dense_backend), N)
    return _prepare_sparse_hessian_aux(
        strict, batch_size_settings, sparsity, coloring_result, f, backend, x, contexts...
    )
end

function _prepare_sparse_hessian_aux(
        strict::Val,
        batch_size_settings::DI.BatchSizeSettings{B},
        sparsity::AbstractMatrix,
        coloring_result::AbstractColoringResult{:symmetric, :column},
        f::F,
        backend::AutoSparse,
        x,
        contexts::Vararg{DI.Context, C}
    ) where {B, F, C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    (; N, A) = batch_size_settings
    dense_backend = dense_ad(backend)
    groups = column_groups(coloring_result)
    seed_prep = DI.multibasis(x, eachindex(x))
    seeds = [DI.multibasis(x, eachindex(x)[group]) for group in groups]
    compressed_matrix = if isempty(groups)
        similar(x, length(x), 0)
    else
        stack(_ -> vec(similar(x)), groups; dims = 2)
    end
    batched_seed_prep = ntuple(b -> copy(seed_prep), Val(B))
    batched_seeds = [
        ntuple(b -> seeds[1 + ((a - 1) * B + (b - 1)) % N], Val(B)) for a in 1:A
    ]
    batched_results = [ntuple(b -> similar(x), Val(B)) for _ in batched_seeds]
    hvp_prep = DI.prepare_hvp_nokwarg(
        strict, f, dense_backend, x, batched_seed_prep, contexts...
    )
    gradient_prep = DI.prepare_gradient_nokwarg(
        strict, f, DI.inner(dense_backend), x, contexts...
    )
    return SMCSparseHessianPrep(
        _sig,
        batch_size_settings,
        sparsity,
        coloring_result,
        compressed_matrix,
        batched_seed_prep,
        batched_seeds,
        batched_results,
        hvp_prep,
        gradient_prep,
    )
end

function DI.hessian!(
        f::F,
        hess,
        prep::SMCSparseHessianPrep{SIG, <:DI.BatchSizeSettings{B}},
        backend::AutoSparse,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, SIG, B, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    (;
        batch_size_settings,
        coloring_result,
        compressed_matrix,
        batched_seed_prep,
        batched_seeds,
        batched_results,
        hvp_prep,
    ) = prep
    (; N) = batch_size_settings
    dense_backend = dense_ad(backend)

    hvp_prep_same = DI.prepare_hvp_same_point(
        f, hvp_prep, dense_backend, x, batched_seed_prep, contexts...
    )

    for a in eachindex(batched_seeds, batched_results)
        DI.hvp!(
            f,
            batched_results[a],
            hvp_prep_same,
            dense_backend,
            x,
            batched_seeds[a],
            contexts...,
        )

        for b in eachindex(batched_results[a])
            copyto!(
                view(compressed_matrix, :, 1 + ((a - 1) * B + (b - 1)) % N),
                vec(batched_results[a][b]),
            )
        end
    end

    decompress!(hess, compressed_matrix, coloring_result)
    return hess
end

function DI.hessian(
        f::F, prep::SMCSparseHessianPrep, backend::AutoSparse, x, contexts::Vararg{DI.Context, C}
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    hess = similar(sparsity_pattern(prep), eltype(x))
    return DI.hessian!(f, hess, prep, backend, x, contexts...)
end

function DI.value_gradient_and_hessian!(
        f::F,
        grad,
        hess,
        prep::SMCSparseHessianPrep,
        backend::AutoSparse,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    y, _ = DI.value_and_gradient!(
        f, grad, prep.gradient_prep, DI.inner(dense_ad(backend)), x, contexts...
    )
    DI.hessian!(f, hess, prep, backend, x, contexts...)
    return y, grad, hess
end

function DI.value_gradient_and_hessian(
        f::F, prep::SMCSparseHessianPrep, backend::AutoSparse, x, contexts::Vararg{DI.Context, C}
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    y, grad = DI.value_and_gradient(
        f, prep.gradient_prep, DI.inner(dense_ad(backend)), x, contexts...
    )
    hess = DI.hessian(f, prep, backend, x, contexts...)
    return y, grad, hess
end

using ADTypes
using ADTypes: dense_ad, mode
using DifferentiationInterface
using DifferentiationInterface:
    AutoSimpleFiniteDiff,
    AutoForwardFromPrimitive,
    AutoReverseFromPrimitive,
    inner,
    outer,
    forward_backend,
    reverse_backend,
    inplace_support,
    pushforward_performance,
    pullback_performance,
    hvp_mode,
    forward_counterpart,
    reverse_counterpart
import DifferentiationInterface as DI
using Test

fb = AutoSimpleFiniteDiff()
rb = AutoReverseFromPrimitive(AutoSimpleFiniteDiff())

@testset "NoAutoDiff" begin
    @test_throws NoAutoDiffSelectedError check_available(NoAutoDiff())
    @test_throws NoAutoDiffSelectedError inplace_support(NoAutoDiff())
    @test_throws NoAutoDiffSelectedError forward_counterpart(NoAutoDiff())
    @test_throws NoAutoDiffSelectedError reverse_counterpart(NoAutoDiff())
end

@testset "SecondOrder" begin
    backend = SecondOrder(fb, rb)
    @test check_available(backend)
    @test outer(backend) isa AutoSimpleFiniteDiff
    @test inner(backend) isa AutoReverseFromPrimitive
    @test mode(backend) isa ADTypes.ForwardMode
    @test Bool(inplace_support(backend))
    @test_throws ArgumentError pushforward_performance(backend)
    @test_throws ArgumentError pullback_performance(backend)
    @test_throws ArgumentError forward_counterpart(backend)
    @test_throws ArgumentError reverse_counterpart(backend)
end

@testset "MixedMode" begin
    backend = MixedMode(fb, rb)
    @test check_available(backend)
    @test mode(backend) isa DifferentiationInterface.ForwardAndReverseMode
    @test forward_backend(backend) isa AutoSimpleFiniteDiff
    @test reverse_backend(backend) isa AutoReverseFromPrimitive
    @test Bool(inplace_support(backend))
    @test_throws MethodError pushforward_performance(backend)
    @test_throws MethodError pullback_performance(backend)
    # a MixedMode backend is its own counterpart in both directions
    @test forward_counterpart(backend) === backend
    @test reverse_counterpart(backend) === backend
end

@testset "Counterparts" begin
    # forward-/reverse-mode backends are their own counterpart
    @test forward_counterpart(fb) === fb
    @test reverse_counterpart(rb) === rb
    # without a known counterpart, the backend is returned unchanged
    @test reverse_counterpart(fb) === fb
    # FromPrimitive wrappers swap the primitive, applying the counterpart inside
    @test forward_counterpart(rb) isa AutoForwardFromPrimitive{<:Any, <:AutoSimpleFiniteDiff}
    @test reverse_counterpart(forward_counterpart(rb)) isa
        AutoReverseFromPrimitive{<:Any, <:AutoSimpleFiniteDiff}
end

@testset "Sparse" begin
    for dense_backend in [fb, rb]
        backend = AutoSparse(dense_backend)
        @test mode(backend) == ADTypes.mode(dense_backend)
        @test Bool(inplace_support(backend))
        @test_throws ArgumentError pushforward_performance(backend)
        @test_throws ArgumentError pullback_performance(backend)
        @test_throws ArgumentError hvp_mode(backend)
    end
    # counterparts act on the dense backend and preserve the sparsity machinery
    backend = AutoSparse(rb)
    counterpart = forward_counterpart(backend)
    @test counterpart isa AutoSparse
    @test dense_ad(counterpart) isa AutoForwardFromPrimitive
    @test counterpart.sparsity_detector === backend.sparsity_detector
    @test counterpart.coloring_algorithm === backend.coloring_algorithm
end

struct MooncakeTwoArgPullbackPrep{SIG, Tcache, DY, N} <: DI.PullbackPrep{SIG}
    _sig::Val{SIG}
    cache::Tcache
    dy_backup::DY
    args_to_zero::NTuple{N, Bool}
end

function DI.prepare_pullback_nokwarg(
        strict::Val,
        f!::F,
        y,
        backend::AutoMooncake,
        x,
        ty::NTuple,
        contexts::Vararg{DI.Context, C}
    ) where {F, C}
    _sig = DI.signature(f!, y, backend, x, ty, contexts...; strict)
    config = get_config(backend)
    cache = prepare_pullback_cache(
        call_and_return,
        f!,
        y,
        x,
        map(DI.unwrap, contexts)...;
        config,
    )
    dy_backup = zero_tangent_or_primal(y, backend)
    contexts_tup_true_except_cache = map(c -> !(c isa DI.Cache), contexts)
    args_to_zero = (
        false,  # call_and_return
        true,  # f!
        false,  # y
        true,  # x
        contexts_tup_true_except_cache...,
    )
    prep = MooncakeTwoArgPullbackPrep(
        _sig, cache, dy_backup, args_to_zero
    )
    return prep
end

function DI.value_and_pullback(
        f!::F,
        y,
        prep::MooncakeTwoArgPullbackPrep,
        backend::AutoMooncake,
        x,
        ty::NTuple{1},
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f!, y, prep, backend, x, ty, contexts...)
    dy = only(ty)
    # Prepare cotangent to add after the forward pass.
    dy_backup = copyto!(prep.dy_backup, dy)
    # Run the reverse-pass and return the results.
    y_after, (_, _, _, dx) = value_and_pullback!!(
        prep.cache,
        dy_backup,
        call_and_return,
        f!,
        y,
        x,
        map(DI.unwrap, contexts)...;
        prep.args_to_zero
    )
    copyto!(y, y_after)
    return y, (_copy_output(dx),)
end

function DI.value_and_pullback(
        f!::F,
        y,
        prep::MooncakeTwoArgPullbackPrep,
        backend::AutoMooncake,
        x,
        ty::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f!, y, prep, backend, x, ty, contexts...)
    tx = map(ty) do dy
        dy_backup = copyto!(prep.dy_backup, dy)
        y_after, (_, _, _, dx) = value_and_pullback!!(
            prep.cache,
            dy_backup,
            call_and_return,
            f!,
            y,
            x,
            map(DI.unwrap, contexts)...;
            prep.args_to_zero
        )
        copyto!(y, y_after)
        _copy_output(dx)
    end
    return y, tx
end

function DI.value_and_pullback!(
        f!::F,
        y,
        tx::NTuple,
        prep::MooncakeTwoArgPullbackPrep,
        backend::AutoMooncake,
        x,
        ty::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f!, y, prep, backend, x, ty, contexts...)
    _, new_tx = DI.value_and_pullback(f!, y, prep, backend, x, ty, contexts...)
    foreach(copyto!, tx, new_tx)
    return y, tx
end

function DI.pullback(
        f!::F,
        y,
        prep::MooncakeTwoArgPullbackPrep,
        backend::AutoMooncake,
        x,
        ty::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f!, y, prep, backend, x, ty, contexts...)
    return DI.value_and_pullback(f!, y, prep, backend, x, ty, contexts...)[2]
end

function DI.pullback!(
        f!::F,
        y,
        tx::NTuple,
        prep::MooncakeTwoArgPullbackPrep,
        backend::AutoMooncake,
        x,
        ty::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f!, y, prep, backend, x, ty, contexts...)
    return DI.value_and_pullback!(f!, y, tx, prep, backend, x, ty, contexts...)[2]
end

module DifferentiationInterfaceGPUArraysCoreExt

using Adapt: adapt
import DifferentiationInterface as DI
using GPUArraysCore: @allowscalar, AbstractGPUArray

function DI.basis(a::AbstractGPUArray{T}, i) where {T}
    b = similar(a)
    fill!(b, zero(T))
    @allowscalar b[i] = oneunit(T)
    return b
end

function DI.multibasis(a::AbstractGPUArray{T}, inds) where {T}
    b = similar(a)
    fill!(b, zero(T))
    view(b, inds) .= oneunit(T)
    return b
end

function DI.arroftup_to_tupofarr(
        tx::AbstractArray{<:NTuple{B, <:Number}}, x::AbstractGPUArray{<:Number}
    ) where {B}
    return ntuple(b -> adapt(typeof(x), getindex.(tx, b)), Val(B))
end

end

module DifferentiationInterfaceGTPSAExt

import DifferentiationInterface as DI
using ADTypes: AutoGTPSA
using GTPSA: GTPSA, TPS, Descriptor

DI.check_available(::AutoGTPSA) = true

include("onearg.jl")
include("twoarg.jl")

end

"""
    BatchSizeSettings{B,singlebatch,aligned}

Configuration for the batch size deduced from a backend and a sample array of length `N`.

# Type parameters

  - `B::Int`: batch size
  - `singlebatch::Bool`: whether `B == N` (`B > N` is only allowed when `N == 0`)
  - `aligned::Bool`: whether `N % B == 0`

# Fields

  - `N::Int`: array length
  - `A::Int`: number of batches `A = div(N, B, RoundUp)`
  - `B_last::Int`: size of the last batch (if `aligned` is `false`)
"""
struct BatchSizeSettings{B, singlebatch, aligned}
    N::Int
    A::Int
    B_last::Int
end

function BatchSizeSettings{B, singlebatch, aligned}(N::Integer) where {B, singlebatch, aligned}
    B > N > 0 && throw(ArgumentError("Batch size $B larger than input size $N"))
    if B == N == 0
        A = B_last = 0
    else
        A = div(N, B, RoundUp)
        B_last = N % B
    end
    return BatchSizeSettings{B, singlebatch, aligned}(N, A, B_last)
end

function BatchSizeSettings{B}(::Val{N}) where {B, N}
    singlebatch = B == N
    aligned = (B == N == 0) || (N % B == 0)
    return BatchSizeSettings{B, singlebatch, aligned}(N)
end

function BatchSizeSettings{B}(N::Integer) where {B}
    # type-unstable
    singlebatch = B == N
    aligned = (B == N == 0) || (N % B == 0)
    return BatchSizeSettings{B, singlebatch, aligned}(N)
end

"""
    pick_batchsize(backend, N::Integer)

Return a [`BatchSizeSettings`](@ref) appropriate for arrays of length `N` with a given `backend`.
"""
function pick_batchsize(backend::AbstractADType, N::Integer)
    check_batchsize_pickable(backend)
    B = 1
    singlebatch = false
    aligned = true
    return BatchSizeSettings{B, singlebatch, aligned}(N)
end

"""
    pick_batchsize(backend, x_or_y::AbstractArray)

Return a [`BatchSizeSettings`](@ref) appropriate for arrays of the same length as `x_or_y` with a given `backend`.

Note that the array in question can be either the input or the output of the function, depending on whether the backend performs forward- or reverse-mode AD.
"""
function pick_batchsize(backend::AbstractADType, x::AbstractArray)
    check_batchsize_pickable(backend)
    return pick_batchsize(backend, length(x))
end

function check_batchsize_pickable(backend::AbstractADType)
    return if backend isa SecondOrder
        throw(
            ArgumentError(
                "You should select the batch size for the inner or outer backend of $backend",
            ),
        )
    elseif backend isa AutoSparse
        throw(
            ArgumentError(
                "You should select the batch size for the dense backend of $backend"
            ),
        )
    elseif backend isa MixedMode
        throw(
            ArgumentError(
                "You should select the batch size for the forward or reverse backend of $backend",
            ),
        )
    end
end

"""
    threshold_batchsize(backend::AbstractADType, B::Integer)

If the backend object has a fixed batch size `B0`, return a new backend where the fixed batch size is `min(B0, B)`.
Otherwise, act as the identity.
"""
function threshold_batchsize end

threshold_batchsize(backend::AbstractADType, ::Integer) = backend

function threshold_batchsize(backend::AutoSparse, B::Integer)
    return AutoSparse(
        threshold_batchsize(dense_ad(backend), B);
        sparsity_detector = backend.sparsity_detector,
        coloring_algorithm = backend.coloring_algorithm,
    )
end

function threshold_batchsize(backend::SecondOrder, B::Integer)
    return SecondOrder(
        threshold_batchsize(outer(backend), B), threshold_batchsize(inner(backend), B)
    )
end

"""
    reasonable_batchsize(N::Integer, Bmax::Integer)

Reproduces the heuristic from ForwardDiff to minimize

 1. the number of batches necessary to cover an array of length `N`
 2. the number of leftover indices in the last partial batch

Source: https://github.com/JuliaDiff/ForwardDiff.jl/blob/ec74fbc32b10bbf60b3c527d8961666310733728/src/prelude.jl#L19-L29
"""
function reasonable_batchsize(N::Integer, Bmax::Integer)
    if N == 0
        return 1
    elseif N <= Bmax
        return N
    else
        A = div(N, Bmax, RoundUp)
        B = div(N, A, RoundUp)
        return B
    end
end

"""
    overloaded_input_type(prep)

If it exists, return the overloaded input type (for the differentiated argument `x`) which will be passed to the differentiated function when preparation result `prep` is reused.

!!! danger

    This function is experimental and not part of the public API.
"""
function overloaded_input_type end

function overloaded_input(::typeof(pushforward), f, backend::AbstractADType, x, tx::NTuple)
    throw(ArgumentError("Overloaded input not defined"))
end

function overloaded_input(
        ::typeof(pushforward), f!, y, backend::AbstractADType, x, tx::NTuple
    )
    throw(ArgumentError("Overloaded input not defined"))
end

## Docstrings

"""
    prepare_hvp(f, backend, x, tx, [contexts...]; strict=Val(true)) -> prep

$(docstring_prepare("hvp"))
"""
function prepare_hvp(
        f::F,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C};
        strict::Val = Val(true),
    ) where {F, C}
    return prepare_hvp_nokwarg(strict, f, backend, x, tx, contexts...)
end

"""
    prepare!_hvp(f, prep, backend, x, tx, [contexts...]) -> new_prep

$(docstring_prepare!("hvp"))
"""
function prepare!_hvp(
        f::F,
        old_prep::HVPPrep,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, old_prep, backend, x, tx, contexts...)
    return prepare_hvp_nokwarg(is_strict(old_prep), f, backend, x, tx, contexts...)
end

"""
    prepare_hvp_same_point(f, backend, x, tx, [contexts...]; strict=Val(true)) -> prep_same

$(docstring_prepare("hvp"; samepoint = true))
"""
function prepare_hvp_same_point(
        f::F,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C};
        strict::Val = Val(true),
    ) where {F, C}
    return prepare_hvp_same_point_nokwarg(strict, f, backend, x, tx, contexts...)
end

function prepare_hvp_same_point_nokwarg(
        strict::Val, f::F, backend::AbstractADType, x, tx::NTuple, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_hvp_nokwarg(strict, f, backend, x, tx, contexts...)
    return prepare_hvp_same_point(f, prep, backend, x, tx, contexts...)
end

function prepare_hvp_same_point(
        f::F, prep::HVPPrep, backend::AbstractADType, x, tx::NTuple, contexts::Vararg{Context, C}
    ) where {F, C}
    check_prep(f, prep, backend, x, tx, contexts...)
    return prep
end

"""
    hvp(f, [prep,] backend, x, tx, [contexts...]) -> tg

Compute the Hessian-vector product of `f` at point `x` with a tuple of tangents `tx`.

$(docstring_preparation_hint("hvp"; same_point = true))
"""
function hvp(f::F, backend::AbstractADType, x, tx, contexts::Vararg{Context, C}) where {F, C}
    prep = prepare_hvp_nokwarg(Val(true), f, backend, x, tx, contexts...)
    return hvp(f, prep, backend, x, tx, contexts...)
end

"""
    hvp!(f, tg, [prep,] backend, x, tx, [contexts...]) -> tg

Compute the Hessian-vector product of `f` at point `x` with a tuple of tangents `tx`, overwriting `tg`.

$(docstring_preparation_hint("hvp"; same_point = true))
"""
function hvp!(
        f::F, tg, backend::AbstractADType, x, tx, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_hvp_nokwarg(Val(true), f, backend, x, tx, contexts...)
    return hvp!(f, tg, prep, backend, x, tx, contexts...)
end

"""
    gradient_and_hvp(f, [prep,] backend, x, tx, [contexts...]) -> (grad, tg)

Compute the gradient and the Hessian-vector product of `f` at point `x` with a tuple of tangents `tx`.

$(docstring_preparation_hint("hvp"; same_point = true))
"""
function gradient_and_hvp(
        f::F, backend::AbstractADType, x, tx, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_hvp_nokwarg(Val(true), f, backend, x, tx, contexts...)
    return gradient_and_hvp(f, prep, backend, x, tx, contexts...)
end

"""
    gradient_and_hvp!(f, grad, tg, [prep,] backend, x, tx, [contexts...]) -> (grad, tg)

Compute the gradient and the Hessian-vector product of `f` at point `x` with a tuple of tangents `tx`, overwriting `grad` and `tg`.

$(docstring_preparation_hint("hvp"; same_point = true))
"""
function gradient_and_hvp!(
        f::F, grad, tg, backend::AbstractADType, x, tx, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_hvp_nokwarg(Val(true), f, backend, x, tx, contexts...)
    return gradient_and_hvp!(f, grad, tg, prep, backend, x, tx, contexts...)
end

## Preparation

function prepare_hvp_nokwarg(
        strict::Val, f::F, backend::AbstractADType, x, tx::NTuple, contexts::Vararg{Context, C}
    ) where {F, C}
    return _prepare_hvp_aux(
        strict,
        hvp_mode(backend),
        inner_preparation_behavior(outer(backend)),
        f,
        backend,
        x,
        tx,
        contexts...
    )
end

## Forward over anything

struct ForwardOverAnythingHVPPrep{SIG, G, GO, GI, PO, PI} <: HVPPrep{SIG}
    # pushforward of many pushforwards in theory, but pushforward of gradient in practice
    _sig::Val{SIG}
    grad_buffer::G
    maybe_inner_gradient_prep::GO
    maybe_inner_gradient_in_prep::GI
    outer_pushforward_prep::PO
    outer_pushforward_in_prep::PI
end

function _prepare_hvp_aux(
        strict::Val,
        ::ForwardOverAnything,
        ::DontPrepareInner,
        f::F,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C}
    ) where {F, C}
    _sig = signature(f, backend, x, tx, contexts...; strict)
    grad_buffer = similar(x)
    rewrap = Rewrap(contexts...)
    # Outer pushforward
    new_contexts = (
        FunctionContext(f), Constant(inner(backend)), Constant(rewrap), contexts...,
    )
    outer_pushforward_prep = prepare_pushforward_nokwarg(
        strict, shuffled_gradient, outer(backend), x, tx, new_contexts...
    )
    outer_pushforward_in_prep = if inplace_support(outer(backend)) isa InPlaceSupported
        prepare_pushforward_nokwarg(
            strict,
            shuffled_gradient!,
            grad_buffer,
            outer(backend),
            x,
            tx,
            new_contexts...
        )
    else
        nothing
    end
    return ForwardOverAnythingHVPPrep(
        _sig, grad_buffer, (), (), outer_pushforward_prep, outer_pushforward_in_prep
    )
end

function _prepare_hvp_aux(
        strict::Val,
        ::ForwardOverAnything,
        ::PrepareInnerSimple,
        f::F,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C}
    ) where {F, C}
    _sig = signature(f, backend, x, tx, contexts...; strict)
    grad_buffer = similar(x)
    rewrap = Rewrap(contexts...)
    # Inner gradient
    inner_gradient_prep = prepare_gradient_nokwarg(
        strict, f, inner(backend), x, contexts...
    )
    inner_gradient_in_prep = inner_gradient_prep
    # Outer pushforward
    new_contexts = (
        FunctionContext(f),
        ConstantOrCache(inner_gradient_prep),
        Constant(inner(backend)),
        Constant(rewrap),
        contexts...,
    )
    new_contexts_in = (
        FunctionContext(f),
        ConstantOrCache(inner_gradient_in_prep),
        Constant(inner(backend)),
        Constant(rewrap),
        contexts...,
    )
    outer_pushforward_prep = prepare_pushforward_nokwarg(
        strict, shuffled_gradient, outer(backend), x, tx, new_contexts...
    )
    outer_pushforward_in_prep = if inplace_support(outer(backend)) isa InPlaceSupported
        prepare_pushforward_nokwarg(
            strict,
            shuffled_gradient!,
            grad_buffer,
            outer(backend),
            x,
            tx,
            new_contexts_in...
        )
    else
        nothing
    end
    return ForwardOverAnythingHVPPrep(
        _sig,
        grad_buffer,
        (inner_gradient_prep,),
        (inner_gradient_in_prep,),
        outer_pushforward_prep,
        outer_pushforward_in_prep,
    )
end

function _prepare_hvp_aux(
        strict::Val,
        ::ForwardOverAnything,
        ::PrepareInnerOverload,
        f::F,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C}
    ) where {F, C}
    _sig = signature(f, backend, x, tx, contexts...; strict)
    grad_buffer = similar(x)
    rewrap = Rewrap(contexts...)
    # Inner gradient
    xo = overloaded_input(pushforward, shuffled_gradient, outer(backend), x, tx)
    xoi = overloaded_input(
        pushforward, shuffled_gradient!, grad_buffer, outer(backend), x, tx
    )
    contextso = adapt_eltype.(contexts, Ref(eltype(xo)))
    contextsoi = adapt_eltype.(contexts, Ref(eltype(xoi)))
    inner_gradient_prep = prepare_gradient_nokwarg(
        strict, f, inner(backend), xo, contextso...
    )
    inner_gradient_in_prep = prepare_gradient_nokwarg(
        strict, f, inner(backend), xoi, contextsoi...
    )
    # Outer pushforward
    new_contexts = (
        FunctionContext(f),
        ConstantOrCache(inner_gradient_prep),
        Constant(inner(backend)),
        Constant(rewrap),
        contexts...,
    )
    new_contexts_in = (
        FunctionContext(f),
        ConstantOrCache(inner_gradient_in_prep),
        Constant(inner(backend)),
        Constant(rewrap),
        contexts...,
    )
    outer_pushforward_prep = prepare_pushforward_nokwarg(
        strict, shuffled_gradient, outer(backend), x, tx, new_contexts...
    )
    outer_pushforward_in_prep = if inplace_support(outer(backend)) isa InPlaceSupported
        prepare_pushforward_nokwarg(
            strict,
            shuffled_gradient!,
            grad_buffer,
            outer(backend),
            x,
            tx,
            new_contexts_in...
        )
    else
        nothing
    end
    return ForwardOverAnythingHVPPrep(
        _sig,
        grad_buffer,
        (inner_gradient_prep,),
        (inner_gradient_in_prep,),
        outer_pushforward_prep,
        outer_pushforward_in_prep,
    )
end

function hvp(
        f::F,
        prep::ForwardOverAnythingHVPPrep,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, tx, contexts...)
    (; maybe_inner_gradient_prep, outer_pushforward_prep) = prep
    rewrap = Rewrap(contexts...)
    new_contexts = (
        FunctionContext(f),
        map(ConstantOrCache, maybe_inner_gradient_prep)...,
        Constant(inner(backend)),
        Constant(rewrap),
        contexts...,
    )
    return pushforward(
        shuffled_gradient, outer_pushforward_prep, outer(backend), x, tx, new_contexts...
    )
end

function hvp!(
        f::F,
        tg::NTuple,
        prep::ForwardOverAnythingHVPPrep,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, tx, contexts...)
    return _hvp_aux!(
        inplace_support(outer(backend)), f, tg, prep, backend, x, tx, contexts...
    )
end

function _hvp_aux!(
        ::InPlaceSupported,
        f::F,
        tg::NTuple,
        prep::ForwardOverAnythingHVPPrep,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    (; grad_buffer, maybe_inner_gradient_in_prep, outer_pushforward_in_prep) = prep
    rewrap = Rewrap(contexts...)
    new_contexts = (
        FunctionContext(f),
        map(ConstantOrCache, maybe_inner_gradient_in_prep)...,
        Constant(inner(backend)),
        Constant(rewrap),
        contexts...,
    )
    return pushforward!(
        shuffled_gradient!,
        grad_buffer,
        tg,
        outer_pushforward_in_prep,
        outer(backend),
        x,
        tx,
        new_contexts...,
    )
end

function _hvp_aux!(
        ::InPlaceNotSupported,
        f::F,
        tg::NTuple,
        prep::ForwardOverAnythingHVPPrep,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    (; maybe_inner_gradient_prep, outer_pushforward_prep) = prep
    rewrap = Rewrap(contexts...)
    new_contexts = (
        FunctionContext(f),
        map(ConstantOrCache, maybe_inner_gradient_prep)...,
        Constant(inner(backend)),
        Constant(rewrap),
        contexts...,
    )
    return pushforward!(
        shuffled_gradient,
        tg,
        outer_pushforward_prep,
        outer(backend),
        x,
        tx,
        new_contexts...,
    )
end

function gradient_and_hvp(
        f::F,
        prep::ForwardOverAnythingHVPPrep,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, tx, contexts...)
    (; maybe_inner_gradient_prep, outer_pushforward_prep) = prep
    rewrap = Rewrap(contexts...)
    new_contexts = (
        FunctionContext(f),
        map(ConstantOrCache, maybe_inner_gradient_prep)...,
        Constant(inner(backend)),
        Constant(rewrap),
        contexts...,
    )
    return value_and_pushforward(
        shuffled_gradient, outer_pushforward_prep, outer(backend), x, tx, new_contexts...
    )
end

function gradient_and_hvp!(
        f::F,
        grad,
        tg::NTuple,
        prep::ForwardOverAnythingHVPPrep,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, tx, contexts...)
    return _gradient_and_hvp_aux!(
        inplace_support(outer(backend)), f, grad, tg, prep, backend, x, tx, contexts...
    )
end

function _gradient_and_hvp_aux!(
        ::InPlaceSupported,
        f::F,
        grad,
        tg::NTuple,
        prep::ForwardOverAnythingHVPPrep,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    (; maybe_inner_gradient_in_prep, outer_pushforward_in_prep) = prep
    rewrap = Rewrap(contexts...)
    new_contexts = (
        FunctionContext(f),
        map(ConstantOrCache, maybe_inner_gradient_in_prep)...,
        Constant(inner(backend)),
        Constant(rewrap),
        contexts...,
    )
    value_and_pushforward!(
        shuffled_gradient!,
        grad,
        tg,
        outer_pushforward_in_prep,
        outer(backend),
        x,
        tx,
        new_contexts...,
    )
    return grad, tg
end

function _gradient_and_hvp_aux!(
        ::InPlaceNotSupported,
        f::F,
        grad,
        tg::NTuple,
        prep::ForwardOverAnythingHVPPrep,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    (; maybe_inner_gradient_prep, outer_pushforward_prep) = prep
    rewrap = Rewrap(contexts...)
    new_contexts = (
        FunctionContext(f),
        map(ConstantOrCache, maybe_inner_gradient_prep)...,
        Constant(inner(backend)),
        Constant(rewrap),
        contexts...,
    )
    new_grad, _ = value_and_pushforward!(
        shuffled_gradient,
        tg,
        outer_pushforward_prep,
        outer(backend),
        x,
        tx,
        new_contexts...,
    )
    return copyto!(grad, new_grad), tg
end

## Reverse over forward

struct ReverseOverForwardHVPPrep{SIG, G2 <: GradientPrep, G1 <: GradientPrep} <: HVPPrep{SIG}
    # gradient of pushforward
    _sig::Val{SIG}
    outer_gradient_prep::G2
    gradient_prep::G1
end

function _prepare_hvp_aux(
        strict::Val,
        ::ReverseOverForward,
        ::InnerPreparationBehavior,
        f::F,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C}
    ) where {F, C}
    _sig = signature(f, backend, x, tx, contexts...; strict)
    rewrap = Rewrap(contexts...)
    new_contexts = (
        FunctionContext(f),
        Constant(inner(backend)),
        Constant(first(tx)),
        Constant(rewrap),
        contexts...,
    )
    outer_gradient_prep = prepare_gradient_nokwarg(
        strict, shuffled_single_pushforward, outer(backend), x, new_contexts...
    )
    gradient_prep = prepare_gradient_nokwarg(strict, f, inner(backend), x, contexts...)
    return ReverseOverForwardHVPPrep(_sig, outer_gradient_prep, gradient_prep)
end

function hvp(
        f::F,
        prep::ReverseOverForwardHVPPrep,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C}
    ) where {F, C}
    check_prep(f, prep, backend, x, tx, contexts...)
    (; outer_gradient_prep) = prep
    rewrap = Rewrap(contexts...)
    tg = map(tx) do dx
        gradient(
            shuffled_single_pushforward,
            outer_gradient_prep,
            outer(backend),
            x,
            FunctionContext(f),
            Constant(inner(backend)),
            Constant(dx),
            Constant(rewrap),
            contexts...,
        )
    end
    return tg
end

function hvp!(
        f::F,
        tg::NTuple,
        prep::ReverseOverForwardHVPPrep,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, tx, contexts...)
    (; outer_gradient_prep) = prep
    rewrap = Rewrap(contexts...)
    for b in eachindex(tx, tg)
        gradient!(
            shuffled_single_pushforward,
            tg[b],
            outer_gradient_prep,
            outer(backend),
            x,
            FunctionContext(f),
            Constant(inner(backend)),
            Constant(tx[b]),
            Constant(rewrap),
            contexts...,
        )
    end
    return tg
end

function gradient_and_hvp(
        f::F,
        prep::ReverseOverForwardHVPPrep,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, tx, contexts...)
    tg = hvp(f, prep, backend, x, tx, contexts...)
    grad = gradient(f, prep.gradient_prep, inner(backend), x, contexts...)
    return grad, tg
end

function gradient_and_hvp!(
        f::F,
        grad,
        tg::NTuple,
        prep::ReverseOverForwardHVPPrep,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, tx, contexts...)
    hvp!(f, tg, prep, backend, x, tx, contexts...)
    gradient!(f, grad, prep.gradient_prep, inner(backend), x, contexts...)
    return grad, tg
end

## Reverse over reverse

struct ReverseOverReverseHVPPrep{SIG, G, PO, PI} <: HVPPrep{SIG}
    # pullback of gradient
    _sig::Val{SIG}
    grad_buffer::G
    outer_pullback_prep::PO
    outer_pullback_in_prep::PI
end

function _prepare_hvp_aux(
        strict::Val,
        ::ReverseOverReverse,
        ::InnerPreparationBehavior,
        f::F,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C}
    ) where {F, C}
    _sig = signature(f, backend, x, tx, contexts...; strict)
    rewrap = Rewrap(contexts...)
    new_contexts = (
        FunctionContext(f), Constant(inner(backend)), Constant(rewrap), contexts...,
    )
    grad_buffer = similar(x)
    outer_pullback_prep = prepare_pullback_nokwarg(
        strict, shuffled_gradient, outer(backend), x, tx, new_contexts...
    )
    outer_pullback_in_prep = if inplace_support(outer(backend)) isa InPlaceSupported
        prepare_pullback_nokwarg(
            strict,
            shuffled_gradient!,
            grad_buffer,
            outer(backend),
            x,
            tx,
            new_contexts...
        )
    else
        nothing
    end
    return ReverseOverReverseHVPPrep(
        _sig, grad_buffer, outer_pullback_prep, outer_pullback_in_prep
    )
end

function hvp(
        f::F,
        prep::ReverseOverReverseHVPPrep,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, tx, contexts...)
    (; outer_pullback_prep) = prep
    rewrap = Rewrap(contexts...)
    new_contexts = (
        FunctionContext(f), Constant(inner(backend)), Constant(rewrap), contexts...,
    )
    return pullback(
        shuffled_gradient, outer_pullback_prep, outer(backend), x, tx, new_contexts...
    )
end

function hvp!(
        f::F,
        tg::NTuple,
        prep::ReverseOverReverseHVPPrep,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, tx, contexts...)
    return _hvp_aux!(
        inplace_support(outer(backend)), f, tg, prep, backend, x, tx, contexts...
    )
end

function _hvp_aux!(
        ::InPlaceSupported,
        f::F,
        tg::NTuple,
        prep::ReverseOverReverseHVPPrep,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    (; grad_buffer, outer_pullback_in_prep) = prep
    rewrap = Rewrap(contexts...)
    new_contexts = (
        FunctionContext(f), Constant(inner(backend)), Constant(rewrap), contexts...,
    )
    return pullback!(
        shuffled_gradient!,
        grad_buffer,
        tg,
        outer_pullback_in_prep,
        outer(backend),
        x,
        tx,
        new_contexts...,
    )
end

function _hvp_aux!(
        ::InPlaceNotSupported,
        f::F,
        tg::NTuple,
        prep::ReverseOverReverseHVPPrep,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    (; outer_pullback_prep) = prep
    rewrap = Rewrap(contexts...)
    new_contexts = (
        FunctionContext(f), Constant(inner(backend)), Constant(rewrap), contexts...,
    )
    return pullback!(
        shuffled_gradient, tg, outer_pullback_prep, outer(backend), x, tx, new_contexts...
    )
end

function gradient_and_hvp(
        f::F,
        prep::ReverseOverReverseHVPPrep,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, tx, contexts...)
    (; outer_pullback_prep) = prep
    rewrap = Rewrap(contexts...)
    new_contexts = (
        FunctionContext(f), Constant(inner(backend)), Constant(rewrap), contexts...,
    )
    return value_and_pullback(
        shuffled_gradient, outer_pullback_prep, outer(backend), x, tx, new_contexts...
    )
end

function gradient_and_hvp!(
        f::F,
        grad,
        tg::NTuple,
        prep::ReverseOverReverseHVPPrep,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, tx, contexts...)
    return _gradient_and_hvp_aux!(
        inplace_support(outer(backend)), f, grad, tg, prep, backend, x, tx, contexts...
    )
end

function _gradient_and_hvp_aux!(
        ::InPlaceSupported,
        f::F,
        grad,
        tg::NTuple,
        prep::ReverseOverReverseHVPPrep,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    (; outer_pullback_in_prep) = prep
    rewrap = Rewrap(contexts...)
    new_contexts = (
        FunctionContext(f), Constant(inner(backend)), Constant(rewrap), contexts...,
    )
    new_grad, _ = value_and_pullback!(
        shuffled_gradient!,
        grad,
        tg,
        outer_pullback_in_prep,
        outer(backend),
        x,
        tx,
        new_contexts...,
    )
    return grad, tg
end

function _gradient_and_hvp_aux!(
        ::InPlaceNotSupported,
        f::F,
        grad,
        tg::NTuple,
        prep::ReverseOverReverseHVPPrep,
        backend::AbstractADType,
        x,
        tx::NTuple,
        contexts::Vararg{Context, C},
    ) where {F, C}
    (; outer_pullback_prep) = prep
    rewrap = Rewrap(contexts...)
    new_contexts = (
        FunctionContext(f), Constant(inner(backend)), Constant(rewrap), contexts...,
    )
    new_grad, _ = value_and_pullback!(
        shuffled_gradient, tg, outer_pullback_prep, outer(backend), x, tx, new_contexts...
    )
    return copyto!(grad, new_grad), tg
end

## Pullback

struct EnzymeReverseTwoArgPullbackPrep{SIG, DF, DC, TY} <: DI.PullbackPrep{SIG}
    _sig::Val{SIG}
    df!::DF
    context_shadows::DC
    ty_copy::TY
end

function DI.prepare_pullback_nokwarg(
        strict::Val,
        f!::F,
        y,
        backend::AutoEnzyme{<:Union{ReverseMode, Nothing}},
        x,
        ty::NTuple{B},
        contexts::Vararg{DI.Context, C}
    ) where {F, B, C}
    _sig = DI.signature(f!, y, backend, x, ty, contexts...; strict)
    mode = reverse_noprimal(backend)
    df! = function_shadow(f!, backend, mode, Val(B))
    context_shadows = make_context_shadows(backend, mode, Val(B), contexts...)
    ty_copy = map(copy, ty)
    return EnzymeReverseTwoArgPullbackPrep(_sig, df!, context_shadows, ty_copy)
end

function DI.value_and_pullback(
        f!::F,
        y,
        prep::EnzymeReverseTwoArgPullbackPrep,
        backend::AutoEnzyme{<:Union{ReverseMode, Nothing}},
        x::Number,
        ty::NTuple{1},
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f!, y, prep, backend, x, ty, contexts...)
    (; df!, context_shadows, ty_copy) = prep
    copyto!(only(ty_copy), only(ty))
    mode = reverse_noprimal(backend)
    f!_and_df! = get_f_and_df_prepared!(df!, f!, backend, Val(1))
    dy = only(ty_copy)
    y_and_dy = Duplicated(y, dy)
    annotated_contexts = translate_prepared!(context_shadows, contexts, Val(1))
    dinputs = only(
        autodiff(mode, f!_and_df!, Const, y_and_dy, Active(x), annotated_contexts...)
    )
    dx = dinputs[2]
    return y, (dx,)
end

function DI.value_and_pullback(
        f!::F,
        y,
        prep::EnzymeReverseTwoArgPullbackPrep,
        backend::AutoEnzyme{<:Union{ReverseMode, Nothing}},
        x::Number,
        ty::NTuple{B},
        contexts::Vararg{DI.Context, C},
    ) where {F, B, C}
    DI.check_prep(f!, y, prep, backend, x, ty, contexts...)
    (; df!, context_shadows, ty_copy) = prep
    foreach(copyto!, ty_copy, ty)
    mode = reverse_noprimal(backend)
    f!_and_df! = get_f_and_df_prepared!(df!, f!, backend, Val(B))
    ty = ty_copy
    y_and_ty = BatchDuplicated(y, ty)
    annotated_contexts = translate_prepared!(context_shadows, contexts, Val(B))
    dinputs = only(
        autodiff(mode, f!_and_df!, Const, y_and_ty, Active(x), annotated_contexts...)
    )
    tx = values(dinputs[2])
    return y, tx
end

function DI.value_and_pullback(
        f!::F,
        y,
        prep::EnzymeReverseTwoArgPullbackPrep,
        backend::AutoEnzyme{<:Union{ReverseMode, Nothing}},
        x,
        ty::NTuple{1},
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f!, y, prep, backend, x, ty, contexts...)
    (; df!, context_shadows, ty_copy) = prep
    copyto!(only(ty_copy), only(ty))
    mode = reverse_noprimal(backend)
    f!_and_df! = get_f_and_df_prepared!(df!, f!, backend, Val(1))
    dx = make_zero(x)  # allocates
    dy = only(ty_copy)
    x_and_dx = Duplicated(x, dx)
    y_and_dy = Duplicated(y, dy)
    annotated_contexts = translate_prepared!(context_shadows, contexts, Val(1))
    autodiff(mode, f!_and_df!, Const, y_and_dy, x_and_dx, annotated_contexts...)
    return y, (dx,)
end

function DI.value_and_pullback(
        f!::F,
        y,
        prep::EnzymeReverseTwoArgPullbackPrep,
        backend::AutoEnzyme{<:Union{ReverseMode, Nothing}},
        x,
        ty::NTuple{B},
        contexts::Vararg{DI.Context, C},
    ) where {F, B, C}
    DI.check_prep(f!, y, prep, backend, x, ty, contexts...)
    (; df!, context_shadows, ty_copy) = prep
    foreach(copyto!, ty_copy, ty)
    mode = reverse_noprimal(backend)
    f!_and_df! = get_f_and_df_prepared!(df!, f!, backend, Val(B))
    tx = ntuple(_ -> make_zero(x), Val(B))  # allocates
    ty = ty_copy
    x_and_tx = BatchDuplicated(x, tx)
    y_and_ty = BatchDuplicated(y, ty)
    annotated_contexts = translate_prepared!(context_shadows, contexts, Val(B))
    autodiff(mode, f!_and_df!, Const, y_and_ty, x_and_tx, annotated_contexts...)
    return y, tx
end

function DI.value_and_pullback!(
        f!::F,
        y,
        tx::NTuple{1},
        prep::EnzymeReverseTwoArgPullbackPrep,
        backend::AutoEnzyme{<:Union{ReverseMode, Nothing}},
        x,
        ty::NTuple{1},
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f!, y, prep, backend, x, ty, contexts...)
    (; df!, context_shadows, ty_copy) = prep
    copyto!(only(ty_copy), only(ty))
    mode = reverse_noprimal(backend)
    f!_and_df! = get_f_and_df_prepared!(df!, f!, backend, Val(1))
    dx = only(tx)
    make_zero!(dx)
    dy = only(ty_copy)
    x_and_dx = Duplicated(x, dx)
    y_and_dy = Duplicated(y, dy)
    annotated_contexts = translate_prepared!(context_shadows, contexts, Val(1))
    autodiff(mode, f!_and_df!, Const, y_and_dy, x_and_dx, annotated_contexts...)
    return y, (dx,)
end

function DI.value_and_pullback!(
        f!::F,
        y,
        tx::NTuple{B},
        prep::EnzymeReverseTwoArgPullbackPrep,
        backend::AutoEnzyme{<:Union{ReverseMode, Nothing}},
        x,
        ty::NTuple{B},
        contexts::Vararg{DI.Context, C},
    ) where {F, B, C}
    DI.check_prep(f!, y, prep, backend, x, ty, contexts...)
    (; df!, context_shadows, ty_copy) = prep
    foreach(copyto!, ty_copy, ty)
    mode = reverse_noprimal(backend)
    f!_and_df! = get_f_and_df_prepared!(df!, f!, backend, Val(B))
    make_zero!(tx)
    ty = ty_copy
    x_and_tx = BatchDuplicated(x, tx)
    y_and_ty = BatchDuplicated(y, ty)
    annotated_contexts = translate_prepared!(context_shadows, contexts, Val(B))
    autodiff(mode, f!_and_df!, Const, y_and_ty, x_and_tx, annotated_contexts...)
    return y, tx
end

## Pushforward

struct MooncakeOneArgPushforwardPrep{SIG, Tcache, FT, CT} <: DI.PushforwardPrep{SIG}
    _sig::Val{SIG}
    cache::Tcache
    df::FT
    context_tangents::CT
end

function DI.prepare_pushforward_nokwarg(
        strict::Val,
        f::F,
        backend::AutoMooncakeForward,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C}
    ) where {F, C}
    _sig = DI.signature(f, backend, x, tx, contexts...; strict)
    config = get_config(backend)
    cache = prepare_derivative_cache(f, x, map(DI.unwrap, contexts)...; config)
    df = zero_tangent_or_primal(f, backend)
    context_tangents = map(zero_tangent_unwrap, contexts)
    prep = MooncakeOneArgPushforwardPrep(_sig, cache, df, context_tangents)
    return prep
end

function DI.value_and_pushforward(
        f::F,
        prep::MooncakeOneArgPushforwardPrep,
        backend::AutoMooncakeForward,
        x::X,
        tx::NTuple,
        contexts::Vararg{DI.Context, C}
    ) where {F, C, X}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    ys_and_ty = map(tx) do dx
        y_and_dy = value_and_derivative!!(
            prep.cache,
            (f, prep.df),
            (x, dx),
            map(first_unwrap, contexts, prep.context_tangents)...,
        )
        y = first(y_and_dy)
        dy = _copy_output(last(y_and_dy))
        return y, dy
    end
    y = _copy_output(first(ys_and_ty[1]))
    ty = map(last, ys_and_ty)
    return y, ty
end

function DI.pushforward(
        f::F,
        prep::MooncakeOneArgPushforwardPrep,
        backend::AutoMooncakeForward,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C}
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    return DI.value_and_pushforward(f, prep, backend, x, tx, contexts...)[2]
end

function DI.value_and_pushforward!(
        f::F,
        ty::NTuple,
        prep::MooncakeOneArgPushforwardPrep,
        backend::AutoMooncakeForward,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C}
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    y, new_ty = DI.value_and_pushforward(f, prep, backend, x, tx, contexts...)
    foreach(copyto!, ty, new_ty)
    return y, ty
end

function DI.pushforward!(
        f::F,
        ty::NTuple,
        prep::MooncakeOneArgPushforwardPrep,
        backend::AutoMooncakeForward,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C}
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    DI.value_and_pushforward!(f, ty, prep, backend, x, tx, contexts...)
    return ty
end

using CUDA
using DifferentiationInterface
import DifferentiationInterface as DI
using LinearAlgebra
using Test

CUDA.versioninfo()

@testset "Basis" begin
    x = CuVector(rand(Float32, 3))
    b = DI.basis(x, 2)
    @test Array(b) == [0, 1, 0]

    X = CuMatrix(rand(Float32, 2, 2))
    B = DI.multibasis(X, [2, 3])
    @test Array(B) == [0 1; 1 0]
end

@testset "Jacobian" begin
    x = CuVector(rand(Float32, 3))
    backend = DI.AutoSimpleFiniteDiff()
    J = jacobian(identity, backend, x)
    @test (J .!= 0) == I
end

function docstring_preptype(preptype::AbstractString, operator::AbstractString)
    return """
        $(preptype)

    Abstract type for additional information needed by [`$(operator)`](@ref) and its variants.
    """
end

function samepoint_warning(samepoint::Bool)
    return if samepoint
        ", _if they are applied at the same point `x` and with the same `contexts`_"
    else
        ""
    end
end

function docstring_prepare(operator; samepoint = false, inplace = false)
    return """
    Create a `prep` object that can be given to [`$(operator)`](@ref) and its variants to speed them up$(samepoint_warning(samepoint)).

    Depending on the backend, this can have several effects (preallocating memory, recording an execution trace) which are transparent to the user.
    $(inplace ? "\nFor in-place functions, `y` is mutated by `f!` during preparation." : "")

    !!! warning
        The preparation result `prep` is only reusable as long as the arguments to `$operator` do not change type or size, and the function and backend themselves are not modified.
        Otherwise, preparation becomes invalid and you need to run it again.
        In some settings, invalid preparations may still give correct results (e.g. for backends that require no preparation), but this is not a semantic guarantee and should not be relied upon.

    !!! danger
        The preparation result `prep` is **not thread-safe**. Sharing it between threads may lead to unexpected behavior. If you need to run differentiation concurrently, prepare separate `prep` objects for each thread.

    When `strict=Val(true)` (the default), type checking is enforced between preparation and execution (but size checking is left to the user).
    While your code may work for different types by setting `strict=Val(false)`, this is not guaranteed by the API and can break without warning.
    """
end

function docstring_prepare!(operator)
    return """
    Same behavior as [`prepare_$(operator)`](@ref) but can resize the contents of an existing `prep` object to avoid some allocations.

    There is no guarantee that `prep` will be mutated, or that performance will be improved compared to preparation from scratch.

    !!! danger
        Compared to when `prep` was first created, the only authorized modification is a size change for input `x` or output `y`.
        Any other modification (like a change of type for the input) is not supported and will give erroneous results.

    !!! danger
        For efficiency, this function needs to rely on backend package internals, therefore it not protected by semantic versioning.
    """
end

function docstring_preparation_hint(operator::AbstractString; same_point = false)
    if same_point
        return "To improve performance via operator preparation, refer to [`prepare_$(operator)`](@ref) and [`prepare_$(operator)_same_point`](@ref)."
    else
        return "To improve performance via operator preparation, refer to [`prepare_$(operator)`](@ref)."
    end
end

## Pushforward

struct ForwardDiffTwoArgPushforwardPrep{SIG, T, X, Y, CD} <: DI.PushforwardPrep{SIG}
    _sig::Val{SIG}
    _t::Type{T}
    xdual_tmp::X
    ydual_tmp::Y
    contexts_dual::CD
end

function DI.prepare_pushforward_nokwarg(
        strict::Val,
        f!::F,
        y,
        backend::AutoForwardDiff,
        x,
        tx::NTuple{B},
        contexts::Vararg{DI.Context, C}
    ) where {F, B, C}
    _sig = DI.signature(f!, y, backend, x, tx, contexts...; strict)
    T = tag_type(f!, backend, x)
    xdual_tmp = make_dual_similar(T, x, tx)
    ydual_tmp = make_dual_similar(T, y, tx)  # tx only for batch size
    contexts_dual = translate_toprep(eltype(xdual_tmp), contexts)
    return ForwardDiffTwoArgPushforwardPrep(_sig, T, xdual_tmp, ydual_tmp, contexts_dual)
end

function compute_ydual_twoarg(
        f!::F,
        y,
        prep::ForwardDiffTwoArgPushforwardPrep{SIG, T},
        x::Number,
        tx::NTuple{B},
        contexts::Vararg{DI.Context, C},
    ) where {F, SIG, T, B, C}
    (; ydual_tmp) = prep
    xdual_tmp = make_dual(T, x, tx)
    contexts_dual = translate_prepared(contexts, prep.contexts_dual)
    f!(ydual_tmp, xdual_tmp, contexts_dual...)
    return ydual_tmp
end

function compute_ydual_twoarg(
        f!::F,
        y,
        prep::ForwardDiffTwoArgPushforwardPrep{SIG, T},
        x,
        tx::NTuple{B},
        contexts::Vararg{DI.Context, C},
    ) where {F, SIG, T, B, C}
    (; ydual_tmp) = prep
    if DI.ismutable_array(x)
        make_dual!(T, prep.xdual_tmp, x, tx)
        xdual_tmp = prep.xdual_tmp
    else
        xdual_tmp = make_dual(T, x, tx)
    end
    contexts_dual = translate_prepared(contexts, prep.contexts_dual)
    f!(ydual_tmp, xdual_tmp, contexts_dual...)
    return ydual_tmp
end

function DI.value_and_pushforward(
        f!::F,
        y,
        prep::ForwardDiffTwoArgPushforwardPrep{SIG, T},
        backend::AutoForwardDiff,
        x,
        tx::NTuple{B},
        contexts::Vararg{DI.Context, C},
    ) where {F, SIG, T, B, C}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    ydual_tmp = compute_ydual_twoarg(f!, y, prep, x, tx, contexts...)
    myvalue!(T, y, ydual_tmp)
    ty = mypartials(T, Val(B), ydual_tmp)
    return y, ty
end

function DI.value_and_pushforward!(
        f!::F,
        y,
        ty::NTuple,
        prep::ForwardDiffTwoArgPushforwardPrep{SIG, T},
        backend::AutoForwardDiff,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {F, SIG, T, C}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    ydual_tmp = compute_ydual_twoarg(f!, y, prep, x, tx, contexts...)
    myvalue!(T, y, ydual_tmp)
    mypartials!(T, ty, ydual_tmp)
    return y, ty
end

function DI.pushforward(
        f!::F,
        y,
        prep::ForwardDiffTwoArgPushforwardPrep{SIG, T},
        backend::AutoForwardDiff,
        x,
        tx::NTuple{B},
        contexts::Vararg{DI.Context, C},
    ) where {F, SIG, T, B, C}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    ydual_tmp = compute_ydual_twoarg(f!, y, prep, x, tx, contexts...)
    ty = mypartials(T, Val(B), ydual_tmp)
    return ty
end

function DI.pushforward!(
        f!::F,
        y,
        ty::NTuple,
        prep::ForwardDiffTwoArgPushforwardPrep{SIG, T},
        backend::AutoForwardDiff,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {F, SIG, T, C}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    ydual_tmp = compute_ydual_twoarg(f!, y, prep, x, tx, contexts...)
    mypartials!(T, ty, ydual_tmp)
    return ty
end

## Derivative

### Unprepared, only when tag is not specified

function DI.value_and_derivative(
        f!::F, y, backend::AutoForwardDiff{chunksize, T}, x, contexts::Vararg{DI.Context, C}
    ) where {F, C, chunksize, T}
    if (T === Nothing && contexts isa NTuple{C, DI.GeneralizedConstant})
        fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
        result = MutableDiffResult(y, (similar(y),))
        result = derivative!(result, fc!, y, x)
        return DiffResults.value(result), DiffResults.derivative(result)
    else
        prep = DI.prepare_derivative_nokwarg(Val(true), f!, y, backend, x, contexts...)
        return DI.value_and_derivative(f!, y, prep, backend, x, contexts...)
    end
end

function DI.value_and_derivative!(
        f!::F, y, der, backend::AutoForwardDiff{chunksize, T}, x, contexts::Vararg{DI.Context, C}
    ) where {F, C, chunksize, T}
    if (T === Nothing && contexts isa NTuple{C, DI.GeneralizedConstant})
        fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
        result = MutableDiffResult(y, (der,))
        result = derivative!(result, fc!, y, x)
        return DiffResults.value(result), DiffResults.derivative(result)
    else
        prep = DI.prepare_derivative_nokwarg(Val(true), f!, y, backend, x, contexts...)
        return DI.value_and_derivative!(f!, y, der, prep, backend, x, contexts...)
    end
end

function DI.derivative(
        f!::F, y, backend::AutoForwardDiff{chunksize, T}, x, contexts::Vararg{DI.Context, C}
    ) where {F, C, chunksize, T}
    if (T === Nothing && contexts isa NTuple{C, DI.GeneralizedConstant})
        fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
        return derivative(fc!, y, x)
    else
        prep = DI.prepare_derivative_nokwarg(Val(true), f!, y, backend, x, contexts...)
        return DI.derivative(f!, y, prep, backend, x, contexts...)
    end
end

function DI.derivative!(
        f!::F, y, der, backend::AutoForwardDiff{chunksize, T}, x, contexts::Vararg{DI.Context, C}
    ) where {F, C, chunksize, T}
    if (T === Nothing && contexts isa NTuple{C, DI.GeneralizedConstant})
        fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
        return derivative!(der, fc!, y, x)
    else
        prep = DI.prepare_derivative_nokwarg(Val(true), f!, y, backend, x, contexts...)
        return DI.derivative!(f!, y, der, prep, backend, x, contexts...)
    end
end

### Prepared

struct ForwardDiffTwoArgDerivativePrep{SIG, X, C, CD} <: DI.DerivativePrep{SIG}
    _sig::Val{SIG}
    x::X
    config::C
    contexts_dual::CD
end

function DI.prepare_derivative_nokwarg(
        strict::Val, f!::F, y, backend::AutoForwardDiff, x::X, contexts::Vararg{DI.Context, C}
    ) where {F, C, X}
    _sig = DI.signature(f!, y, backend, x, contexts...; strict)
    tag = get_tag(f!, backend, x)
    config = DerivativeConfig(nothing, y, x, tag)
    contexts_dual = translate_toprep(dual_type(config), contexts)
    return ForwardDiffTwoArgDerivativePrep(_sig, copy(x), config, contexts_dual)
end

function DI.prepare!_derivative(
        f!::F,
        y,
        old_prep::ForwardDiffTwoArgDerivativePrep,
        backend::AutoForwardDiff,
        x,
        contexts::Vararg{DI.GeneralizedConstant, C},
    ) where {F, C}
    DI.check_prep(f!, y, old_prep, backend, x, contexts...)
    if y isa Vector
        (; config) = old_prep
        resize!(config.duals, length(y))
        return old_prep
    else
        return DI.prepare_derivative_nokwarg(
            DI.is_strict(old_prep), f!, y, backend, x, contexts...
        )
    end
end

function DI.value_and_derivative(
        f!::F,
        y,
        prep::ForwardDiffTwoArgDerivativePrep,
        backend::AutoForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    contexts_dual = translate_prepared(contexts, prep.contexts_dual)
    fc! = DI.fix_tail(f!, contexts_dual...)
    result = MutableDiffResult(y, (similar(y),))
    CHK = tag_type(backend) === Nothing
    if CHK
        checktag(prep.config, f!, x)
    end
    result = derivative!(result, fc!, y, x, prep.config, Val(false))
    return DiffResults.value(result), DiffResults.derivative(result)
end

function DI.value_and_derivative!(
        f!::F,
        y,
        der,
        prep::ForwardDiffTwoArgDerivativePrep,
        backend::AutoForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    contexts_dual = translate_prepared(contexts, prep.contexts_dual)
    fc! = DI.fix_tail(f!, contexts_dual...)
    result = MutableDiffResult(y, (der,))
    CHK = tag_type(backend) === Nothing
    if CHK
        checktag(prep.config, f!, x)
    end
    result = derivative!(result, fc!, y, x, prep.config, Val(false))
    return DiffResults.value(result), DiffResults.derivative(result)
end

function DI.derivative(
        f!::F,
        y,
        prep::ForwardDiffTwoArgDerivativePrep,
        backend::AutoForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    contexts_dual = translate_prepared(contexts, prep.contexts_dual)
    fc! = DI.fix_tail(f!, contexts_dual...)
    CHK = tag_type(backend) === Nothing
    if CHK
        checktag(prep.config, f!, x)
    end
    return derivative(fc!, y, x, prep.config, Val(false))
end

function DI.derivative!(
        f!::F,
        y,
        der,
        prep::ForwardDiffTwoArgDerivativePrep,
        backend::AutoForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    contexts_dual = translate_prepared(contexts, prep.contexts_dual)
    fc! = DI.fix_tail(f!, contexts_dual...)
    CHK = tag_type(backend) === Nothing
    if CHK
        checktag(prep.config, f!, x)
    end
    return derivative!(der, fc!, y, x, prep.config, Val(false))
end

## Jacobian

### Unprepared, only when chunk size and tag are not specified

function DI.value_and_jacobian(
        f!::F, y, backend::AutoForwardDiff{chunksize, T}, x, contexts::Vararg{DI.Context, C}
    ) where {F, C, chunksize, T}
    if (
            isnothing(chunksize) &&
                T === Nothing &&
                contexts isa NTuple{C, DI.GeneralizedConstant}
        )
        fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
        jac = similar(y, length(y), length(x))
        result = MutableDiffResult(y, (jac,))
        result = jacobian!(result, fc!, y, x)
        return DiffResults.value(result), DiffResults.jacobian(result)
    else
        prep = DI.prepare_jacobian_nokwarg(Val(true), f!, y, backend, x, contexts...)
        return DI.value_and_jacobian(f!, y, prep, backend, x, contexts...)
    end
end

function DI.value_and_jacobian!(
        f!::F, y, jac, backend::AutoForwardDiff{chunksize, T}, x, contexts::Vararg{DI.Context, C}
    ) where {F, C, chunksize, T}
    if (
            isnothing(chunksize) &&
                T === Nothing &&
                contexts isa NTuple{C, DI.GeneralizedConstant}
        )
        fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
        result = MutableDiffResult(y, (jac,))
        result = jacobian!(result, fc!, y, x)
        return DiffResults.value(result), DiffResults.jacobian(result)
    else
        prep = DI.prepare_jacobian_nokwarg(Val(true), f!, y, backend, x, contexts...)
        return DI.value_and_jacobian!(f!, y, jac, prep, backend, x, contexts...)
    end
end

function DI.jacobian(
        f!::F, y, backend::AutoForwardDiff{chunksize, T}, x, contexts::Vararg{DI.Context, C}
    ) where {F, C, chunksize, T}
    if (
            isnothing(chunksize) &&
                T === Nothing &&
                contexts isa NTuple{C, DI.GeneralizedConstant}
        )
        fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
        return jacobian(fc!, y, x)
    else
        prep = DI.prepare_jacobian_nokwarg(Val(true), f!, y, backend, x, contexts...)
        return DI.jacobian(f!, y, prep, backend, x, contexts...)
    end
end

function DI.jacobian!(
        f!::F, y, jac, backend::AutoForwardDiff{chunksize, T}, x, contexts::Vararg{DI.Context, C}
    ) where {F, C, chunksize, T}
    if (
            isnothing(chunksize) &&
                T === Nothing &&
                contexts isa NTuple{C, DI.GeneralizedConstant}
        )
        fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
        return jacobian!(jac, fc!, y, x)
    else
        prep = DI.prepare_jacobian_nokwarg(Val(true), f!, y, backend, x, contexts...)
        return DI.jacobian!(f!, y, jac, prep, backend, x, contexts...)
    end
end

### Prepared

struct ForwardDiffTwoArgJacobianPrep{SIG, C, CD} <: DI.JacobianPrep{SIG}
    _sig::Val{SIG}
    config::C
    contexts_dual::CD
end

function DI.prepare_jacobian_nokwarg(
        strict::Val, f!::F, y, backend::AutoForwardDiff, x, contexts::Vararg{DI.Context, C}
    ) where {F, C}
    _sig = DI.signature(f!, y, backend, x, contexts...; strict)
    chunk = choose_chunk(backend, x)
    tag = get_tag(f!, backend, x)
    config = JacobianConfig(nothing, y, x, chunk, tag)
    contexts_dual = translate_toprep(dual_type(config), contexts)
    return ForwardDiffTwoArgJacobianPrep(_sig, config, contexts_dual)
end

function DI.prepare!_jacobian(
        f!::F,
        y,
        old_prep::ForwardDiffTwoArgJacobianPrep,
        backend::AutoForwardDiff,
        x,
        contexts::Vararg{DI.GeneralizedConstant, C},
    ) where {F, C}
    DI.check_prep(f!, y, old_prep, backend, x, contexts...)
    if x isa Vector && y isa Vector
        (; config) = old_prep
        (yduals, xduals) = config.duals
        resize!(yduals, length(y))
        resize!(xduals, length(x))
        return old_prep
    else
        return DI.prepare_jacobian_nokwarg(
            DI.is_strict(old_prep), f!, y, backend, x, contexts...
        )
    end
end

function DI.value_and_jacobian(
        f!::F,
        y,
        prep::ForwardDiffTwoArgJacobianPrep,
        backend::AutoForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    contexts_dual = translate_prepared(contexts, prep.contexts_dual)
    fc! = DI.fix_tail(f!, contexts_dual...)
    jac = similar(y, length(y), length(x))
    result = MutableDiffResult(y, (jac,))
    CHK = tag_type(backend) === Nothing
    if CHK
        checktag(prep.config, f!, x)
    end
    result = jacobian!(result, fc!, y, x, prep.config, Val(false))
    return DiffResults.value(result), DiffResults.jacobian(result)
end

function DI.value_and_jacobian!(
        f!::F,
        y,
        jac,
        prep::ForwardDiffTwoArgJacobianPrep,
        backend::AutoForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    contexts_dual = translate_prepared(contexts, prep.contexts_dual)
    fc! = DI.fix_tail(f!, contexts_dual...)
    result = MutableDiffResult(y, (jac,))
    CHK = tag_type(backend) === Nothing
    if CHK
        checktag(prep.config, f!, x)
    end
    result = jacobian!(result, fc!, y, x, prep.config, Val(false))
    return DiffResults.value(result), DiffResults.jacobian(result)
end

function DI.jacobian(
        f!::F,
        y,
        prep::ForwardDiffTwoArgJacobianPrep,
        backend::AutoForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    contexts_dual = translate_prepared(contexts, prep.contexts_dual)
    fc! = DI.fix_tail(f!, contexts_dual...)
    CHK = tag_type(backend) === Nothing
    if CHK
        checktag(prep.config, f!, x)
    end
    return jacobian(fc!, y, x, prep.config, Val(false))
end

function DI.jacobian!(
        f!::F,
        y,
        jac,
        prep::ForwardDiffTwoArgJacobianPrep,
        backend::AutoForwardDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    contexts_dual = translate_prepared(contexts, prep.contexts_dual)
    fc! = DI.fix_tail(f!, contexts_dual...)
    CHK = tag_type(backend) === Nothing
    if CHK
        checktag(prep.config, f!, x)
    end
    return jacobian!(jac, fc!, y, x, prep.config, Val(false))
end

module DifferentiationInterfaceMooncakeExt

using ADTypes: ADTypes, AutoMooncake, AutoMooncakeForward
import DifferentiationInterface as DI
using Mooncake:
    Mooncake,
    CoDual,
    Config,
    Dual,
    prepare_derivative_cache,
    prepare_gradient_cache,
    prepare_pullback_cache,
    primal,
    tangent,
    tangent_type,
    value_and_derivative!!,
    value_and_gradient!!,
    value_and_pullback!!,
    zero_dual,
    zero_tangent,
    rdata_type,
    fdata,
    rdata,
    tangent_type,
    NoTangent,
    @is_primitive,
    zero_fcodual,
    MinimalCtx,
    NoRData,
    primal,
    _copy_output,
    _copy_to_output!!

const AnyAutoMooncake{C} = Union{AutoMooncake{C}, AutoMooncakeForward{C}}

DI.check_available(::AnyAutoMooncake{C}) where {C} = true
DI.inner_preparation_behavior(::AutoMooncakeForward) = DI.PrepareInnerSimple()

@inline new_friendly_tangents() = isdefined(Mooncake, :FriendlyTangentCache)

include("utils.jl")
include("counterparts.jl")
include("onearg.jl")
include("twoarg.jl")
include("forward_onearg.jl")
include("forward_twoarg.jl")
include("differentiate_with.jl")

end

## Docstrings

"""
    prepare_second_derivative(f, backend, x, [contexts...]; strict=Val(true)) -> prep

$(docstring_prepare("second_derivative"))
"""
function prepare_second_derivative(
        f::F, backend::AbstractADType, x, contexts::Vararg{Context, C}; strict::Val = Val(true)
    ) where {F, C}
    return prepare_second_derivative_nokwarg(strict, f, backend, x, contexts...)
end

"""
    prepare!_second_derivative(f, prep, backend, x, [contexts...]) -> new_prep

$(docstring_prepare!("second_derivative"))
"""
function prepare!_second_derivative(
        f::F,
        old_prep::SecondDerivativePrep,
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C}
    ) where {F, C}
    check_prep(f, old_prep, backend, x, contexts...)
    return prepare_second_derivative_nokwarg(
        is_strict(old_prep), f, backend, x, contexts...
    )
end

"""
    second_derivative(f, [prep,] backend, x, [contexts...]) -> der2

Compute the second derivative of the function `f` at point `x`.

$(docstring_preparation_hint("second_derivative"))
"""
function second_derivative(
        f::F, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_second_derivative_nokwarg(Val(true), f, backend, x, contexts...)
    return second_derivative(f, prep, backend, x, contexts...)
end

"""
    second_derivative!(f, der2, [prep,] backend, x, [contexts...]) -> der2

Compute the second derivative of the function `f` at point `x`, overwriting `der2`.

$(docstring_preparation_hint("second_derivative"))
"""
function second_derivative!(
        f::F, der2, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_second_derivative_nokwarg(Val(true), f, backend, x, contexts...)
    return second_derivative!(f, der2, prep, backend, x, contexts...)
end

"""
    value_derivative_and_second_derivative(f, [prep,] backend, x, [contexts...]) -> (y, der, der2)

Compute the value, first derivative and second derivative of the function `f` at point `x`.

$(docstring_preparation_hint("second_derivative"))
"""
function value_derivative_and_second_derivative(
        f::F, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_second_derivative_nokwarg(Val(true), f, backend, x, contexts...)
    return value_derivative_and_second_derivative(f, prep, backend, x, contexts...)
end

"""
    value_derivative_and_second_derivative!(f, der, der2, [prep,] backend, x, [contexts...]) -> (y, der, der2)

Compute the value, first derivative and second derivative of the function `f` at point `x`, overwriting `der` and `der2`.

$(docstring_preparation_hint("second_derivative"))
"""
function value_derivative_and_second_derivative!(
        f::F, der, der2, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_second_derivative_nokwarg(Val(true), f, backend, x, contexts...)
    return value_derivative_and_second_derivative!(
        f, der, der2, prep, backend, x, contexts...
    )
end

## Preparation

struct DerivativeSecondDerivativePrep{SIG, E <: DerivativePrep} <: SecondDerivativePrep{SIG}
    _sig::Val{SIG}
    outer_derivative_prep::E
end

function prepare_second_derivative_nokwarg(
        strict::Val, f::F, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    _sig = signature(f, backend, x, contexts...; strict)
    rewrap = Rewrap(contexts...)
    new_contexts = (
        FunctionContext(f), Constant(inner(backend)), Constant(rewrap), contexts...,
    )
    outer_derivative_prep = prepare_derivative_nokwarg(
        strict, shuffled_derivative, outer(backend), x, new_contexts...
    )
    return DerivativeSecondDerivativePrep(_sig, outer_derivative_prep)
end

## One argument

function second_derivative(
        f::F,
        prep::DerivativeSecondDerivativePrep,
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, contexts...)
    (; outer_derivative_prep) = prep
    rewrap = Rewrap(contexts...)
    new_contexts = (
        FunctionContext(f), Constant(inner(backend)), Constant(rewrap), contexts...,
    )
    return derivative(
        shuffled_derivative, outer_derivative_prep, outer(backend), x, new_contexts...
    )
end

function value_derivative_and_second_derivative(
        f::F,
        prep::DerivativeSecondDerivativePrep,
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, contexts...)
    (; outer_derivative_prep) = prep
    rewrap = Rewrap(contexts...)
    new_contexts = (
        FunctionContext(f), Constant(inner(backend)), Constant(rewrap), contexts...,
    )
    y = f(x, map(unwrap, contexts)...)
    der, der2 = value_and_derivative(
        shuffled_derivative, outer_derivative_prep, outer(backend), x, new_contexts...
    )
    return y, der, der2
end

function second_derivative!(
        f::F,
        der2,
        prep::SecondDerivativePrep,
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, contexts...)
    (; outer_derivative_prep) = prep
    rewrap = Rewrap(contexts...)
    new_contexts = (
        FunctionContext(f), Constant(inner(backend)), Constant(rewrap), contexts...,
    )
    return derivative!(
        shuffled_derivative, der2, outer_derivative_prep, outer(backend), x, new_contexts...
    )
end

function value_derivative_and_second_derivative!(
        f::F,
        der,
        der2,
        prep::SecondDerivativePrep,
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, contexts...)
    (; outer_derivative_prep) = prep
    rewrap = Rewrap(contexts...)
    new_contexts = (
        FunctionContext(f), Constant(inner(backend)), Constant(rewrap), contexts...,
    )
    y = f(x, map(unwrap, contexts)...)
    new_der, _ = value_and_derivative!(
        shuffled_derivative, der2, outer_derivative_prep, outer(backend), x, new_contexts...
    )
    return y, copyto!(der, new_der), der2
end

pre_basis(a::AbstractArray{T}) where {T} = fill!(similar(a), zero(T))

function post_basis(b::AbstractArray, a::AbstractArray)
    if ismutable_array(a)
        return b
    else
        return map(+, zero(a), b)
    end
end

"""
    basis(a::AbstractArray, i)

Construct the `i`-th standard basis array in the vector space of `a`.
"""
function basis(a::AbstractArray, i)
    b = pre_basis(a)
    b[i] = oneunit(eltype(b))
    return post_basis(b, a)
end

# compatible with zero-length vectors
function basis(a::AbstractArray)
    b = pre_basis(a)
    return post_basis(b, a)
end

"""
    multibasis(a::AbstractArray, inds)

Construct the sum of the `i`-th standard basis arrays in the vector space of `a` for all `i ∈ inds`.
"""
function multibasis(a::AbstractArray, inds)
    b = pre_basis(a)
    for i in inds
        b[i] = oneunit(eltype(b))
    end
    return post_basis(b, a)
end

## Pushforward

# Input: Contains either a single pre-allocated initial TPS
# or a vector of pre-allocated TPSs.
#
# Output: Contains a vector of pre-allocated TPSs
struct GTPSATwoArgPushforwardPrep{SIG, X, Y} <: DI.PushforwardPrep{SIG}
    _sig::Val{SIG}
    xt::X
    yt::Y
end

function DI.prepare_pushforward_nokwarg(
        strict::Val,
        f!::F,
        y,
        backend::AutoGTPSA{D},
        x,
        tx::NTuple,
        contexts::Vararg{DI.Constant, C}
    ) where {F, D, C}
    _sig = DI.signature(f!, y, backend, x, tx, contexts...; strict)
    # For pushforward/JVP, we only actually need 1 single variable (in the GTPSA sense)
    # because we even if we did multiple we will add up the derivatives of each at the end.
    if D != Nothing
        d = backend.descriptor
    else
        d = Descriptor(1, 1) # 1 variable to first order
    end
    if x isa Number
        xt = TPS{promote_type(typeof(first(tx)), typeof(x), Float64)}(; use = d)
    else
        xt = similar(x, TPS{promote_type(eltype(first(tx)), eltype(x), Float64)})
        for i in eachindex(xt)
            xt[i] = TPS{promote_type(eltype(first(tx)), eltype(x), Float64)}(; use = d)
        end
    end

    yt = similar(y, TPS{promote_type(eltype(y), Float64)})

    for i in eachindex(yt)
        yt[i] = TPS{promote_type(eltype(y), Float64)}(; use = d)
    end
    return GTPSATwoArgPushforwardPrep(_sig, xt, yt)
end

function DI.pushforward(
        f!,
        y,
        prep::GTPSATwoArgPushforwardPrep,
        backend::AutoGTPSA,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Constant, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
    ty = map(tx) do dx
        foreach((t, xi, dxi) -> (t[0] = xi; t[1] = dxi), prep.xt, x, dx)
        fc!(prep.yt, prep.xt)
        dy = map(t -> t[1], prep.yt)
        return dy
    end
    map!(t -> t[0], y, prep.yt)
    return ty
end

function DI.pushforward!(
        f!,
        y,
        ty::NTuple,
        prep::GTPSATwoArgPushforwardPrep,
        backend::AutoGTPSA,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Constant, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
    for b in eachindex(tx, ty)
        dx, dy = tx[b], ty[b]
        foreach((t, xi, dxi) -> (t[0] = xi; t[1] = dxi), prep.xt, x, dx)
        fc!(prep.yt, prep.xt)
        map!(t -> t[1], dy, prep.yt)
    end
    map!(t -> t[0], y, prep.yt)
    return ty
end

function DI.value_and_pushforward(
        f!,
        y,
        prep::GTPSATwoArgPushforwardPrep,
        backend::AutoGTPSA,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Constant, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    ty = DI.pushforward(f!, y, prep, backend, x, tx, contexts...)
    return y, ty
end

function DI.value_and_pushforward!(
        f!,
        y,
        ty::NTuple,
        prep::GTPSATwoArgPushforwardPrep,
        backend::AutoGTPSA,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Constant, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    DI.pushforward!(f!, y, ty, prep, backend, x, tx, contexts...)
    return y, ty
end

## Jacobian
# Input: Contains a vector of pre-allocated TPSs
# Output: Contains a vector of pre-allocated TPSs
struct GTPSATwoArgJacobianPrep{SIG, X, Y} <: DI.JacobianPrep{SIG}
    _sig::Val{SIG}
    xt::X
    yt::Y
end

function DI.prepare_jacobian_nokwarg(
        strict::Val, f!, y, backend::AutoGTPSA{D}, x, contexts::Vararg{DI.Constant, C}
    ) where {D, C}
    _sig = DI.signature(f!, y, backend, x, contexts...; strict)
    if D != Nothing
        d = backend.descriptor
    else
        d = Descriptor(length(x), 1) # n variables to first order
    end

    # We set the slopes of each variable to 1 here, this will always be the case for Jacobian
    xt = similar(x, TPS{promote_type(eltype(x), Float64)})
    j = 1
    for i in eachindex(xt)
        xt[i] = TPS{promote_type(eltype(x), Float64)}(; use = d)
        xt[i][j] = 1
        j += 1
    end

    yt = similar(y, TPS{promote_type(eltype(y), Float64)})

    for i in eachindex(yt)
        yt[i] = TPS{promote_type(eltype(y), Float64)}(; use = d)
    end

    return GTPSATwoArgJacobianPrep(_sig, xt, yt)
end

function DI.jacobian(
        f!,
        y,
        prep::GTPSATwoArgJacobianPrep,
        backend::AutoGTPSA,
        x,
        contexts::Vararg{DI.Constant, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    foreach((t, xi) -> t[0] = xi, prep.xt, x) # Set the scalar part
    fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
    fc!(prep.yt, prep.xt)
    jac = similar(x, GTPSA.numtype(eltype(prep.yt)), (length(prep.yt), length(x)))
    GTPSA.jacobian!(jac, prep.yt; include_params = true, unsafe_inbounds = true)
    map!(t -> t[0], y, prep.yt)
    return jac
end

function DI.jacobian!(
        f!,
        y,
        jac,
        prep::GTPSATwoArgJacobianPrep,
        backend::AutoGTPSA,
        x,
        contexts::Vararg{DI.Constant, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    foreach((t, xi) -> t[0] = xi, prep.xt, x) # Set the scalar part
    fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
    fc!(prep.yt, prep.xt)
    GTPSA.jacobian!(jac, prep.yt; include_params = true, unsafe_inbounds = true)
    map!(t -> t[0], y, prep.yt)
    return jac
end

function DI.value_and_jacobian(
        f!,
        y,
        prep::GTPSATwoArgJacobianPrep,
        backend::AutoGTPSA,
        x,
        contexts::Vararg{DI.Constant, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    jac = DI.jacobian(f!, y, prep, backend, x, contexts...) # y set on line 151
    return y, jac
end

function DI.value_and_jacobian!(
        f!,
        y,
        jac,
        prep::GTPSATwoArgJacobianPrep,
        backend::AutoGTPSA,
        x,
        contexts::Vararg{DI.Constant, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    DI.jacobian!(f!, y, jac, prep, backend, x, contexts...)
    return y, jac
end

const AnyDuplicated = Union{
    Duplicated,
    MixedDuplicated,
    BatchDuplicated,
    BatchMixedDuplicated,
    DuplicatedNoNeed,
    BatchDuplicatedNoNeed,
}

# until https://github.com/EnzymeAD/Enzyme.jl/pull/1545 is merged
function DI.pick_batchsize(::AutoEnzyme, N::Integer)
    B = DI.reasonable_batchsize(N, 16)
    return DI.BatchSizeSettings{B}(N)
end

to_val(::DI.BatchSizeSettings{B}) where {B} = Val(B)

## Annotations

function get_f_and_df_prepared!(_df, f::F, ::AutoEnzyme{M, Nothing}, ::Val{B}) where {F, M, B}
    return f
end

function get_f_and_df_prepared!(_df, f::F, ::AutoEnzyme{M, <:Const}, ::Val{B}) where {F, M, B}
    return Const(f)
end

function get_f_and_df_prepared!(
        df, f::F, ::AutoEnzyme{M, <:AnyDuplicated}, ::Val{B}
    ) where {F, M, B}
    if isnothing(df)
        return Const(f)
    else
        if B == 1
            return Duplicated(f, df)
        else
            return BatchDuplicated(f, df)
        end
    end
end

function function_shadow(
        ::F, ::AutoEnzyme{M, <:Union{Const, Nothing}}, ::Mode, ::Val{B}
    ) where {M, B, F}
    return nothing
end

function function_shadow(f::F, ::AutoEnzyme{M, <:AnyDuplicated}, mode::Mode, ::Val{B}) where {F, M, B}
    IA = guess_activity(F, mode)
    return if IA <: Const
        nothing
    else
        if B == 1
            return make_zero(f)
        else
            return ntuple(_ -> make_zero(f), Val(B))
        end
    end
end

force_annotation(f::F) where {F <: Annotation} = f
force_annotation(f::F) where {F} = Const(f)

function _shadow(::AutoEnzyme, ::Mode, ::Val{B}, c_wrapped::DI.Constant) where {B}
    return nothing
end

function _shadow(::AutoEnzyme, ::Mode, ::Val{B}, c_wrapped::DI.Cache) where {B}
    c = DI.unwrap(c_wrapped)
    if B == 1
        return make_zero(c)
    else
        return ntuple(_ -> make_zero(c), Val(B))
    end
end

function _shadow(
        ::AutoEnzyme, mode::Mode, valB::Val{B}, c_wrapped::DI.ConstantOrCache
    ) where {B}
    c = DI.unwrap(c_wrapped)
    IA = guess_activity(typeof(c), mode)
    return if IA <: Const
        nothing
    else
        if B == 1
            return make_zero(c)
        else
            return ntuple(_ -> make_zero(c), Val(B))
        end
    end
end

function _shadow(
        backend::AutoEnzyme,
        mode::Mode,
        ::Val{B},
        c_wrapped::DI.FunctionContext,
    ) where {B}
    f = DI.unwrap(c_wrapped)
    return function_shadow(f, backend, mode, Val(B))
end

function make_context_shadows(
        backend::AutoEnzyme, mode::Mode, ::Val{B}, contexts::Vararg{DI.Context, C}
    ) where {B, C}
    context_shadows = map(contexts) do c_wrapped
        _shadow(backend, mode, Val(B), c_wrapped)
    end
    return context_shadows
end

function _translate_prepared!(dc, c_wrapped::DI.Constant, ::Val{B}) where {B}
    c = DI.unwrap(c_wrapped)
    return Const(c)
end

function _translate_prepared!(dc, c_wrapped::DI.Cache, ::Val{B}) where {B}
    c = DI.unwrap(c_wrapped)
    if B == 1
        return Duplicated(c, dc)
    else
        return BatchDuplicated(c, dc)
    end
end

function _translate_prepared!(
        dc, c_wrapped::Union{DI.ConstantOrCache, DI.FunctionContext}, ::Val{B}
    ) where {B}
    c = DI.unwrap(c_wrapped)
    if isnothing(dc)
        return Const(c)
    else
        if B == 1
            return Duplicated(c, dc)
        else
            return BatchDuplicated(c, dc)
        end
    end
end

function translate_prepared!(
        context_shadows::NTuple{C, Any}, contexts::NTuple{C, DI.Context}, ::Val{B}
    ) where {B, C}
    new_contexts = map(context_shadows, contexts) do dc, c_wrapped
        _translate_prepared!(dc, c_wrapped, Val(B))
    end
    return new_contexts
end

## Modes

forward_noprimal(backend::AutoEnzyme{<:ForwardMode}) = NoPrimal(backend.mode)
forward_noprimal(::AutoEnzyme{Nothing}) = Forward

forward_withprimal(backend::AutoEnzyme{<:ForwardMode}) = WithPrimal(backend.mode)
forward_withprimal(::AutoEnzyme{Nothing}) = ForwardWithPrimal

reverse_noprimal(backend::AutoEnzyme{<:ReverseMode}) = NoPrimal(backend.mode)
reverse_noprimal(::AutoEnzyme{Nothing}) = Reverse

reverse_withprimal(backend::AutoEnzyme{<:ReverseMode}) = WithPrimal(backend.mode)
reverse_withprimal(::AutoEnzyme{Nothing}) = ReverseWithPrimal

function reverse_split_withprimal(backend::AutoEnzyme{<:ReverseMode})
    return set_err(WithPrimal(Split(backend.mode)), backend)
end

function reverse_split_withprimal(backend::AutoEnzyme{Nothing})
    return set_err(ReverseSplitWithPrimal, backend)
end

function set_err(mode::Mode, backend::AutoEnzyme{<:Any, Nothing})
    return EnzymeCore.set_err_if_func_written(mode)
end
set_err(mode::Mode, backend::AutoEnzyme{<:Any, <:Annotation}) = mode

function maybe_reshape(A::AbstractMatrix, m, n)
    @assert size(A) == (m, n)
    return A
end

function maybe_reshape(A::AbstractArray, m, n)
    return reshape(A, m, n)
end

annotate(::Type{Active{T}}, x, dx) where {T} = Active(x)
annotate(::Type{Duplicated{T}}, x, dx) where {T} = Duplicated(x, dx)

function annotate(::Type{BatchDuplicated{T, B}}, x, tx::NTuple{B}) where {T, B}
    return BatchDuplicated(x, tx)
end

batchify_activity(::Type{Active{T}}, ::Val{B}) where {T, B} = Active{T}
batchify_activity(::Type{Duplicated{T}}, ::Val{B}) where {T, B} = BatchDuplicated{T, B}

"""
    DifferentiateWith

Function wrapper that enforces differentiation with a "substitute" AD backend, possible different from the "true" AD backend that is called.

For instance, suppose a function `f` is not differentiable with Zygote because it involves mutation, but you know that it is differentiable with Enzyme.
Then `f2 = DifferentiateWith(f, AutoEnzyme())` is a new function that behaves like `f`, except that `f2` is differentiable with Zygote (thanks to a chain rule which calls Enzyme under the hood).
Moreover, any larger algorithm `alg` that calls `f2` instead of `f` will also be differentiable with Zygote (as long as `f` was the only Zygote blocker).

!!! tip

    This is mainly relevant for package developers who want to produce differentiable code at low cost, without writing the differentiation rules themselves.
    If you sprinkle a few `DifferentiateWith` in places where some AD backends may struggle, end users can pick from a wider variety of packages to differentiate your algorithms.

!!! warning

    `DifferentiateWith` only supports out-of-place functions `y = f(x)` without additional context arguments.
    It only makes these functions differentiable if the true backend is either [ForwardDiff](https://github.com/JuliaDiff/ForwardDiff.jl), reverse-mode [Mooncake](https://github.com/chalk-lab/Mooncake.jl), or if it automatically importing rules from [ChainRules](https://github.com/JuliaDiff/ChainRules.jl) (e.g. [Zygote](https://github.com/FluxML/Zygote.jl)). Some backends are also able to [manually import rules](https://juliadiff.org/ChainRulesCore.jl/stable/#Packages-supporting-importing-rules-from-ChainRules.) from ChainRules.
    For any other true backend, the differentiation behavior is not altered by `DifferentiateWith` (it becomes a transparent wrapper).

!!! warning

    When using `DifferentiateWith(f, AutoSomething())`, the function `f` must not close over any active data.
    As of now, we cannot differentiate with respect to parameters stored inside `f`.

# Fields

  - `f`: the function in question, with signature `f(x)`
  - `backend::AbstractADType`: the substitute backend to use for differentiation

!!! note

    For the substitute AD backend to be called under the hood, its package needs to be loaded in addition to the package of the true AD backend.

# Constructor

    DifferentiateWith(f, backend)

# Example

```jldoctest
julia> using DifferentiationInterface

julia> using FiniteDiff: FiniteDiff
       using ForwardDiff: ForwardDiff
       using Zygote: Zygote

julia> function f(x::Vector{Float64})
           a = Vector{Float64}(undef, 1)  # type constraint breaks ForwardDiff
           a[1] = sum(abs2, x)  # mutation breaks Zygote
           return a[1]
       end;

julia> f2 = DifferentiateWith(f, AutoFiniteDiff());

julia> f([3.0, 5.0]) == f2([3.0, 5.0])
true

julia> alg(x) = 7 * f2(x);

julia> ForwardDiff.gradient(alg, [3.0, 5.0])
2-element Vector{Float64}:
 42.0
 70.0

julia> Zygote.gradient(alg, [3.0, 5.0])[1]
2-element Vector{Float64}:
 42.0
 70.0
```
"""
struct DifferentiateWith{F, B <: AbstractADType}
    f::F
    backend::B
end

(dw::DifferentiateWith)(x) = dw.f(x)

function Base.show(io::IO, dw::DifferentiateWith)
    (; f, backend) = dw
    return print(
        io,
        DifferentiateWith,
        "(",
        repr(f; context = io),
        ", ",
        repr(backend; context = io),
        ")",
    )
end

using Base: get_extension
using DifferentiationInterface
import DifferentiationInterface as DI
using Documenter
using DocumenterInterLinks

using ADTypes: ADTypes
using ForwardDiff: ForwardDiff
using Zygote: Zygote

links = InterLinks(
    "ADTypes" => "https://sciml.github.io/ADTypes.jl/stable/",
    "SparseConnectivityTracer" => "https://adrianhill.de/SparseConnectivityTracer.jl/stable/",
    "SparseMatrixColorings" => "https://juliadiff.org/SparseMatrixColorings.jl/stable/",
    "Symbolics" => "https://symbolics.juliasymbolics.org/stable/",
)

readme_str = read(joinpath(@__DIR__, "..", "README.md"), String)
readme_str = replace(readme_str, "> [!CAUTION]\n> " => "!!! warning\n    ")
write(joinpath(@__DIR__, "src", "index.md"), readme_str)

makedocs(;
    modules = [DifferentiationInterface],
    authors = "Guillaume Dalle, Adrian Hill",
    sitename = "DifferentiationInterface.jl",
    format = Documenter.HTML(; assets = ["assets/favicon.ico"]),
    pages = [
        "Home" => "index.md",
        "Tutorials" => ["tutorials/basic.md", "tutorials/advanced.md"],
        "api.md",
        "Explanation" => [
            "explanation/arguments.md",
            "explanation/operators.md",
            "explanation/backends.md",
            "explanation/advanced.md",
        ],
        "FAQ" => ["faq/limitations.md", "faq/differentiability.md"],
        "Development" => [
            "dev/internals.md",
            "dev/math.md",
            "dev/contributing.md",
        ],
    ],
    plugins = [links],
)

deploydocs(;
    repo = "github.com/JuliaDiff/DifferentiationInterface.jl",
    devbranch = "main",
    dirname = "DifferentiationInterface",
    tag_prefix = "DifferentiationInterface-",
    push_preview = false,
)

module DifferentiationInterfaceFiniteDifferencesExt

using ADTypes: AutoFiniteDifferences
import DifferentiationInterface as DI
using FiniteDifferences: FiniteDifferences, grad, jacobian, jvp, j′vp
using LinearAlgebra: dot

DI.check_available(::AutoFiniteDifferences) = true
DI.inplace_support(::AutoFiniteDifferences) = DI.InPlaceNotSupported()
DI.inner_preparation_behavior(::AutoFiniteDifferences) = DI.PrepareInnerSimple()

## Pushforward

function DI.prepare_pushforward_nokwarg(
        strict::Val,
        f,
        backend::AutoFiniteDifferences,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, tx, contexts...; strict)
    return DI.NoPushforwardPrep(_sig)
end

function DI.pushforward(
        f,
        prep::DI.NoPushforwardPrep,
        backend::AutoFiniteDifferences,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    ty = map(tx) do dx
        jvp(backend.fdm, fc, (x, dx))
    end
    return ty
end

function DI.value_and_pushforward(
        f,
        prep::DI.NoPushforwardPrep,
        backend::AutoFiniteDifferences,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    return f(x, map(DI.unwrap, contexts)...),
        DI.pushforward(f, prep, backend, x, tx, contexts...)
end

## Pullback

function DI.prepare_pullback_nokwarg(
        strict::Val,
        f,
        backend::AutoFiniteDifferences,
        x,
        ty::NTuple,
        contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, ty, contexts...; strict)
    return DI.NoPullbackPrep(_sig)
end

function DI.pullback(
        f,
        prep::DI.NoPullbackPrep,
        backend::AutoFiniteDifferences,
        x,
        ty::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, ty, contexts...)
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    tx = map(ty) do dy
        only(j′vp(backend.fdm, fc, dy, x))
    end
    return tx
end

function DI.value_and_pullback(
        f,
        prep::DI.NoPullbackPrep,
        backend::AutoFiniteDifferences,
        x,
        ty::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, ty, contexts...)
    return f(x, map(DI.unwrap, contexts)...),
        DI.pullback(f, prep, backend, x, ty, contexts...)
end

## Gradient

function DI.prepare_gradient_nokwarg(
        strict::Val, f, backend::AutoFiniteDifferences, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    return DI.NoGradientPrep(_sig)
end

function DI.gradient(
        f,
        prep::DI.NoGradientPrep,
        backend::AutoFiniteDifferences,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    return only(grad(backend.fdm, fc, x))
end

function DI.value_and_gradient(
        f,
        prep::DI.NoGradientPrep,
        backend::AutoFiniteDifferences,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return f(x, map(DI.unwrap, contexts)...), DI.gradient(f, prep, backend, x, contexts...)
end

function DI.gradient!(
        f,
        grad,
        prep::DI.NoGradientPrep,
        backend::AutoFiniteDifferences,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return copyto!(grad, DI.gradient(f, prep, backend, x, contexts...))
end

function DI.value_and_gradient!(
        f,
        grad,
        prep::DI.NoGradientPrep,
        backend::AutoFiniteDifferences,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    y, new_grad = DI.value_and_gradient(f, prep, backend, x, contexts...)
    return y, copyto!(grad, new_grad)
end

## Jacobian

function DI.prepare_jacobian_nokwarg(
        strict::Val, f, backend::AutoFiniteDifferences, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    return DI.NoJacobianPrep(_sig)
end

function DI.jacobian(
        f,
        prep::DI.NoJacobianPrep,
        backend::AutoFiniteDifferences,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    return only(jacobian(backend.fdm, fc, x))
end

function DI.value_and_jacobian(
        f,
        prep::DI.NoJacobianPrep,
        backend::AutoFiniteDifferences,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return f(x, map(DI.unwrap, contexts)...), DI.jacobian(f, prep, backend, x, contexts...)
end

function DI.jacobian!(
        f,
        jac,
        prep::DI.NoJacobianPrep,
        backend::AutoFiniteDifferences,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return copyto!(jac, DI.jacobian(f, prep, backend, x, contexts...))
end

function DI.value_and_jacobian!(
        f,
        jac,
        prep::DI.NoJacobianPrep,
        backend::AutoFiniteDifferences,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    y, new_jac = DI.value_and_jacobian(f, prep, backend, x, contexts...)
    return y, copyto!(jac, new_jac)
end

end

include("../../testutils.jl")

using DifferentiationInterface, DifferentiationInterfaceTest
import DifferentiationInterface as DI
import DifferentiationInterfaceTest as DIT
using ExplicitImports
using HyperHessians
import JET
using Test

check_no_implicit_imports(DifferentiationInterface)

backends = [
    DI.AutoHyperHessians(),
    DI.AutoHyperHessians(; chunksize = 4),
]

for backend in backends
    @test DI.check_available(backend)
    @test !DI.check_inplace(backend)
    test_counterparts(backend)
end

scenarios = default_scenarios(; include_constantified = true, include_cachified = true)

test_differentiation(
    backends, scenarios;
    excluded = FIRST_ORDER, logging = LOGGING,
)

test_differentiation(
    DI.AutoHyperHessians(), scenarios;
    correctness = false,
    type_stability = safetypestab(:prepared),
    excluded = FIRST_ORDER,
    logging = LOGGING,
)

using ADTypes
using DifferentiationInterface
using DifferentiationInterface: required_packages
using Test

backend = SecondOrder(AutoForwardDiff(), AutoZygote())
@test string(backend) == "SecondOrder(AutoForwardDiff(), AutoZygote())"

detector = DenseSparsityDetector(AutoForwardDiff(); atol = 1.0e-23)
@test string(detector) ==
    "DenseSparsityDetector(AutoForwardDiff(); atol=1.0e-23, method=:iterative)"

diffwith = DifferentiateWith(exp, AutoForwardDiff())
@test string(diffwith) == "DifferentiateWith(exp, AutoForwardDiff())"

@test required_packages(AutoForwardDiff()) == ["ForwardDiff"]
@test required_packages(AutoZygote()) == ["Zygote"]
@test required_packages(AutoSparse(AutoForwardDiff())) ==
    ["ForwardDiff", "SparseMatrixColorings"]
@test required_packages(SecondOrder(AutoForwardDiff(), AutoZygote())) ==
    ["ForwardDiff", "Zygote"]
@test required_packages(MixedMode(AutoForwardDiff(), AutoZygote())) ==
    ["ForwardDiff", "Zygote"]

### A Pluto.jl notebook ###
# v0.19.41

using Markdown
using InteractiveUtils

# ╔═╡ 1f172822-03b3-11ef-2c76-5164aefd5c71
begin
    using Luxor
    using Colors
end

# ╔═╡ d1b44dac-8487-4581-82fd-ece0ce89f8e2
begin
    const purple = Luxor.julia_purple
    const red = Luxor.julia_red
    const green = Luxor.julia_green
    const blue = Luxor.julia_blue
    const white = RGB(1, 1, 1)
    const black = RGB(0, 0, 0)
    const colors = (purple, red, green)
end;

# ╔═╡ 0ab9b560-28f3-490f-9983-ced5a6cae7ec
logo = begin
    Drawing(200, 200, "logo.svg")
    origin()
    scale(3.4)

    fontface("Arial Bold")
    fontsize(50)

    # Define center points and corners of triangle
    center = Point(0, 4)
    corners = ngon(center, 16, 3, -0.75π / 2; vertices = true)

    # Draw three blended partials
    for (i, c) in enumerate(corners)
        b = blend(c, 0, center, 50, colors[i], black)
        setblend(b)
        text("∂", c; valign = :middle, halign = :center, angle = 0.68π + 2π / 3 * i)
    end

    finish()
    preview()
end

# ╔═╡ 69d0fa4d-2585-42a0-981f-99d43f7e2c1f
md"## Creating Favicons
Using Imagemagick, run
```bash
convert -background transparent logo.svg -define icon:auto-resize=256,128,48,32,16 favicon.ico
```
"

# ╔═╡ 00000000-0000-0000-0000-000000000001
PLUTO_PROJECT_TOML_CONTENTS = """
[deps]
Colors = "5ae59095-9a9b-59fe-a467-6f913c188581"
Luxor = "ae8d54c2-7ccd-5906-9d76-62fc9837b5bc"

[compat]
Colors = "~0.12.10"
Luxor = "~4.0.0"
"""

# ╔═╡ 00000000-0000-0000-0000-000000000002
PLUTO_MANIFEST_TOML_CONTENTS = """
# This file is machine-generated - editing it directly is not advised

julia_version = "1.10.2"
manifest_format = "2.0"
project_hash = "9b55894a9478a2272afcfd519210f127aaf17882"

[[deps.ArgTools]]
uuid = "0dad84c5-d112-42e6-8d28-ef12dabb789f"
version = "1.1.1"

[[deps.Artifacts]]
uuid = "56f22d72-fd6d-98f1-02f0-08ddc0907c33"

[[deps.Base64]]
uuid = "2a0f44e3-6c83-55bd-87e4-b1978d98bd5f"

[[deps.Bzip2_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "9e2a6b69137e6969bab0152632dcb3bc108c8bdd"
uuid = "6e34b625-4abd-537c-b88f-471c36dfa7a0"
version = "1.0.8+1"

[[deps.Cairo]]
deps = ["Cairo_jll", "Colors", "Glib_jll", "Graphics", "Libdl", "Pango_jll"]
git-tree-sha1 = "d0b3f8b4ad16cb0a2988c6788646a5e6a17b6b1b"
uuid = "159f3aea-2a34-519c-b102-8c37f9878175"
version = "1.0.5"

[[deps.Cairo_jll]]
deps = ["Artifacts", "Bzip2_jll", "CompilerSupportLibraries_jll", "Fontconfig_jll", "FreeType2_jll", "Glib_jll", "JLLWrappers", "LZO_jll", "Libdl", "Pixman_jll", "Xorg_libXext_jll", "Xorg_libXrender_jll", "Zlib_jll", "libpng_jll"]
git-tree-sha1 = "a4c43f59baa34011e303e76f5c8c91bf58415aaf"
uuid = "83423d85-b0ee-5818-9007-b63ccbeb887a"
version = "1.18.0+1"

[[deps.ColorTypes]]
deps = ["FixedPointNumbers", "Random"]
git-tree-sha1 = "b10d0b65641d57b8b4d5e234446582de5047050d"
uuid = "3da002f7-5984-5a60-b8a6-cbb66c0b333f"
version = "0.11.5"

[[deps.Colors]]
deps = ["ColorTypes", "FixedPointNumbers", "Reexport"]
git-tree-sha1 = "fc08e5930ee9a4e03f84bfb5211cb54e7769758a"
uuid = "5ae59095-9a9b-59fe-a467-6f913c188581"
version = "0.12.10"

[[deps.Compat]]
deps = ["TOML", "UUIDs"]
git-tree-sha1 = "c955881e3c981181362ae4088b35995446298b80"
uuid = "34da2185-b29b-5c13-b0c7-acf172513d20"
version = "4.14.0"
weakdeps = ["Dates", "LinearAlgebra"]

    [deps.Compat.extensions]
    CompatLinearAlgebraExt = "LinearAlgebra"

[[deps.CompilerSupportLibraries_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "e66e0078-7015-5450-92f7-15fbd957f2ae"
version = "1.1.0+0"

[[deps.DataStructures]]
deps = ["Compat", "InteractiveUtils", "OrderedCollections"]
git-tree-sha1 = "1d0a14036acb104d9e89698bd408f63ab58cdc82"
uuid = "864edb3b-99cc-5e75-8d2d-829cb0a9cfe8"
version = "0.18.20"

[[deps.Dates]]
deps = ["Printf"]
uuid = "ade2ca70-3891-5945-98fb-dc099432e06a"

[[deps.Downloads]]
deps = ["ArgTools", "FileWatching", "LibCURL", "NetworkOptions"]
uuid = "f43a241f-c20a-4ad4-852c-f6b1247861c6"
version = "1.6.0"

[[deps.Expat_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl"]
git-tree-sha1 = "4558ab818dcceaab612d1bb8c19cee87eda2b83c"
uuid = "2e619515-83b5-522b-bb60-26c02a35a201"
version = "2.5.0+0"

[[deps.FFMPEG]]
deps = ["FFMPEG_jll"]
git-tree-sha1 = "b57e3acbe22f8484b4b5ff66a7499717fe1a9cc8"
uuid = "c87230d0-a227-11e9-1b43-d7ebe4e7570a"
version = "0.4.1"

[[deps.FFMPEG_jll]]
deps = ["Artifacts", "Bzip2_jll", "FreeType2_jll", "FriBidi_jll", "JLLWrappers", "LAME_jll", "Libdl", "Ogg_jll", "OpenSSL_jll", "Opus_jll", "PCRE2_jll", "Zlib_jll", "libaom_jll", "libass_jll", "libfdk_aac_jll", "libvorbis_jll", "x264_jll", "x265_jll"]
git-tree-sha1 = "466d45dc38e15794ec7d5d63ec03d776a9aff36e"
uuid = "b22a6f82-2f65-5046-a5b2-351ab43fb4e5"
version = "4.4.4+1"

[[deps.FileIO]]
deps = ["Pkg", "Requires", "UUIDs"]
git-tree-sha1 = "82d8afa92ecf4b52d78d869f038ebfb881267322"
uuid = "5789e2e9-d7fb-5bc7-8068-2c6fae9b9549"
version = "1.16.3"

[[deps.FileWatching]]
uuid = "7b1f6079-737a-58dc-b8bc-7a2ca5c1b5ee"

[[deps.FixedPointNumbers]]
deps = ["Statistics"]
git-tree-sha1 = "335bfdceacc84c5cdf16aadc768aa5ddfc5383cc"
uuid = "53c48c17-4a7d-5ca2-90c5-79b7896eea93"
version = "0.8.4"

[[deps.Fontconfig_jll]]
deps = ["Artifacts", "Bzip2_jll", "Expat_jll", "FreeType2_jll", "JLLWrappers", "Libdl", "Libuuid_jll", "Pkg", "Zlib_jll"]
git-tree-sha1 = "21efd19106a55620a188615da6d3d06cd7f6ee03"
uuid = "a3f928ae-7b40-5064-980b-68af3947d34b"
version = "2.13.93+0"

[[deps.FreeType2_jll]]
deps = ["Artifacts", "Bzip2_jll", "JLLWrappers", "Libdl", "Zlib_jll"]
git-tree-sha1 = "d8db6a5a2fe1381c1ea4ef2cab7c69c2de7f9ea0"
uuid = "d7e528f0-a631-5988-bf34-fe36492bcfd7"
version = "2.13.1+0"

[[deps.FriBidi_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "aa31987c2ba8704e23c6c8ba8a4f769d5d7e4f91"
uuid = "559328eb-81f9-559d-9380-de523a88c83c"
version = "1.0.10+0"

[[deps.Gettext_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "JLLWrappers", "Libdl", "Libiconv_jll", "Pkg", "XML2_jll"]
git-tree-sha1 = "9b02998aba7bf074d14de89f9d37ca24a1a0b046"
uuid = "78b55507-aeef-58d4-861c-77aaff3498b1"
version = "0.21.0+0"

[[deps.Glib_jll]]
deps = ["Artifacts", "Gettext_jll", "JLLWrappers", "Libdl", "Libffi_jll", "Libiconv_jll", "Libmount_jll", "PCRE2_jll", "Zlib_jll"]
git-tree-sha1 = "359a1ba2e320790ddbe4ee8b4d54a305c0ea2aff"
uuid = "7746bdde-850d-59dc-9ae8-88ece973131d"
version = "2.80.0+0"

[[deps.Graphics]]
deps = ["Colors", "LinearAlgebra", "NaNMath"]
git-tree-sha1 = "d61890399bc535850c4bf08e4e0d3a7ad0f21cbd"
uuid = "a2bd30eb-e257-5431-a919-1863eab51364"
version = "1.1.2"

[[deps.Graphite2_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "344bf40dcab1073aca04aa0df4fb092f920e4011"
uuid = "3b182d85-2403-5c21-9c21-1e1f0cc25472"
version = "1.3.14+0"

[[deps.HarfBuzz_jll]]
deps = ["Artifacts", "Cairo_jll", "Fontconfig_jll", "FreeType2_jll", "Glib_jll", "Graphite2_jll", "JLLWrappers", "Libdl", "Libffi_jll", "Pkg"]
git-tree-sha1 = "129acf094d168394e80ee1dc4bc06ec835e510a3"
uuid = "2e76f6c2-a576-52d4-95c1-20adfe4de566"
version = "2.8.1+1"

[[deps.InteractiveUtils]]
deps = ["Markdown"]
uuid = "b77e0a4c-d291-57a0-90e8-8db25a27a240"

[[deps.JLLWrappers]]
deps = ["Artifacts", "Preferences"]
git-tree-sha1 = "7e5d6779a1e09a36db2a7b6cff50942a0a7d0fca"
uuid = "692b3bcd-3c85-4b1f-b108-f13ce0eb3210"
version = "1.5.0"

[[deps.JpegTurbo_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl"]
git-tree-sha1 = "3336abae9a713d2210bb57ab484b1e065edd7d23"
uuid = "aacddb02-875f-59d6-b918-886e6ef4fbf8"
version = "3.0.2+0"

[[deps.LAME_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "f6250b16881adf048549549fba48b1161acdac8c"
uuid = "c1c5ebd0-6772-5130-a774-d5fcae4a789d"
version = "3.100.1+0"

[[deps.LERC_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "bf36f528eec6634efc60d7ec062008f171071434"
uuid = "88015f11-f218-50d7-93a8-a6af411a945d"
version = "3.0.0+1"

[[deps.LLVMOpenMP_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl"]
git-tree-sha1 = "d986ce2d884d49126836ea94ed5bfb0f12679713"
uuid = "1d63c593-3942-5779-bab2-d838dc0a180e"
version = "15.0.7+0"

[[deps.LZO_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "e5b909bcf985c5e2605737d2ce278ed791b89be6"
uuid = "dd4b983a-f0e5-5f8d-a1b7-129d4a5fb1ac"
version = "2.10.1+0"

[[deps.LibCURL]]
deps = ["LibCURL_jll", "MozillaCACerts_jll"]
uuid = "b27032c2-a3e7-50c8-80cd-2d36dbcbfd21"
version = "0.6.4"

[[deps.LibCURL_jll]]
deps = ["Artifacts", "LibSSH2_jll", "Libdl", "MbedTLS_jll", "Zlib_jll", "nghttp2_jll"]
uuid = "deac9b47-8bc7-5906-a0fe-35ac56dc84c0"
version = "8.4.0+0"

[[deps.LibGit2]]
deps = ["Base64", "LibGit2_jll", "NetworkOptions", "Printf", "SHA"]
uuid = "76f85450-5226-5b5a-8eaa-529ad045b433"

[[deps.LibGit2_jll]]
deps = ["Artifacts", "LibSSH2_jll", "Libdl", "MbedTLS_jll"]
uuid = "e37daf67-58a4-590a-8e99-b0245dd2ffc5"
version = "1.6.4+0"

[[deps.LibSSH2_jll]]
deps = ["Artifacts", "Libdl", "MbedTLS_jll"]
uuid = "29816b5a-b9ab-546f-933c-edad1886dfa8"
version = "1.11.0+1"

[[deps.Libdl]]
uuid = "8f399da3-3557-5675-b5ff-fb832c97cbdb"

[[deps.Libffi_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "0b4a5d71f3e5200a7dff793393e09dfc2d874290"
uuid = "e9f186c6-92d2-5b65-8a66-fee21dc1b490"
version = "3.2.2+1"

[[deps.Libgcrypt_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Libgpg_error_jll"]
git-tree-sha1 = "9fd170c4bbfd8b935fdc5f8b7aa33532c991a673"
uuid = "d4300ac3-e22c-5743-9152-c294e39db1e4"
version = "1.8.11+0"

[[deps.Libgpg_error_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "c333716e46366857753e273ce6a69ee0945a6db9"
uuid = "7add5ba3-2f88-524e-9cd5-f83b8a55f7b8"
version = "1.42.0+0"

[[deps.Libiconv_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl"]
git-tree-sha1 = "f9557a255370125b405568f9767d6d195822a175"
uuid = "94ce4f54-9a6c-5748-9c1c-f9c7231a4531"
version = "1.17.0+0"

[[deps.Libmount_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl"]
git-tree-sha1 = "dae976433497a2f841baadea93d27e68f1a12a97"
uuid = "4b2f31a3-9ecc-558c-b454-b3730dcb73e9"
version = "2.39.3+0"

[[deps.Librsvg_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pango_jll", "Pkg", "gdk_pixbuf_jll"]
git-tree-sha1 = "ae0923dab7324e6bc980834f709c4cd83dd797ed"
uuid = "925c91fb-5dd6-59dd-8e8c-345e74382d89"
version = "2.54.5+0"

[[deps.Libtiff_jll]]
deps = ["Artifacts", "JLLWrappers", "JpegTurbo_jll", "LERC_jll", "Libdl", "XZ_jll", "Zlib_jll", "Zstd_jll"]
git-tree-sha1 = "6355fb9a4d22d867318db186fd09b09b35bd2ed7"
uuid = "89763e89-9b03-5906-acba-b20f662cd828"
version = "4.6.0+0"

[[deps.Libuuid_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl"]
git-tree-sha1 = "0a04a1318df1bf510beb2562cf90fb0c386f58c4"
uuid = "38a345b3-de98-5d2b-a5d3-14cd9215e700"
version = "2.39.3+1"

[[deps.LinearAlgebra]]
deps = ["Libdl", "OpenBLAS_jll", "libblastrampoline_jll"]
uuid = "37e2e46d-f89d-539d-b4ee-838fcccc9c8e"

[[deps.Logging]]
uuid = "56ddb016-857b-54e1-b83d-db4d58db5568"

[[deps.Luxor]]
deps = ["Base64", "Cairo", "Colors", "DataStructures", "Dates", "FFMPEG", "FileIO", "PolygonAlgorithms", "PrecompileTools", "Random", "Rsvg"]
git-tree-sha1 = "97e13acec42f02139fcf1b2035010d5e3369d070"
uuid = "ae8d54c2-7ccd-5906-9d76-62fc9837b5bc"
version = "4.0.0"

    [deps.Luxor.extensions]
    LuxorExtLatex = ["LaTeXStrings", "MathTeXEngine"]

    [deps.Luxor.weakdeps]
    LaTeXStrings = "b964fa9f-0449-5b57-a5c2-d3ea65f4040f"
    MathTeXEngine = "0a4f8689-d25c-4efe-a92b-7142dfc1aa53"

[[deps.Markdown]]
deps = ["Base64"]
uuid = "d6f4376e-aef5-505a-96c1-9c027394607a"

[[deps.MbedTLS_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "c8ffd9c3-330d-5841-b78e-0817d7145fa1"
version = "2.28.2+1"

[[deps.MozillaCACerts_jll]]
uuid = "14a3606d-f60d-562e-9121-12d972cd8159"
version = "2023.1.10"

[[deps.NaNMath]]
deps = ["OpenLibm_jll"]
git-tree-sha1 = "0877504529a3e5c3343c6f8b4c0381e57e4387e4"
uuid = "77ba4419-2d1f-58cd-9bb1-8ffee604a2e3"
version = "1.0.2"

[[deps.NetworkOptions]]
uuid = "ca575930-c2e3-43a9-ace4-1e988b2c1908"
version = "1.2.0"

[[deps.Ogg_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "887579a3eb005446d514ab7aeac5d1d027658b8f"
uuid = "e7412a2a-1a6e-54c0-be00-318e2571c051"
version = "1.3.5+1"

[[deps.OpenBLAS_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "Libdl"]
uuid = "4536629a-c528-5b80-bd46-f80d51c5b363"
version = "0.3.23+4"

[[deps.OpenLibm_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "05823500-19ac-5b8b-9628-191a04bc5112"
version = "0.8.1+2"

[[deps.OpenSSL_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl"]
git-tree-sha1 = "3da7367955dcc5c54c1ba4d402ccdc09a1a3e046"
uuid = "458c3c95-2e84-50aa-8efc-19380b2a3a95"
version = "3.0.13+1"

[[deps.Opus_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "51a08fb14ec28da2ec7a927c4337e4332c2a4720"
uuid = "91d4177d-7536-5919-b921-800302f37372"
version = "1.3.2+0"

[[deps.OrderedCollections]]
git-tree-sha1 = "dfdf5519f235516220579f949664f1bf44e741c5"
uuid = "bac558e1-5e72-5ebc-8fee-abe8a469f55d"
version = "1.6.3"

[[deps.PCRE2_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "efcefdf7-47ab-520b-bdef-62a2eaa19f15"
version = "10.42.0+1"

[[deps.Pango_jll]]
deps = ["Artifacts", "Cairo_jll", "Fontconfig_jll", "FreeType2_jll", "FriBidi_jll", "Glib_jll", "HarfBuzz_jll", "JLLWrappers", "Libdl"]
git-tree-sha1 = "cb5a2ab6763464ae0f19c86c56c63d4a2b0f5bda"
uuid = "36c8627f-9965-5494-a995-c6b170f724f3"
version = "1.52.2+0"

[[deps.Pixman_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "JLLWrappers", "LLVMOpenMP_jll", "Libdl"]
git-tree-sha1 = "64779bc4c9784fee475689a1752ef4d5747c5e87"
uuid = "30392449-352a-5448-841d-b1acce4e97dc"
version = "0.42.2+0"

[[deps.Pkg]]
deps = ["Artifacts", "Dates", "Downloads", "FileWatching", "LibGit2", "Libdl", "Logging", "Markdown", "Printf", "REPL", "Random", "SHA", "Serialization", "TOML", "Tar", "UUIDs", "p7zip_jll"]
uuid = "44cfe95a-1eb2-52ea-b672-e2afdf69b78f"
version = "1.10.0"

[[deps.PolygonAlgorithms]]
git-tree-sha1 = "a5ded6396172cff3bacdd1354d190b93cb667c4b"
uuid = "32a0d02f-32d9-4438-b5ed-3a2932b48f96"
version = "0.2.0"

[[deps.PrecompileTools]]
deps = ["Preferences"]
git-tree-sha1 = "5aa36f7049a63a1528fe8f7c3f2113413ffd4e1f"
uuid = "aea7be01-6a6a-4083-8856-8a6e6704d82a"
version = "1.2.1"

[[deps.Preferences]]
deps = ["TOML"]
git-tree-sha1 = "9306f6085165d270f7e3db02af26a400d580f5c6"
uuid = "21216c6a-2e73-6563-6e65-726566657250"
version = "1.4.3"

[[deps.Printf]]
deps = ["Unicode"]
uuid = "de0858da-6303-5e67-8744-51eddeeeb8d7"

[[deps.REPL]]
deps = ["InteractiveUtils", "Markdown", "Sockets", "Unicode"]
uuid = "3fa0cd96-eef1-5676-8a61-b3b8758bbffb"

[[deps.Random]]
deps = ["SHA"]
uuid = "9a3f8284-a2c9-5f02-9a11-845980a1fd5c"

[[deps.Reexport]]
git-tree-sha1 = "45e428421666073eab6f2da5c9d310d99bb12f9b"
uuid = "189a3867-3050-52da-a836-e630ba90ab69"
version = "1.2.2"

[[deps.Requires]]
deps = ["UUIDs"]
git-tree-sha1 = "838a3a4188e2ded87a4f9f184b4b0d78a1e91cb7"
uuid = "ae029012-a4dd-5104-9daa-d747884805df"
version = "1.3.0"

[[deps.Rsvg]]
deps = ["Cairo", "Glib_jll", "Librsvg_jll"]
git-tree-sha1 = "3d3dc66eb46568fb3a5259034bfc752a0eb0c686"
uuid = "c4c386cf-5103-5370-be45-f3a111cca3b8"
version = "1.0.0"

[[deps.SHA]]
uuid = "ea8e919c-243c-51af-8825-aaa63cd721ce"
version = "0.7.0"

[[deps.Serialization]]
uuid = "9e88b42a-f829-5b0c-bbe9-9e923198166b"

[[deps.Sockets]]
uuid = "6462fe0b-24de-5631-8697-dd941f90decc"

[[deps.SparseArrays]]
deps = ["Libdl", "LinearAlgebra", "Random", "Serialization", "SuiteSparse_jll"]
uuid = "2f01184e-e22b-5df5-ae63-d93ebab69eaf"
version = "1.10.0"

[[deps.Statistics]]
deps = ["LinearAlgebra", "SparseArrays"]
uuid = "10745b16-79ce-11e8-11f9-7d13ad32a3b2"
version = "1.10.0"

[[deps.SuiteSparse_jll]]
deps = ["Artifacts", "Libdl", "libblastrampoline_jll"]
uuid = "bea87d4a-7f5b-5778-9afe-8cc45184846c"
version = "7.2.1+1"

[[deps.TOML]]
deps = ["Dates"]
uuid = "fa267f1f-6049-4f14-aa54-33bafae1ed76"
version = "1.0.3"

[[deps.Tar]]
deps = ["ArgTools", "SHA"]
uuid = "a4e569a6-e804-4fa4-b0f3-eef7a1d5b13e"
version = "1.10.0"

[[deps.UUIDs]]
deps = ["Random", "SHA"]
uuid = "cf7118a7-6976-5b1a-9a39-7adc72f591a4"

[[deps.Unicode]]
uuid = "4ec0a83e-493e-50e2-b9ac-8f72acf5a8f5"

[[deps.XML2_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Libiconv_jll", "Zlib_jll"]
git-tree-sha1 = "532e22cf7be8462035d092ff21fada7527e2c488"
uuid = "02c8fc9c-b97f-50b9-bbe4-9be30ff0a78a"
version = "2.12.6+0"

[[deps.XSLT_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Libgcrypt_jll", "Libgpg_error_jll", "Libiconv_jll", "Pkg", "XML2_jll", "Zlib_jll"]
git-tree-sha1 = "91844873c4085240b95e795f692c4cec4d805f8a"
uuid = "aed1982a-8fda-507f-9586-7b0439959a61"
version = "1.1.34+0"

[[deps.XZ_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl"]
git-tree-sha1 = "ac88fb95ae6447c8dda6a5503f3bafd496ae8632"
uuid = "ffd25f8a-64ca-5728-b0f7-c24cf3aae800"
version = "5.4.6+0"

[[deps.Xorg_libX11_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Xorg_libxcb_jll", "Xorg_xtrans_jll"]
git-tree-sha1 = "afead5aba5aa507ad5a3bf01f58f82c8d1403495"
uuid = "4f6342f7-b3d2-589e-9d20-edeb45f2b2bc"
version = "1.8.6+0"

[[deps.Xorg_libXau_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl"]
git-tree-sha1 = "6035850dcc70518ca32f012e46015b9beeda49d8"
uuid = "0c0b7dd1-d40b-584c-a123-a41640f87eec"
version = "1.0.11+0"

[[deps.Xorg_libXdmcp_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl"]
git-tree-sha1 = "34d526d318358a859d7de23da945578e8e8727b7"
uuid = "a3789734-cfe1-5b06-b2d0-1dd0d9d62d05"
version = "1.1.4+0"

[[deps.Xorg_libXext_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libX11_jll"]
git-tree-sha1 = "b7c0aa8c376b31e4852b360222848637f481f8c3"
uuid = "1082639a-0dae-5f34-9b06-72781eeb8cb3"
version = "1.3.4+4"

[[deps.Xorg_libXrender_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg", "Xorg_libX11_jll"]
git-tree-sha1 = "19560f30fd49f4d4efbe7002a1037f8c43d43b96"
uuid = "ea2f1a96-1ddc-540d-b46f-429655e07cfa"
version = "0.9.10+4"

[[deps.Xorg_libpthread_stubs_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl"]
git-tree-sha1 = "8fdda4c692503d44d04a0603d9ac0982054635f9"
uuid = "14d82f49-176c-5ed1-bb49-ad3f5cbd8c74"
version = "0.1.1+0"

[[deps.Xorg_libxcb_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "XSLT_jll", "Xorg_libXau_jll", "Xorg_libXdmcp_jll", "Xorg_libpthread_stubs_jll"]
git-tree-sha1 = "b4bfde5d5b652e22b9c790ad00af08b6d042b97d"
uuid = "c7cfdc94-dc32-55de-ac96-5a1b8d977c5b"
version = "1.15.0+0"

[[deps.Xorg_xtrans_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl"]
git-tree-sha1 = "e92a1a012a10506618f10b7047e478403a046c77"
uuid = "c5fb5394-a638-5e4d-96e5-b29de1b5cf10"
version = "1.5.0+0"

[[deps.Zlib_jll]]
deps = ["Libdl"]
uuid = "83775a58-1f1d-513f-b197-d71354ab007a"
version = "1.2.13+1"

[[deps.Zstd_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl"]
git-tree-sha1 = "e678132f07ddb5bfa46857f0d7620fb9be675d3b"
uuid = "3161d3a3-bdf6-5164-811a-617609db77b4"
version = "1.5.6+0"

[[deps.gdk_pixbuf_jll]]
deps = ["Artifacts", "Glib_jll", "JLLWrappers", "JpegTurbo_jll", "Libdl", "Libtiff_jll", "Xorg_libX11_jll", "libpng_jll"]
git-tree-sha1 = "86e7731be08b12fa5e741f719603ae740e16b666"
uuid = "da03df04-f53b-5353-a52f-6a8b0620ced0"
version = "2.42.10+0"

[[deps.libaom_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "3a2ea60308f0996d26f1e5354e10c24e9ef905d4"
uuid = "a4ae2306-e953-59d6-aa16-d00cac43593b"
version = "3.4.0+0"

[[deps.libass_jll]]
deps = ["Artifacts", "Bzip2_jll", "FreeType2_jll", "FriBidi_jll", "HarfBuzz_jll", "JLLWrappers", "Libdl", "Pkg", "Zlib_jll"]
git-tree-sha1 = "5982a94fcba20f02f42ace44b9894ee2b140fe47"
uuid = "0ac62f75-1d6f-5e53-bd7c-93b484bb37c0"
version = "0.15.1+0"

[[deps.libblastrampoline_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "8e850b90-86db-534c-a0d3-1478176c7d93"
version = "5.8.0+1"

[[deps.libfdk_aac_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "daacc84a041563f965be61859a36e17c4e4fcd55"
uuid = "f638f0a6-7fb0-5443-88ba-1cc74229b280"
version = "2.0.2+0"

[[deps.libpng_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Zlib_jll"]
git-tree-sha1 = "d7015d2e18a5fd9a4f47de711837e980519781a4"
uuid = "b53b4c65-9356-5827-b1ea-8c7a1a84506f"
version = "1.6.43+1"

[[deps.libvorbis_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Ogg_jll", "Pkg"]
git-tree-sha1 = "b910cb81ef3fe6e78bf6acee440bda86fd6ae00c"
uuid = "f27f6e37-5d2b-51aa-960f-b287f2bc3b7a"
version = "1.3.7+1"

[[deps.nghttp2_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "8e850ede-7688-5339-a07c-302acd2aaf8d"
version = "1.52.0+1"

[[deps.p7zip_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "3f19e933-33d8-53b3-aaab-bd5110c3b7a0"
version = "17.4.0+2"

[[deps.x264_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "4fea590b89e6ec504593146bf8b988b2c00922b2"
uuid = "1270edf5-f2f9-52d2-97e9-ab00b5d0237a"
version = "2021.5.5+0"

[[deps.x265_jll]]
deps = ["Artifacts", "JLLWrappers", "Libdl", "Pkg"]
git-tree-sha1 = "ee567a171cce03570d77ad3a43e90218e38937a9"
uuid = "dfaa095f-4041-5dcd-9319-2fabd8486b76"
version = "3.5.0+0"
"""

# ╔═╡ Cell order:
# ╠═1f172822-03b3-11ef-2c76-5164aefd5c71
# ╠═d1b44dac-8487-4581-82fd-ece0ce89f8e2
# ╠═0ab9b560-28f3-490f-9983-ced5a6cae7ec
# ╟─69d0fa4d-2585-42a0-981f-99d43f7e2c1f
# ╟─00000000-0000-0000-0000-000000000001
# ╟─00000000-0000-0000-0000-000000000002

## Gradient
DI.overloaded_input_type(prep::ReverseDiffGradientPrep) = typeof(prep.config.input)

## Jacobian
DI.overloaded_input_type(prep::ReverseDiffOneArgJacobianPrep) = typeof(prep.config.input)
DI.overloaded_input_type(prep::ReverseDiffTwoArgJacobianPrep) = typeof(prep.config.input)

include("../../testutils.jl")

using DifferentiationInterface, DifferentiationInterfaceTest
using GTPSA: GTPSA
using Test
import JET

using ExplicitImports
check_no_implicit_imports(DifferentiationInterface)

for backend in [AutoGTPSA()]
    @test check_available(backend)
    @test check_inplace(backend)
    test_counterparts(backend)
end

# Test no Descriptor (use context)
test_differentiation(
    AutoGTPSA(),
    default_scenarios(; include_constantified = true);
    type_stability = safetypestab(:full),
    logging = LOGGING,
);

# Test with Descriptor:
d1 = GTPSA.Descriptor(20, 2) # 20 variables to 2nd order
test_differentiation(AutoGTPSA(d1); type_stability = safetypestab(:full), logging = LOGGING);

# Test with Descriptor using varying orders
vos = 2 * ones(Int, 20)
vos[1] = 3
d2 = GTPSA.Descriptor(vos, 3)
test_differentiation(AutoGTPSA(d2); type_stability = safetypestab(:full), logging = LOGGING);

include("../../testutils.jl")

using ADTypes: ADTypes
using DifferentiationInterface, DifferentiationInterfaceTest
import DifferentiationInterfaceTest as DIT
using Enzyme: Enzyme
using LinearAlgebra
using StaticArrays
using Test

using ExplicitImports
check_no_implicit_imports(DifferentiationInterface)

backends = [
    AutoEnzyme(; mode = nothing),
    AutoEnzyme(; mode = Enzyme.Forward),
    AutoEnzyme(; mode = Enzyme.Reverse),
    AutoEnzyme(; mode = nothing, function_annotation = Enzyme.Const),
]

duplicated_backends = [
    AutoEnzyme(; mode = Enzyme.Forward, function_annotation = Enzyme.Duplicated),
    AutoEnzyme(; mode = Enzyme.Reverse, function_annotation = Enzyme.Duplicated),
]

@testset "Checks" begin
    @testset "Check $(typeof(backend))" for backend in backends
        @test check_available(backend)
        @test check_inplace(backend)
        test_counterparts(backend)
    end
end;

@testset "Counterpart mode attributes" begin
    # a reverse mode with non-default attributes, to check they survive the flip
    rev_mode = Enzyme.set_runtime_activity(Enzyme.ReverseWithPrimal)
    rev = AutoEnzyme(; mode = rev_mode, function_annotation = Enzyme.Const)
    fwd = DifferentiationInterface.forward_counterpart(rev)
    @test ADTypes.mode(fwd) isa ADTypes.ForwardMode
    @test fwd isa AutoEnzyme{<:Any, Enzyme.Const}  # function annotation preserved
    # ReturnPrimal and RuntimeActivity must carry over (ForwardMode{ReturnPrimal,...,RuntimeActivity,...})
    @test fwd.mode isa Enzyme.EnzymeCore.ForwardMode{true, <:Any, <:Any, true}
    # round-trip back to reverse recovers the original mode
    @test DifferentiationInterface.reverse_counterpart(fwd) === rev
    # split reverse mode also maps to forward mode, carrying over its attributes
    split_mode = Enzyme.set_runtime_activity(Enzyme.ReverseSplitWithPrimal)
    split = AutoEnzyme(; mode = split_mode, function_annotation = Enzyme.Const)
    fwd_split = DifferentiationInterface.forward_counterpart(split)
    @test ADTypes.mode(fwd_split) isa ADTypes.ForwardMode
    @test fwd_split isa AutoEnzyme{<:Any, Enzyme.Const}
    @test fwd_split.mode isa Enzyme.EnzymeCore.ForwardMode{true, <:Any, <:Any, true}
end;

@testset "First order" begin
    test_differentiation(
        backends, default_scenarios(); excluded = SECOND_ORDER, logging = LOGGING
    )

    test_differentiation(
        backends[1:3],
        default_scenarios(; include_normal = false, include_constantified = true);
        excluded = SECOND_ORDER,
        logging = LOGGING,
    )

    test_differentiation(
        backends[2:3],
        default_scenarios(;
            include_normal = false,
            include_cachified = true,
            include_constantorcachified = true,
            use_tuples = true,
        );
        excluded = SECOND_ORDER,
        logging = LOGGING,
    )

    test_differentiation(
        duplicated_backends,
        default_scenarios(; include_normal = false, include_closurified = true);
        excluded = SECOND_ORDER,
        logging = LOGGING,
    )
end

@testset "Second order" begin
    test_differentiation(
        AutoEnzyme(),
        default_scenarios(; include_constantified = true, include_cachified = true);
        excluded = vcat(FIRST_ORDER, :hvp, :hessian),
        logging = LOGGING,
    )

    test_differentiation(
        AutoEnzyme(),
        default_scenarios(; include_constantified = true);
        excluded = vcat(FIRST_ORDER, :second_derivative),
        logging = LOGGING,
    )

    test_differentiation(
        # TODO: simplify when https://github.com/EnzymeAD/Enzyme.jl/issues/2854 and https://github.com/EnzymeAD/Enzyme.jl/issues/2925 are fixed
        if VERSION >= v"1.11"
            SecondOrder(
                AutoEnzyme(; mode = Enzyme.set_runtime_activity(Enzyme.Forward)),
                AutoEnzyme(; mode = Enzyme.set_runtime_activity(Enzyme.Reverse))
            )
        else
            AutoEnzyme()
        end,
        default_scenarios(; include_normal = false, include_constantified = false, include_cachified = true);
        excluded = vcat(FIRST_ORDER, :second_derivative),
        logging = LOGGING,
    )

    test_differentiation(
        [
            SecondOrder(
                AutoEnzyme(; mode = Enzyme.Reverse), AutoEnzyme(; mode = Enzyme.Forward)
            ),
        ],
        default_scenarios(; include_constantified = true, include_cachified = true);
        excluded = FIRST_ORDER,
        logging = LOGGING,
    )
end

@testset "Sparse" begin
    test_differentiation(
        MyAutoSparse.(AutoEnzyme(; function_annotation = Enzyme.Const)),
        if VERSION < v"1.11"
            sparse_scenarios()
        else
            filter(s -> s.x isa AbstractVector, sparse_scenarios())
        end;
        sparsity = true,
        logging = LOGGING,
    )
end

@testset "Static" begin
    filtered_static_scenarios = filter(static_scenarios()) do s
        DIT.operator_place(s) == :out && DIT.function_place(s) == :out
    end

    test_differentiation(
        [AutoEnzyme(; mode = Enzyme.Forward), AutoEnzyme(; mode = Enzyme.Reverse)],
        filtered_static_scenarios;
        excluded = SECOND_ORDER,
        logging = LOGGING,
    )
end

@testset "Coverage" begin
    # ConstantOrCache without cache
    f_nocontext(x, p) = x
    @test I == DifferentiationInterface.jacobian(
        f_nocontext, AutoEnzyme(; mode = Enzyme.Forward), rand(10), ConstantOrCache(nothing)
    )
    @test I == DifferentiationInterface.jacobian(
        f_nocontext, AutoEnzyme(; mode = Enzyme.Reverse), rand(10), ConstantOrCache(nothing)
    )
end

@testset "Hints" begin
    @testset "MutabilityError" begin
        f = let
            cache = [0.0]
            x -> sum(copyto!(cache, x))
        end

        e = nothing
        try
            gradient(f, AutoEnzyme(), [1.0])
        catch e
        end
        msg = sprint(showerror, e)
        @test occursin("AutoEnzyme", msg)
        @test occursin("function_annotation", msg)
        @test occursin("ADTypes", msg)
    end

    @testset "RuntimeActivityError" begin
        function g(active_var, constant_var, cond)
            if cond
                return active_var
            else
                return constant_var
            end
        end

        function h(active_var, constant_var, cond)
            return [g(active_var, constant_var, cond), g(active_var, constant_var, cond)]
        end

        e = nothing
        try
            pushforward(
                h,
                AutoEnzyme(; mode = Enzyme.Forward),
                [1.0],
                ([1.0],),
                Constant([1.0]),
                Constant(true),
            )
        catch e
        end
        msg = sprint(showerror, e)
        @test_broken occursin("AutoEnzyme", msg)
        @test_broken occursin("ADTypes", msg)
    end
end

@testset "Empty arrays" begin
    test_differentiation(
        [AutoEnzyme(; mode = Enzyme.Forward), AutoEnzyme(; mode = Enzyme.Reverse)],
        empty_scenarios();
        excluded = [:jacobian],
    )
end;

include("../../testutils.jl")

using DifferentiationInterface, DifferentiationInterfaceTest
using Test
using Zygote: ZygoteRuleConfig

using ExplicitImports
check_no_implicit_imports(DifferentiationInterface)

for backend in [AutoChainRules(ZygoteRuleConfig())]
    @test check_available(backend)
    @test !check_inplace(backend)
    test_counterparts(backend)
end

test_differentiation(
    AutoChainRules(ZygoteRuleConfig()),
    default_scenarios();
    excluded = [:second_derivative],
    logging = LOGGING,
);

test_differentiation(
    AutoChainRules(ZygoteRuleConfig()),
    default_scenarios(; include_normal = false, include_constantified = true);
    excluded = SECOND_ORDER,
    logging = LOGGING,
);

@is_primitive MinimalCtx Tuple{DI.DifferentiateWith, <:Any}

struct MooncakeDifferentiateWithError <: Exception
    F::Type
    X::Type
    Y::Type
    function MooncakeDifferentiateWithError(::F, ::X, ::Y) where {F, X, Y}
        return new(F, X, Y)
    end
end

function Base.showerror(io::IO, e::MooncakeDifferentiateWithError)
    return print(
        io,
        "MooncakeDifferentiateWithError: For the function type $(e.F) and input type $(e.X), the output type $(e.Y) is currently not supported.",
    )
end

function Mooncake.rrule!!(dw::CoDual{<:DI.DifferentiateWith}, x::CoDual{<:Number})
    primal_func = primal(dw)
    primal_x = primal(x)
    (; f, backend) = primal_func
    y = zero_fcodual(f(primal_x))

    # output is a vector, so we need to use the vector pullback
    function pullback_array!!(dy::NoRData)
        tx = DI.pullback(f, backend, primal_x, (y.dx,))
        @assert rdata(only(tx)) isa rdata_type(tangent_type(typeof(primal_x)))
        return NoRData(), rdata(only(tx))
    end

    # output is a scalar, so we can use the scalar pullback
    function pullback_scalar!!(dy::Number)
        tx = DI.pullback(f, backend, primal_x, (dy,))
        @assert rdata(only(tx)) isa rdata_type(tangent_type(typeof(primal_x)))
        return NoRData(), rdata(only(tx))
    end

    pullback = if primal(y) isa Number
        pullback_scalar!!
    elseif primal(y) isa AbstractArray
        pullback_array!!
    else
        throw(MooncakeDifferentiateWithError(primal_func, primal_x, primal(y)))
    end

    return y, pullback
end

function Mooncake.rrule!!(
        dw::CoDual{<:DI.DifferentiateWith}, x::CoDual{<:AbstractArray{<:Number}}
    )
    primal_func = primal(dw)
    primal_x = primal(x)
    fdata_arg = x.dx
    (; f, backend) = primal_func
    y = zero_fcodual(f(primal_x))

    # output is a vector, so we need to use the vector pullback
    function pullback_array!!(dy::NoRData)
        tx = DI.pullback(f, backend, primal_x, (y.dx,))
        @assert rdata(first(only(tx))) isa rdata_type(tangent_type(typeof(first(primal_x))))
        fdata_arg .+= only(tx)
        return NoRData(), dy
    end

    # output is a scalar, so we can use the scalar pullback
    function pullback_scalar!!(dy::Number)
        tx = DI.pullback(f, backend, primal_x, (dy,))
        @assert rdata(first(only(tx))) isa rdata_type(tangent_type(typeof(first(primal_x))))
        fdata_arg .+= only(tx)
        return NoRData(), NoRData()
    end

    pullback = if primal(y) isa Number
        pullback_scalar!!
    elseif primal(y) isa AbstractArray
        pullback_array!!
    else
        throw(MooncakeDifferentiateWithError(primal_func, primal_x, primal(y)))
    end

    return y, pullback
end

## Backend counterparts

# Flip the Enzyme mode while preserving its other type parameters (and the function
# annotation `A`).

function DI.forward_counterpart(
        ::AutoEnzyme{
            <:ReverseMode{
                ReturnPrimal, RuntimeActivity, StrongZero, ABI, Holomorphic, ErrIfFuncWritten,
            },
            A,
        },
    ) where {ReturnPrimal, RuntimeActivity, StrongZero, ABI, Holomorphic, ErrIfFuncWritten, A}
    mode = ForwardMode{ReturnPrimal, ABI, ErrIfFuncWritten, RuntimeActivity, StrongZero}()
    return AutoEnzyme(; mode, function_annotation = A)
end

function DI.forward_counterpart(
        ::AutoEnzyme{
            <:ReverseModeSplit{
                ReturnPrimal, ReturnShadow, RuntimeActivity, StrongZero, Width,
                ModifiedBetween, ABI, Holomorphic, ErrIfFuncWritten, ShadowInit,
            },
            A,
        },
    ) where {
        ReturnPrimal, ReturnShadow, RuntimeActivity, StrongZero, Width,
        ModifiedBetween, ABI, Holomorphic, ErrIfFuncWritten, ShadowInit, A,
    }
    mode = ForwardMode{ReturnPrimal, ABI, ErrIfFuncWritten, RuntimeActivity, StrongZero}()
    return AutoEnzyme(; mode, function_annotation = A)
end

function DI.reverse_counterpart(
        ::AutoEnzyme{
            <:ForwardMode{ReturnPrimal, ABI, ErrIfFuncWritten, RuntimeActivity, StrongZero},
            A,
        },
    ) where {ReturnPrimal, ABI, ErrIfFuncWritten, RuntimeActivity, StrongZero, A}
    mode = ReverseMode{ReturnPrimal, RuntimeActivity, StrongZero, ABI, false, ErrIfFuncWritten}()
    return AutoEnzyme(; mode, function_annotation = A)
end

module DifferentiationInterfaceFastDifferentiationExt

using ADTypes: ADTypes, AutoFastDifferentiation, AutoSparse
import DifferentiationInterface as DI
using FastDifferentiation:
    derivative,
    hessian,
    hessian_times_v,
    jacobian,
    jacobian_times_v,
    jacobian_transpose_v,
    make_function,
    make_variables,
    sparse_hessian,
    sparse_jacobian
using LinearAlgebra: dot
using FastDifferentiation.RuntimeGeneratedFunctions: RuntimeGeneratedFunction

DI.check_available(::AutoFastDifferentiation) = true

myvec(x::Number) = [x]
myvec(x::AbstractArray) = vec(x)

variablize(::Number, name::Symbol) = only(make_variables(name))
variablize(x::AbstractArray, name::Symbol) = make_variables(name, size(x)...)

function variablize(contexts::NTuple{C, DI.Context}) where {C}
    return map(enumerate(contexts)) do (k, c)
        variablize(DI.unwrap(c), Symbol("context$k"))
    end
end

dense_ad(backend::AutoFastDifferentiation) = backend
dense_ad(backend::AutoSparse{<:AutoFastDifferentiation}) = ADTypes.dense_ad(backend)

myvec_unwrap(x) = myvec(DI.unwrap(x))

include("onearg.jl")
include("twoarg.jl")

end

## Pullback

function DI.prepare_pullback_nokwarg(
        strict::Val, f, backend::AutoReverseDiff, x, ty::NTuple, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, ty, contexts...; strict)
    return DI.NoPullbackPrep(_sig)
end

function DI.value_and_pullback(
        f,
        prep::DI.NoPullbackPrep,
        backend::AutoReverseDiff,
        x::AbstractArray,
        ty::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, ty, contexts...)
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    y = fc(x)
    dotclosure(z, dy) = dot(fc(z), dy)
    tx = map(ty) do dy
        if y isa Number
            dy .* gradient(fc, x)
        elseif y isa AbstractArray
            gradient(Fix2(dotclosure, dy), x)
        end
    end
    return y, tx
end

function DI.value_and_pullback!(
        f,
        tx::NTuple,
        prep::DI.NoPullbackPrep,
        backend::AutoReverseDiff,
        x::AbstractArray,
        ty::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, ty, contexts...)
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    y = fc(x)
    dotclosure(z, dy) = dot(fc(z), dy)
    for b in eachindex(tx, ty)
        dx, dy = tx[b], ty[b]
        if y isa Number
            dx = gradient!(dx, fc, x)
            dx .*= dy
        elseif y isa AbstractArray
            gradient!(dx, Fix2(dotclosure, dy), x)
        end
    end
    return y, tx
end

function DI.value_and_pullback(
        f,
        prep::DI.NoPullbackPrep,
        backend::AutoReverseDiff,
        x::Number,
        ty::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, ty, contexts...)
    x_array = [x]
    f_array(x_array, args...) = f(only(x_array), args...)
    y, tx_array = DI.value_and_pullback(f_array, backend, x_array, ty, contexts...)
    return y, only.(tx_array)
end

## Gradient

### Without contexts

struct ReverseDiffGradientPrep{SIG, C, T} <: DI.GradientPrep{SIG}
    _sig::Val{SIG}
    config::C
    tape::T
end

function DI.prepare_gradient_nokwarg(
        strict::Val, f, backend::AutoReverseDiff{compile}, x
    ) where {compile}
    _sig = DI.signature(f, backend, x; strict)
    if compile
        tape = ReverseDiff.compile(GradientTape(f, x))
        return ReverseDiffGradientPrep(_sig, nothing, tape)
    else
        config = GradientConfig(x)
        return ReverseDiffGradientPrep(_sig, config, nothing)
    end
end

function DI.value_and_gradient!(
        f, grad, prep::ReverseDiffGradientPrep, backend::AutoReverseDiff{compile}, x
    ) where {compile}
    DI.check_prep(f, prep, backend, x)
    result = MutableDiffResult(zero(eltype(x)), (grad,))  # ReverseDiff#251
    if compile
        result = gradient!(result, prep.tape, x)
    else
        result = gradient!(result, f, x, prep.config)
    end
    return DR.value(result), grad  # ReverseDiff#269
end

function DI.value_and_gradient(
        f, prep::ReverseDiffGradientPrep, backend::AutoReverseDiff{compile}, x
    ) where {compile}
    DI.check_prep(f, prep, backend, x)
    # GradientResult tries to mutate an SArray
    result = MutableDiffResult(zero(eltype(x)), (similar(x),))
    if compile
        result = gradient!(result, prep.tape, x)
    else
        result = gradient!(result, f, x, prep.config)
    end
    return DR.value(result), DR.gradient(result)
end

function DI.gradient!(
        f, grad, prep::ReverseDiffGradientPrep, backend::AutoReverseDiff{compile}, x
    ) where {compile}
    DI.check_prep(f, prep, backend, x)
    if compile
        return gradient!(grad, prep.tape, x)
    else
        return gradient!(grad, f, x, prep.config)
    end
end

function DI.gradient(
        f, prep::ReverseDiffGradientPrep, backend::AutoReverseDiff{compile}, x
    ) where {compile}
    DI.check_prep(f, prep, backend, x)
    if compile
        return gradient!(prep.tape, x)
    else
        return gradient(f, x, prep.config)
    end
end

### With contexts

function DI.prepare_gradient_nokwarg(
        strict::Val, f, backend::AutoReverseDiff, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    config = GradientConfig(x)
    return ReverseDiffGradientPrep(_sig, config, nothing)
end

function DI.value_and_gradient!(
        f,
        grad,
        prep::ReverseDiffGradientPrep,
        backend::AutoReverseDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    result = MutableDiffResult(zero(eltype(x)), (grad,))  # ReverseDiff#251
    result = gradient!(result, fc, x, prep.config)
    return DR.value(result), grad  # ReverseDiff#269
end

function DI.value_and_gradient(
        f,
        prep::ReverseDiffGradientPrep,
        backend::AutoReverseDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    # GradientResult tries to mutate an SArray
    result = MutableDiffResult(zero(eltype(x)), (similar(x),))
    result = gradient!(result, fc, x, prep.config)
    return DR.value(result), DR.gradient(result)
end

function DI.gradient!(
        f,
        grad,
        prep::ReverseDiffGradientPrep,
        backend::AutoReverseDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    return gradient!(grad, fc, x, prep.config)
end

function DI.gradient(
        f,
        prep::ReverseDiffGradientPrep,
        backend::AutoReverseDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    return gradient(fc, x, prep.config)
end

## Jacobian

### Without contexts

struct ReverseDiffOneArgJacobianPrep{SIG, C, T} <: DI.JacobianPrep{SIG}
    _sig::Val{SIG}
    config::C
    tape::T
end

function DI.prepare_jacobian_nokwarg(
        strict::Val, f, backend::AutoReverseDiff{compile}, x
    ) where {compile}
    _sig = DI.signature(f, backend, x; strict)
    if compile
        tape = ReverseDiff.compile(JacobianTape(f, x))
        return ReverseDiffOneArgJacobianPrep(_sig, nothing, tape)
    else
        config = JacobianConfig(x)
        return ReverseDiffOneArgJacobianPrep(_sig, config, nothing)
    end
end

function DI.value_and_jacobian!(
        f, jac, prep::ReverseDiffOneArgJacobianPrep, backend::AutoReverseDiff{compile}, x
    ) where {compile}
    DI.check_prep(f, prep, backend, x)
    y = f(x)
    result = DiffResult(y, (jac,))
    if compile
        result = jacobian!(result, prep.tape, x)
    else
        result = jacobian!(result, f, x, prep.config)
    end
    y = DR.value(result)
    jac === DR.jacobian(result) || copyto!(jac, DR.jacobian(result))
    return y, jac
end

function DI.value_and_jacobian(
        f, prep::ReverseDiffOneArgJacobianPrep, backend::AutoReverseDiff{compile}, x
    ) where {compile}
    DI.check_prep(f, prep, backend, x)
    if compile
        return f(x), jacobian!(prep.tape, x)
    else
        return f(x), jacobian(f, x, prep.config)
    end
end

function DI.jacobian!(
        f, jac, prep::ReverseDiffOneArgJacobianPrep, backend::AutoReverseDiff{compile}, x
    ) where {compile}
    DI.check_prep(f, prep, backend, x)
    if compile
        return jacobian!(jac, prep.tape, x)
    else
        return jacobian!(jac, f, x, prep.config)
    end
end

function DI.jacobian(
        f, prep::ReverseDiffOneArgJacobianPrep, backend::AutoReverseDiff{compile}, x
    ) where {compile}
    DI.check_prep(f, prep, backend, x)
    if compile
        return jacobian!(prep.tape, x)
    else
        return jacobian(f, x, prep.config)
    end
end

### With contexts

function DI.prepare_jacobian_nokwarg(
        strict::Val, f, backend::AutoReverseDiff, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    config = JacobianConfig(x)
    return ReverseDiffOneArgJacobianPrep(_sig, config, nothing)
end

function DI.value_and_jacobian!(
        f,
        jac,
        prep::ReverseDiffOneArgJacobianPrep,
        backend::AutoReverseDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    y = fc(x)
    result = DiffResult(y, (jac,))
    result = jacobian!(result, fc, x, prep.config)
    y = DR.value(result)
    jac === DR.jacobian(result) || copyto!(jac, DR.jacobian(result))
    return y, jac
end

function DI.value_and_jacobian(
        f,
        prep::ReverseDiffOneArgJacobianPrep,
        backend::AutoReverseDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    return fc(x), jacobian(fc, x, prep.config)
end

function DI.jacobian!(
        f,
        jac,
        prep::ReverseDiffOneArgJacobianPrep,
        backend::AutoReverseDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    return jacobian!(jac, fc, x, prep.config)
end

function DI.jacobian(
        f,
        prep::ReverseDiffOneArgJacobianPrep,
        backend::AutoReverseDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    return jacobian(fc, x, prep.config)
end

## Hessian

### Without contexts

struct ReverseDiffHessianPrep{SIG, G <: ReverseDiffGradientPrep, HC, HT} <: DI.HessianPrep{SIG}
    _sig::Val{SIG}
    gradient_prep::G
    hessian_config::HC
    hessian_tape::HT
end

function DI.prepare_hessian_nokwarg(
        strict::Val, f, backend::AutoReverseDiff{compile}, x
    ) where {compile}
    _sig = DI.signature(f, backend, x; strict)
    gradient_prep = DI.prepare_gradient_nokwarg(strict, f, backend, x)
    if compile
        hessian_tape = ReverseDiff.compile(HessianTape(f, x))
        return ReverseDiffHessianPrep(_sig, gradient_prep, nothing, hessian_tape)
    else
        hessian_config = HessianConfig(x)
        return ReverseDiffHessianPrep(_sig, gradient_prep, hessian_config, nothing)
    end
end

function DI.hessian!(
        f, hess, prep::ReverseDiffHessianPrep, backend::AutoReverseDiff{compile}, x
    ) where {compile}
    DI.check_prep(f, prep, backend, x)
    if compile
        return hessian!(hess, prep.hessian_tape, x)
    else
        return hessian!(hess, f, x, prep.hessian_config)
    end
end

function DI.hessian(
        f, prep::ReverseDiffHessianPrep, backend::AutoReverseDiff{compile}, x
    ) where {compile}
    DI.check_prep(f, prep, backend, x)
    if compile
        return hessian!(prep.hessian_tape, x)
    else
        return hessian(f, x, prep.hessian_config)
    end
end

function DI.value_gradient_and_hessian!(
        f, grad, hess, prep::ReverseDiffHessianPrep, backend::AutoReverseDiff{compile}, x
    ) where {compile}
    DI.check_prep(f, prep, backend, x)
    y = f(x)
    DI.gradient!(f, grad, prep.gradient_prep, backend, x)
    DI.hessian!(f, hess, prep, backend, x)
    return y, grad, hess
end

function DI.value_gradient_and_hessian(
        f, prep::ReverseDiffHessianPrep, backend::AutoReverseDiff{compile}, x
    ) where {compile}
    DI.check_prep(f, prep, backend, x)
    y = f(x)
    grad = DI.gradient(f, prep.gradient_prep, backend, x)
    hess = DI.hessian(f, prep, backend, x)
    return y, grad, hess
end

### With contexts

function DI.prepare_hessian_nokwarg(
        strict::Val, f, backend::AutoReverseDiff, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    gradient_prep = DI.prepare_gradient_nokwarg(strict, f, backend, x, contexts...)
    hessian_config = HessianConfig(x)
    return ReverseDiffHessianPrep(_sig, gradient_prep, hessian_config, nothing)
end

function DI.hessian!(
        f,
        hess,
        prep::ReverseDiffHessianPrep,
        backend::AutoReverseDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    return hessian!(hess, fc, x, prep.hessian_config)
end

function DI.hessian(
        f,
        prep::ReverseDiffHessianPrep,
        backend::AutoReverseDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    fc = DI.fix_tail(f, map(DI.unwrap, contexts)...)
    return hessian(fc, x, prep.hessian_config)
end

function DI.value_gradient_and_hessian!(
        f,
        grad,
        hess,
        prep::ReverseDiffHessianPrep,
        backend::AutoReverseDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    y = f(x, map(DI.unwrap, contexts)...)
    DI.gradient!(f, grad, prep.gradient_prep, backend, x, contexts...)
    DI.hessian!(f, hess, prep, backend, x, contexts...)
    return y, grad, hess
end

function DI.value_gradient_and_hessian(
        f,
        prep::ReverseDiffHessianPrep,
        backend::AutoReverseDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    y = f(x, map(DI.unwrap, contexts)...)
    grad = DI.gradient(f, prep.gradient_prep, backend, x, contexts...)
    hess = DI.hessian(f, prep, backend, x, contexts...)
    return y, grad, hess
end

"""
    jacobian_sparsity_with_contexts(f, detector, x, contexts...)
    jacobian_sparsity_with_contexts(f!, y, detector, x, contexts...)

Wrapper around [`ADTypes.jacobian_sparsity`](@extref ADTypes.jacobian_sparsity) enabling the allocation of caches with proper element types.
"""
function jacobian_sparsity_with_contexts(
        f::F, detector::AbstractSparsityDetector, x, contexts::Vararg{Context, C}
    ) where {F, C}
    return jacobian_sparsity(fix_tail(f, map(unwrap, contexts)...), x, detector)
end

function jacobian_sparsity_with_contexts(
        f!::F, y, detector::AbstractSparsityDetector, x, contexts::Vararg{Context, C}
    ) where {F, C}
    return jacobian_sparsity(fix_tail(f!, map(unwrap, contexts)...), y, x, detector)
end

"""
    hessian_sparsity_with_contexts(f, detector, x, contexts...)

Wrapper around [`ADTypes.hessian_sparsity`](@extref ADTypes.hessian_sparsity) enabling the allocation of caches with proper element types.
"""
function hessian_sparsity_with_contexts(
        f::F, detector::AbstractSparsityDetector, x, contexts::Vararg{Context, C}
    ) where {F, C}
    return hessian_sparsity(fix_tail(f, map(unwrap, contexts)...), x, detector)
end

## Preparation

struct SMCMixedModeSparseJacobianPrep{
        SIG,
        BSf <: DI.BatchSizeSettings,
        BSr <: DI.BatchSizeSettings,
        P <: AbstractMatrix,
        C <: AbstractColoringResult{:nonsymmetric, :bidirectional},
        Mf <: AbstractMatrix{<:Number},
        Mr <: AbstractMatrix{<:Number},
        Sfp <: NTuple,
        Srp <: NTuple,
        Sf <: Vector{<:NTuple},
        Sr <: Vector{<:NTuple},
        Rf <: Vector{<:NTuple},
        Rr <: Vector{<:NTuple},
        Ef <: DI.PushforwardPrep,
        Er <: DI.PullbackPrep,
    } <: SMCSparseJacobianPrep{SIG}
    _sig::Val{SIG}
    batch_size_settings_forward::BSf
    batch_size_settings_reverse::BSr
    sparsity::P
    coloring_result::C
    compressed_matrix_forward::Mf
    compressed_matrix_reverse::Mr
    batched_seed_forward_prep::Sfp
    batched_seed_reverse_prep::Srp
    batched_seeds_forward::Sf
    batched_seeds_reverse::Sr
    batched_results_forward::Rf
    batched_results_reverse::Rr
    pushforward_prep::Ef
    pullback_prep::Er
end

function DI.prepare_jacobian_nokwarg(
        strict::Val,
        f::F,
        backend::AutoSparse{<:DI.MixedMode},
        x,
        contexts::Vararg{DI.Context, C}
    ) where {F, C}
    y = f(x, map(DI.unwrap, contexts)...)
    return _prepare_mixed_sparse_jacobian_aux(strict, y, (f,), backend, x, contexts...)
end

function DI.prepare_jacobian_nokwarg(
        strict::Val,
        f!::F,
        y,
        backend::AutoSparse{<:DI.MixedMode},
        x,
        contexts::Vararg{DI.Context, C}
    ) where {F, C}
    return _prepare_mixed_sparse_jacobian_aux(strict, y, (f!, y), backend, x, contexts...)
end

function _prepare_mixed_sparse_jacobian_aux(
        strict::Val,
        y,
        f_or_f!y::FY,
        backend::AutoSparse{<:DI.MixedMode},
        x,
        contexts::Vararg{DI.Context, C}
    ) where {FY, C}
    dense_backend = dense_ad(backend)
    sparsity = DI.jacobian_sparsity_with_contexts(
        f_or_f!y..., sparsity_detector(backend), x, contexts...
    )
    problem = ColoringProblem{:nonsymmetric, :bidirectional}()
    coloring_result = coloring(
        sparsity,
        problem,
        coloring_algorithm(backend);
        decompression_eltype = promote_type(eltype(x), eltype(y)),
    )

    Nf = length(column_groups(coloring_result))
    Nr = length(row_groups(coloring_result))
    batch_size_settings_forward = DI.pick_batchsize(DI.forward_backend(dense_backend), Nf)
    batch_size_settings_reverse = DI.pick_batchsize(DI.reverse_backend(dense_backend), Nr)

    return _prepare_mixed_sparse_jacobian_aux_aux(
        strict,
        batch_size_settings_forward,
        batch_size_settings_reverse,
        sparsity,
        coloring_result,
        y,
        f_or_f!y,
        backend,
        x,
        contexts...
    )
end

function _prepare_mixed_sparse_jacobian_aux_aux(
        strict::Val,
        batch_size_settings_forward::DI.BatchSizeSettings{Bf},
        batch_size_settings_reverse::DI.BatchSizeSettings{Br},
        sparsity::AbstractMatrix,
        coloring_result::AbstractColoringResult{:nonsymmetric, :bidirectional},
        y,
        f_or_f!y::FY,
        backend::AutoSparse{<:DI.MixedMode},
        x,
        contexts::Vararg{DI.Context, C}
    ) where {Bf, Br, FY, C}
    _sig = DI.signature(f_or_f!y..., backend, x, contexts...; strict)
    Nf, Af = batch_size_settings_forward.N, batch_size_settings_forward.A
    Nr, Ar = batch_size_settings_reverse.N, batch_size_settings_reverse.A

    dense_backend = dense_ad(backend)

    groups_forward = column_groups(coloring_result)
    groups_reverse = row_groups(coloring_result)

    seed_forward_prep = DI.multibasis(x, eachindex(x))
    seed_reverse_prep = DI.multibasis(y, eachindex(y))
    seeds_forward = [DI.multibasis(x, eachindex(x)[group]) for group in groups_forward]
    seeds_reverse = [DI.multibasis(y, eachindex(y)[group]) for group in groups_reverse]

    compressed_matrix_forward = if isempty(groups_forward)
        similar(vec(y), length(y), 0)
    else
        stack(_ -> vec(similar(y)), groups_forward; dims = 2)
    end
    compressed_matrix_reverse = if isempty(groups_reverse)
        similar(vec(x), 0, length(x))
    else
        stack(_ -> vec(similar(x)), groups_reverse; dims = 1)
    end

    batched_seed_forward_prep = ntuple(b -> copy(seed_forward_prep), Val(Bf))
    batched_seed_reverse_prep = ntuple(b -> copy(seed_reverse_prep), Val(Br))
    batched_seeds_forward = [
        ntuple(b -> seeds_forward[1 + ((a - 1) * Bf + (b - 1)) % Nf], Val(Bf)) for a in 1:Af
    ]
    batched_seeds_reverse = [
        ntuple(b -> seeds_reverse[1 + ((a - 1) * Br + (b - 1)) % Nr], Val(Br)) for a in 1:Ar
    ]

    batched_results_forward = [
        ntuple(b -> similar(y), Val(Bf)) for _ in batched_seeds_forward
    ]
    batched_results_reverse = [
        ntuple(b -> similar(x), Val(Br)) for _ in batched_seeds_reverse
    ]

    pushforward_prep = DI.prepare_pushforward_nokwarg(
        strict,
        f_or_f!y...,
        DI.forward_backend(dense_backend),
        x,
        batched_seed_forward_prep,
        contexts...
    )
    pullback_prep = DI.prepare_pullback_nokwarg(
        strict,
        f_or_f!y...,
        DI.reverse_backend(dense_backend),
        x,
        batched_seed_reverse_prep,
        contexts...
    )

    return SMCMixedModeSparseJacobianPrep(
        _sig,
        batch_size_settings_forward,
        batch_size_settings_reverse,
        sparsity,
        coloring_result,
        compressed_matrix_forward,
        compressed_matrix_reverse,
        batched_seed_forward_prep,
        batched_seed_reverse_prep,
        batched_seeds_forward,
        batched_seeds_reverse,
        batched_results_forward,
        batched_results_reverse,
        pushforward_prep,
        pullback_prep,
    )
end

## Common auxiliaries

function _sparse_jacobian_aux!(
        f_or_f!y::FY,
        jac,
        prep::SMCMixedModeSparseJacobianPrep{
            SIG, <:DI.BatchSizeSettings{Bf}, <:DI.BatchSizeSettings{Br},
        },
        backend::AutoSparse,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {FY, SIG, Bf, Br, C}
    (;
        batch_size_settings_forward,
        batch_size_settings_reverse,
        coloring_result,
        compressed_matrix_forward,
        compressed_matrix_reverse,
        batched_seed_forward_prep,
        batched_seed_reverse_prep,
        batched_seeds_forward,
        batched_seeds_reverse,
        batched_results_forward,
        batched_results_reverse,
        pushforward_prep,
        pullback_prep,
    ) = prep

    dense_backend = dense_ad(backend)
    Nf = batch_size_settings_forward.N
    Nr = batch_size_settings_reverse.N

    pushforward_prep_same = DI.prepare_pushforward_same_point(
        f_or_f!y...,
        pushforward_prep,
        DI.forward_backend(dense_backend),
        x,
        batched_seed_forward_prep,
        contexts...,
    )
    pullback_prep_same = DI.prepare_pullback_same_point(
        f_or_f!y...,
        pullback_prep,
        DI.reverse_backend(dense_backend),
        x,
        batched_seed_reverse_prep,
        contexts...,
    )

    for a in eachindex(batched_seeds_forward, batched_results_forward)
        DI.pushforward!(
            f_or_f!y...,
            batched_results_forward[a],
            pushforward_prep_same,
            DI.forward_backend(dense_backend),
            x,
            batched_seeds_forward[a],
            contexts...,
        )

        for b in eachindex(batched_results_forward[a])
            copyto!(
                view(compressed_matrix_forward, :, 1 + ((a - 1) * Bf + (b - 1)) % Nf),
                vec(batched_results_forward[a][b]),
            )
        end
    end

    for a in eachindex(batched_seeds_reverse, batched_results_reverse)
        DI.pullback!(
            f_or_f!y...,
            batched_results_reverse[a],
            pullback_prep_same,
            DI.reverse_backend(dense_backend),
            x,
            batched_seeds_reverse[a],
            contexts...,
        )

        for b in eachindex(batched_results_reverse[a])
            if eltype(x) <: Complex
                batched_results_reverse[a][b] .= conj.(batched_results_reverse[a][b])
            end
            copyto!(
                view(compressed_matrix_reverse, 1 + ((a - 1) * Br + (b - 1)) % Nr, :),
                vec(batched_results_reverse[a][b]),
            )
        end
    end

    decompress!(jac, compressed_matrix_reverse, compressed_matrix_forward, coloring_result)

    return jac
end

## Docstrings

"""
    prepare_hessian(f, backend, x, [contexts...]; strict=Val(true)) -> prep

$(docstring_prepare("hessian"))
"""
function prepare_hessian(
        f::F, backend::AbstractADType, x, contexts::Vararg{Context, C}; strict::Val = Val(true)
    ) where {F, C}
    return prepare_hessian_nokwarg(strict, f, backend, x, contexts...)
end

"""
    prepare!_hessian(f, prep, backend, x, [contexts...]) -> new_prep

$(docstring_prepare!("hessian"))
"""
function prepare!_hessian(
        f::F, old_prep::HessianPrep, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    check_prep(f, old_prep, backend, x, contexts...)
    return prepare_hessian_nokwarg(is_strict(old_prep), f, backend, x, contexts...)
end

"""
    hessian(f, [prep,] backend, x, [contexts...]) -> hess

Compute the Hessian matrix of the function `f` at point `x`.

$(docstring_preparation_hint("hessian"))
"""
function hessian(f::F, backend::AbstractADType, x, contexts::Vararg{Context, C}) where {F, C}
    prep = prepare_hessian_nokwarg(Val(true), f, backend, x, contexts...)
    return hessian(f, prep, backend, x, contexts...)
end

"""
    hessian!(f, hess, [prep,] backend, x, [contexts...]) -> hess

Compute the Hessian matrix of the function `f` at point `x`, overwriting `hess`.

$(docstring_preparation_hint("hessian"))
"""
function hessian!(
        f::F, hess, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_hessian_nokwarg(Val(true), f, backend, x, contexts...)
    return hessian!(f, hess, prep, backend, x, contexts...)
end

"""
    value_gradient_and_hessian(f, [prep,] backend, x, [contexts...]) -> (y, grad, hess)

Compute the value, gradient vector and Hessian matrix of the function `f` at point `x`.

$(docstring_preparation_hint("hessian"))
"""
function value_gradient_and_hessian(
        f::F, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_hessian_nokwarg(Val(true), f, backend, x, contexts...)
    return value_gradient_and_hessian(f, prep, backend, x, contexts...)
end

"""
    value_gradient_and_hessian!(f, grad, hess, [prep,] backend, x, [contexts...]) -> (y, grad, hess)

Compute the value, gradient vector and Hessian matrix of the function `f` at point `x`, overwriting `grad` and `hess`.

$(docstring_preparation_hint("hessian"))
"""
function value_gradient_and_hessian!(
        f::F, grad, hess, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    prep = prepare_hessian_nokwarg(Val(true), f, backend, x, contexts...)
    return value_gradient_and_hessian!(f, grad, hess, prep, backend, x, contexts...)
end

## Preparation

struct HVPGradientHessianPrep{
        SIG,
        BS <: BatchSizeSettings,
        S <: AbstractVector{<:NTuple},
        R <: AbstractVector{<:NTuple},
        SE <: NTuple,
        E2 <: HVPPrep,
        E1 <: GradientPrep,
    } <: HessianPrep{SIG}
    _sig::Val{SIG}
    batch_size_settings::BS
    batched_seeds::S
    batched_results::R
    seed_example::SE
    hvp_prep::E2
    gradient_prep::E1
end

function prepare_hessian_nokwarg(
        strict::Val, f::F, backend::AbstractADType, x, contexts::Vararg{Context, C}
    ) where {F, C}
    # type-unstable
    batch_size_settings = pick_batchsize(outer(backend), x)
    # function barrier
    return _prepare_hessian_aux(strict, batch_size_settings, f, backend, x, contexts...)
end

function _prepare_hessian_aux(
        strict::Val,
        batch_size_settings::BatchSizeSettings{B},
        f::F,
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C}
    ) where {B, F, C}
    _sig = signature(f, backend, x, contexts...; strict)
    (; N, A) = batch_size_settings
    seeds = [basis(x, ind) for ind in eachindex(x)]
    batched_seeds = [
        ntuple(b -> seeds[1 + ((a - 1) * B + (b - 1)) % N], Val(B)) for a in 1:A
    ]
    batched_results = [ntuple(b -> similar(x), Val(B)) for _ in batched_seeds]
    seed_example = ntuple(b -> basis(x), Val(B))
    hvp_prep = prepare_hvp_nokwarg(strict, f, backend, x, seed_example, contexts...)
    gradient_prep = prepare_gradient_nokwarg(strict, f, inner(backend), x, contexts...)
    return HVPGradientHessianPrep(
        _sig,
        batch_size_settings,
        batched_seeds,
        batched_results,
        seed_example,
        hvp_prep,
        gradient_prep,
    )
end

## One argument

function hessian(
        f::F,
        prep::HVPGradientHessianPrep{SIG, <:BatchSizeSettings{B, true}},
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {F, SIG, B, C}
    check_prep(f, prep, backend, x, contexts...)
    (; batched_seeds, hvp_prep) = prep
    dg_batch = hvp(f, hvp_prep, backend, x, only(batched_seeds), contexts...)
    block = stack_vec_col(dg_batch)
    return block
end

function hessian(
        f::F,
        prep::HVPGradientHessianPrep{SIG, <:BatchSizeSettings{1, false, true}},
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {F, SIG, C}
    check_prep(f, prep, backend, x, contexts...)
    (; batched_seeds, seed_example, hvp_prep) = prep

    hvp_prep_same = prepare_hvp_same_point(
        f, hvp_prep, backend, x, seed_example, contexts...
    )

    hess = mapreduce(hcat, eachindex(batched_seeds)) do a
        dg = only(hvp(f, hvp_prep_same, backend, x, batched_seeds[a], contexts...))
        return vec(dg)
    end
    return hess
end

function hessian(
        f::F,
        prep::HVPGradientHessianPrep{SIG, <:BatchSizeSettings{B, false, aligned}},
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {F, SIG, B, aligned, C}
    check_prep(f, prep, backend, x, contexts...)
    (; batch_size_settings, batched_seeds, seed_example, hvp_prep) = prep
    (; A, B_last) = batch_size_settings

    hvp_prep_same = prepare_hvp_same_point(
        f, hvp_prep, backend, x, seed_example, contexts...
    )

    hess = mapreduce(hcat, eachindex(batched_seeds)) do a
        dg_batch = hvp(f, hvp_prep_same, backend, x, batched_seeds[a], contexts...)
        block = stack_vec_col(dg_batch)
        if !aligned && a == A
            return block[:, 1:B_last]
        else
            return block
        end
    end
    return hess
end

function hessian!(
        f::F,
        hess,
        prep::HVPGradientHessianPrep{SIG, <:BatchSizeSettings{B}},
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {F, SIG, B, C}
    check_prep(f, prep, backend, x, contexts...)
    (; batch_size_settings, batched_seeds, batched_results, seed_example, hvp_prep) = prep
    (; N) = batch_size_settings

    hvp_prep_same = prepare_hvp_same_point(
        f, hvp_prep, backend, x, seed_example, contexts...
    )

    for a in eachindex(batched_seeds, batched_results)
        hvp!(
            f, batched_results[a], hvp_prep_same, backend, x, batched_seeds[a], contexts...
        )

        for b in eachindex(batched_results[a])
            copyto!(
                view(hess, :, 1 + ((a - 1) * B + (b - 1)) % N), vec(batched_results[a][b])
            )
        end
    end

    return hess
end

function value_gradient_and_hessian(
        f::F,
        prep::HVPGradientHessianPrep,
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, contexts...)
    y, grad = value_and_gradient(f, prep.gradient_prep, inner(backend), x, contexts...)
    hess = hessian(f, prep, backend, x, contexts...)
    return y, grad, hess
end

function value_gradient_and_hessian!(
        f::F,
        grad,
        hess,
        prep::HVPGradientHessianPrep,
        backend::AbstractADType,
        x,
        contexts::Vararg{Context, C},
    ) where {F, C}
    check_prep(f, prep, backend, x, contexts...)
    y, _ = value_and_gradient!(f, grad, prep.gradient_prep, inner(backend), x, contexts...)
    hessian!(f, hess, prep, backend, x, contexts...)
    return y, grad, hess
end

module DifferentiationInterfaceEnzymeExt

using ADTypes: ADTypes, AutoEnzyme
using Base: Fix1
import DifferentiationInterface as DI
using EnzymeCore:
    Active,
    Annotation,
    BatchDuplicated,
    BatchDuplicatedNoNeed,
    BatchMixedDuplicated,
    Combined,
    Const,
    Duplicated,
    DuplicatedNoNeed,
    EnzymeCore,
    Forward,
    ForwardMode,
    ForwardWithPrimal,
    MixedDuplicated,
    Mode,
    NoPrimal,
    Reverse,
    ReverseMode,
    ReverseModeSplit,
    ReverseSplitNoPrimal,
    ReverseSplitWidth,
    ReverseSplitWithPrimal,
    ReverseWithPrimal,
    Split,
    WithPrimal
using Enzyme:
    Enzyme,
    autodiff,
    autodiff_thunk,
    create_shadows,
    gradient,
    gradient!,
    guess_activity,
    hvp,
    hvp!,
    jacobian,
    make_zero,
    make_zero!,
    onehot

DI.check_available(::AutoEnzyme) = true

include("utils.jl")
include("counterparts.jl")

include("forward_onearg.jl")
include("forward_twoarg.jl")

include("reverse_onearg.jl")
include("reverse_twoarg.jl")

include("init.jl")

end # module

include("../../testutils.jl")

using DifferentiationInterface, DifferentiationInterfaceTest
import DifferentiationInterface as DI
using ForwardDiff: ForwardDiff
using PolyesterForwardDiff: PolyesterForwardDiff
using Test

using ExplicitImports
check_no_implicit_imports(DifferentiationInterface)

struct MyTag end

backends = [
    AutoPolyesterForwardDiff(; tag = ForwardDiff.Tag(MyTag(), Float64)),  #
    AutoPolyesterForwardDiff(; chunksize = 2),
]

for backend in backends
    @test check_available(backend)
    @test check_inplace(backend)
    test_counterparts(backend)
    @test DifferentiationInterface.inner_preparation_behavior(backend) isa
        DifferentiationInterface.PrepareInnerOverload
end

test_differentiation(
    backends,
    default_scenarios(;
        include_constantified = true, include_cachified = true, use_tuples = true
    );
    logging = LOGGING,
);

@testset "Batch size" begin
    @test DI.pick_batchsize(AutoPolyesterForwardDiff(), 10) ==
        DI.pick_batchsize(AutoForwardDiff(), 10)
    @test DI.pick_batchsize(AutoPolyesterForwardDiff(; chunksize = 3), rand(10)) ==
        DI.pick_batchsize(AutoForwardDiff(; chunksize = 3), rand(10))
end

## Pushforward

struct EnzymeTwoArgPushforwardPrep{SIG, DF, DC} <: DI.PushforwardPrep{SIG}
    _sig::Val{SIG}
    df!::DF
    context_shadows::DC
end

function DI.prepare_pushforward_nokwarg(
        strict::Val,
        f!::F,
        y,
        backend::AutoEnzyme{<:Union{ForwardMode, Nothing}},
        x,
        tx::NTuple{B},
        contexts::Vararg{DI.Context, C}
    ) where {F, B, C}
    _sig = DI.signature(f!, y, backend, x, tx, contexts...; strict)
    mode = forward_noprimal(backend)
    df! = function_shadow(f!, backend, mode, Val(B))
    context_shadows = make_context_shadows(backend, mode, Val(B), contexts...)
    return EnzymeTwoArgPushforwardPrep(_sig, df!, context_shadows)
end

function DI.value_and_pushforward(
        f!::F,
        y,
        prep::EnzymeTwoArgPushforwardPrep,
        backend::AutoEnzyme{<:Union{ForwardMode, Nothing}},
        x,
        tx::NTuple{1},
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    (; df!, context_shadows) = prep
    mode = forward_noprimal(backend)
    f!_and_df! = get_f_and_df_prepared!(df!, f!, backend, Val(1))
    dx = only(tx)
    dy = make_zero(y)
    x_and_dx = Duplicated(x, dx)
    y_and_dy = Duplicated(y, dy)
    annotated_contexts = translate_prepared!(context_shadows, contexts, Val(1))
    autodiff(mode, f!_and_df!, Const, y_and_dy, x_and_dx, annotated_contexts...)
    return y, (dy,)
end

function DI.value_and_pushforward(
        f!::F,
        y,
        prep::EnzymeTwoArgPushforwardPrep,
        backend::AutoEnzyme{<:Union{ForwardMode, Nothing}},
        x,
        tx::NTuple{B},
        contexts::Vararg{DI.Context, C},
    ) where {F, B, C}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    (; df!, context_shadows) = prep
    mode = forward_noprimal(backend)
    f!_and_df! = get_f_and_df_prepared!(df!, f!, backend, Val(B))
    ty = ntuple(_ -> make_zero(y), Val(B))
    x_and_tx = BatchDuplicated(x, tx)
    y_and_ty = BatchDuplicated(y, ty)
    annotated_contexts = translate_prepared!(context_shadows, contexts, Val(B))
    autodiff(mode, f!_and_df!, Const, y_and_ty, x_and_tx, annotated_contexts...)
    return y, ty
end

function DI.pushforward(
        f!::F,
        y,
        prep::EnzymeTwoArgPushforwardPrep,
        backend::AutoEnzyme{<:Union{ForwardMode, Nothing}},
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    _, ty = DI.value_and_pushforward(f!, y, prep, backend, x, tx, contexts...)
    return ty
end

function DI.value_and_pushforward!(
        f!::F,
        y,
        ty::NTuple{B},
        prep::EnzymeTwoArgPushforwardPrep,
        backend::AutoEnzyme{<:Union{ForwardMode, Nothing}},
        x,
        tx::NTuple{B},
        contexts::Vararg{DI.Context, C},
    ) where {F, B, C}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    (; df!, context_shadows) = prep
    mode = forward_noprimal(backend)
    f!_and_df! = get_f_and_df_prepared!(df!, f!, backend, Val(B))
    x_and_tx = BatchDuplicated(x, tx)
    y_and_ty = BatchDuplicated(y, ty)
    annotated_contexts = translate_prepared!(context_shadows, contexts, Val(B))
    autodiff(mode, f!_and_df!, Const, y_and_ty, x_and_tx, annotated_contexts...)
    return y, ty
end

function DI.pushforward!(
        f!::F,
        y,
        ty::NTuple,
        prep::EnzymeTwoArgPushforwardPrep,
        backend::AutoEnzyme{<:Union{ForwardMode, Nothing}},
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    DI.value_and_pushforward!(f!, y, ty, prep, backend, x, tx, contexts...)
    return ty
end

## Preparation

struct SMCPushforwardSparseJacobianPrep{
        SIG,
        BS <: DI.BatchSizeSettings,
        P <: AbstractMatrix,
        C <: AbstractColoringResult{:nonsymmetric, :column},
        M <: AbstractMatrix{<:Number},
        S <: AbstractVector{<:NTuple},
        R <: AbstractVector{<:NTuple},
        E <: DI.PushforwardPrep,
    } <: SMCSparseJacobianPrep{SIG}
    _sig::Val{SIG}
    batch_size_settings::BS
    sparsity::P
    coloring_result::C
    compressed_matrix::M
    batched_seeds::S
    batched_results::R
    pushforward_prep::E
end

struct SMCPullbackSparseJacobianPrep{
        SIG,
        BS <: DI.BatchSizeSettings,
        P <: AbstractMatrix,
        C <: AbstractColoringResult{:nonsymmetric, :row},
        M <: AbstractMatrix{<:Number},
        S <: AbstractVector{<:NTuple},
        R <: AbstractVector{<:NTuple},
        E <: DI.PullbackPrep,
    } <: SMCSparseJacobianPrep{SIG}
    _sig::Val{SIG}
    batch_size_settings::BS
    sparsity::P
    coloring_result::C
    compressed_matrix::M
    batched_seeds::S
    batched_results::R
    pullback_prep::E
end

function DI.prepare_jacobian_nokwarg(
        strict::Val, f::F, backend::AutoSparse, x, contexts::Vararg{DI.Context, C}
    ) where {F, C}
    dense_backend = dense_ad(backend)
    y = f(x, map(DI.unwrap, contexts)...)
    perf = DI.pushforward_performance(dense_backend)
    return _prepare_sparse_jacobian_aux(strict, perf, y, (f,), backend, x, contexts...)
end

function DI.prepare_jacobian_nokwarg(
        strict::Val, f!::F, y, backend::AutoSparse, x, contexts::Vararg{DI.Context, C}
    ) where {F, C}
    dense_backend = dense_ad(backend)
    perf = DI.pushforward_performance(dense_backend)
    return _prepare_sparse_jacobian_aux(strict, perf, y, (f!, y), backend, x, contexts...)
end

function _prepare_sparse_jacobian_aux(
        strict::Val,
        perf::DI.PushforwardPerformance,
        y,
        f_or_f!y::FY,
        backend::AutoSparse,
        x,
        contexts::Vararg{DI.Context, C}
    ) where {FY, C}
    dense_backend = dense_ad(backend)
    sparsity = DI.jacobian_sparsity_with_contexts(
        f_or_f!y..., sparsity_detector(backend), x, contexts...
    )
    if perf isa DI.PushforwardFast
        problem = ColoringProblem{:nonsymmetric, :column}()
    else
        problem = ColoringProblem{:nonsymmetric, :row}()
    end
    coloring_result = coloring(
        sparsity,
        problem,
        coloring_algorithm(backend);
        decompression_eltype = promote_type(eltype(x), eltype(y)),
    )
    if perf isa DI.PushforwardFast
        N = length(column_groups(coloring_result))
    else
        N = length(row_groups(coloring_result))
    end
    batch_size_settings = DI.pick_batchsize(dense_backend, N)
    return _prepare_sparse_jacobian_aux_aux(
        strict,
        batch_size_settings,
        sparsity,
        coloring_result,
        y,
        f_or_f!y,
        backend,
        x,
        contexts...,
    )
end

function _prepare_sparse_jacobian_aux_aux(
        strict::Val,
        batch_size_settings::DI.BatchSizeSettings{B},
        sparsity::AbstractMatrix,
        coloring_result::AbstractColoringResult{:nonsymmetric, :column},
        y,
        f_or_f!y::FY,
        backend::AutoSparse,
        x,
        contexts::Vararg{DI.Context, C}
    ) where {B, FY, C}
    _sig = DI.signature(f_or_f!y..., backend, x, contexts...; strict)
    (; N, A) = batch_size_settings
    dense_backend = dense_ad(backend)
    groups = column_groups(coloring_result)
    seeds = [DI.multibasis(x, eachindex(x)[group]) for group in groups]
    compressed_matrix = stack(_ -> vec(similar(y)), groups; dims = 2)
    batched_seeds = [
        ntuple(b -> seeds[1 + ((a - 1) * B + (b - 1)) % N], Val(B)) for a in 1:A
    ]
    batched_results = [ntuple(b -> similar(y), Val(B)) for _ in batched_seeds]
    pushforward_prep = DI.prepare_pushforward_nokwarg(
        strict, f_or_f!y..., dense_backend, x, batched_seeds[1], contexts...
    )
    return SMCPushforwardSparseJacobianPrep(
        _sig,
        batch_size_settings,
        sparsity,
        coloring_result,
        compressed_matrix,
        batched_seeds,
        batched_results,
        pushforward_prep,
    )
end

function _prepare_sparse_jacobian_aux_aux(
        strict::Val,
        batch_size_settings::DI.BatchSizeSettings{B},
        sparsity::AbstractMatrix,
        coloring_result::AbstractColoringResult{:nonsymmetric, :row},
        y,
        f_or_f!y::FY,
        backend::AutoSparse,
        x,
        contexts::Vararg{DI.Context, C}
    ) where {B, FY, C}
    _sig = DI.signature(f_or_f!y..., backend, x, contexts...; strict)
    (; N, A) = batch_size_settings
    dense_backend = dense_ad(backend)
    groups = row_groups(coloring_result)
    seeds = [DI.multibasis(y, eachindex(y)[group]) for group in groups]
    compressed_matrix = stack(_ -> vec(similar(x)), groups; dims = 1)
    batched_seeds = [
        ntuple(b -> seeds[1 + ((a - 1) * B + (b - 1)) % N], Val(B)) for a in 1:A
    ]
    batched_results = [ntuple(b -> similar(x), Val(B)) for _ in batched_seeds]
    pullback_prep = DI.prepare_pullback_nokwarg(
        strict, f_or_f!y..., dense_backend, x, batched_seeds[1], contexts...
    )
    return SMCPullbackSparseJacobianPrep(
        _sig,
        batch_size_settings,
        sparsity,
        coloring_result,
        compressed_matrix,
        batched_seeds,
        batched_results,
        pullback_prep,
    )
end

## One argument

function DI.jacobian!(
        f::F,
        jac,
        prep::SMCSparseJacobianPrep,
        backend::AutoSparse,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return _sparse_jacobian_aux!((f,), jac, prep, backend, x, contexts...)
end

function DI.jacobian(
        f::F,
        prep::SMCSparseJacobianPrep,
        backend::AutoSparse,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    jac = similar(sparsity_pattern(prep), eltype(x))
    return DI.jacobian!(f, jac, prep, backend, x, contexts...)
end

function DI.value_and_jacobian(
        f::F,
        prep::SMCSparseJacobianPrep,
        backend::AutoSparse,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return f(x, map(DI.unwrap, contexts)...), DI.jacobian(f, prep, backend, x, contexts...)
end

function DI.value_and_jacobian!(
        f::F,
        jac,
        prep::SMCSparseJacobianPrep,
        backend::AutoSparse,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return f(x, map(DI.unwrap, contexts)...),
        DI.jacobian!(f, jac, prep, backend, x, contexts...)
end

## Two arguments

function DI.jacobian!(
        f!::F,
        y,
        jac,
        prep::SMCSparseJacobianPrep,
        backend::AutoSparse,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    return _sparse_jacobian_aux!((f!, y), jac, prep, backend, x, contexts...)
end

function DI.jacobian(
        f!::F,
        y,
        prep::SMCSparseJacobianPrep,
        backend::AutoSparse,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    jac = similar(sparsity_pattern(prep), promote_type(eltype(x), eltype(y)))
    return DI.jacobian!(f!, y, jac, prep, backend, x, contexts...)
end

function DI.value_and_jacobian(
        f!::F,
        y,
        prep::SMCSparseJacobianPrep,
        backend::AutoSparse,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    jac = DI.jacobian(f!, y, prep, backend, x, contexts...)
    f!(y, x, map(DI.unwrap, contexts)...)
    return y, jac
end

function DI.value_and_jacobian!(
        f!::F,
        y,
        jac,
        prep::SMCSparseJacobianPrep,
        backend::AutoSparse,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {F, C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    DI.jacobian!(f!, y, jac, prep, backend, x, contexts...)
    f!(y, x, map(DI.unwrap, contexts)...)
    return y, jac
end

## Common auxiliaries

function _sparse_jacobian_aux!(
        f_or_f!y::FY,
        jac,
        prep::SMCPushforwardSparseJacobianPrep{SIG, <:DI.BatchSizeSettings{B}},
        backend::AutoSparse,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {FY, SIG, B, C}
    (;
        batch_size_settings,
        coloring_result,
        compressed_matrix,
        batched_seeds,
        batched_results,
        pushforward_prep,
    ) = prep
    (; N) = batch_size_settings
    dense_backend = dense_ad(backend)

    pushforward_prep_same = DI.prepare_pushforward_same_point(
        f_or_f!y..., pushforward_prep, dense_backend, x, batched_seeds[1], contexts...
    )

    for a in eachindex(batched_seeds, batched_results)
        DI.pushforward!(
            f_or_f!y...,
            batched_results[a],
            pushforward_prep_same,
            dense_backend,
            x,
            batched_seeds[a],
            contexts...,
        )

        for b in eachindex(batched_results[a])
            copyto!(
                view(compressed_matrix, :, 1 + ((a - 1) * B + (b - 1)) % N),
                vec(batched_results[a][b]),
            )
        end
    end

    decompress!(jac, compressed_matrix, coloring_result)
    return jac
end

function _sparse_jacobian_aux!(
        f_or_f!y::FY,
        jac,
        prep::SMCPullbackSparseJacobianPrep{SIG, <:DI.BatchSizeSettings{B}},
        backend::AutoSparse,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {FY, SIG, B, C}
    (;
        batch_size_settings,
        coloring_result,
        compressed_matrix,
        batched_seeds,
        batched_results,
        pullback_prep,
    ) = prep
    (; N) = batch_size_settings
    dense_backend = dense_ad(backend)

    pullback_prep_same = DI.prepare_pullback_same_point(
        f_or_f!y..., pullback_prep, dense_backend, x, batched_seeds[1], contexts...
    )

    for a in eachindex(batched_seeds, batched_results)
        DI.pullback!(
            f_or_f!y...,
            batched_results[a],
            pullback_prep_same,
            dense_backend,
            x,
            batched_seeds[a],
            contexts...,
        )

        for b in eachindex(batched_results[a])
            if eltype(x) <: Complex
                batched_results[a][b] .= conj.(batched_results[a][b])
            end
            copyto!(
                view(compressed_matrix, 1 + ((a - 1) * B + (b - 1)) % N, :),
                vec(batched_results[a][b]),
            )
        end
    end

    decompress!(jac, compressed_matrix, coloring_result)
    return jac
end

## Operator overloading

function DI.overloaded_input_type(prep::SMCPushforwardSparseJacobianPrep)
    return DI.overloaded_input_type(prep.pushforward_prep)
end

function (dw::DI.DifferentiateWith)(x::Dual{T, V, N}) where {T, V, N}
    (; f, backend) = dw
    xval = myvalue(T, x)
    tx = mypartials(T, Val(N), x)
    y, ty = DI.value_and_pushforward(f, backend, xval, tx)
    return make_dual(T, y, ty)
end

function (dw::DI.DifferentiateWith)(x::AbstractArray{Dual{T, V, N}}) where {T, V, N}
    (; f, backend) = dw
    xval = myvalue(T, x)
    tx = mypartials(T, Val(N), x)
    y, ty = DI.value_and_pushforward(f, backend, xval, tx)
    return make_dual(T, y, ty)
end

## Pushforward

struct SymbolicsOneArgPushforwardPrep{SIG, E1, E1!} <: DI.PushforwardPrep{SIG}
    _sig::Val{SIG}
    pf_exe::E1
    pf_exe!::E1!
end

function DI.prepare_pushforward_nokwarg(
        strict::Val, f, backend::AutoSymbolics, x, tx::NTuple, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, tx, contexts...; strict)
    dx = first(tx)
    x_var = variablize(x, :x)
    dx_var = variablize(dx, :dx)
    t_var = variable(:t)
    context_vars = variablize(contexts)
    step_der_var = derivative(f(x_var + t_var * dx_var, context_vars...), t_var)
    pf_var = substitute(step_der_var, Dict(t_var => zero(eltype(x))))

    erase_cache_vars!(context_vars, contexts)
    res = build_function(
        pf_var, x_var, dx_var, context_vars...; expression = Val(false), cse = true
    )
    (pf_exe, pf_exe!) = if res isa Tuple
        res
    elseif res isa RuntimeGeneratedFunction
        res, nothing
    end
    return SymbolicsOneArgPushforwardPrep(_sig, pf_exe, pf_exe!)
end

function DI.pushforward(
        f,
        prep::SymbolicsOneArgPushforwardPrep,
        backend::AutoSymbolics,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    ty = map(tx) do dx
        dy = prep.pf_exe(x, dx, map(DI.unwrap, contexts)...)
    end
    return ty
end

function DI.pushforward!(
        f,
        ty::NTuple,
        prep::SymbolicsOneArgPushforwardPrep,
        backend::AutoSymbolics,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    for b in eachindex(tx, ty)
        dx, dy = tx[b], ty[b]
        prep.pf_exe!(dy, x, dx, map(DI.unwrap, contexts)...)
    end
    return ty
end

function DI.value_and_pushforward(
        f,
        prep::SymbolicsOneArgPushforwardPrep,
        backend::AutoSymbolics,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    return f(x, map(DI.unwrap, contexts)...),
        DI.pushforward(f, prep, backend, x, tx, contexts...)
end

function DI.value_and_pushforward!(
        f,
        ty::NTuple,
        prep::SymbolicsOneArgPushforwardPrep,
        backend::AutoSymbolics,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    return f(x, map(DI.unwrap, contexts)...),
        DI.pushforward!(f, ty, prep, backend, x, tx, contexts...)
end

## Derivative

struct SymbolicsOneArgDerivativePrep{SIG, E1, E1!} <: DI.DerivativePrep{SIG}
    _sig::Val{SIG}
    der_exe::E1
    der_exe!::E1!
end

function DI.prepare_derivative_nokwarg(
        strict::Val, f, backend::AutoSymbolics, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    x_var = variablize(x, :x)
    context_vars = variablize(contexts)
    der_var = derivative(f(x_var, context_vars...), x_var)

    erase_cache_vars!(context_vars, contexts)
    res = build_function(der_var, x_var, context_vars...; expression = Val(false), cse = true)
    (der_exe, der_exe!) = if res isa Tuple
        res
    elseif res isa RuntimeGeneratedFunction
        res, nothing
    end
    return SymbolicsOneArgDerivativePrep(_sig, der_exe, der_exe!)
end

function DI.derivative(
        f,
        prep::SymbolicsOneArgDerivativePrep,
        backend::AutoSymbolics,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return prep.der_exe(x, map(DI.unwrap, contexts)...)
end

function DI.derivative!(
        f,
        der,
        prep::SymbolicsOneArgDerivativePrep,
        backend::AutoSymbolics,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    prep.der_exe!(der, x, map(DI.unwrap, contexts)...)
    return der
end

function DI.value_and_derivative(
        f,
        prep::SymbolicsOneArgDerivativePrep,
        backend::AutoSymbolics,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return f(x, map(DI.unwrap, contexts)...),
        DI.derivative(f, prep, backend, x, contexts...)
end

function DI.value_and_derivative!(
        f,
        der,
        prep::SymbolicsOneArgDerivativePrep,
        backend::AutoSymbolics,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return f(x, map(DI.unwrap, contexts)...),
        DI.derivative!(f, der, prep, backend, x, contexts...)
end

## Gradient

struct SymbolicsOneArgGradientPrep{SIG, E1, E1!} <: DI.GradientPrep{SIG}
    _sig::Val{SIG}
    grad_exe::E1
    grad_exe!::E1!
end

function DI.prepare_gradient_nokwarg(
        strict::Val, f, backend::AutoSymbolics, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    x_var = variablize(x, :x)
    context_vars = variablize(contexts)
    # Symbolic.gradient only accepts vectors
    grad_var = gradient(f(x_var, context_vars...), vec(x_var))

    erase_cache_vars!(context_vars, contexts)
    res = build_function(
        grad_var, vec(x_var), context_vars...; expression = Val(false), cse = true
    )
    (grad_exe, grad_exe!) = res
    return SymbolicsOneArgGradientPrep(_sig, grad_exe, grad_exe!)
end

function DI.gradient(
        f,
        prep::SymbolicsOneArgGradientPrep,
        backend::AutoSymbolics,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return reshape(prep.grad_exe(vec(x), map(DI.unwrap, contexts)...), size(x))
end

function DI.gradient!(
        f,
        grad,
        prep::SymbolicsOneArgGradientPrep,
        backend::AutoSymbolics,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    prep.grad_exe!(vec(grad), vec(x), map(DI.unwrap, contexts)...)
    return grad
end

function DI.value_and_gradient(
        f,
        prep::SymbolicsOneArgGradientPrep,
        backend::AutoSymbolics,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return f(x, map(DI.unwrap, contexts)...), DI.gradient(f, prep, backend, x, contexts...)
end

function DI.value_and_gradient!(
        f,
        grad,
        prep::SymbolicsOneArgGradientPrep,
        backend::AutoSymbolics,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return f(x, map(DI.unwrap, contexts)...),
        DI.gradient!(f, grad, prep, backend, x, contexts...)
end

## Jacobian

struct SymbolicsOneArgJacobianPrep{SIG, P, E1, E1!} <: DI.SparseJacobianPrep{SIG}
    _sig::Val{SIG}
    sparsity::P
    jac_exe::E1
    jac_exe!::E1!
end

function DI.prepare_jacobian_nokwarg(
        strict::Val,
        f,
        backend::Union{AutoSymbolics, AutoSparse{<:AutoSymbolics}},
        x,
        contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    x_var = variablize(x, :x)
    context_vars = variablize(contexts)
    if backend isa AutoSparse
        jac_var = sparsejacobian(vec(f(x_var, context_vars...)), vec(x_var))
        sparsity = DI.get_pattern(jac_var)
    else
        jac_var = jacobian(f(x_var, context_vars...), x_var)
        sparsity = nothing
    end

    erase_cache_vars!(context_vars, contexts)
    res = build_function(jac_var, x_var, context_vars...; expression = Val(false), cse = true)
    (jac_exe, jac_exe!) = res
    return SymbolicsOneArgJacobianPrep(_sig, sparsity, jac_exe, jac_exe!)
end

function DI.jacobian(
        f,
        prep::SymbolicsOneArgJacobianPrep,
        backend::Union{AutoSymbolics, AutoSparse{<:AutoSymbolics}},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return prep.jac_exe(x, map(DI.unwrap, contexts)...)
end

function DI.jacobian!(
        f,
        jac,
        prep::SymbolicsOneArgJacobianPrep,
        backend::Union{AutoSymbolics, AutoSparse{<:AutoSymbolics}},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    prep.jac_exe!(jac, x, map(DI.unwrap, contexts)...)
    return jac
end

function DI.value_and_jacobian(
        f,
        prep::SymbolicsOneArgJacobianPrep,
        backend::Union{AutoSymbolics, AutoSparse{<:AutoSymbolics}},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return f(x, map(DI.unwrap, contexts)...), DI.jacobian(f, prep, backend, x, contexts...)
end

function DI.value_and_jacobian!(
        f,
        jac,
        prep::SymbolicsOneArgJacobianPrep,
        backend::Union{AutoSymbolics, AutoSparse{<:AutoSymbolics}},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return f(x, map(DI.unwrap, contexts)...),
        DI.jacobian!(f, jac, prep, backend, x, contexts...)
end

## Hessian

struct SymbolicsOneArgHessianPrep{SIG, G, P, E2, E2!} <: DI.SparseHessianPrep{SIG}
    _sig::Val{SIG}
    gradient_prep::G
    sparsity::P
    hess_exe::E2
    hess_exe!::E2!
end

function DI.prepare_hessian_nokwarg(
        strict::Val,
        f,
        backend::Union{AutoSymbolics, AutoSparse{<:AutoSymbolics}},
        x,
        contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    x_var = variablize(x, :x)
    context_vars = variablize(contexts)
    # Symbolic.hessian only accepts vectors
    if backend isa AutoSparse
        hess_var = sparsehessian(f(x_var, context_vars...), vec(x_var))
        sparsity = DI.get_pattern(hess_var)
    else
        hess_var = hessian(f(x_var, context_vars...), vec(x_var))
        sparsity = nothing
    end

    erase_cache_vars!(context_vars, contexts)
    res = build_function(
        hess_var, vec(x_var), context_vars...; expression = Val(false), cse = true
    )
    (hess_exe, hess_exe!) = res

    gradient_prep = DI.prepare_gradient_nokwarg(
        strict, f, dense_ad(backend), x, contexts...
    )
    return SymbolicsOneArgHessianPrep(_sig, gradient_prep, sparsity, hess_exe, hess_exe!)
end

function DI.hessian(
        f,
        prep::SymbolicsOneArgHessianPrep,
        backend::Union{AutoSymbolics, AutoSparse{<:AutoSymbolics}},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return prep.hess_exe(vec(x), map(DI.unwrap, contexts)...)
end

function DI.hessian!(
        f,
        hess,
        prep::SymbolicsOneArgHessianPrep,
        backend::Union{AutoSymbolics, AutoSparse{<:AutoSymbolics}},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    prep.hess_exe!(hess, vec(x), map(DI.unwrap, contexts)...)
    return hess
end

function DI.value_gradient_and_hessian(
        f,
        prep::SymbolicsOneArgHessianPrep,
        backend::Union{AutoSymbolics, AutoSparse{<:AutoSymbolics}},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    y, grad = DI.value_and_gradient(
        f, prep.gradient_prep, dense_ad(backend), x, contexts...
    )
    hess = DI.hessian(f, prep, backend, x, contexts...)
    return y, grad, hess
end

function DI.value_gradient_and_hessian!(
        f,
        grad,
        hess,
        prep::SymbolicsOneArgHessianPrep,
        backend::Union{AutoSymbolics, AutoSparse{<:AutoSymbolics}},
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    y, _ = DI.value_and_gradient!(
        f, grad, prep.gradient_prep, dense_ad(backend), x, contexts...
    )
    DI.hessian!(f, hess, prep, backend, x, contexts...)
    return y, grad, hess
end

## HVP

struct SymbolicsOneArgHVPPrep{SIG, G, E2, E2!} <: DI.HVPPrep{SIG}
    _sig::Val{SIG}
    gradient_prep::G
    hvp_exe::E2
    hvp_exe!::E2!
end

function DI.prepare_hvp_nokwarg(
        strict::Val, f, backend::AutoSymbolics, x, tx::NTuple, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, tx, contexts...; strict)
    dx = first(tx)
    x_var = variablize(x, :x)
    dx_var = variablize(dx, :dx)
    context_vars = variablize(contexts)
    # Symbolic.hessian only accepts vectors
    hess_var = hessian(f(x_var, context_vars...), vec(x_var))
    hvp_vec_var = hess_var * vec(dx_var)

    erase_cache_vars!(context_vars, contexts)
    res = build_function(
        hvp_vec_var,
        vec(x_var),
        vec(dx_var),
        context_vars...;
        expression = Val(false),
        cse = true,
    )
    (hvp_exe, hvp_exe!) = res

    gradient_prep = DI.prepare_gradient_nokwarg(strict, f, backend, x, contexts...)
    return SymbolicsOneArgHVPPrep(_sig, gradient_prep, hvp_exe, hvp_exe!)
end

function DI.hvp(
        f,
        prep::SymbolicsOneArgHVPPrep,
        backend::AutoSymbolics,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    return map(tx) do dx
        dg_vec = prep.hvp_exe(vec(x), vec(dx), map(DI.unwrap, contexts)...)
        reshape(dg_vec, size(x))
    end
end

function DI.hvp!(
        f,
        tg::NTuple,
        prep::SymbolicsOneArgHVPPrep,
        backend::AutoSymbolics,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    for b in eachindex(tx, tg)
        dx, dg = tx[b], tg[b]
        prep.hvp_exe!(vec(dg), vec(x), vec(dx), map(DI.unwrap, contexts)...)
    end
    return tg
end

function DI.gradient_and_hvp(
        f,
        prep::SymbolicsOneArgHVPPrep,
        backend::AutoSymbolics,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    tg = DI.hvp(f, prep, backend, x, tx, contexts...)
    grad = DI.gradient(f, prep.gradient_prep, backend, x, contexts...)
    return grad, tg
end

function DI.gradient_and_hvp!(
        f,
        grad,
        tg::NTuple,
        prep::SymbolicsOneArgHVPPrep,
        backend::AutoSymbolics,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    DI.hvp!(f, tg, prep, backend, x, tx, contexts...)
    DI.gradient!(f, grad, prep.gradient_prep, backend, x, contexts...)
    return grad, tg
end

## Second derivative

struct SymbolicsOneArgSecondDerivativePrep{SIG, D, E1, E1!} <: DI.SecondDerivativePrep{SIG}
    _sig::Val{SIG}
    derivative_prep::D
    der2_exe::E1
    der2_exe!::E1!
end

function DI.prepare_second_derivative_nokwarg(
        strict::Val, f, backend::AutoSymbolics, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    x_var = variablize(x, :x)
    context_vars = variablize(contexts)
    der_var = derivative(f(x_var, context_vars...), x_var)
    der2_var = derivative(der_var, x_var)

    erase_cache_vars!(context_vars, contexts)
    res = build_function(der2_var, x_var, context_vars...; expression = Val(false), cse = true)
    (der2_exe, der2_exe!) = if res isa Tuple
        res
    elseif res isa RuntimeGeneratedFunction
        res, nothing
    end
    derivative_prep = DI.prepare_derivative_nokwarg(strict, f, backend, x, contexts...)
    return SymbolicsOneArgSecondDerivativePrep(_sig, derivative_prep, der2_exe, der2_exe!)
end

function DI.second_derivative(
        f,
        prep::SymbolicsOneArgSecondDerivativePrep,
        backend::AutoSymbolics,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    return prep.der2_exe(x, map(DI.unwrap, contexts)...)
end

function DI.second_derivative!(
        f,
        der2,
        prep::SymbolicsOneArgSecondDerivativePrep,
        backend::AutoSymbolics,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    prep.der2_exe!(der2, x, map(DI.unwrap, contexts)...)
    return der2
end

function DI.value_derivative_and_second_derivative(
        f,
        prep::SymbolicsOneArgSecondDerivativePrep,
        backend::AutoSymbolics,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    y, der = DI.value_and_derivative(f, prep.derivative_prep, backend, x, contexts...)
    der2 = DI.second_derivative(f, prep, backend, x, contexts...)
    return y, der, der2
end

function DI.value_derivative_and_second_derivative!(
        f,
        der,
        der2,
        prep::SymbolicsOneArgSecondDerivativePrep,
        backend::AutoSymbolics,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    y, _ = DI.value_and_derivative!(f, der, prep.derivative_prep, backend, x, contexts...)
    DI.second_derivative!(f, der2, prep, backend, x, contexts...)
    return y, der, der2
end

module DifferentiationInterfaceSparseArraysExt

using ADTypes: ADTypes
using DifferentiationInterface
import DifferentiationInterface as DI
using SparseArrays: SparseMatrixCSC, sparse, nonzeros

function DI.get_pattern(M::SparseMatrixCSC)
    S = similar(M, Bool)
    nonzeros(S) .= true
    return S
end

include("sparsity_detector.jl")

end

## Pushforward

struct MooncakeTwoArgPushforwardPrep{SIG, Tcache, FT0, FT, YT, CT} <: DI.PushforwardPrep{SIG}
    _sig::Val{SIG}
    cache::Tcache
    dcall::FT0
    df!::FT
    dy::YT
    context_tangents::CT
end

function DI.prepare_pushforward_nokwarg(
        strict::Val,
        f!::F,
        y,
        backend::AutoMooncakeForward,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C}
    ) where {F, C}
    _sig = DI.signature(f!, y, backend, x, tx, contexts...; strict)
    config = get_config(backend)
    cache = prepare_derivative_cache(
        call_and_return,
        f!,
        y,
        x,
        map(DI.unwrap, contexts)...;
        config
    )
    dcall = zero_tangent_or_primal(call_and_return, backend)
    df! = zero_tangent_or_primal(f!, backend)
    dy = zero_tangent_or_primal(y, backend)
    context_tangents = map(zero_tangent_unwrap, contexts)
    prep = MooncakeTwoArgPushforwardPrep(_sig, cache, dcall, df!, dy, context_tangents)
    return prep
end

function DI.value_and_pushforward(
        f!::F,
        y,
        prep::MooncakeTwoArgPushforwardPrep,
        backend::AutoMooncakeForward,
        x::X,
        tx::NTuple,
        contexts::Vararg{DI.Context, C}
    ) where {F, C, X}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    ty = map(tx) do dx
        _, new_dy = value_and_derivative!!(
            prep.cache,
            (call_and_return, prep.dcall),
            (f!, prep.df!),
            (y, prep.dy),
            (x, dx),
            map(first_unwrap, contexts, prep.context_tangents)...,
        )
        return _copy_output(new_dy)
    end
    return y, ty
end

function DI.pushforward(
        f!::F,
        y,
        prep::MooncakeTwoArgPushforwardPrep,
        backend::AutoMooncakeForward,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C}
    ) where {F, C}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    return DI.value_and_pushforward(f!, y, prep, backend, x, tx, contexts...)[2]
end

function DI.value_and_pushforward!(
        f!::F,
        y::Y,
        ty::NTuple,
        prep::MooncakeTwoArgPushforwardPrep,
        backend::AutoMooncakeForward,
        x::X,
        tx::NTuple,
        contexts::Vararg{DI.Context, C}
    ) where {F, C, X, Y}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    foreach(tx, ty) do dx, dy
        _, new_dy = value_and_derivative!!(
            prep.cache,
            (call_and_return, prep.dcall),
            (f!, prep.df!),
            (y, dy),
            (x, dx),
            map(first_unwrap, contexts, prep.context_tangents)...,
        )
        copyto!(dy, new_dy)
    end
    return y, ty
end

function DI.pushforward!(
        f!::F,
        y,
        ty::NTuple,
        prep::MooncakeTwoArgPushforwardPrep,
        backend::AutoMooncakeForward,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C}
    ) where {F, C}
    DI.check_prep(f!, y, prep, backend, x, tx, contexts...)
    DI.value_and_pushforward!(f!, y, ty, prep, backend, x, tx, contexts...)
    return ty
end

module DifferentiationInterfaceHyperHessiansExt

import DifferentiationInterface as DI
import .DI: AutoHyperHessians
using HyperHessians:
    HVPConfig,
    HessianConfig,
    Chunk,
    chunksize,
    HyperDual,
    hessian,
    hessian!,
    hessian_gradient_value,
    hessian_gradient_value!,
    hvp,
    hvp!,
    hvp_gradient_value,
    hvp_gradient_value!

## Traits
DI.check_available(::DI.AutoHyperHessians) = true
DI.inplace_support(::DI.AutoHyperHessians) = DI.InPlaceNotSupported()

chunk_from_backend(::DI.AutoHyperHessians{nothing}, x) = Chunk(x)
chunk_from_backend(::DI.AutoHyperHessians{CS}, x) where {CS} = Chunk{CS}()
chunk_from_backend(::DI.AutoHyperHessians{nothing}, N::Integer, ::Type{T}) where {T} = Chunk(N, T)
chunk_from_backend(::DI.AutoHyperHessians{CS}, ::Integer, ::Type) where {CS} = Chunk{CS}()

function DI.pick_batchsize(backend::DI.AutoHyperHessians, x::AbstractArray)
    B = chunksize(chunk_from_backend(backend, x))
    return DI.BatchSizeSettings{B}(length(x))
end

function DI.pick_batchsize(backend::DI.AutoHyperHessians, N::Integer)
    B = chunksize(chunk_from_backend(backend, N, Float64))
    return DI.BatchSizeSettings{B}(N)
end

function DI.threshold_batchsize(::DI.AutoHyperHessians{nothing}, ::Integer)
    return DI.AutoHyperHessians()
end
function DI.threshold_batchsize(::DI.AutoHyperHessians{CS}, chunksize2::Integer) where {CS}
    return DI.AutoHyperHessians(; chunksize = min(CS, chunksize2))
end

function _translate_toprep(::Type{T}, c::Union{DI.GeneralizedConstant, DI.ConstantOrCache}) where {T}
    return nothing
end
function _translate_toprep(::Type{T}, c::DI.Cache) where {T}
    return DI.recursive_similar(DI.unwrap(c), T)
end

function translate_toprep(::Type{T}, contexts::NTuple{C, DI.Context}) where {T, C}
    new_contexts = map(contexts) do c
        _translate_toprep(T, c)
    end
    return new_contexts
end

function _translate_prepared(c::Union{DI.GeneralizedConstant, DI.ConstantOrCache}, _pc)
    return DI.unwrap(c)
end
_translate_prepared(_c::DI.Cache, pc) = pc

function translate_prepared(
        contexts::NTuple{C, DI.Context}, prep_contexts::NTuple{C, Any}
    ) where {C}
    new_contexts = map(contexts, prep_contexts) do c, pc
        _translate_prepared(c, pc)
    end
    return new_contexts
end

## Second derivative (scalar input)

struct HyperHessiansSecondDerivativePrep{SIG, C} <: DI.SecondDerivativePrep{SIG}
    _sig::Val{SIG}
    contexts_prepared::C
end

function DI.prepare_second_derivative_nokwarg(
        strict::Val, f, backend::DI.AutoHyperHessians, x::Number, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    contexts_prepared = translate_toprep(HyperDual{1, 1, typeof(x)}, contexts)
    return HyperHessiansSecondDerivativePrep(_sig, contexts_prepared)
end

function DI.second_derivative(
        f,
        prep::HyperHessiansSecondDerivativePrep,
        backend::DI.AutoHyperHessians,
        x::Number,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    contexts_prepared = translate_prepared(contexts, prep.contexts_prepared)
    fc = DI.fix_tail(f, contexts_prepared...)
    return hessian(fc, x)
end

function DI.second_derivative!(
        f,
        der2,
        prep::HyperHessiansSecondDerivativePrep,
        backend::DI.AutoHyperHessians,
        x::Number,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    new_der2 = DI.second_derivative(f, prep, backend, x, contexts...)
    return copyto!(der2, new_der2)
end

function DI.value_derivative_and_second_derivative(
        f,
        prep::HyperHessiansSecondDerivativePrep,
        backend::DI.AutoHyperHessians,
        x::Number,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    contexts_prepared = translate_prepared(contexts, prep.contexts_prepared)
    fc = DI.fix_tail(f, contexts_prepared...)
    res = hessian_gradient_value(fc, x)
    return res.value, res.gradient, res.hessian
end

function DI.value_derivative_and_second_derivative!(
        f,
        der,
        der2,
        prep::HyperHessiansSecondDerivativePrep,
        backend::DI.AutoHyperHessians,
        x::Number,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    y, new_der, new_der2 = DI.value_derivative_and_second_derivative(f, prep, backend, x, contexts...)
    copyto!(der, new_der)
    copyto!(der2, new_der2)
    return y, der, der2
end

## Preparation structs

struct HyperHessiansHessianPrep{SIG, C, CP} <: DI.HessianPrep{SIG}
    _sig::Val{SIG}
    cfg::C
    contexts_prepared::CP
end

struct HyperHessiansHVPPrep{SIG, C, CP} <: DI.HVPPrep{SIG}
    _sig::Val{SIG}
    cfg::C
    contexts_prepared::CP
end

## Hessian

function DI.prepare_hessian_nokwarg(
        strict::Val, f, backend::DI.AutoHyperHessians, x::AbstractArray, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, contexts...; strict)
    cfg = HessianConfig(x, chunk_from_backend(backend, x))
    contexts_prepared = translate_toprep(eltype(cfg.duals), contexts)
    return HyperHessiansHessianPrep(_sig, cfg, contexts_prepared)
end

function DI.hessian(
        f,
        prep::HyperHessiansHessianPrep,
        backend::DI.AutoHyperHessians,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    contexts_prepared = translate_prepared(contexts, prep.contexts_prepared)
    fc = DI.fix_tail(f, contexts_prepared...)
    return hessian(fc, x, prep.cfg)
end

function DI.hessian!(
        f,
        hess,
        prep::HyperHessiansHessianPrep,
        backend::DI.AutoHyperHessians,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    contexts_prepared = translate_prepared(contexts, prep.contexts_prepared)
    fc = DI.fix_tail(f, contexts_prepared...)
    return hessian!(hess, fc, x, prep.cfg)
end

function DI.value_gradient_and_hessian(
        f,
        prep::HyperHessiansHessianPrep,
        backend::DI.AutoHyperHessians,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    contexts_prepared = translate_prepared(contexts, prep.contexts_prepared)
    fc = DI.fix_tail(f, contexts_prepared...)
    res = hessian_gradient_value(fc, x, prep.cfg)
    return res.value, res.gradient, res.hessian
end

function DI.value_gradient_and_hessian!(
        f,
        grad,
        hess,
        prep::HyperHessiansHessianPrep,
        backend::DI.AutoHyperHessians,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, contexts...)
    contexts_prepared = translate_prepared(contexts, prep.contexts_prepared)
    fc = DI.fix_tail(f, contexts_prepared...)
    val = hessian_gradient_value!(hess, grad, fc, x, prep.cfg)
    return val, grad, hess
end

## HVP

function DI.prepare_hvp_nokwarg(
        strict::Val, f, backend::DI.AutoHyperHessians, x::AbstractArray, tx::NTuple, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f, backend, x, tx, contexts...; strict)
    cfg = HVPConfig(x, tx, chunk_from_backend(backend, x))
    contexts_prepared = translate_toprep(eltype(cfg.duals), contexts)
    return HyperHessiansHVPPrep(_sig, cfg, contexts_prepared)
end

function DI.prepare_hvp_same_point(
        f,
        prep::HyperHessiansHVPPrep,
        backend::DI.AutoHyperHessians,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    return prep
end

function DI.hvp(
        f,
        prep::HyperHessiansHVPPrep,
        backend::DI.AutoHyperHessians,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    contexts_prepared = translate_prepared(contexts, prep.contexts_prepared)
    fc = DI.fix_tail(f, contexts_prepared...)
    return hvp(fc, x, tx, prep.cfg)
end

function DI.hvp!(
        f,
        tg::NTuple,
        prep::HyperHessiansHVPPrep,
        backend::DI.AutoHyperHessians,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    contexts_prepared = translate_prepared(contexts, prep.contexts_prepared)
    fc = DI.fix_tail(f, contexts_prepared...)
    return hvp!(tg, fc, x, tx, prep.cfg)
end

function DI.gradient_and_hvp(
        f,
        prep::HyperHessiansHVPPrep,
        backend::DI.AutoHyperHessians,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    contexts_prepared = translate_prepared(contexts, prep.contexts_prepared)
    fc = DI.fix_tail(f, contexts_prepared...)
    res = hvp_gradient_value(fc, x, tx, prep.cfg)
    return res.gradient, res.hvp
end

function DI.gradient_and_hvp!(
        f,
        grad,
        tg::NTuple,
        prep::HyperHessiansHVPPrep,
        backend::DI.AutoHyperHessians,
        x,
        tx::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f, prep, backend, x, tx, contexts...)
    contexts_prepared = translate_prepared(contexts, prep.contexts_prepared)
    fc = DI.fix_tail(f, contexts_prepared...)
    hvp_gradient_value!(tg, grad, fc, x, tx, prep.cfg)
    return grad, tg
end

end

using DifferentiationInterface: basis, multibasis
using LinearAlgebra
using StaticArrays, JLArrays
using Test
using Dates

@testset "Basis" begin
    b_ref = [0, 1, 0]
    @test basis(rand(3), 2) isa Vector
    @test basis(rand(3), 2) == b_ref
    @test basis(jl(rand(3)), 2) isa JLArray
    @test Array(basis(jl(rand(3)), 2)) == [0, 1, 0]
    @test multibasis(jl(rand(3)), [1, 2]) isa JLArray
    @test Array(multibasis(jl(rand(3)), [1, 2])) == [1, 1, 0]
    @test all(basis(jl(rand(3)), 2) .== b_ref)
    @test basis(@SVector(rand(3)), 2) isa SVector
    @test basis(@SVector(rand(3)), 2) == b_ref

    b_ref = [0 1 0; 0 0 0; 0 0 0]
    @test basis(rand(3, 3), 4) isa Matrix
    @test basis(rand(3, 3), 4) == b_ref
    @test basis(jl(rand(3, 3)), 4) isa JLArray
    @test all(basis(jl(rand(3, 3)), 4) .== b_ref)
    @test basis(@SMatrix(rand(3, 3)), 4) isa SMatrix
    @test basis(@SMatrix(rand(3, 3)), 4) == b_ref

    t = [Time(1) - Time(0)]
    @test basis(t, 1) isa Vector{Nanosecond}

    @test basis([1, 2]) == [0, 0]
    @test basis(Int[]) == Int[]
end

## Pullback

function DI.prepare_pullback_nokwarg(
        strict::Val,
        f!,
        y,
        backend::AutoReverseDiff,
        x,
        ty::NTuple,
        contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f!, y, backend, x, ty, contexts...; strict)
    return DI.NoPullbackPrep(_sig)
end

### Array in

function DI.value_and_pullback(
        f!,
        y,
        prep::DI.NoPullbackPrep,
        backend::AutoReverseDiff,
        x::AbstractArray,
        ty::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, ty, contexts...)
    fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
    function dotclosure(x, dy)
        y_copy = similar(y, eltype(x))
        fc!(y_copy, x)
        return dot(y_copy, dy)
    end
    tx = map(ty) do dy
        gradient(Fix2(dotclosure, dy), x)
    end
    fc!(y, x)
    return y, tx
end

function DI.value_and_pullback!(
        f!,
        y,
        tx::NTuple,
        prep::DI.NoPullbackPrep,
        backend::AutoReverseDiff,
        x::AbstractArray,
        ty::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, ty, contexts...)
    fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
    function dotclosure(x, dy)
        y_copy = similar(y, eltype(x))
        fc!(y_copy, x)
        return dot(y_copy, dy)
    end
    for b in eachindex(tx, ty)
        dx, dy = tx[b], ty[b]
        gradient!(dx, Fix2(dotclosure, dy), x)
    end
    fc!(y, x)
    return y, tx
end

function DI.pullback(
        f!,
        y,
        prep::DI.NoPullbackPrep,
        backend::AutoReverseDiff,
        x::AbstractArray,
        ty::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, ty, contexts...)
    fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
    function dotclosure(x, dy)
        y_copy = similar(y, eltype(x))
        fc!(y_copy, x)
        return dot(y_copy, dy)
    end
    tx = map(ty) do dy
        gradient(Fix2(dotclosure, dy), x)
    end
    return tx
end

function DI.pullback!(
        f!,
        y,
        tx::NTuple,
        prep::DI.NoPullbackPrep,
        backend::AutoReverseDiff,
        x::AbstractArray,
        ty::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, ty, contexts...)
    fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
    function dotclosure(x, dy)
        y_copy = similar(y, eltype(x))
        fc!(y_copy, x)
        return dot(y_copy, dy)
    end
    for b in eachindex(tx, ty)
        dx, dy = tx[b], ty[b]
        gradient!(dx, Fix2(dotclosure, dy), x)
    end
    return tx
end

### Number in, not supported

function DI.value_and_pullback(
        f!,
        y,
        prep::DI.NoPullbackPrep,
        backend::AutoReverseDiff,
        x::Number,
        ty::NTuple,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, ty, contexts...)
    x_array = [x]
    function f!_array(_y::AbstractArray, _x_array, args...)
        return f!(_y, only(_x_array), args...)
    end
    y, tx_array = DI.value_and_pullback(f!_array, y, backend, x_array, ty, contexts...)
    return y, only.(tx_array)
end

## Jacobian

### Without contexts

struct ReverseDiffTwoArgJacobianPrep{SIG, C, T} <: DI.JacobianPrep{SIG}
    _sig::Val{SIG}
    config::C
    tape::T
end

function DI.prepare_jacobian_nokwarg(
        strict::Val, f!, y, backend::AutoReverseDiff{compile}, x
    ) where {compile}
    _sig = DI.signature(f!, y, backend, x; strict)
    if compile
        tape = ReverseDiff.compile(JacobianTape(f!, y, x))
        return ReverseDiffTwoArgJacobianPrep(_sig, nothing, tape)
    else
        config = JacobianConfig(y, x)
        return ReverseDiffTwoArgJacobianPrep(_sig, config, nothing)
    end
end

function DI.value_and_jacobian(
        f!, y, prep::ReverseDiffTwoArgJacobianPrep, backend::AutoReverseDiff{compile}, x
    ) where {compile}
    DI.check_prep(f!, y, prep, backend, x)
    jac = similar(y, length(y), length(x))
    result = MutableDiffResult(y, (jac,))
    if compile
        result = jacobian!(result, prep.tape, x)
    else
        result = jacobian!(result, f!, y, x, prep.config)
    end
    return DiffResults.value(result), DiffResults.derivative(result)
end

function DI.value_and_jacobian!(
        f!, y, jac, prep::ReverseDiffTwoArgJacobianPrep, backend::AutoReverseDiff{compile}, x
    ) where {compile}
    DI.check_prep(f!, y, prep, backend, x)
    result = MutableDiffResult(y, (jac,))
    if compile
        result = jacobian!(result, prep.tape, x)
    else
        result = jacobian!(result, f!, y, x, prep.config)
    end
    return DiffResults.value(result), DiffResults.derivative(result)
end

function DI.jacobian(
        f!, y, prep::ReverseDiffTwoArgJacobianPrep, backend::AutoReverseDiff{compile}, x
    ) where {compile}
    DI.check_prep(f!, y, prep, backend, x)
    if compile
        jac = jacobian!(prep.tape, x)
    else
        jac = jacobian(f!, y, x, prep.config)
    end
    return jac
end

function DI.jacobian!(
        f!, y, jac, prep::ReverseDiffTwoArgJacobianPrep, backend::AutoReverseDiff{compile}, x
    ) where {compile}
    DI.check_prep(f!, y, prep, backend, x)
    if compile
        jac = jacobian!(jac, prep.tape, x)
    else
        jac = jacobian!(jac, f!, y, x, prep.config)
    end
    return jac
end

### With contexts

function DI.prepare_jacobian_nokwarg(
        strict::Val, f!, y, backend::AutoReverseDiff, x, contexts::Vararg{DI.Context, C}
    ) where {C}
    _sig = DI.signature(f!, y, backend, x, contexts...; strict)
    config = JacobianConfig(y, x)
    return ReverseDiffTwoArgJacobianPrep(_sig, config, nothing)
end

function DI.value_and_jacobian(
        f!,
        y,
        prep::ReverseDiffTwoArgJacobianPrep,
        backend::AutoReverseDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
    jac = similar(y, length(y), length(x))
    result = MutableDiffResult(y, (jac,))
    result = jacobian!(result, fc!, y, x, prep.config)
    return DiffResults.value(result), DiffResults.derivative(result)
end

function DI.value_and_jacobian!(
        f!,
        y,
        jac,
        prep::ReverseDiffTwoArgJacobianPrep,
        backend::AutoReverseDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
    result = MutableDiffResult(y, (jac,))
    result = jacobian!(result, fc!, y, x, prep.config)
    return DiffResults.value(result), DiffResults.derivative(result)
end

function DI.jacobian(
        f!,
        y,
        prep::ReverseDiffTwoArgJacobianPrep,
        backend::AutoReverseDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
    jac = jacobian(fc!, y, x, prep.config)
    return jac
end

function DI.jacobian!(
        f!,
        y,
        jac,
        prep::ReverseDiffTwoArgJacobianPrep,
        backend::AutoReverseDiff,
        x,
        contexts::Vararg{DI.Context, C},
    ) where {C}
    DI.check_prep(f!, y, prep, backend, x, contexts...)
    fc! = DI.fix_tail(f!, map(DI.unwrap, contexts)...)
    jac = jacobian!(jac, fc!, y, x, prep.config)
    return jac
end

using ADTypes
using DifferentiationInterface
using DifferentiationInterface:
    AutoSimpleFiniteDiff,
    BatchSizeSettings,
    pick_batchsize,
    reasonable_batchsize,
    threshold_batchsize
import DifferentiationInterface as DI
using StaticArrays
using Test

BSS = BatchSizeSettings

@testset "Default" begin
    @test (@inferred pick_batchsize(AutoZygote(), zeros(0))) isa BSS{1, false, true}
    @test (@inferred pick_batchsize(AutoZygote(), zeros(2))) isa BSS{1, false, true}
    @test (@inferred pick_batchsize(AutoZygote(), zeros(100))) isa BSS{1, false, true}
    @test_throws ArgumentError pick_batchsize(AutoSparse(AutoZygote()), zeros(2))
    @test_throws ArgumentError pick_batchsize(
        SecondOrder(AutoZygote(), AutoZygote()), zeros(2)
    )
    @test_throws ArgumentError pick_batchsize(
        MixedMode(AutoSimpleFiniteDiff(), AutoZygote()), zeros(2)
    )
end

@testset "SimpleFiniteDiff (adaptive)" begin
    @test (pick_batchsize(AutoSimpleFiniteDiff(), zeros(0))) isa BSS{1, false, true}
    @test (pick_batchsize(AutoSimpleFiniteDiff(), zeros(2))) isa BSS{2, true, true}
    @test (pick_batchsize(AutoSimpleFiniteDiff(), zeros(6))) isa BSS{6, true, true}
    @test (pick_batchsize(AutoSimpleFiniteDiff(), zeros(12))) isa BSS{12, true, true}
    @test (pick_batchsize(AutoSimpleFiniteDiff(), zeros(24))) isa BSS{12, false, true}
    @test (pick_batchsize(AutoSimpleFiniteDiff(), zeros(100))) isa BSS{12, false, false}
    @test (@inferred pick_batchsize(AutoSimpleFiniteDiff(), @SVector(zeros(0)))) isa
        BSS{0, true, true}
    @test (@inferred pick_batchsize(AutoSimpleFiniteDiff(), @SVector(zeros(2)))) isa
        BSS{2, true, true}
    @test (@inferred pick_batchsize(AutoSimpleFiniteDiff(), @SVector(zeros(6)))) isa
        BSS{6, true, true}
    @test (@inferred pick_batchsize(AutoSimpleFiniteDiff(), @SVector(zeros(100)))) isa
        BSS{100, true, true}
end

@testset "SimpleFiniteDiff (fixed)" begin
    @test_throws ArgumentError pick_batchsize(AutoSimpleFiniteDiff(; chunksize = 4), zeros(2))
    @test_throws ArgumentError pick_batchsize(
        AutoSimpleFiniteDiff(; chunksize = 4), @SVector(zeros(2))
    )
    @test pick_batchsize(AutoSimpleFiniteDiff(; chunksize = 4), zeros(6)) isa BSS{4}
    @test pick_batchsize(AutoSimpleFiniteDiff(; chunksize = 4), zeros(100)) isa BSS{4}
    BSS{4, true, true}
    @test pick_batchsize(AutoSimpleFiniteDiff(; chunksize = 4), zeros(99)) isa BSS{4}
    BSS{4, true, false}
    @test (
        @inferred pick_batchsize(
            AutoSimpleFiniteDiff(; chunksize = 4), @SVector(zeros(6))
        )
    ) isa BSS{4, false, false}
    @test (
        @inferred pick_batchsize(
            AutoSimpleFiniteDiff(; chunksize = 4), @SVector(zeros(100))
        )
    ) isa BSS{4, false, true}
end

@testset "Thresholding" begin
    @test threshold_batchsize(AutoSimpleFiniteDiff(), 2) isa AutoSimpleFiniteDiff{nothing}
    @test threshold_batchsize(AutoSimpleFiniteDiff(; chunksize = 4), 2) isa
        AutoSimpleFiniteDiff{2}
    @test threshold_batchsize(AutoSimpleFiniteDiff(; chunksize = 4), 6) isa
        AutoSimpleFiniteDiff{4}
    @test threshold_batchsize(AutoSparse(AutoSimpleFiniteDiff(; chunksize = 4)), 2) isa
        AutoSparse{<:AutoSimpleFiniteDiff{2}}
    @test threshold_batchsize(
        SecondOrder(
            AutoSimpleFiniteDiff(; chunksize = 4), AutoSimpleFiniteDiff(; chunksize = 3)
        ),
        6,
    ) isa SecondOrder{<:AutoSimpleFiniteDiff{4}, <:AutoSimpleFiniteDiff{3}}
    @test threshold_batchsize(
        SecondOrder(
            AutoSimpleFiniteDiff(; chunksize = 4), AutoSimpleFiniteDiff(; chunksize = 3)
        ),
        2,
    ) isa SecondOrder{<:AutoSimpleFiniteDiff{2}, <:AutoSimpleFiniteDiff{2}}
    @test threshold_batchsize(
        SecondOrder(
            AutoSimpleFiniteDiff(; chunksize = 1), AutoSimpleFiniteDiff(; chunksize = 3)
        ),
        2,
    ) isa SecondOrder{<:AutoSimpleFiniteDiff{1}, <:AutoSimpleFiniteDiff{2}}
    @test threshold_batchsize(
        SecondOrder(
            AutoSimpleFiniteDiff(; chunksize = 4), AutoSimpleFiniteDiff(; chunksize = 1)
        ),
        2,
    ) isa SecondOrder{<:AutoSimpleFiniteDiff{2}, <:AutoSimpleFiniteDiff{1}}
    @test threshold_batchsize(
        MixedMode(AutoSimpleFiniteDiff(; chunksize = 4), AutoZygote()), 2
    ) isa MixedMode{<:AutoSimpleFiniteDiff{2}, <:AutoZygote}
end

@testset "Reasonable" begin
    for Bmax in 1:5
        @test all(<=(Bmax), reasonable_batchsize.(1:10, Bmax))
        @test issorted(div.(1:10, reasonable_batchsize.(1:10, Bmax), RoundUp))
        if Bmax > 2
            @test reasonable_batchsize(Bmax + 1, Bmax) < Bmax
        end
    end
end

using ADTypes
using DifferentiationInterface
import DifferentiationInterface as DI
using Test

@testset "Missing backend" begin
    e = nothing
    try
        gradient(sum, AutoZygote(), [1.0])
    catch e
    end
    msg = sprint(showerror, e)
    @test occursin("import Zygote", msg)
end

# API

```@meta
CollapsedDocStrings = true
```

```@docs
DifferentiationInterface
```

## Argument wrappers

```@docs
Context
Constant
Cache
ConstantOrCache
```

## First order

### Pushforward

```@docs
prepare_pushforward
prepare_pushforward_same_point
pushforward
pushforward!
value_and_pushforward
value_and_pushforward!
```

### Pullback

```@docs
prepare_pullback
prepare_pullback_same_point
pullback
pullback!
value_and_pullback
value_and_pullback!
```

### Derivative

```@docs
prepare_derivative
derivative
derivative!
value_and_derivative
value_and_derivative!
```

### Gradient

```@docs
prepare_gradient
gradient
gradient!
value_and_gradient
value_and_gradient!
```

### Jacobian

```@docs
prepare_jacobian
jacobian
jacobian!
value_and_jacobian
value_and_jacobian!
```

## Second order

```@docs
SecondOrder
```

### Second derivative

```@docs
prepare_second_derivative
second_derivative
second_derivative!
value_derivative_and_second_derivative
value_derivative_and_second_derivative!
```

### Hessian-vector product

```@docs
prepare_hvp
prepare_hvp_same_point
hvp
hvp!
gradient_and_hvp
gradient_and_hvp!
```

### Hessian

```@docs
prepare_hessian
hessian
hessian!
value_gradient_and_hessian
value_gradient_and_hessian!
```

## Utilities

### Backend queries

```@docs
check_available
check_inplace
DifferentiationInterface.outer
DifferentiationInterface.inner
```

### Backend switch

```@docs
DifferentiateWith
DifferentiationInterface.forward_counterpart
DifferentiationInterface.reverse_counterpart
```

### Sparsity tools

```@docs
MixedMode
DenseSparsityDetector
```

### From primitive

```@docs
DifferentiationInterface.AutoForwardFromPrimitive
DifferentiationInterface.AutoReverseFromPrimitive
```

### Preparation type

```@docs
DifferentiationInterface.Prep
```

# Operators

!!! tip

    If there are some concepts you do not understand, take a look at the book [_The Elements of Differentiable Programming_](https://arxiv.org/abs/2403.14606) (Blondel and Roulet, 2024).

## List of operators

Given a function `f(x) = y`, there are several differentiation operators available. The terminology depends on:

- the type and shape of the input `x`
- the type and shape of the output `y`
- the order of differentiation

Below we list and describe all the operators we support.

!!! warning

    The package is thoroughly tested with inputs and outputs of the following types: `Float64`, `Vector{Float64}` and `Matrix{Float64}`.
    We also expect it to work on most kinds of `Number` and `AbstractArray` variables.
    Beyond that, you are in uncharted territory.
    We voluntarily keep the type annotations minimal, so that passing more complex objects or custom structs _might work in some cases_, but we make no guarantees about that yet.

### High-level operators

These operators are computed using only the input `x`.

| operator                    | order | input `x`       | output `y`      | operator result type | operator result shape    |
|:--------------------------- |:----- |:--------------- |:--------------- |:-------------------- |:------------------------ |
| [`derivative`](@ref)        | 1     | `Number`        | `Any`           | similar to `y`       | `size(y)`                |
| [`second_derivative`](@ref) | 2     | `Number`        | `Any`           | similar to `y`       | `size(y)`                |
| [`gradient`](@ref)          | 1     | `Any`           | `Number`        | similar to `x`       | `size(x)`                |
| [`jacobian`](@ref)          | 1     | `AbstractArray` | `AbstractArray` | `AbstractMatrix`     | `(length(y), length(x))` |
| [`hessian`](@ref)           | 2     | `AbstractArray` | `Number`        | `AbstractMatrix`     | `(length(x), length(x))` |

### Low-level operators

These operators are computed using the input `x` and another argument `t` of type `NTuple`, which contains one or more tangents.
You can think of tangents as perturbations propagated through the function; they live either in the same space as `x` or in the same space as `y`.

| operator                    | order | input `x` | output `y` | element type of `t` | operator result type | operator result shape |
|:--------------------------- |:----- |:--------- |:---------- |:------------------- |:-------------------- |:--------------------- |
| [`pushforward`](@ref) (JVP) | 1     | `Any`     | `Any`      | similar to `x`      | similar to `y`       | `size(y)`             |
| [`pullback`](@ref) (VJP)    | 1     | `Any`     | `Any`      | similar to `y`      | similar to `x`       | `size(x)`             |
| [`hvp`](@ref)               | 2     | `Any`     | `Number`   | similar to `x`      | similar to `x`       | `size(x)`             |

## Variants

Several variants of each operator are defined:

- out-of-place operators return a new derivative object
- in-place operators mutate the provided derivative object

| out-of-place                | in-place                     | out-of-place + primal                            | in-place + primal                                 |
|:--------------------------- |:---------------------------- |:------------------------------------------------ |:------------------------------------------------- |
| [`derivative`](@ref)        | [`derivative!`](@ref)        | [`value_and_derivative`](@ref)                   | [`value_and_derivative!`](@ref)                   |
| [`second_derivative`](@ref) | [`second_derivative!`](@ref) | [`value_derivative_and_second_derivative`](@ref) | [`value_derivative_and_second_derivative!`](@ref) |
| [`gradient`](@ref)          | [`gradient!`](@ref)          | [`value_and_gradient`](@ref)                     | [`value_and_gradient!`](@ref)                     |
| [`hessian`](@ref)           | [`hessian!`](@ref)           | [`value_gradient_and_hessian`](@ref)             | [`value_gradient_and_hessian!`](@ref)             |
| [`jacobian`](@ref)          | [`jacobian!`](@ref)          | [`value_and_jacobian`](@ref)                     | [`value_and_jacobian!`](@ref)                     |
| [`pushforward`](@ref)       | [`pushforward!`](@ref)       | [`value_and_pushforward`](@ref)                  | [`value_and_pushforward!`](@ref)                  |
| [`pullback`](@ref)          | [`pullback!`](@ref)          | [`value_and_pullback`](@ref)                     | [`value_and_pullback!`](@ref)                     |
| [`hvp`](@ref)               | [`hvp!`](@ref)               | [`gradient_and_hvp`](@ref)                       | [`gradient_and_hvp!`](@ref)                       |

## Mutation and signatures

Two kinds of functions are supported:

- out-of-place functions `f(x) = y`
- in-place functions `f!(y, x) = nothing`

!!! warning

    In-place functions only work with [`pushforward`](@ref), [`pullback`](@ref), [`derivative`](@ref) and [`jacobian`](@ref).
    The other operators [`hvp`](@ref), [`gradient`](@ref) and [`hessian`](@ref) require scalar outputs, so it makes no sense to mutate the number `y`.

This results in various operator signatures (the necessary arguments and their order):

| function signature        | out-of-place operator (returns `result`) | in-place  operator (mutates `result`) |
|:------------------------- |:---------------------------------------- |:------------------------------------- |
| out-of-place function `f` | `op(f, backend, x, [t])`                 | `op!(f, result, backend, x, [t])`     |
| in-place function `f!`    | `op(f!, y, backend, x, [t])`             | `op!(f!, y, result, backend, x, [t])` |

!!! warning

    The positional arguments between `f`/`f!` and `backend` are always mutated, regardless of the bang `!` in the operator name.
    In particular, for in-place functions `f!(y, x)`, every variant of every operator will mutate `y`.

## Preparation

### Principle

In many cases, AD can be accelerated if the function has been called at least once (e.g. to record a tape) or if some cache objects are pre-allocated.
This preparation procedure is backend-specific, but we expose a common syntax to achieve it.

| operator            | preparation (different point)       | preparation (same point)                 |
|:------------------- |:----------------------------------- |:---------------------------------------- |
| `derivative`        | [`prepare_derivative`](@ref)        | -                                        |
| `gradient`          | [`prepare_gradient`](@ref)          | -                                        |
| `jacobian`          | [`prepare_jacobian`](@ref)          | -                                        |
| `second_derivative` | [`prepare_second_derivative`](@ref) | -                                        |
| `hessian`           | [`prepare_hessian`](@ref)           | -                                        |
| `pushforward`       | [`prepare_pushforward`](@ref)       | [`prepare_pushforward_same_point`](@ref) |
| `pullback`          | [`prepare_pullback`](@ref)          | [`prepare_pullback_same_point`](@ref)    |
| `hvp`               | [`prepare_hvp`](@ref)               | [`prepare_hvp_same_point`](@ref)         |

In addition, the preparation syntax depends on the number of arguments accepted by the function.

| function signature    | preparation signature                |
|:--------------------- |:------------------------------------ |
| out-of-place function | `prepare_op(f, backend, x, [t])`     |
| in-place function     | `prepare_op(f!, y, backend, x, [t])` |

Preparation creates an object called `prep` which contains the the necessary information to speed up an operator and its variants.
The idea is that you prepare only once, which can be costly, but then call the operator several times while reusing the same `prep`.

```julia
op(f, backend, x, [t])  # slow because it includes preparation
op(f, prep, backend, x, [t])  # fast because it skips preparation
```

!!! warning

    The `prep` object is the last argument before `backend` and it is always mutated, regardless of the bang `!` in the operator name.
    As a consequence, preparation is **not thread-safe** and  sharing `prep` objects between threads may lead to unexpected behavior. If you need to run differentiation concurrently, prepare separate `prep` objects for each thread.

### Reusing preparation

It is not always safe to reuse the results of preparation.
For different-point preparation, the output `prep` of

```julia
prepare_op(f, [y], backend, x, [t, contexts...])
```

can be reused in subsequent calls to

```julia
op(f, prep, [other_y], backend, other_x, [other_t, other_contexts...])
```

provided that the following conditions all hold:

- `f` and `backend` remain the same
- `other_x` has the same type and size as `x`
- `other_y` has the same type and size as `y`
- `other_t` has the same type and size as `t`
- all the elements of `other_contexts` have the same type and size as the corresponding elements of `contexts`

For same-point preparation, the same rules hold with two modifications:

- `other_x` must be _equal_ to `x`
- any element of `other_contexts` with type `Constant`, as well as any constant parts of `ConstantOrCache`, must be _equal_ to the corresponding element of `contexts`

Therein lies the key difference between same-point and different-point preparation: in the latter, input and context values are allowed to differ.

!!! danger

    Reusing preparation with different types or sizes may work with some backends and error with others, so it is not allowed by default.
    To circumvent this limitation, you can pass `strict=Val(false)` to the preparation functions, but do so at your own risk.

!!! warning

    These rules hold for the majority of backends, but there are some exceptions.
    The most important exception is [ReverseDiff.jl](https://github.com/JuliaDiff/ReverseDiff.jl) and its taping mechanism, which is sensitive to control flow inside the function.

# Advanced features

## Sparsity

When faced with sparse Jacobian or Hessian matrices, one can take advantage of their sparsity pattern to speed up the computation.
DifferentiationInterface does this automatically if you pass a backend of type [`AutoSparse`](@extref ADTypes.AutoSparse).

!!! tip

    To know more about sparse AD, read the survey [_What Color Is Your Jacobian? Graph Coloring for Computing Derivatives_](https://epubs.siam.org/doi/10.1137/S0036144504444711) (Gebremedhin et al., 2005).

### `AutoSparse` object

`AutoSparse` backends only support [`jacobian`](@ref) and [`hessian`](@ref) (as well as their variants), because other operators do not output matrices.
An `AutoSparse` backend must be constructed from three ingredients:

 1. An underlying (dense) backend, which can be [`SecondOrder`](@ref) or anything from [ADTypes.jl](https://github.com/SciML/ADTypes.jl)

 2. A sparsity pattern detector following the [`ADTypes.AbstractSparsityDetector`](@extref ADTypes.AbstractSparsityDetector) interface, such as:

      + [`TracerSparsityDetector`](@extref SparseConnectivityTracer.TracerSparsityDetector) from [SparseConnectivityTracer.jl](https://github.com/adrhill/SparseConnectivityTracer.jl)
      + [`SymbolicsSparsityDetector`](@extref Symbolics.SymbolicsSparsityDetector) from [Symbolics.jl](https://github.com/JuliaSymbolics/Symbolics.jl)
      + [`DenseSparsityDetector`](@ref) from DifferentiationInterface.jl (beware that this detector only gives a locally valid pattern)
      + [`KnownJacobianSparsityDetector`](@extref ADTypes.KnownJacobianSparsityDetector) or [`KnownHessianSparsityDetector`](@extref ADTypes.KnownHessianSparsityDetector) from [ADTypes.jl](https://github.com/SciML/ADTypes.jl) (if you already know the pattern)

 3. A coloring algorithm following the [`ADTypes.AbstractColoringAlgorithm`](@extref ADTypes.AbstractColoringAlgorithm) interface, such as those from [SparseMatrixColorings.jl](https://github.com/JuliaDiff/SparseMatrixColorings.jl):

      + [`GreedyColoringAlgorithm`](@extref SparseMatrixColorings.GreedyColoringAlgorithm) (our generic recommendation, don't forget to tune the `order` parameter)
      + [`ConstantColoringAlgorithm`](@extref SparseMatrixColorings.ConstantColoringAlgorithm) (if you have already computed the optimal coloring and always want to return it)
      + [`OptimalColoringAlgorithm`](@extref SparseMatrixColorings.OptimalColoringAlgorithm) (if you have a low-dimensional matrix for which you want to know the best possible coloring)

!!! note

    Symbolic backends have built-in sparsity handling, so `AutoSparse(AutoSymbolics())` and `AutoSparse(AutoFastDifferentiation())` do not need additional configuration for pattern detection or coloring.

### Reusing sparse preparation

The preparation step of `jacobian` or `hessian` with an `AutoSparse` backend can be long, because it needs to detect the sparsity pattern and perform a matrix coloring.
But after preparation, the more zeros are present in the matrix, the greater the speedup will be compared to dense differentiation.

!!! danger

    The result of preparation for an `AutoSparse` backend cannot be reused if the sparsity pattern changes.
    In particular, during preparation, make sure to pick input and context values that do not give rise to exceptional patterns (e.g. with too many zeros because of a multiplication with a constant `c = 0`, which may then be non-zero later on). Random values are usually a better choice during sparse preparation.

### Tuning the coloring algorithm

The complexity of sparse Jacobians or Hessians grows with the number of distinct colors in a coloring of the sparsity pattern.
To reduce this number of colors, [`GreedyColoringAlgorithm`](@extref SparseMatrixColorings.GreedyColoringAlgorithm) has two main settings: the order used for vertices and the decompression method.
Depending on your use case, you may want to modify either of these options to increase performance.
See the documentation of [SparseMatrixColorings.jl](https://github.com/JuliaDiff/SparseMatrixColorings.jl) for details.

### Mixed mode

When a Jacobian matrix has both dense rows and dense columns, it can be more efficient to use "mixed-mode" differentiation, a mixture of forward and reverse.
The associated bidirectional coloring algorithm automatically decides how to cover the Jacobian using a set of columns (computed in forward mode) plus a set of rows (computed in reverse mode).
This behavior is triggered as soon as you put a [`MixedMode`](@ref) object inside `AutoSparse`, like so:

```julia
AutoSparse(
    MixedMode(forward_backend, reverse_backend); sparsity_detector, coloring_algorithm
)
```

At the moment, mixed mode tends to work best (output fewer colors) when the [`GreedyColoringAlgorithm`](@extref SparseMatrixColorings.GreedyColoringAlgorithm) is provided with a [`RandomOrder`](@extref SparseMatrixColorings.RandomOrder) instead of the usual [`NaturalOrder`](@extref SparseMatrixColorings.NaturalOrder), and when "post-processing" is activated after coloring.
For full reproducibility, you should use a random number generator from [StableRNGs.jl](https://github.com/JuliaRandom/StableRNGs.jl).
Thus, the right setup looks like:

```julia
using StableRNGs

seed = 3
coloring_algorithm = GreedyColoringAlgorithm(
    RandomOrder(StableRNG(seed), seed); postprocessing=true
)
```

## Batch mode

### Multiple tangents

The [`jacobian`](@ref) and [`hessian`](@ref) operators compute matrices by repeatedly applying lower-level operators ([`pushforward`](@ref), [`pullback`](@ref) or [`hvp`](@ref)) to a set of tangents.
The tangents usually correspond to basis elements of the appropriate vector space.
We could call the lower-level operator on each tangent separately, but some packages ([ForwardDiff.jl](https://github.com/JuliaDiff/ForwardDiff.jl) and [Enzyme.jl](https://github.com/EnzymeAD/Enzyme.jl)) have optimized implementations to handle multiple tangents at once.

This behavior is often called "vector mode" AD, but we call it "batch mode" to avoid confusion with Julia's `Vector` type.
As a matter of fact, the optimal batch size $B$ (number of simultaneous tangents) is usually very small, so tangents are passed within an `NTuple` and not a `Vector`.
When the underlying vector space has dimension $N$, the operators `jacobian` and `hessian` process $\lceil N / B \rceil$ batches of size $B$ each.

### Optimal batch size

For every backend which does not support batch mode, the batch size is set to $B = 1$.
But for [`AutoForwardDiff`](@extref ADTypes.AutoForwardDiff) and [`AutoEnzyme`](@extref ADTypes.AutoEnzyme), more complicated rules apply.
If the backend object has a pre-determined batch size $B_0$, then we always set $B = B_0$.
In particular, this will throw errors when $N < B_0$.
On the other hand, without a pre-determined batch size, we apply backend-specific heuristics to pick $B$ based on $N$.

# Arguments

## General guidelines

### Function form

DifferentiationInterface only computes derivatives for functions with one of two specific forms:

```julia
y = f(x, contexts...)  # out of place, returns `y`
f!(y, x, contexts...)  # in place, returns `nothing`
```

In this notation:

- `f` (or `f!`) is the differentiated function
- `y` is the output
- `x` is the input, the only "active" argument, which always comes first
- `contexts` may contain additional, inactive arguments

The quantities returned by the various [operators](@ref "Operators") always correspond to (partial) derivatives of `y` with respect to `x`.

### Assumptions

The package makes one central assumption on the behavior and implementation of `f` (or `f!`):

!!! danger "Mutation rule"
    Either an argument's provided value matters, or it can be mutated during the function call, but never both.

This rule is declined as follows:

- The provided value of `x` matters because we evaluate and differentiate `f` at point `x`. Therefore, `x` cannot be mutated by the function.
- For in-place functions `f!`, the output `y` is meant to be overwritten. Hence, its provided (initial) value cannot matter, and it must be entirely overwritten.

!!! warning
    Whether or not the function object itself can be mutated is a tricky question, and support for this varies between backends.
    When in doubt, try to avoid mutating functions and pass contexts instead.
    In any case, DifferentiationInterface will assume that the recursive components (fields, subfields, etc.) of `f` or `f!` individually satisfy the same mutation rule: whenever the initial value matters, no mutation is allowed.

## Contexts

### Motivation

As stated, there can be only one active argument, which we call `x`.
However, version 0.6 of the package introduced the possibility of additional "context" arguments, whose derivatives we don't need to compute.
Contexts can be useful if you have a function `y = f(x, a, b, c, ...)` or `f!(y, x, a, b, c, ...)` and you only want the derivative of `y` with respect to `x`.
Another option would be creating a closure, but that is sometimes undesirable for performance reasons.

Every context argument must be wrapped in a subtype of [`Context`](@ref) and come after the active argument `x`.

### Context types

There are three kinds of context: [`Constant`](@ref), [`Cache`](@ref) and the hybrid [`ConstantOrCache`](@ref).
Those are also classified based on the mutation rule:

- [`Constant`](@ref) contexts wrap data that influences the output of the function. Hence they cannot be mutated.
- [`Cache`](@ref) contexts correspond to scratch spaces that can be mutated at will. Hence their provided value is arbitrary.
- [`ConstantOrCache`](@ref) is a hybrid, whose recursive components (fields, subfields, etc.) must individually satisfy the assumptions of either `Constant` or `Cache`.

Semantically, both of these calls compute the partial gradient of `f(x, c)` with respect to `x`, but they consider `c` differently:

```julia
gradient(f, backend, x, Constant(c))
gradient(f, backend, x, Cache(c))
```

In the first call, `c` must be kept unchanged throughout the function evaluation.
In the second call, `c` may be mutated with values computed during the function.

!!! warning
    Not every backend supports every type of context. See the documentation on [backends](@ref "Backends") for more details.

# Differentiability

DifferentiationInterface.jl and its sibling package [DifferentiationInterfaceTest.jl](https://github.com/JuliaDiff/DifferentiationInterface.jl/tree/main/DifferentiationInterfaceTest) allow you to try out differentiation of existing code with a variety of AD backends.
However, they will not help you _write_ differentiable code in the first place.
To make your functions compatible with several backends, you need to mind the restrictions imposed by each one.

The list of backends available at [juliadiff.org](https://juliadiff.org/) is split into 2 main families: operator overloading and source transformation.
Writing differentiable code requires a specific approach in each paradigm:

- For operator overloading, ensure type-genericity.
- For source transformation, rely on existing rules or write your own.

!!! tip

    Depending on your intended use case, you may not need to ensure compatibility with every single backend.
    In particular, some applications strongly suggest a specific "mode" of AD (forward or reverse), in which case backends limited to the other mode are mostly irrelevant.

In what follows, we do not discuss AD with finite differences ([FiniteDiff.jl](https://github.com/JuliaDiff/FiniteDiff.jl) and [FiniteDifferences.jl](https://github.com/JuliaDiff/FiniteDifferences.jl)) because those packages will work as long as your function itself can run, which is obviously a prerequisite.

## Operator overloading

### ForwardDiff

One of the most common backends in the ecosystem is [ForwardDiff.jl](https://github.com/JuliaDiff/ForwardDiff.jl).
It performs AD at a scalar level by replacing plain numbers with [`Dual` numbers](https://juliadiff.org/ForwardDiff.jl/stable/dev/how_it_works/), which carry derivative information.
As explained in the [limitations of ForwardDiff](https://juliadiff.org/ForwardDiff.jl/stable/user/limitations/), this will only work if the differentiated code does not restrict number types too much.
Otherwise, you may encounter errors like this one:

```
MethodError: no method matching Float64(::ForwardDiff.Dual{...})
```

To prevent them, here are a few things to look out for:

- Avoid functions with overly specific type annotations.

```julia
f(x::Vector{Float64}) = x # bad
f(x::AbstractVector{<:Real}) = x # good
```

- When creating new containers or buffers, adapt to the input number type if necessary.

```julia
tmp = zeros(length(x))  # bad
tmp = zeros(eltype(x), length(x))  # good
tmp = similar(x)  # best when possible
```

In some situations, manually writing overloads for `x::Dual` or `x::AbstractArray{<:Dual}` can be necessary.

### ReverseDiff

[ReverseDiff.jl](https://github.com/JuliaDiff/ReverseDiff.jl) relies on operator overloading for scalars, but also for arrays.
The relevant types are called `TrackedReal` and `TrackedArray`, they have a set of [limitations](https://juliadiff.org/ReverseDiff.jl/stable/limits/) very similar to that of ForwardDiff.jl's `Dual` and will cause similar errors.

### Symbolic backends

[Symbolics.jl](https://github.com/JuliaSymbolics/Symbolics.jl) and [FastDifferentiation.jl](https://github.com/brianguenter/FastDifferentiation.jl) are also based on operator overloading.
However, their respective number types are a bit different because they represent symbolic variables instead of numerical values.
The operator overloading aims at reconstructing a symbolic representation of the function (an equation, more or less), which means certain language constructs will not be tolerated even though ForwardDiff.jl or ReverseDiff.jl could handle them.

## Source transformation

### Zygote

[Zygote.jl](https://github.com/FluxML/Zygote.jl) can differentiate a lot of Julia code, but it does have some major [limitations](https://fluxml.ai/Zygote.jl/stable/limitations/).
The most frequently encountered is the lack of support for mutation: if you try to modify the contents of an array during differentiation, you will get an error like

```
ERROR: Mutating arrays is not supported
```

Mutations and some other language constructs (exceptions, foreign calls) will make a function incompatible with Zygote.
In such cases, the proper workaround is to define a reverse rule (`rrule`) for that function using [ChainRulesCore.jl](https://github.com/JuliaDiff/ChainRulesCore.jl).
You can find a [pedagogical example](https://juliadiff.org/ChainRulesCore.jl/stable/rule_author/example.html) for rule-writing in the documentation of ChainRulesCore.jl.

### Enzyme

By targeting a lower-level code representation than Zygote.jl, [Enzyme.jl](https://github.com/EnzymeAD/Enzyme.jl) is able to differentiate a much wider set of functions.
The [FAQ](https://enzymead.github.io/Enzyme.jl/stable/faq/) gives some details on the breadth of coverage, but it should be enough for a lot of use cases.

Enzyme.jl also has an extensible [rule system](https://enzymead.github.io/Enzyme.jl/stable/generated/custom_rule/) which you can use to circumvent differentiation errors.
Note that its rule writing is very different from ChainRulesCore.jl due to the presence of input activity [annotations](https://enzymead.github.io/Enzyme.jl/stable/api/#EnzymeCore.Annotation).

### Mooncake

[Mooncake.jl](https://github.com/chalk-lab/Mooncake.jl) is a recent package which also handles a large subset of all Julia programs out-of-the-box.

Its [rule system](https://chalk-lab.github.io/Mooncake.jl/stable/understanding_mooncake/rule_system/) is less expressive than that of Enzyme.jl, which might make it easier to start with.

## A rule mayhem?

To summarize, here are the main rule systems which coexist at the moment:

- `Dual` numbers in ForwardDiff.jl
- ChainRulesCore.jl
- Enzyme.jl
- Mooncake.jl

### Rule translation

This split situation is unfortunate, but AD packages are so complex that making a cross-backend rule system is a very ambitious endeavor.
ChainRulesCore.jl is the closest thing we have to a standard, but it does not handle mutation.
As a result, Enzyme.jl and Mooncake.jl both rolled out their own designs, which are not mutually compatible.
There are, however, translation utilities:

- from ChainRulesCore.jl to ForwardDiff.jl with [ForwardDiffChainRules.jl](https://github.com/ThummeTo/ForwardDiffChainRules.jl)
- from ChainRulesCore.jl to Enzyme.jl with [`Enzyme.@import_rrule`](https://enzymead.github.io/Enzyme.jl/stable/api/#Enzyme.@import_rrule-Tuple)
- from ChainRulesCore.jl to Mooncake.jl with [`Mooncake.@from_rrule`](https://chalk-lab.github.io/Mooncake.jl/stable/utilities/defining_rules/#Using-ChainRules.jl)

### Backend switch

Also note the existence of [`DifferentiationInterface.DifferentiateWith`](@ref), which allows the user to wrap a function that should be differentiated with a specific backend.

Right now, it only targets [ForwardDiff.jl](https://github.com/JuliaDiff/ForwardDiff.jl), [Mooncake.jl](), [ChainRules.jl](https://juliadiff.org/ChainRulesCore.jl/stable/)-compatible backends (e.g., [Zygote.jl](https://github.com/FluxML/Zygote.jl)), but PRs are welcome to define Enzyme.jl rules for this object.

# Basic tutorial

We present the main features of DifferentiationInterface.jl.

```@example tuto_basic
using DifferentiationInterface
```

## Computing a gradient

A common use case of automatic differentiation (AD) is optimizing real-valued functions with first- or second-order methods.
Let's define a simple objective (the squared norm) and a random input vector

```@example tuto_basic
f(x) = sum(abs2, x)
```

```@example tuto_basic
x = collect(1.0:5.0)
```

To compute its gradient, we need to choose a "backend", i.e. an AD package to call under the hood.
Most backend types are defined by [ADTypes.jl](https://github.com/SciML/ADTypes.jl) and re-exported by DifferentiationInterface.jl.

[ForwardDiff.jl](https://github.com/JuliaDiff/ForwardDiff.jl) is very generic and efficient for low-dimensional inputs, so it's a good starting point:

```@example tuto_basic
using ForwardDiff: ForwardDiff

backend = AutoForwardDiff()
```

!!! tip

    To avoid name conflicts, load AD packages with `import` instead of `using`.
    Indeed, most AD packages also export operators like `gradient` and `jacobian`, but you only want to use the ones from DifferentiationInterface.jl.

Now you can use the following syntax to compute the gradient:

```@example tuto_basic
gradient(f, backend, x)
```

Was that fast?
[BenchmarkTools.jl](https://github.com/JuliaCI/BenchmarkTools.jl) helps you answer that question.

```@example tuto_basic
using BenchmarkTools

@benchmark gradient($f, $backend, $x)
```

Not bad, but you can do better.

## Overwriting a gradient

Since you know how much space your gradient will occupy (the same as your input `x`), you can pre-allocate that memory and offer it to AD.
Some backends get a speed boost from this trick.

```@example tuto_basic
grad = similar(x)
gradient!(f, grad, backend, x)
grad  # has been mutated
```

The bang indicates that one of the arguments of `gradient!` might be mutated.
More precisely, our convention is that _every positional argument between the function and the backend is mutated_.

```@example tuto_basic
@benchmark gradient!($f, $grad, $backend, $x)
```

For some reason the in-place version is not much better than your first attempt.
However, it makes fewer allocations, thanks to the gradient vector you provided.
Don't worry, you can get even more performance.

## Preparing for multiple gradients

Internally, ForwardDiff.jl creates some data structures to keep track of things.
These objects can be reused between gradient computations, even on different input values.
We abstract away the preparation step behind a backend-agnostic syntax:

```@example tuto_basic
using Random
typical_x = randn!(similar(x))
prep = prepare_gradient(f, backend, typical_x)
```

You don't need to know what this object is, you just need to pass it to the gradient operator.
Note that preparation does not depend on the actual components of the vector `x`, just on its type and size.

You can then reuse the `prep` for different values of the input.

```@example tuto_basic
grad = similar(x)
gradient!(f, grad, prep, backend, x)
grad  # has been mutated
```

!!! warning
    Reusing the `prep` object on inputs of a different type will throw an error.
    Reusing the `prep` object on inputs of a different size may either work, fail silently or fail loudly, possibly even crash your REPL. Do not try it.

Preparation makes the gradient computation much faster, and (in this case) allocation-free.

```@example tuto_basic
@benchmark gradient!($f, $grad, $prep, $backend, $x)
```

Beware that the `prep` object is nearly always mutated by differentiation operators, even though it is given as the last positional argument.

## Switching backends

The whole point of DifferentiationInterface.jl is that you can easily experiment with different AD solutions.
Typically, for gradients, reverse mode AD might be a better fit, so let's try [Zygote.jl](https://github.com/FluxML/Zygote.jl)!

```@example tuto_basic
using Zygote: Zygote

backend2 = AutoZygote()
```

Once the backend is created, things run smoothly with exactly the same syntax as before:

```@example tuto_basic
gradient(f, backend2, x)
```

And you can run the same benchmarks to see what you gained (although such a small input may not be realistic):

```@example tuto_basic
prep2 = prepare_gradient(f, backend2, randn!(similar(x)))

@benchmark gradient!($f, $grad, $prep2, $backend2, $x)
```

In short, DifferentiationInterface.jl allows for easy testing and comparison of AD backends.
If you want to go further, check out the [documentation of DifferentiationInterfaceTest.jl](https://juliadiff.org/DifferentiationInterface.jl/DifferentiationInterfaceTest).
This related package provides benchmarking utilities to compare backends and help you select the one that is best suited for your problem.

# Limitations

## Multithreading

The preparation result `prep` is not thread-safe, since it usually contains values that are mutated by differentiation calls.
Sharing it between threads may lead to unexpected behavior or errors.
If you need to run differentiation concurrently, construct a separate `prep` object for each thread, for instance with the help of [OhMyThreads.jl](https://github.com/JuliaFolds2/OhMyThreads.jl).

Note that functions which use multithreading internally are completely fine:

```julia
function f!(y, x)
    @threads for i in eachindex(y, x)
        y[i] = x[i]
    end
    return nothing
end

# this is correct
prep = prepare_jacobian(f!, y, backend, x)
J = jacobian(f!, y, prep, backend, x)
```

The pattern we are warning about concerns multithreading outside of the function:

```julia
# this is incorrect
prep = prepare_jacobian(f!, y, backend, x)
@threads for k in 1:n
    # same prep object, different threads writing to it
    J = jacobian(f!, ys[k], prep, backend, xs[k])
end
```

## Multiple active arguments

At the moment, most backends cannot work with multiple active (differentiated) arguments.
As a result, DifferentiationInterface only supports a single active argument, called `x` in the documentation.

## Complex numbers

Complex derivatives are only handled by a few AD backends, sometimes using different conventions.
To find the easiest common ground, DifferentiationInterface assumes that whenever complex numbers are involved, the function to differentiate is holomorphic.
This functionality is still considered experimental and not yet part of the public API guarantees.
If you work with non-holomorphic functions, you will need to manually separate real and imaginary parts.

# Mathematical model

This page recaps the mathematical model of automatic differentiation used by DI, which justifies how preparation results are constructed.
It is inspired by

- the [documentation](https://chalk-lab.github.io/Mooncake.jl/stable/understanding_mooncake/rule_system/) of [Mooncake.jl](https://github.com/chalk-lab/Mooncake.jl)
- [this Discourse answer](https://discourse.julialang.org/t/do-i-understand-enzyme-properly/97760) about [Enzyme.jl](https://github.com/EnzymeAD/Enzyme.jl)

## Setting and hypotheses

Consider a mathematical function $f(x, c, s) = y$ where

-  $x \in \mathcal{X}$ is the active argument (the one being differentiated)
-  $c \in \mathcal{C}$ is a constant argument (corresponds to [`Constant`](@ref) contexts)
-  $s \in \mathcal{S}$ is a scratch argument (corresponds to [`Cache`](@ref) contexts)
-  $y \in \mathcal{Y}$ is the output

In Julia code, some of the input arguments might be mutated, while the output may be written to as well.
Therefore, the proper model is a function $\phi(x_0, c_0, s_0, y_0) = (x_1, c_1, s_1, y_1)$ where $a_0$ is the state of argument $a$ before $f$ is run, while $a_1$ is its state after $f$ is run.

DI makes the following hypotheses on the implementation of $f$ (aka the behavior of $\phi$):

1. The active argument $x$ is not mutated, so $x_1 = x_0$.
2. The constant argument $c$ is not mutated, so $c_1 = c_0$.
3. The initial value of the scratch argument $s_0$ does not matter. It does not affect any of the states $x_1$, $c_1$, $s_1$, $y_1$.
4. The initial value of the output $y_0$ does not matter. It does not affect any of the states $x_1$, $c_1$, $s_1$, $y_1$.

## Forward mode

We want to compute a Jacobian-Vector Product (JVP) $\dot{y} = \left(\frac{\partial f}{\partial x}\right) \dot{x}$ where $\dot{x} \in \mathcal{X}$ is an input tangent.

To do that, we run our AD backend on $\phi$ with input tangents $(\dot{x}_0, \dot{c}_0, \dot{s}_0, \dot{y}_0)$ and obtain $(\dot{x}_1, \dot{c}_1, \dot{s}_1, \dot{y}_1)$.
The value of interest is
$$\dot{y}_1 = \frac{\partial y_1}{\partial x_0} \dot{x}_0 + \frac{\partial y_1}{\partial c_0} \dot{c}_0 + \frac{\partial y_1}{\partial s_0} \dot{s}_0 + \frac{\partial y_1}{\partial y_0} \dot{y}_0$$

Thanks to our hypotheses 3 and 4 on the function's implementation, $\frac{\partial y_1}{\partial s_0} = 0$ and $\frac{\partial y_1}{\partial y_0} = 0$, so we are left with:
$$\dot{y}_1 = \frac{\partial y_1}{\partial x_0} \dot{x_0} + \frac{\partial y_1}{\partial c_0} \dot{c_0}$$

Thus, as long as we set $\dot{c}_0 = 0$, the output tangent $\dot{y}_1$ contains the correct JVP.
Let us now look at $\dot{c}_1$ with the help of hypothesis 2:
$$\dot{c}_1 = \frac{\partial c_1}{\partial x_0} \dot{x}_0 + \frac{\partial c_1}{\partial c_0} \dot{c}_0 + \frac{\partial c_1}{\partial s_0} \dot{s}_0 + \frac{\partial c_1}{\partial y_0} \dot{y}_0 = \dot{c}_0$$

The tangent of $c$ will always be preserved by differentiation.

## Reverse mode

We want to compute a Vector-Jacobian Product (VJP) $\bar{x} = \left(\frac{\partial f}{\partial x}\right)^* \bar{y}$ where $\bar{y} \in \mathcal{Y}$ is an output sensivity.

To do that, we run our AD backend on $\phi$ with output sensitivities $(\bar{x}_1, \bar{c}_1, \bar{s}_1, \bar{y}_1)$ and obtain $(\bar{x}_0, \bar{c}_0, \bar{s}_0, \bar{y}_0)$.
The value of interest is
$$\bar{x}_0 = \left(\frac{\partial x_1}{\partial x_0}\right)^* \bar{x}_1 + \left(\frac{\partial c_1}{\partial x_0}\right)^* \bar{c}_1 + \left(\frac{\partial s_1}{\partial x_0}\right)^* \bar{s}_1 + \left(\frac{\partial y_1}{\partial x_0}\right)^* \bar{y}_1$$

Thanks to our hypotheses 1 and 2 on the function's implementation, $\frac{\partial x_1}{\partial x_0} = I$ and $\frac{\partial c_1}{\partial x_0} = \frac{\partial c_0}{\partial x_0} =0$, so we are left with:
$$\bar{x}_0 = \bar{x}_1 + \left(\frac{\partial s_1}{\partial x_0}\right)^* \bar{s}_1 + \left(\frac{\partial y_1}{\partial x_0}\right)^* \bar{y}_1$$

Thus, as long as we set $\bar{x}_1 = 0$ and $\bar{s}_1 = 0$, the input sensitivity $\bar{x}_0$ contains the correct VJP.
Let us now look at $\bar{s}_0$ with the help of hypothesis 3, which tells us that $\frac{\partial x_1}{\partial s_0} = 0$, $\frac{\partial c_1}{\partial s_0} = 0$, $\frac{\partial s_1}{\partial s_0} = 0$, and $\frac{\partial y_1}{\partial s_0} = 0$:

$$\bar{s}_0 = \left(\frac{\partial x_1}{\partial s_0}\right)^* \bar{x}_1 + \left(\frac{\partial c_1}{\partial s_0}\right)^* \bar{c}_1 + \left(\frac{\partial s_1}{\partial s_0}\right)^* \bar{s}_1 + \left(\frac{\partial y_1}{\partial s_0}\right)^* \bar{y}_1 = 0$$

The sensitivity of $s$ will always be set to $0$ by differentiation.

## Implementation

DI's preparation mechanism allows pre-allocating the memory for tangents and sensitivities, inside a `prep` object.
This object is then reused across several AD calls.

For mutable objects, each AD call performs the following transformations on the provided shadow/dual storage (`Duplicated` for Enzyme, `Dual` / `CoDual` for Mooncake):

- In forward mode, $\dot{a}$ is updated from $\dot{a}_0$ to $\dot{a}_1$
- In reverse mode, $\bar{a}$ is updated from $\bar{a}_1$ to $\bar{a}_0$

### At initialization

How to initialize shadow/dual memory inside `prep`?

- In forward mode, make sure that $\dot{c} = 0$.
- In reverse mode, make sure that $\bar{x} = 0$ and $\bar{s} = 0$.

### At every call

Should the shadow/dual memory inside `prep` be reset before every AD call?

- In forward mode, no need ($\dot{c}$ will remain $0$ if it is initialized to $0$)
- In reverse mode, just set $\bar{x} = 0$ ($\bar{s}$ will be reset to $0$ at every AD call)

!!! warning "Mooncake's constant handling"
    As noticed in [Mooncake#1238](https://github.com/chalk-lab/Mooncake.jl/issues/1238), the actual pullback implemented by Mooncake doesn't annihilate the influence of $\bar{c}_1$ onto $\bar{x}_0$.
    Thus, constant contexts also need to be zeroed out systematically with this backend, otherwise noise will accumulate into their cotangents.

# Advanced tutorial

We present contexts and sparsity handling with DifferentiationInterface.jl.

```@example tuto_advanced
using ADTypes
using BenchmarkTools
using DifferentiationInterface
using ForwardDiff: ForwardDiff
using Zygote: Zygote
using Random
using SparseConnectivityTracer
using SparseMatrixColorings
```

## Contexts

Assume you want differentiate a multi-argument function with respect to the first argument.

```@example tuto_advanced
f_multiarg(x, c) = c * sum(abs2, x)
nothing  # hide
```

The first way, which works with every backend, is to create a closure:

```@example tuto_advanced
f_singlearg(c) = x -> f_multiarg(x, c)
nothing  # hide
```

Let's see it in action:

```@example tuto_advanced
backend = AutoForwardDiff()
x = float.(1:3)

gradient(f_singlearg(10), backend, x)
```

However, for performance reasons, it is sometimes preferrable to avoid closures and pass all arguments to the original function.
We can do this by wrapping `c` into a [`Constant`](@ref) and giving this constant to the `gradient` operator.

```@example tuto_advanced
gradient(f_multiarg, backend, x, Constant(10))
```

Preparation also works in this case, even if the constant changes before execution:

```@example tuto_advanced
prep_other_constant = prepare_gradient(f_multiarg, backend, x, Constant(-1))
gradient(f_multiarg, prep_other_constant, backend, x, Constant(10))
```

For additional arguments which act as mutated buffers, the [`Cache`](@ref) wrapper is the appropriate choice instead of [`Constant`](@ref).

## Sparsity

!!! tip

    If you use DifferentiationInterface's Sparse AD functionality in your research,
    please cite our preprint [*Sparser, Better, Faster, Stronger: Efficient Automatic Differentiation for Sparse Jacobians and Hessians*](https://arxiv.org/abs/2501.17737).

Sparse AD is very useful when Jacobian or Hessian matrices have a lot of zeros.
So let us write functions that satisfy this property.

```@example tuto_advanced
f_sparse_vector(x::AbstractVector) = diff(x .^ 2) + diff(reverse(x .^ 2))
f_sparse_scalar(x::AbstractVector) = sum(f_sparse_vector(x) .^ 2)
nothing  # hide
```

### Dense backends

When we use the [`jacobian`](@ref) or [`hessian`](@ref) operator with a dense backend, we get a dense matrix with plenty of zeros.

```@example tuto_advanced
x = float.(1:8);
```

```@example tuto_advanced
dense_forward_backend = AutoForwardDiff()
J_dense = jacobian(f_sparse_vector, dense_forward_backend, x)
```

```@example tuto_advanced
dense_second_order_backend = SecondOrder(AutoForwardDiff(), AutoZygote())
H_dense = hessian(f_sparse_scalar, dense_second_order_backend, x)
```

The results are correct but the procedure is very slow.
By using a sparse backend, we can get the runtime to increase with the number of nonzero elements, instead of the total number of elements.

### Sparse backends

Recipe to create a sparse backend: combine a dense backend, a sparsity detector and a compatible coloring algorithm inside [`AutoSparse`](@extref ADTypes.AutoSparse).
The following are reasonable defaults:

```@example tuto_advanced
sparse_forward_backend = AutoSparse(
    dense_forward_backend;  # any object from ADTypes
    sparsity_detector=TracerSparsityDetector(),
    coloring_algorithm=GreedyColoringAlgorithm(),
)

sparse_second_order_backend = AutoSparse(
    dense_second_order_backend;  # any object from ADTypes or a SecondOrder from DI
    sparsity_detector=TracerSparsityDetector(),
    coloring_algorithm=GreedyColoringAlgorithm(),
)
nothing  # hide
```

Now the resulting matrices are sparse:

```@example tuto_advanced
jacobian(f_sparse_vector, sparse_forward_backend, x)
```

```@example tuto_advanced
hessian(f_sparse_scalar, sparse_second_order_backend, x)
```

### Sparse preparation

In the examples above, we didn't use preparation.
Sparse preparation is more costly than dense preparation, but it is even more essential.
Indeed, once preparation is done, sparse differentiation is much faster than dense differentiation, because it makes fewer calls to the underlying function.

Some result analysis functions from [SparseMatrixColorings.jl](https://github.com/JuliaDiff/SparseMatrixColorings.jl) can help you figure out what the preparation contains.
First, it records the sparsity pattern itself (the one returned by the detector).

```@example tuto_advanced
jac_prep = prepare_jacobian(f_sparse_vector, sparse_forward_backend, x)
sparsity_pattern(jac_prep)
```

In forward mode, each column of the sparsity pattern gets a color.

```@example tuto_advanced
column_colors(jac_prep)
```

And the colors in turn define non-overlapping groups (for Jacobians at least, Hessians are a bit more complicated).

```@example tuto_advanced
column_groups(jac_prep)
```

### Sparsity speedup

When preparation is used, the speedup due to sparsity becomes very visible in large dimensions.

```@example tuto_advanced
xbig = rand(1000)
nothing  # hide
```

```@example tuto_advanced
jac_prep_dense = prepare_jacobian(f_sparse_vector, dense_forward_backend, zero(xbig))
@benchmark jacobian($f_sparse_vector, $jac_prep_dense, $dense_forward_backend, $xbig)
```

```@example tuto_advanced
jac_prep_sparse = prepare_jacobian(f_sparse_vector, sparse_forward_backend, zero(xbig))
@benchmark jacobian($f_sparse_vector, $jac_prep_sparse, $sparse_forward_backend, $xbig)
```

Better memory use can be achieved by pre-allocating the matrix from the preparation result (so that it has the correct structure).

```@example tuto_advanced
jac_buffer = similar(sparsity_pattern(jac_prep_sparse), eltype(xbig))
@benchmark jacobian!(
    $f_sparse_vector, $jac_buffer, $jac_prep_sparse, $sparse_forward_backend, $xbig
)
```

And for optimal speed, one should write non-allocating and type-stable functions.

```@example tuto_advanced
function f_sparse_vector!(y::AbstractVector, x::AbstractVector)
    n = length(x)
    for i in eachindex(y)
        y[i] = abs2(x[i + 1]) - abs2(x[i]) + abs2(x[n - i]) - abs2(x[n - i + 1])
    end
    return nothing
end

ybig = zeros(length(xbig) - 1)
f_sparse_vector!(ybig, xbig)
ybig ≈ f_sparse_vector(xbig)
```

In this case, the sparse Jacobian should also become non-allocating (for our specific choice of backend).

```@example tuto_advanced
jac_prep_sparse_nonallocating = prepare_jacobian(
    f_sparse_vector!, zero(ybig), sparse_forward_backend, zero(xbig)
)
jac_buffer = similar(sparsity_pattern(jac_prep_sparse_nonallocating), eltype(xbig))
@benchmark jacobian!(
    $f_sparse_vector!,
    $ybig,
    $jac_buffer,
    $jac_prep_sparse_nonallocating,
    $sparse_forward_backend,
    $xbig,
)
```

### Mixed mode

Some Jacobians have a structure which includes dense rows and dense columns, like this one:

```@example tuto_advanced
arrowhead(x) = x .+ x[1] .+ vcat(sum(x), zeros(eltype(x), length(x)-1))

jacobian_sparsity(arrowhead, x, TracerSparsityDetector())
```

In such cases, sparse AD is only beneficial in "mixed mode", where we combine a forward and a reverse backend.
This is achieved using the [`MixedMode`](@ref) wrapper, for which we recommend a random coloring order (see [`RandomOrder`](@extref SparseMatrixColorings.RandomOrder)):

```@example tuto_advanced
sparse_mixed_backend = AutoSparse(
    MixedMode(AutoForwardDiff(), AutoZygote());
    sparsity_detector=TracerSparsityDetector(),
    coloring_algorithm=GreedyColoringAlgorithm(RandomOrder(MersenneTwister(), 0)),
)
```

It unlocks a large speedup compared to pure forward mode, and the same would be true compared to reverse mode:

```@example tuto_advanced
@benchmark jacobian($arrowhead, prep, $sparse_forward_backend, $xbig) setup=(
    prep=prepare_jacobian(arrowhead, sparse_forward_backend, xbig)
)
```

```@example tuto_advanced
@benchmark jacobian($arrowhead, prep, $sparse_mixed_backend, $xbig) setup=(
    prep=prepare_jacobian(arrowhead, sparse_mixed_backend, xbig)
)
```

# Contributing

This page is important reading if you want to contribute to DifferentiationInterface.jl.
It is not part of the public API and the content below may become outdated, in which case you should refer to the source code as the ground truth.

## General principles

The package is structured around 8 [operators](@ref Operators):

- [`derivative`](@ref)
- [`second_derivative`](@ref)
- [`gradient`](@ref)
- [`jacobian`](@ref)
- [`hessian`](@ref)
- [`pushforward`](@ref)
- [`pullback`](@ref)
- [`hvp`](@ref)

Most operators have 4 variants, which look like this in the first order: `operator`, `operator!`, `value_and_operator`, `value_and_operator!`.

## New operator

To implement a new operator for an existing backend, you need to write 5 methods: 1 for [preparation](@ref Preparation) and 4 corresponding to the variants of the operator (see above).
For some operators, you will also need to support [in-place functions](@ref "Mutation and signatures"), which requires another 5 methods (defined on `f!` instead of `f`).

The method `prepare_operator_nokwarg` must output a `prep` object of the correct type.
For instance, `prepare_gradient_nokwarg(strict, f, backend, x)` must return a [`DifferentiationInterface.GradientPrep`](@ref).
Assuming you don't need any preparation for said operator, you can use the trivial preparation types that are already defined, like `DifferentiationInterface.NoGradientPrep{SIG}`.
Otherwise, define a custom struct like `MyGradientPrep{SIG} <: DifferentiationInterface.GradientPrep{SIG}` and put the necessary storage in there.
Take inspiration from existing operators on how to enforce the signature `SIG`.

## New backend

If you want to implement a new backend, for instance because you developed a new AD package called `SuperDiff`, please open a pull request to DifferentiationInterface.jl.
Your AD package needs to be registered first.

### Core code

In the main package, you should define a new struct `SuperDiffBackend` which subtypes [`ADTypes.AbstractADType`](@extref ADTypes), and endow it with the fields you need to parametrize your differentiation routines.
You also have to define [`ADTypes.mode`](@extref), [`DifferentiationInterface.check_available`](@ref) and [`DifferentiationInterface.inplace_support`](@ref) on `SuperDiffBackend`.

!!! info

    In the end, this backend struct will need to be contributed to [ADTypes.jl](https://github.com/SciML/ADTypes.jl).
    However, putting it in the DifferentiationInterface.jl PR is a good first step for debugging.

In a [package extension](https://pkgdocs.julialang.org/v1/creating-packages/#Conditional-loading-of-code-in-packages-(Extensions)) named `DifferentiationInterfaceSuperDiffExt`, you need to implement at least [`pushforward`](@ref) or [`pullback`](@ref) (and their variants).
The exact requirements depend on the differentiation mode you chose:

| backend mode                                      | pushforward necessary | pullback necessary |
| :------------------------------------------------ | :-------------------- | :----------------- |
| [`ADTypes.ForwardMode`](@extref ADTypes)          | yes                   | no                 |
| [`ADTypes.ReverseMode`](@extref ADTypes)          | no                    | yes                |
| [`ADTypes.ForwardOrReverseMode`](@extref ADTypes) | yes                   | yes                |
| [`ADTypes.SymbolicMode`](@extref ADTypes)         | yes                   | yes                |

Every other operator can be deduced from these two, but you can gain efficiency by implementing additional operators.

### Tests and docs

Once that is done, you need to add your new backend to the test suite.
Test files should be gathered in a folder named `SuperDiff` inside [`DifferentiationInterface/test/Back`](https://github.com/JuliaDiff/DifferentiationInterface.jl/tree/main/DifferentiationInterface/test/Back).
They should use [DifferentiationInterfaceTest.jl](https://github.com/JuliaDiff/DifferentiationInterface.jl/tree/main/DifferentiationInterfaceTest) to check correctness against the default scenarios.
Take inspiration from the tests of other backends to write your own.
To activate tests in CI, modify the [test workflow](https://github.com/JuliaDiff/DifferentiationInterface.jl/blob/main/.github/workflows/Test.yml) and add your package to the list.
To run the tests locally, replace the following line in [`DifferentiationInterface/test/runtests.jl`](https://github.com/JuliaDiff/DifferentiationInterface.jl/blob/main/DifferentiationInterface/test/runtests.jl)

```julia
GROUP = get(ENV, "JULIA_DI_TEST_GROUP", "All")
```

with the much cheaper version

```julia
GROUP = get(ENV, "JULIA_DI_TEST_GROUP", "Back/SuperDiff")
```

but don't forget to switch it back before pushing.

Finally, you need to add your backend to the documentation, modifying every page that involves a list of backends (including the `README.md`).

# Backends

## List

We support the following dense backend choices from [ADTypes.jl](https://github.com/SciML/ADTypes.jl):

- [`AutoChainRules`](@extref ADTypes.AutoChainRules)
- [`AutoDiffractor`](@extref ADTypes.AutoDiffractor)
- [`AutoEnzyme`](@extref ADTypes.AutoEnzyme)
- [`AutoFastDifferentiation`](@extref ADTypes.AutoFastDifferentiation)
- [`AutoFiniteDiff`](@extref ADTypes.AutoFiniteDiff)
- [`AutoFiniteDifferences`](@extref ADTypes.AutoFiniteDifferences)
- [`AutoForwardDiff`](@extref ADTypes.AutoForwardDiff)
- [`AutoGTPSA`](@extref ADTypes.AutoGTPSA)
- [`AutoHyperHessians`](@extref ADTypes.AutoHyperHessians)
- [`AutoMooncake`](@extref ADTypes.AutoMooncake) and [`AutoMooncakeForward`](@extref ADTypes.AutoMooncake) (the latter is experimental)
- [`AutoPolyesterForwardDiff`](@extref ADTypes.AutoPolyesterForwardDiff)
- [`AutoReverseDiff`](@extref ADTypes.AutoReverseDiff)
- [`AutoSymbolics`](@extref ADTypes.AutoSymbolics)
- [`AutoTracker`](@extref ADTypes.AutoTracker)
- [`AutoZygote`](@extref ADTypes.AutoZygote)

## Features

Given a backend object, you can use:

- [`check_available`](@ref) to know whether the required AD package is loaded
- [`check_inplace`](@ref) to know whether the backend supports in-place functions (all backends support out-of-place functions)

In theory, all we need from each backend is either a `pushforward` or a `pullback`: we can deduce every other operator from these two.
In practice, many AD backends have custom implementations for high-level operators like `gradient` or `jacobian`, which we reuse whenever possible.

!!! details

    In the rough summary table below,

      - ✅ means that we reuse the custom implementation from the backend;
      - ❌ means that a custom implementation doesn't exist, so we use our default fallbacks;
      - 🔀 means it's complicated or not done yet.

    |                            | `pf` | `pb` | `der` | `grad` | `jac` | `hess` | `hvp` | `der2` |
    |:-------------------------- |:---- |:---- |:----- |:------ |:----- |:------ |:----- |:------ |
    | `AutoChainRules`           | ❌    | ✅    | ❌     | ❌      | ❌     | ❌      | ❌     | ❌      |
    | `AutoDiffractor`           | ✅    | ❌    | ❌     | ❌      | ❌     | ❌      | ❌     | ❌      |
    | `AutoEnzyme` (forward)     | ✅    | ❌    | ❌     | ✅      | ✅     | ❌      | ❌     | ❌      |
    | `AutoEnzyme` (reverse)     | ❌    | ✅    | ❌     | ✅      | ✅     | ❌      | 🔀     | ❌      |
    | `AutoFastDifferentiation`  | ✅    | ✅    | ✅     | ✅      | ✅     | ✅      | ✅     | ✅      |
    | `AutoFiniteDiff`           | 🔀    | ❌    | ✅     | ✅      | ✅     | ✅      | ❌     | ❌      |
    | `AutoFiniteDifferences`    | 🔀    | ❌    | ❌     | ✅      | ✅     | ❌      | ❌     | ❌      |
    | `AutoForwardDiff`          | ✅    | ❌    | ✅     | ✅      | ✅     | ✅      | ✅     | ✅      |
    | `AutoGTPSA`                | ✅    | ❌    | ❌     | ✅      | ✅     | ✅      | ✅     | ✅      |
    | `AutoHyperHessians`        | ❌    | ❌    | ❌     | ❌      | ❌     | ✅      | ✅     | ✅      |
    | `AutoMooncake`             | ❌    | ✅    | ❌     | ❌      | ❌     | ❌      | ❌     | ❌      |
    | `AutoMooncakeForward`      | ✅    | ❌    | ❌     | ❌      | ❌     | ❌      | ❌     | ❌      |
    | `AutoPolyesterForwardDiff` | 🔀    | ❌    | 🔀     | ✅      | ✅     | 🔀      | 🔀     | 🔀      |
    | `AutoReverseDiff`          | ❌    | 🔀    | ❌     | ✅      | ✅     | ✅      | ❌     | ❌      |
    | `AutoSymbolics`            | ✅    | ❌    | ✅     | ✅      | ✅     | ✅      | ✅     | ✅      |
    | `AutoTracker`              | ❌    | ✅    | ❌     | ✅      | ❌     | ❌      | ❌     | ❌      |
    | `AutoZygote`               | ❌    | ✅    | ❌     | ✅      | ✅     | ✅      | 🔀     | ❌      |

Moreover, each context type is supported by a specific subset of backends:

|                            | [`Constant`](@ref) | [`Cache`](@ref) |
|:-------------------------- |:------------------ |:--------------- |
| `AutoChainRules`           | ✅                  | ❌               |
| `AutoDiffractor`           | ❌                  | ❌               |
| `AutoEnzyme` (forward)     | ✅                  | ✅               |
| `AutoEnzyme` (reverse)     | ✅                  | ✅               |
| `AutoFastDifferentiation`  | ✅                  | ✅               |
| `AutoFiniteDiff`           | ✅                  | ✅               |
| `AutoFiniteDifferences`    | ✅                  | ✅               |
| `AutoForwardDiff`          | ✅                  | ✅               |
| `AutoGTPSA`                | ✅                  | ❌               |
| `AutoHyperHessians`        | ✅                  | ✅               |
| `AutoMooncake`             | ✅                  | ✅               |
| `AutoMooncakeForward`      | ✅                  | ✅               |
| `AutoPolyesterForwardDiff` | ✅                  | ✅               |
| `AutoReverseDiff`          | ✅                  | ❌               |
| `AutoSymbolics`            | ✅                  | ✅               |
| `AutoTracker`              | ✅                  | ❌               |
| `AutoZygote`               | ✅                  | 🔀               |

## Second order

For second-order operators like [`second_derivative`](@ref), [`hessian`](@ref) and [`hvp`](@ref), there are two main options.
You can either use a single backend, or combine two of them within the [`SecondOrder`](@ref) struct:

```julia
backend = SecondOrder(outer_backend, inner_backend)
```

The inner backend will be called first, and the outer backend will differentiate the generated code.
In general, using a forward outer backend over a reverse inner backend will yield the best performance.

!!! danger

    Second-order AD is tricky, and many backend combinations will fail (even if you combine a backend with itself).
    Be ready to experiment and open issues if necessary.

## Backend switch

The wrapper [`DifferentiateWith`](@ref) allows you to switch between backends.
It takes a function `f` and specifies that `f` should be differentiated with the substitute backend of your choice, instead of whatever true backend the surrounding code is trying to use.
In other words, when someone tries to differentiate `dw = DifferentiateWith(f, substitute_backend)` with `true_backend`, then `substitute_backend` steps in and `true_backend` does not dive into the function `f` itself.

At the moment, `DifferentiateWith` only works when `true_backend` is either [ForwardDiff.jl](https://github.com/JuliaDiff/ForwardDiff.jl), reverse-mode [Mooncake.jl](https://github.com/chalk-lab/Mooncake.jl), or a [ChainRules.jl](https://github.com/JuliaDiff/ChainRules.jl)-compatible backend (e.g., [Zygote.jl](https://github.com/FluxML/Zygote.jl)).

## Implementations

What follows is a list of implementation details from the package extensions of DifferentiationInterface.jl
It is not part of the public API or protected by semantic versioning, and it may become outdated.
When in doubt, refer to the code itself.

### ChainRulesCore

We only implement `pullback`, using the [`RuleConfig` mechanism](https://juliadiff.org/ChainRulesCore.jl/stable/rule_author/superpowers/ruleconfig.html#config) to call back into AD.
Same-point preparation runs the forward sweep and returns the pullback closure.

### Diffractor

We only implement `pushforward`.

!!! danger

    The latest releases of Diffractor [broke DifferentiationInterface](https://github.com/JuliaDiff/Diffractor.jl/issues/290).

### Enzyme

Depending on the `mode` attribute inside [`AutoEnzyme`](@extref ADTypes.AutoEnzyme), we implement either `pushforward` or `pullback` based on `Enzyme.autodiff`.
When necessary, preparation chooses a number of chunks (for `gradient` and `jacobian` in forward mode, for `jacobian` only in reverse mode).

!!! warning

    Enzyme.jl's handling of activities and multiple arguments is not fully supported here, which can cause slowdowns or errors.
    If differentiation fails or takes too long, consider using Enzyme.jl through its [native API](https://enzymead.github.io/Enzyme.jl/stable/) instead.

### FastDifferentiation

For every operator, preparation generates an [executable function](https://brianguenter.github.io/FastDifferentiation.jl/stable/makefunction/) from the symbolic expression of the differentiated function.

!!! warning

    Preparation can be very slow for symbolic AD.

### FiniteDiff

Whenever possible, preparation creates a cache object.
Pushforward is implemented rather slowly using a closure.

### FiniteDifferences

Nothing specific to mention.

### ForwardDiff

We implement [`pushforward`](@ref) directly using [`Dual` numbers](https://juliadiff.org/ForwardDiff.jl/stable/dev/how_it_works/), and preparation allocates the necessary space.
For higher level operators, preparation creates a [config object](https://juliadiff.org/ForwardDiff.jl/stable/user/api/#Preallocating/Configuring-Work-Buffers), which can be type-unstable.

### GTPSA

For all operators, preparation preallocates the input [`TPS`s](https://bmad-sim.github.io/GTPSA.jl/stable/man/c_tps/), and for in-place functions the output `TPS`s as well. For minimal allocations of `TPS` temporaries inside of a function, the [`@FastGTPSA`/`@FastGTPSA!`](https://bmad-sim.github.io/GTPSA.jl/stable/man/j_fastgtpsa/) macros are recommended.

If a GTPSA [`Descriptor`](https://bmad-sim.github.io/GTPSA.jl/stable/man/b_descriptor/) is not provided to `AutoGTPSA`, then a `Descriptor` will be generated in preparation based on the context.

!!! danger

    When providing a custom GTPSA `Descriptor` to `AutoGTPSA`, it is the responsibility of the user to ensure that the number of [GTPSA "variables"](https://bmad-sim.github.io/GTPSA.jl/stable/quickstart/#Calculating-a-Truncated-Power-Series) specified in the `Descriptor` is consistent with the number of inputs of the provided function. Undefined behavior and crashes may occur if this is not the case.

### PolyesterForwardDiff

Most operators fall back on `AutoForwardDiff`.

### ReverseDiff

With `AutoReverseDiff(compile=false)`, preparation preallocates a [config](https://juliadiff.org/ReverseDiff.jl/dev/api/#The-AbstractConfig-API).

With `AutoReverseDiff(compile=true)`, preparation records a [tape](https://juliadiff.org/ReverseDiff.jl/dev/api/#The-AbstractTape-API) of the function's execution.
This tape is computed from the input `x` provided at preparation time.
It is control-flow dependent, so only one branch is recorded at each `if` statement.

!!! danger

    If your function has value-specific control flow (like `if x[1] > 0` or `if c == 1`), you may get silently wrong results whenever it takes new branches that were not taken during preparation.
    You must make sure to run preparation with an input and contexts whose values trigger the correct control flow for future executions.

Whenever contexts are provided, tape recording is deactivated in all cases, because otherwise the context values would be hardcoded into a tape.

### Symbolics

For all operators, preparation generates an [executable function](https://docs.sciml.ai/Symbolics/stable/manual/build_function/) from the symbolic expression of the differentiated function.

!!! warning

    Preparation can be very slow for symbolic AD.

### Mooncake

For `pullback`, preparation [builds the reverse rule](https://chalk-lab.github.io/Mooncake.jl/stable/understanding_mooncake/rule_system/) of the function.

### Tracker

We implement `pullback` based on `Tracker.back`.
Same-point preparation runs the forward sweep and returns the pullback closure at `x`.

### Zygote

We implement `pullback` based on `Zygote.pullback`.
Same-point preparation runs the forward sweep and returns the pullback closure at `x`.

# Internals

The following names are not part of the public API.

```@autodocs
Modules = [DifferentiationInterface]
Public = false
Filter = t -> !(Symbol(t) in [:outer, :inner, :Prep, :AutoForwardFromPrimitive, :AutoReverseFromPrimitive])
```
